//
//  NewRKVc.swift
//  GeliBusinessPlatform
//
//  Created by junye lu on 2020/6/2.
//  Copyright © 2020 junye lu. All rights reserved.
//

import UIKit
import LGButton
protocol NewRKVcDelegate {
    func NewRKVcFinish()
}
class NewRKVc: BaseViewController ,UITableViewDelegate,UITableViewDataSource, NewOnlyRKCellDelegate,NewSelectItemVcDelegate,NewSelectWarehouseVCDelegate,GLAlertSelectViewDelegate,GeliAlertTextViewDelegate, ShowTimeSelectViewDelegate{
    let UserToken = UserDefaults.standard.value(forKey: "user_token")
    var delegate:NewRKVcDelegate?
    var po_id = 0
    var isCaiGou = false
    var remark = ""
    var orderNumStr = ""
    //MARK: - 提交申请
    func sureGeliAlertTextViewAction(sender: String) {
        
        remark = sender
        holderArr.insert(remark, at: holderArr.count-1)
        holderArr.remove(at: holderArr.count-1)
        listView.reloadData()
    }
    @IBAction func gmAction(_ sender: Any) {
        if gmNumber == nil {
            if holderArr[0] == "请选择仓库" {
                HUD.flash(.label("请选择仓库"), delay: 1.2)
                return
            }
            if holderArr[1] == "请选择库位" {
                HUD.flash(.label("请选择库位"), delay: 1.2)
                return
            }
        }
        if holderArr[2] == "请选择入库类型" {
            HUD.flash(.label("请选择入库类型"), delay: 1.2)
            return
        }
        if rkSelectArr.count == 0 {
            HUD.flash(.label("请选择商品"), delay: 1.2)
            return
        }
        
        for item in rkSelectArr{
            if  item.RKSL == nil{
                HUD.flash(.label("请填写入库数量"), delay: 1.2)
                return
            }
            if item.createDay == nil {
                HUD.flash(.label("请选择生产日期"), delay: 1.2)
                return
            }
            if item.BZQ == nil {
                HUD.flash(.label("请填写保质期"), delay: 1.2)
                return
            }
        }
        HUD.show(.progress)
        if lgBtnTitLbl.text != "提交申请"{
            var goodsInfoArr:Array<Any>? = []
            rkSelectArr.forEach { (model) in
                var rkjg:Float = 0
                var total:Float = 0
                if model.RKJG != nil {
                    rkjg = model.RKJG!
                    if model.RKSL != nil {
                        total = rkjg * Float(model.RKSL!)
                    }
                }
                
                var shelf_life = model.BZQ
                if model.DayType == 0 {
                    shelf_life = model.BZQ! * 30
                }
                let goods = [
                    "goods_id":model.goods_id as Any,
                    "sku_id":model.sku_id as Any,
                    "goods_name":model.goods_name as Any,
                    "goods_spec":model.spec_str as Any,
                    "number":model.RKSL as Any,
                    "price":model.price as Any,
                    "amount":rkjg as Any,
                    "subtotal":total as Any,
                    "production_data":model.createDay as Any,
                    "shelf_life":shelf_life as Any,
                    "report_id":0 as Any,
                    "pog_id":model.pog_id as Any
                ]
                goodsInfoArr?.append(goods)
            }
            let goods_info = dataChangeString(sender: goodsInfoArr!)
            //直接入库
            
            let dict = [
                "user_token":UserToken as Any,
                "w_id":w_id as Any,
                "p_id":p_id as Any,
                "i_type":typeSelect! + 1 as Any,
                "apply_remark":remark as Any,
                "po_id":po_id as Any,
                "goods_info":goods_info as Any
            ]
            GoodsInput(dict, success: { (data) in
                HUD.hide()
                HUD.flash(.labeledSubSuccess(subtitle: "入库成功"), delay: 1.2)
                self.delegate?.NewRKVcFinish()
                self.navigationController?.popViewController(animated: true)
                
            }) { (error) in
                
            }
        }else{
            
            
            var goodsInfoArr:Array<Any>? = []
            rkSelectArr.forEach { (model) in
                var total:Float = 0
                total = model.RKJG! * Float(model.RKSL!)
                
                var shelf_life = model.BZQ
                if model.DayType == 0 {
                    shelf_life = model.BZQ! * 30
                }
                
                
                let goods = [
                    "goods_id":model.goods_id as Any,
                    "sku_id":model.sku_id as Any,
                    "goods_name":model.goods_name as Any,
                    "goods_spec":model.spec_str as Any,
                    "number":model.RKSL! as Any,
                    "price":model.price as Any,
                    "amount":model.RKJG! as Any,
                    "subtotal":total as Any,
                    "production_data":model.createDay as Any,
                    "shelf_life":shelf_life as Any,
                    "report_id":0 as Any,
                    "pog_id":model.pog_id as Any
                ]
                goodsInfoArr?.append(goods)
            }
            let goods_info = dataChangeString(sender: goodsInfoArr!)
            let dict = [
                "user_token":UserToken as Any,
                "i_type":typeSelect! + 1 as Any,
                "apply_remark":remark as Any,
                "po_id":po_id as Any,
                "goods_info":goods_info as Any
            ]
            
            GoodsInputApply(dict, success: { (data) in
                HUD.hide()
                HUD.flash(.labeledSubSuccess(subtitle: "申请成功"), delay: 1.2)
                self.delegate?.NewRKVcFinish()
                self.navigationController?.popViewController(animated: true)
                
            }) { (error) in
                
            }
            
        }
        
    }
    
    var gmNumber:Int?
    
    var sku_id:Int?
    var goods_id:Int?
    @IBOutlet weak var lgBtnTitLbl: UILabel!
    @IBOutlet weak var lgBtn: LGButton!
    var isGm = false
    var titleArr = ["仓库：","库位：","入库类型：","入库时间：","备注："]
    var holderArr = ["请选择仓库","请选择库位","请选择入库类型","时间","请输入备注"]
    //入库类型
    var rkTypeArr = ["采购","调入","退货","生产","调出被拒绝","外采","其他","固定采购","临时采购"]
    var typeSelect:Int?
    
    var glSelectView:GLAlertSelectView?
    
    var poiArr:Array<ShopWarehouseDetailDataPositionModel> = []
    
    @IBOutlet weak var btmView: UIView!
    @IBOutlet weak var listView: UITableView!
    
    var rkSelectArr:Array<InputInitInfoGoodsInfoModel> = []//产品选择
    var rkDatas:Array<InputInitInfoGoodsInfoModel> = []//产品
    
    var rkWareHouseArr:Array<InputInitInfoWareHouseResModel> = []//库位选择
    var selectIdx:Int?//库位选择
    
    var authArr:Array<String> = []//权限
    
    var w_id:Int?
    var p_id:Int?
    override func viewDidLoad() {
        super.viewDidLoad()
        
        if orderNumStr.count > 0 {
            titleArr.append("采购单号：")
            holderArr.append(orderNumStr)
        }
        
        if isCaiGou {
            typeSelect = 0
            holderArr.insert(rkTypeArr[typeSelect!], at: 2)
            holderArr.remove(at: 3)
        }
        
        let strNowTime = getTimeNow()
        holderArr.insert(strNowTime, at: 3)
        holderArr.remove(at: 4)
        
        navbar.title = "入库"
        self.view.addSubview(navbar)
        SetTopFrameView(view: listView, btmView: btmView)
        listView.separatorStyle = .none
        
        listView.register(UINib(nibName: "CRKBtnCell", bundle: nil), forCellReuseIdentifier: "CRKBtnCell")
        listView.register(UINib(nibName: "NewOnlyRKCell", bundle: nil), forCellReuseIdentifier: "NewOnlyRKCell")
        listView.register(UINib(nibName: "TitleAndLblCell", bundle: nil), forCellReuseIdentifier: "TitleAndLblCell")
        
        loadData()
        
        // Do any additional setup after loading the view.
    }
    
    func loadData(){
        HUD.flash(.progress)
        listView.isHidden = true
        lgBtn.isHidden = true
        lgBtnTitLbl.isHidden = true
        InputInitInfo(["user_token":UserToken as Any,"goods_id":goods_id as Any], success: { (data) in
            let model = data as! InputInitInfoModel
            
            model.data?.auth?.forEach({ (str) in
                self.authArr.append(str)
            })
            model.data?.warehouse_res?.forEach({ (item) in
                if item.is_default == 1 {
                    self.holderArr.insert(item.w_name!, at: 0)
                    self.holderArr.remove(at: 1)
                    
                    self.w_id = item.w_id
                    
                    item.warehouse_position?.forEach({ (data) in
                        if data.is_default == 1 {
                            self.p_id = data.p_id
                            self.holderArr.insert(data.p_name!, at: 1)
                            self.holderArr.remove(at: 2)
                        }
                    })
                }
            })
            
            
            if self.authArr.contains("63") == false && self.authArr.contains("65") == false {
                self.listView.isHidden = true
                self.lgBtn.isHidden = true
                self.lgBtnTitLbl.isHidden = true
                HUD.flash(.label("亲，您不具备编辑的权限"), delay:1.2)
                return
            }
            
            if self.gmNumber != nil{//入库申请
                var pass = false
                self.authArr.forEach { (str) in
                    if str == "\(self.gmNumber!)"{
                        self.lgBtnTitLbl.text = "提交申请"
                        pass = true
                    }
                }
                if pass == false {
                    self.listView.isHidden = true
                    self.lgBtn.isHidden = true
                    self.lgBtnTitLbl.isHidden = true
                    HUD.flash(.label("亲，您不具备编辑的权限"), delay:1.2)
                    return
                }
            }else{
                self.lgBtnTitLbl.text = "提交申请"
                if self.authArr.contains("63"){
                    self.isGm = true
                    self.lgBtnTitLbl.text = "直接入库"
                }
            }
            
            
            
            model.data?.warehouse_res?.forEach({ (item) in
                self.rkWareHouseArr.append(item)
            })
            model.data?.goods_info?.forEach({ (item) in
                if item.sku_id == self.sku_id {
                    self.rkSelectArr.append(item)
                }
                self.rkDatas.append(item)
            })
            
            
            self.listView.reloadData()
            HUD.hide()
            self.listView.isHidden = false
            self.lgBtn.isHidden = false
            self.lgBtnTitLbl.isHidden = false
        }) { (error) in
            
        }
    }
    
    func tableView(_ tableView: UITableView, didSelectRowAt indexPath: IndexPath) {
        if indexPath.section == 1 {
            return
        }
        if indexPath.row == 4 {
            let alterView = GeliAlertTextView(frame: self.view.window!.bounds)
            alterView.delegate = self
            alterView.titleLbl.text = "请填写入库备注"
            alterView.placerLbl.text = "请填写入库备注..."
            if remark.count > 0 {
                alterView.textview.text = remark
                alterView.placerLbl.isHidden = true
            }
            self.view.window?.addSubview(alterView)
        }
        if indexPath.row == 2 {
            if isCaiGou  == false{
                if glSelectView == nil {
                    let view = GLAlertSelectView(frame: self.view.bounds)
                    view.tag = indexPath.row
                    if typeSelect != nil {
                        view.selectNum = typeSelect
                        view.tempNum = view.selectNum
                    }
                    view.isOnlySelectKuWei = true
                    view.delegate = self
                    view.titleLbl.text = "请选择入库类型"
                    view.dataArr = rkTypeArr
                    self.view.addSubview(view)
                    glSelectView = view
                }
            }
        }
        if indexPath.row == 0 {
            let vc = NewSelectWarehouseVC()
            vc.rkWareHouseArr = rkWareHouseArr
            vc.delegate = self
            self.navigationController?.pushViewController(vc, animated: true)
        }
        if indexPath.row == 1 {
            
            if poiArr.count > 0 {
                if glSelectView == nil {
                    let view = GLAlertSelectView(frame: self.view.bounds)
                    if selectIdx != nil {
                        view.selectNum = selectIdx
                        view.tempNum = view.selectNum
                    }
                    view.isOnlySelectKuWei = true
                    view.delegate = self
                    view.titleLbl.text = "请选择库位"
                    var pArr:Array<String> = []
                    for item in poiArr {
                        let str = item.p_name! + "(库存数:\(item.inventory_count!))"
                        pArr.append(str)
                    }
                    
                    view.dataArr = pArr
                    self.view.addSubview(view)
                    glSelectView = view
                }
            }else{//待
                if w_id != nil {
                    
                    WarehouseDetail(["user_token":UserToken as Any,"w_id":w_id as Any], success: { (data) in
                        let model = data as! ShopWarehouseDetailModel
                        model.data?.position_res?.forEach({ (item) in
                            self.poiArr.append(item)
                        })
                        if self.glSelectView == nil {
                            let view = GLAlertSelectView(frame: self.view.bounds)
                            
                            view.isOnlySelectKuWei = true
                            view.delegate = self
                            view.titleLbl.text = "请选择库位"
                            var pArr:Array<String> = []
                            for i in 0 ..< self.poiArr.count {
                                let item = self.poiArr[i]
                                let str = item.p_name! + "(库存数:\(item.inventory_count!))"
                                if item.p_id == self.p_id {
                                    self.selectIdx = i
                                }
                                pArr.append(str)
                            }
                            
                            view.selectNum = self.selectIdx
                            view.tempNum = view.selectNum
                            
                            view.dataArr = pArr
                            self.view.addSubview(view)
                            self.glSelectView = view
                        }
                    }) { (error) in
                        
                    }
                    
                }else{
                    HUD.flash(.label("请选择仓库"), delay: 1.2)
                }
            }
        }
    }
    //MARK: - cellForRow
    func tableView(_ tableView: UITableView, cellForRowAt indexPath: IndexPath) -> UITableViewCell {
        if indexPath.section == 1{
            let cell = tableView.dequeueReusableCell(withIdentifier: "NewOnlyRKCell") as! NewOnlyRKCell
            cell.tag = indexPath.row
            cell.delegate = self
            if isCaiGou {
                cell.delBtn.isHidden = true
            }
            let data = rkSelectArr[indexPath.row]
            cell.nameLbl.text = data.goods_name
            if data.no_push_num != nil {
                cell.titLbl.text = "入库数量：(可入库量为\(data.no_push_num!))"
            }
            cell.detailLbl.text = data.spec_str! + " " + "¥\(data.price!)"
            cell.rkPriceTf.text = "\(data.price!)"
            cell.rkCountTf.text = "1"
            cell.bzqTf.text = ""
            cell.timeLbl.text = "请选择生产日期"
            if data.RKJG != nil {
                cell.rkPriceTf.text = "\(data.RKJG!)"
            }else{
                let num = data.price! as! NSString
                data.RKJG = num.floatValue
            }
            if data.RKSL != nil {
                cell.rkCountTf.text = "\(data.RKSL!)"
            }else{
                cell.rkCountTf.text = "1"
                data.RKSL = 1
            }
            if data.ZJ != nil {
                cell.totalPriceTf.text = "\(data.ZJ!)"
            }else{
                cell.totalPriceTf.text = data.price!
            }
            if data.BZQ != nil {
                cell.bzqTf.text = "\(data.BZQ!)"
            }
            
            if data.DayType == 0 {
                cell.rightBtn.isSelected = true
                cell.leftBtn.isSelected = false
            }
            if data.createDayStr != nil {
                cell.timeLbl.text = data.createDayStr
            }
            return cell
        }
        
        if indexPath.row == 4 {
            let cell = tableView.dequeueReusableCell(withIdentifier: "TitleAndLblCell") as! TitleAndLblCell
            cell.nameLbl.text = titleArr[indexPath.row]
            if orderNumStr.count == 0 {
                cell.btmLine.isHidden = true
            }
            cell.contentLbl.text = holderArr[indexPath.row]
            cell.btmW.constant = 0
            cell.contentRight.constant = 0
            cell.imgRight.constant = 15
            cell.contentLbl.textColor = UIColor(named: "#999999")
            if remark.count != 0 {
                cell.contentLbl.text = remark
                cell.btmW.constant = 15
                cell.contentRight.constant = 5
                cell.imgRight.constant = 22
                cell.contentLbl.textColor = UIColor(named: "标题字颜色")
            }
            return cell
        }
        
        let cell = tableView.dequeueReusableCell(withIdentifier: "CRKBtnCell") as! CRKBtnCell
        cell.tag = indexPath.row
        cell.nameLbl.text = titleArr[indexPath.row]
        cell.contentLbl.text = holderArr[indexPath.row]
        cell.mustLbl.isHidden = true
        cell.nameLeft.constant = 0
        cell.mustWidth.constant = 0
        if indexPath.row > 2 {
            setCellUI(cell: cell)
        }
        return cell
        
    }
    //MARK: - 入库商品delegate
    func NewOnlyRKCellDateTypeSelect(sender: Int, cell: NewOnlyRKCell) {
        // 0:月， 1:天
        let data = rkSelectArr[cell.tag]
        data.DayType = sender
    }
    
    //MARK:---跳转日期选择
    var tempTag:Int?
    func NewOnlyRKCellDateSelect(cell: NewOnlyRKCell) {
        print("跳转日期选择")
        let timeSelectV = ShowTimeSelectView(frame: self.view.window!.bounds)
        timeSelectV.moreSelection = false
        tempTag = cell.tag
        let data = rkSelectArr[tempTag!]
        print("date ==",data.createDayStr,data.createDay)
        //把默认值传回去
        if data.createDay != nil {
            let time = TimeInterval(exactly: data.createDay!)
            timeSelectV.BeginDate = Date(timeIntervalSince1970: time!)
            timeSelectV.EndDate = Date(timeIntervalSince1970: time!)//无用处
            
        }
        
        timeSelectV.endDateByWork = Date()
        timeSelectV.titleLbl.text = "请选择生产日期"
        timeSelectV.delegate = self
        self.view.window?.addSubview(timeSelectV)
    }
    //MARK:--选择时间回调数据
    func showTimeSelectByData(timeStr: String, beginDate: Date, endginDate: Date) {
        let timeInterval:TimeInterval = beginDate.timeIntervalSince1970
        print(tempTag,timeStr,"生产日期",timeInterval)
        
        let data = rkSelectArr[tempTag!]
        data.createDay = Int(timeInterval)
        data.createDayStr = timeStr
        listView.reloadData()
        
    }
    func NewOnlyRKCellAddRepord(cell: NewOnlyRKCell) {
        //添加检测报告
    }
    
    func NewOnlyRKCellDel(cell: NewOnlyRKCell) {
        //删除
        rkSelectArr.remove(at: cell.tag)
        listView.reloadData()
    }
    
    func NewOnlyRKCellTFinput(text: String, inputType: Int, cell: NewOnlyRKCell) {
        //text:数据  inputType: 100-保质期 101-总价 102-入库数量 103-入库价格
        let num = text as NSString
        let data = rkSelectArr[cell.tag]
        switch inputType {
        case 100:
            data.BZQ = num.integerValue
            break
        case 101:
            data.ZJ = num.floatValue
            break
        case 102:
            if num.integerValue == 0 {
                HUD.flash(.label("入库数量不小于1"), delay: 1.2)
                data.RKSL = 1
                let idx = IndexPath(row: cell.tag, section: 1)
                listView.reloadRows(at: [idx], with: .none)
            }else{
                data.RKSL = num.integerValue
            }
            if data.RKJG != nil && data.RKSL != nil {
                data.ZJ = data.RKJG! * Float(data.RKSL!)
                cell.totalPriceTf.text = "\(data.ZJ!)"
            }
            break
        case 103:
            data.RKJG = num.floatValue
            if data.RKJG != nil && data.RKSL != nil {
                data.ZJ = data.RKJG! * Float(data.RKSL!)
                cell.totalPriceTf.text = "\(data.ZJ!)"
            }
            break
        default:
            break
        }
    }
    
    //添加商品
    @objc func addProduct(){
        let vc = NewSelectItemVc()
        vc.delegate = self
        vc.rkDatas = rkDatas
        vc.rkSelectArr = rkSelectArr
        self.navigationController?.pushViewController(vc, animated: true)
    }
//    func getStrHeight(str:String) -> CGFloat{
//        let lbl = UILabel()
//        lbl.text = titleArr.last
//        lbl.font = UIFont.systemFont(ofSize: 13)
//        lbl.sizeToFit()
//        let margin = lbl.bounds.size.width + 77
//        let viewSize = CGSize(width:fullScreenWidth - margin , height: CGFloat(MAXFLOAT))
//        let font = UIFont.systemFont(ofSize: 13)
//        return (str as NSString).boundingRect(with: viewSize, options: [.usesLineFragmentOrigin], attributes: [NSAttributedString.Key.font:font], context: nil).height
//    }
    //MARK: - cell delegate
    func tableView(_ tableView: UITableView, heightForRowAt indexPath: IndexPath) -> CGFloat {
        if indexPath.section == 0 {
            if isGm == false {
                if indexPath.row < 2{
                    return 0.001
                }
            }
            if indexPath.row == 4 {
                return UITableView.automaticDimension
//                if getStrHeight(str: remark)+30 > 49 {
//                    return getStrHeight(str: remark)+30
//                }
            }
            return 49
        }
        
        return 326
    }
    func setCellUI(cell:CRKBtnCell){
        cell.contentLbl.textColor = UIColor(named: "标题字颜色")
        cell.arrowImg.isHidden = true
        cell.contentRight.constant = -7
        
    }
    func tableView(_ tableView: UITableView, viewForFooterInSection section: Int) -> UIView? {
        if section == 0 {
            let view = UIView(frame: CGRect(x: 0, y: 0, width: fullScreenWidth, height: 10))
            view.backgroundColor = UIColor(named: "app底色")
            return view
        }
        if isCaiGou == false {
            let view = UIView(frame: CGRect(x: 0, y: 0, width: fullScreenWidth, height: 147.5))
            let img = UIImageView()
            view.addSubview(img)
            img.image = UIImage(named: "tianjiashangpin")
            img.snp.makeConstraints { (make) in
                make.top.equalTo(30)
                make.width.height.equalTo(52)
                make.centerX.equalTo(view.snp_centerX)
            }
            let btn = UIButton()
            view.addSubview(btn)
            btn.snp.makeConstraints { (make) in
                make.top.left.right.bottom.equalTo(0)
            }
            btn.addTarget(self, action: #selector(addProduct), for: .touchUpInside)
            return view
        }else{
            let view = UIView(frame: CGRect(x: 0, y: 0, width: fullScreenWidth, height: 10))
            view.backgroundColor = UIColor(named: "app底色")
            return view
        }
    }
    
    func tableView(_ tableView: UITableView, heightForFooterInSection section: Int) -> CGFloat {
        if section == 0 {
            return 10
        }
        if isCaiGou == false {
            return 147.5
        }
        return 0.001
    }
    func tableView(_ tableView: UITableView, viewForHeaderInSection section: Int) -> UIView? {
        if section == 1 {
            let view = UIView(frame: CGRect(x: 0, y: 0, width: fullScreenWidth, height: 39))
            let lbl = UILabel(frame: CGRect(x: 15, y: 15, width: fullScreenWidth, height: 21))
            lbl.text = "选择商品"
            lbl.textColor = UIColor(named: "标题字颜色")
            lbl.font = UIFont.boldSystemFont(ofSize: 15)
            lbl.sizeToFit()
            view.addSubview(lbl)
            
            if rkSelectArr.count > 0 {
                let lbl2 = UILabel(frame: CGRect(x: lbl.frame.maxX + 5, y: 16, width: fullScreenWidth, height: 18.5))
                lbl2.text = "(共\(rkSelectArr.count)件)"
                lbl2.textColor = UIColor(named: "标题字颜色")
                lbl2.font = UIFont.boldSystemFont(ofSize: 13)
                view.addSubview(lbl2)
            }
            return view
        }
        return UIView()
    }
    
    func tableView(_ tableView: UITableView, heightForHeaderInSection section: Int) -> CGFloat {
        if section == 1 {
            if rkSelectArr.count > 0 {
                return 49
            }
            return 39
        }
        return 0.001
    }
    
    func numberOfSections(in tableView: UITableView) -> Int {
        return 2
    }
    
    func tableView(_ tableView: UITableView, numberOfRowsInSection section: Int) -> Int {
        if section == 0 {
            return titleArr.count
        }
        return rkSelectArr.count
    }
    func NewSelectWarehouseVCFinish(kuWeiArr: Array<ShopWarehouseDetailDataPositionModel>, data: InputInitInfoWareHouseResModel) {
        holderArr.insert(data.w_name!, at: 0)
        holderArr.remove(at: 1)
        if w_id != data.w_id {
            holderArr.insert("请选择库位", at: 1)
            holderArr.remove(at: 2)
            w_id = data.w_id
        }
        poiArr.removeAll()
        kuWeiArr.forEach { (item) in
            poiArr.append(item)
        }
        listView.reloadData()
    }
    
    func NewSelectItemVcSelect(datas: Array<InputInitInfoGoodsInfoModel>) {
        rkSelectArr.removeAll()
        datas.forEach { (model) in
            rkSelectArr.append(model)
        }
        listView.reloadData()
    }
    func GLASClose(view: GLAlertSelectView, selectnum: Int, selectArr: Array<Int>) {
        if view.tag == 2 {
            typeSelect = selectnum
        }else{
            selectIdx = selectnum
        }
        view.removeFromSuperview()
        glSelectView = nil
    }
    
    func GLAlertSelectViewClick(selectNum: Int, view: GLAlertSelectView) {
        if view.tag == 2 {
            typeSelect = selectNum
            holderArr.insert(rkTypeArr[typeSelect!], at: 2)
            holderArr.remove(at: 3)
        }else{
            selectIdx = selectNum
            let data = poiArr[selectIdx!]
            p_id = data.p_id
            holderArr.insert(data.p_name!, at: 1)
            holderArr.remove(at: 2)
        }
        glSelectView?.removeFromSuperview()
        glSelectView = nil
        listView.reloadData()
    }
    @IBAction func actionClick(_ sender: UIButton) {
    }
}
