//
//  NewSelectWarehouseVC.swift
//  GeliBusinessPlatform
//
//  Created by junye lu on 2020/6/3.
//  Copyright © 2020 junye lu. All rights reserved.
//

import UIKit
protocol NewSelectWarehouseVCDelegate {
    func NewSelectWarehouseVCFinish(kuWeiArr:Array<ShopWarehouseDetailDataPositionModel>,data:InputInitInfoWareHouseResModel)
}
class NewSelectWarehouseVC: BaseViewController ,UITableViewDelegate,UITableViewDataSource{
    var delegate:NewSelectWarehouseVCDelegate?
    var rkWareHouseArr:Array<InputInitInfoWareHouseResModel> = []

   
    @IBOutlet weak var listView: UITableView!
    @IBOutlet weak var searchBg: UIView!
    override func viewDidLoad() {
        super.viewDidLoad()
        navbar.title = "选择仓库"
        self.view.addSubview(navbar)
        SetTopFrame(view: searchBg, height: 0)
        
        listView.separatorStyle = .none
        listView.register(UINib(nibName: "WarehoseMangementCell", bundle: nil), forCellReuseIdentifier: "WarehoseMangementCell")
    }

    func tableView(_ tableView: UITableView, didSelectRowAt indexPath: IndexPath) {
        
        let UserToken = UserDefaults.standard.value(forKey: "user_token")
        let wModel = rkWareHouseArr[indexPath.row]
   
        WarehouseDetail(["user_token":UserToken as Any,"w_id":wModel.w_id as Any], success: { (data) in
            var arr:Array<ShopWarehouseDetailDataPositionModel> = []
            let model = data as! ShopWarehouseDetailModel
            model.data?.position_res?.forEach({ (item) in
                arr.append(item)
            })
            self.delegate?.NewSelectWarehouseVCFinish(kuWeiArr: arr, data: wModel)
            self.navigationController?.popViewController(animated: true)
        }) { (error) in
            
        }
    }
    
    func tableView(_ tableView: UITableView, cellForRowAt indexPath: IndexPath) -> UITableViewCell {
        let cell = tableView.dequeueReusableCell(withIdentifier: "WarehoseMangementCell") as! WarehoseMangementCell
        cell.tag = indexPath.row
        let data = rkWareHouseArr[cell.tag]
        cell.statusLbl.isHidden = false
        cell.nameLbl.text = data.w_name
        cell.kuCunLbl.text = "库存位" +  StringByInt(number: data.inventory_count!)
        cell.adrLbl.text = data.w_address
        switch data.w_type {
        case 0:
            //异常
            cell.statusLbl.isHidden = true
            break
        case 1:
            cell.statusLbl.backgroundColor = UIColor(named: "标题背景色")
            cell.statusLbl.alpha = 1
            break
        case 2:
            cell.statusLbl.backgroundColor = UIColor(named: "蓝色字体颜色")
            cell.statusLbl.alpha = 0.5
            break
        case 3:
            cell.statusLbl.backgroundColor = UIColor(named: "蓝色字体颜色")
            cell.statusLbl.alpha = 1
            break
        default:
            break
        }
        return cell
    }
    func tableView(_ tableView: UITableView, numberOfRowsInSection section: Int) -> Int {
        return rkWareHouseArr.count
    }
    func tableView(_ tableView: UITableView, heightForRowAt indexPath: IndexPath) -> CGFloat {
        return 94
    }
}
