//
//  NewCKVc.swift
//  GeliBusinessPlatform
//
//  Created by junye lu on 2020/6/3.
//  Copyright © 2020 junye lu. All rights reserved.
//

import UIKit
import LGButton

class NewCKVc: BaseViewController,UITableViewDelegate,UITableViewDataSource,CKNonGmCellDelegate,CKGmCellDelegate, PiCiXuanZeViewControllerDelegate,GLAlertSelectViewDelegate,NewSelectItemVcDelegate,GeliAlertTextViewDelegate{
    let UserToken = UserDefaults.standard.value(forKey: "user_token")
    var gmNumber:Int?
    
    var piCiArr:Array<Array<GetGoodBatchDataModel>>? = []
    
    let titleArr = ["出库类型：","出库时间："]
    var holderArr = ["请选择出库类型","时间"]
    var glSelectView:GLAlertSelectView?
    let ckTypeArr = ["销售","调出","报损","赠品","自用","生产使用","过期处理","用户试用","采购退货","其他"]
    var typeSelect:Int?
    
    var isGm = false
    var goods_id:Int?
    var sku_id:Int?
    var rkSelectArr:Array<InputInitInfoGoodsInfoModel> = []//产品选择
    var rkDatas:Array<InputInitInfoGoodsInfoModel> = []//产品
    
    var authArr:Array<String> = []//权限
    
    
    @IBAction func submitAction(_ sender: Any) {
        if holderArr.first == "请选择出库类型" {
            HUD.flash(.label("请选择出库类型"), delay: 1.2)
            return
        }
        if rkSelectArr.count == 0 {
            HUD.flash(.label("请选择出库商品"), delay: 1.2)
            return
        }
        if isGm == false {
            rkSelectArr.forEach { (model) in
                if model.chuKuLiang == nil {
                    HUD.flash(.label("请填写出库数量"), delay: 1.2)
                    return
                }
            }
        }else{
            for i in 0 ..< rkSelectArr.count {
                if piCiArr![i].count == 0 {
                    HUD.flash(.label("请选择商品批次"), delay: 1.2)
                    return
                }
            }
        }
        
        let alterView = GeliAlertTextView(frame: self.view.window!.bounds)
        alterView.delegate = self
        alterView.titleLbl.text = "请填写出库备注"
        alterView.placerLbl.text = "请填写出库备注..."
        self.view.window?.addSubview(alterView)
        
    }
    
    func sureGeliAlertTextViewAction(sender: String) {
        
        if isGm {//直接出库
            HUD.show(.progress)
            if sender.count == 0 {
                HUD.flash(.label("请填写备注"), delay: 1.2)
                return
            }
            var goodsInfoArr:Array<Any> = []
            for i in 0 ..< rkSelectArr.count {
                let item = rkSelectArr[i]
                var count = 0
                
                let pici = piCiArr![i]
                for data in pici {
                    count += data.chuHuoLiang!
                }
                
                var batchInfo:Array<Any> = []
                piCiArr!.forEach { (batchArr) in
                    batchArr.forEach { (model) in
                        let batch = [
                            "w_id":model.w_id as Any,
                            "p_id":model.p_id as Any,
                            "number":model.chuHuoLiang as Any,
                            "production_data":model.production_data as Any,
                            "shelf_life":model.shelf_life as Any,
                            "valid_date":model.valid_date as Any,
                            "batch_id":model.batch_id as Any,
                            "report_id":model.report_id as Any
                        ]
                        batchInfo.append(batch)
                    }
                }
                
                let goods = [
                    "goods_id":item.goods_id as Any,
                    "goods_name":item.goods_name as Any,
                    "goods_spec":item.spec_str as Any,
                    "sku_id":item.sku_id as Any,
                    "number":count as Any,
                    "batch_info":batchInfo as Any,
                ]
                goodsInfoArr.append(goods)
            }
            
            let dict = [
                "user_token":UserToken as Any,
                "o_type":typeSelect! + 1 as Any,
                "audit_remark":sender as Any,
                "goods_info":dataChangeString(sender: goodsInfoArr) as Any
            ]
            GoodsOutput(dict, success: { (data) in
                HUD.hide()
                HUD.flash(.labeledSubSuccess(subtitle: "出库成功"), delay: 1.2)
                self.navigationController?.popViewController(animated: true)
            }) { (error) in
                
            }
        }else{//提交申请
            
            var goodsInfoArr:Array<Any> = []
            rkSelectArr.forEach { (model) in
                let goods = [
                    "goods_id":model.goods_id as Any,
                    "goods_name":model.goods_name as Any,
                    "goods_spec":model.spec_str as Any,
                    "sku_id":model.sku_id as Any,
                    "number":model.chuKuLiang as Any
                ]
                goodsInfoArr.append(goods)
            }
            
            let dict = [
                "user_token":UserToken as Any,
                "o_type":typeSelect! + 1 as Any,
                "audit_remark":sender as Any,
                "goods_info":dataChangeString(sender: goodsInfoArr) as Any
            ]
            GoodsOutputApply(dict, success: { (data) in
                HUD.hide()
                HUD.flash(.labeledSubSuccess(subtitle: "申请成功"), delay: 1.2)
                self.navigationController?.popViewController(animated: true)
            }) { (error) in
                
            }
        }
    }
    
    
    
    func CKNonGmCellInputCount(sender: String, cell: CKNonGmCell) {
        //输入数据
        let num = sender as NSString
        let data = rkSelectArr[cell.tag]
        if num.integerValue == 0 {
            HUD.flash(.label("出库数量不低于1"), delay: 1.2)
            data.chuKuLiang = 1
            let idx = IndexPath(row: cell.tag, section: 1)
            listView.reloadRows(at: [idx], with: .none)
        }else{
            data.chuKuLiang = num.integerValue
        }
    }
    
    @IBOutlet weak var btmBtn: LGButton!
    @IBOutlet weak var btmLbl: UILabel!
    @IBOutlet weak var listView: UITableView!
    override func viewDidLoad() {
        super.viewDidLoad()
        navbar.title = "出库"
        self.view.addSubview(navbar)
        SetTopFrameView(view: listView, btmView: btmLbl)
        listView.separatorStyle = .none
        
        listView.register(UINib(nibName: "CKNonGmCell", bundle: nil), forCellReuseIdentifier: "CKNonGmCell")
        listView.register(UINib(nibName: "CRKBtnCell", bundle: nil), forCellReuseIdentifier: "CRKBtnCell")
        listView.register(UINib(nibName: "CKGmCell", bundle: nil), forCellReuseIdentifier: "CKGmCell")
        
        holderArr.insert(getTimeNow(), at: 1)
        holderArr.remove(at: 2)
        
        
        self.listView.isHidden = true
        self.btmLbl.isHidden = true
        self.btmBtn.isHidden = true
        HUD.flash(.progress)
        OutputInitInfo(["user_token":UserToken as Any,"p_id":0 as Any], success: { (data) in
            
            let model = data as! InputInitInfoModel
            
            model.data?.goods_info?.forEach({ (item) in
                if item.sku_id == self.sku_id {
                    self.rkSelectArr.append(item)
                }
                self.rkDatas.append(item)
                self.piCiArr?.append([])
            })
            
            model.data?.auth?.forEach({ (str) in
                self.authArr.append(str)
            })
            
            
            if self.authArr.contains("64") == false && self.authArr.contains("66") == false {
                self.listView.isHidden = true
                self.btmLbl.isHidden = true
                self.btmBtn.isHidden = true
                HUD.flash(.label("亲，您不具备编辑的权限"), delay:1.2)
                return
            }
            if self.gmNumber != nil{//入库申请
                var pass = false
                self.authArr.forEach { (str) in
                    if str == "\(self.gmNumber!)"{
                        self.btmLbl.text = "提交申请"
                        pass = true
                    }
                }
                if pass == false {
                    self.listView.isHidden = true
                    self.btmBtn.isHidden = true
                    self.btmLbl.isHidden = true
                    HUD.flash(.label("亲，您不具备编辑的权限"), delay:1.2)
                    return
                }
            }else{
                self.btmLbl.text = "提交申请"
                if self.authArr.contains("64"){
                    self.isGm = true
                    self.btmLbl.text = "直接出库"
                }
            }
            self.listView.reloadData()
            self.listView.isHidden = false
            self.btmLbl.isHidden = false
            self.btmBtn.isHidden = false
            HUD.hide()
        }) { (error) in
            
        }
    }
    //添加商品
    @objc func addProduct(){
        let vc = NewSelectItemVc()
        vc.delegate = self
        vc.rkDatas = rkDatas
        vc.rkSelectArr = rkSelectArr
        self.navigationController?.pushViewController(vc, animated: true)
    }
    //MARK: - cell delegate
    func tableView(_ tableView: UITableView, cellForRowAt indexPath: IndexPath) -> UITableViewCell {
        
        if indexPath.section == 1 {
            
            if isGm  {
                let cell = tableView.dequeueReusableCell(withIdentifier: "CKGmCell") as! CKGmCell
                cell.tag = indexPath.row
                let data = rkSelectArr[cell.tag]
                cell.delegate = self
                cell.nameLbl.text = data.goods_name
                cell.detailLbl.text = data.spec_str
                
                let arr = piCiArr?[cell.tag]
                if arr!.count > 0 {
                    cell.dataArr = arr
                    cell.titleView.alpha = 1
                    cell.titleView.isHidden = false
                    cell.titleViewH.constant = 35
                    cell.listBg.isHidden = false
                    cell.listBg.alpha = 1
                }else{
                    cell.listBg.isHidden = true
                    cell.titleView.isHidden = true
                    cell.titleViewH.constant = 0
                    cell.titleView.alpha = 0
                    cell.listBg.alpha = 0
                }
                return cell
            }
            
            let cell = tableView.dequeueReusableCell(withIdentifier: "CKNonGmCell") as! CKNonGmCell
            cell.tag = indexPath.row
            let data = rkSelectArr[cell.tag]
            cell.delegate = self
            cell.nameLbl.text = data.goods_name
            cell.detailLbl.text = data.spec_str
            if data.chuKuLiang != nil {
                cell.ckCountTf.text = "\(data.chuKuLiang!)"
            }else{
                cell.ckCountTf.text = "1"
                data.chuKuLiang = 1
            }
            return cell
            
        }
        
        let cell = tableView.dequeueReusableCell(withIdentifier: "CRKBtnCell") as! CRKBtnCell
        cell.tag = indexPath.row
        cell.nameLbl.text = titleArr[indexPath.row]
        cell.contentLbl.text = holderArr[indexPath.row]
        cell.mustLbl.isHidden = true
        cell.mustWidth.constant = 0
        cell.nameLeft.constant = 0
        if indexPath.row == 1 {
            setCellUI(cell: cell)
        }
        return cell
    }
    func tableView(_ tableView: UITableView, heightForRowAt indexPath: IndexPath) -> CGFloat {
        if indexPath.section == 0 {
            return 49
        }
        if isGm {
            let arr = piCiArr![indexPath.row]
            if arr.count > 0 {
                return CGFloat(125 + arr.count * 30 + 35)
            }else{
                return 125
            }
            
        }
        return 139
    }
    func setCellUI(cell:CRKBtnCell){
        cell.contentLbl.textColor = UIColor(named: "标题字颜色")
        cell.arrowImg.isHidden = true
        cell.contentRight.constant = -7
        
    }
    func tableView(_ tableView: UITableView, viewForFooterInSection section: Int) -> UIView? {
        if section == 0 {
            let view = UIView(frame: CGRect(x: 0, y: 0, width: fullScreenWidth, height: 10))
            view.backgroundColor = UIColor(named: "app底色")
            return view
        }
        let view = UIView(frame: CGRect(x: 0, y: 0, width: fullScreenWidth, height: 147.5))
        let img = UIImageView()
        view.addSubview(img)
        img.image = UIImage(named: "tianjiashangpin")
        img.snp.makeConstraints { (make) in
            make.top.equalTo(30)
            make.width.height.equalTo(52)
            make.centerX.equalTo(view.snp_centerX)
        }
        let btn = UIButton()
        view.addSubview(btn)
        btn.snp.makeConstraints { (make) in
            make.top.left.right.bottom.equalTo(0)
        }
        btn.addTarget(self, action: #selector(addProduct), for: .touchUpInside)
        return view
    }
    
    func tableView(_ tableView: UITableView, heightForFooterInSection section: Int) -> CGFloat {
        if section == 0 {
            return 10
        }
        return 147.5
    }
    func tableView(_ tableView: UITableView, viewForHeaderInSection section: Int) -> UIView? {
        if section == 1 {
            let view = UIView(frame: CGRect(x: 0, y: 0, width: fullScreenWidth, height: 39))
            let lbl = UILabel(frame: CGRect(x: 15, y: 15, width: fullScreenWidth, height: 21))
            lbl.text = "选择商品"
            lbl.textColor = UIColor(named: "标题字颜色")
            lbl.font = UIFont.boldSystemFont(ofSize: 15)
            lbl.sizeToFit()
            view.addSubview(lbl)
            
            if rkSelectArr.count > 0 {
                let lbl2 = UILabel(frame: CGRect(x: lbl.frame.maxX + 5, y: 16, width: fullScreenWidth, height: 18.5))
                lbl2.text = "(共\(rkSelectArr.count)件)"
                lbl2.textColor = UIColor(named: "标题字颜色")
                lbl2.font = UIFont.boldSystemFont(ofSize: 13)
                view.addSubview(lbl2)
            }
            return view
        }
        return UIView()
    }
    
    func tableView(_ tableView: UITableView, heightForHeaderInSection section: Int) -> CGFloat {
        if section == 1 {
            if rkSelectArr.count > 0 {
                return 49
            }
            return 39
        }
        return 0.001
    }
    
    func numberOfSections(in tableView: UITableView) -> Int {
        return 2
    }
    func tableView(_ tableView: UITableView, numberOfRowsInSection section: Int) -> Int {
        if section == 0 {
            return 2
        }
        return rkSelectArr.count
    }
    func tableView(_ tableView: UITableView, didSelectRowAt indexPath: IndexPath) {
        if indexPath.section == 0 {
            if indexPath.row == 0 {
                if glSelectView == nil {
                    let view = GLAlertSelectView(frame: self.view.bounds)
                    view.tag = indexPath.row
                    if typeSelect != nil {
                        view.selectNum = typeSelect
                        view.tempNum = view.selectNum
                    }
                    view.isOnlySelectKuWei = true
                    view.delegate = self
                    view.titleLbl.text = "请选择出库类型"
                    view.dataArr = ckTypeArr
                    self.view.addSubview(view)
                    glSelectView = view
                }
            }
        }
    }
    func GLAlertSelectViewClick(selectNum: Int, view: GLAlertSelectView) {
        
        typeSelect = selectNum
        holderArr.insert(ckTypeArr[typeSelect!], at: 0)
        holderArr.remove(at: 1)
        
        glSelectView?.removeFromSuperview()
        glSelectView = nil
        listView.reloadData()
    }
    func NewSelectItemVcSelect(datas: Array<InputInitInfoGoodsInfoModel>) {
        rkSelectArr.removeAll()
        datas.forEach { (item) in
            rkSelectArr.append(item)
        }
        listView.reloadData()
    }
    
    
    func PiCiXuanZeViewControllerPiCiSelect(data: Array<GetGoodBatchDataModel>, p_id: Int) {
        print(data.count)
        piCiArr?.insert(data, at: p_id)
        piCiArr?.remove(at: p_id + 1)
        listView.reloadData()
    }
    
    //MARK: - 普通流程
    func CKNonGmCellDelAction(cell: CKNonGmCell) {
        //删除
        rkSelectArr.remove(at: cell.tag)
        listView.reloadData()
    }
    //MARK: - 权限操作
    func CKGmCellDelAction(cell: CKGmCell) {
        //删除
        piCiArr?.remove(at: cell.tag)
        piCiArr?.append([])
        
        rkSelectArr.remove(at: cell.tag)
        listView.reloadData()
    }
    func CKGmCellSelectAction(cell: CKGmCell) {
        //跳转选择批次
        let data = rkSelectArr[cell.tag]
        let vc = PiCiXuanZeViewController()
        vc.sku_id = data.sku_id
        vc.delegate = self
        vc.tag = cell.tag
        if piCiArr!.count > 0 {
            let arr = piCiArr![cell.tag]
            vc.recordArr = arr
        }
        self.navigationController?.pushViewController(vc, animated: true)
    }
    func GLASClose(view: GLAlertSelectView, selectnum: Int, selectArr: Array<Int>) {
        
        typeSelect = selectnum
        
        view.removeFromSuperview()
        glSelectView = nil
    }
}
