//
//  PersonCenterViewController.swift
//  GeliBusinessPlatform
//
//  Created by junye lu on 2020/4/16.
//  Copyright © 2020 junye lu. All rights reserved.
//

import UIKit
import Photos
import Alamofire
import SwiftDate
class PersonCenterViewController: BaseViewController,UITableViewDelegate,UITableViewDataSource {
    @IBOutlet weak var editBtn: UIButton!
    
    @IBOutlet weak var shopNameLbl: UILabel!
    @IBOutlet weak var iconImg: UIImageView!
    @IBOutlet weak var nameLbl: UILabel!
    @IBOutlet weak var topBgImg: UIImageView!
    @IBOutlet weak var topImgBg: UIImageView!
    @IBOutlet weak var listView: UITableView!
    var dataModel : AdminInfoModel? = nil
    let listArray = ["格利支付","蓝牙打印设置","权限设置"]
    //MARK:--加载数据
    
    func loadData(){
        let UserToken = UserDefaults.standard.value(forKey: "user_token")
        HUD.flash(.progress)
        adminInfo(["user_token":UserToken as Any], success: { (data) in
            HUD.hide()
            self.dataModel = (data as! AdminInfoModel)
//            self.iconImg.sd_setImage(with:  URL(string: SERVERCE_ImageHost + (self.dataModel?.data?.shop_img)!), placeholderImage: UIImage.init(named: "个人设置头像"))
            self.shopNameLbl.text = self.dataModel?.data?.stall_name
            self.nameLbl.text = self.nowDateStr()
        }) { (error) in
            
        }
    }
    func nowDateStr() -> String {
        let date  = Date() + 8.hours
 
        if date.compare(.isMorning) {
            return "Hi~早上好！" + (dataModel?.data?.shop_name!)!
        }else if date.compare(.isAfternoon) {
            return "Hi~下午好！" + (dataModel?.data?.shop_name!)!
        }else if date.compare(.isEvening) {
            return "Hi~傍晚好！" + (dataModel?.data?.shop_name!)!
        }else if date.compare(.isNight) {
            return "Hi~深夜了！" + (dataModel?.data?.shop_name!)!
        }
        return ""
    }
    override func viewWillAppear(_ animated: Bool) {
        super.viewWillAppear(animated)
        loadData()
    }
    override func viewDidLoad() {
        super.viewDidLoad()
        topImgBg.snp.makeConstraints { (make) in
            make.top.left.right.equalTo(0)
            make.height.equalTo(227*glscale)
        }
        topBgImg.snp.makeConstraints { (make) in
            make.bottom.equalTo(topImgBg.snp_top)
            make.left.right.equalTo(0)
            make.height.equalTo(60)
        }

        listView.delegate = self
        listView.dataSource = self
        listView.isScrollEnabled = false
        listView.separatorStyle = .none
        listView.snp.makeConstraints { (make) in
            make.top.equalTo(iconImg.snp_bottom).offset(30)
            make.left.equalTo(15)
            make.right.equalTo(-15)
            make.height.equalTo(listArray.count * 50)
        }
        listView?.register(UINib(nibName: "PersonCenterCell", bundle: nil), forCellReuseIdentifier: "listCell")
        // Do any additional setup after loading the view.
        
        let btn = UIButton()
        self.view.addSubview(btn)
        btn.snp.makeConstraints { (make) in
            make.centerY.equalTo(editBtn.snp.centerY)
            make.left.equalTo(15)
            make.height.width.equalTo(17)
        }
        btn.setImage(UIImage(named: "xiaoxi"), for: .normal)
        btn.addTarget(self, action: #selector(toMsgCenterAction(_:)), for: .touchUpInside)
        /*
         自适应字体大小后重新编辑背景框
         shopNameLbl.text = "123"
         shopNameLbl.sizeToFit()
         shopNameLbl.snp.makeConstraints { (make) in
         make.left.equalTo(nameLbl.snp_left)
         make.top.equalTo(nameLbl.snp_bottom).offset(10)
         make.width.equalTo(shopNameLbl.frame.size.width+8)
         make.height.equalTo(20)
         }
         */
        NotificationCenter.default.addObserver(self, selector: #selector(jpushServiceNotification(notion:)), name: NSNotification.Name(rawValue: "jpushServiceNotification4"), object: nil)
        
    }
    //MARK:--jpushServiceNotification
    @objc func jpushServiceNotification(notion:Notification) {
        let dict = notion.userInfo! as NSDictionary
         print("123123 ==",dict.allKeys)
        let vc = MsgCenterViewController()
        self.navigationController?.pushViewController(vc, animated: true)
    }
    //MARK: -方法
    @IBAction func editAction(_ sender: Any) {
        print("编辑资料")
        if self.dataModel == nil {
            return
        }
        let vc = AccountViewController()
        vc.dataModel = self.dataModel
        self.navigationController?.pushViewController(vc, animated: true)
        
    }
    //MARK:--跳转消息中心
    @objc func toMsgCenterAction(_ sender: Any) {
        print("跳转消息中心")
        
        let vc = MsgCenterViewController()
        self.navigationController?.pushViewController(vc, animated: true)
    }
    
    //MARK: -Cell delegate方法
    func tableView(_ tableView: UITableView, didSelectRowAt indexPath: IndexPath) {
        print(indexPath.row)
        if indexPath.row == 0 {
            //格利支付
            let vc = PayViewController()
            self.navigationController?.pushViewController(vc, animated: true)
        }else if indexPath.row == 1 {
            //蓝牙设置
            let vc = BluetoothConnectViewController()
            self.navigationController?.pushViewController(vc, animated: true)
        }else if indexPath.row == 2{
            //权限设置-弹窗
            HUD.flash(.label("权限设置开发中"), delay: 1.2)
   
        }
    }
    
    func tableView(_ tableView: UITableView, heightForRowAt indexPath: IndexPath) -> CGFloat {
        return 50
    }
    func tableView(_ tableView: UITableView, numberOfRowsInSection section: Int) -> Int {
        return listArray.count
    }
    
    func tableView(_ tableView: UITableView, cellForRowAt indexPath: IndexPath) -> UITableViewCell {
        var cell = tableView.dequeueReusableCell(withIdentifier: "listCell") as! PersonCenterCell
        cell.titleLbl.text = listArray[indexPath.row]
        return cell
    }
    
}
