//
//  WarehoseMangementListVC.swift
//  GeliBusinessPlatform
//
//  Created by 刘俊宏 on 2020/4/25.
//  Copyright © 2020 junye lu. All rights reserved.
//

import UIKit
import ViewAnimator
import SwipeCellKit
protocol WarehoseMangementListVCDelegate {
    func WarehoseMangementListVCSelectFinish(sender:ShopWarehouseListDataModel,kuWeiArr:Array<ShopWarehouseDetailDataPositionModel>)
}
class WarehoseMangementListVC: BaseViewController, UISearchBarDelegate, UITableViewDelegate, UITableViewDataSource, SearchBarViewDelegate,SwipeTableViewCellDelegate,CheckWareHourseViewControllerDelegate{
    func CheckWareHourseViewControllerRefresh() {
        tableV.mj_header?.beginRefreshing()
    }
    var delegate:WarehoseMangementListVCDelegate?
     let UserToken = UserDefaults.standard.value(forKey: "user_token")
    @IBOutlet weak var topBgView: UIView!
    weak var searchV: SearchBarView? = nil
    @IBOutlet weak var contentView: UIView!
    @IBOutlet weak var searchView: UIView!
    var page : Int = 0
    var isUpData = false
    var keyWord = ""
    var isSelectWarehouse = false
    override func viewDidLoad() {
        super.viewDidLoad()
        self.view.backgroundColor = UIColor.white
        //searchbar
        let searchBr = SearchBarView.init()
        searchV = searchBr
        self.searchView.addSubview(searchBr)
        searchBr.snp.makeConstraints { (make) in
            make.left.equalTo(0)
            make.right.equalTo(0)
            make.centerY.equalToSuperview()
            make.height.equalTo(35)
        }
        if isSelectWarehouse{
            navbar.title = "仓库选择"
            self.view.addSubview(navbar)
            SetTopFrame(view: topBgView, height: 45)
        }
        
        
        searchBr.delegateL = self
        searchBr.placeholderStr = "请输入仓库名称"
        searchBr.cornerRadius = 35/2.0
        searchBr.delegate = self
        setTabv()
        
        headerMJ.setRefreshingTarget(self, refreshingAction: #selector(loadData))
        self.tableV!.mj_header = headerMJ
        //上拉加载相关设置
        footerMJ.setRefreshingTarget(self, refreshingAction: #selector(loadMoreData))
        self.tableV!.mj_footer = footerMJ
        self.tableV?.mj_header?.beginRefreshing()
        NotificationCenter.default.addObserver(self, selector: #selector(jpushServiceNotification(notion:)), name: NSNotification.Name(rawValue: "jpushServiceNotification3"), object: nil)
        
    }
    //MARK:--jpushServiceNotification
    @objc func jpushServiceNotification(notion:Notification) {
        let dict = notion.userInfo! as NSDictionary
         print("123123 ==",dict.allKeys)
        let vc = MsgCenterViewController()
        self.navigationController?.pushViewController(vc, animated: true)
    }
    @objc func loadData(){
        print("加载数据")
        isUpData = true
        page = 1
       
        let dict = ["user_token":UserToken as Any,"keyword":keyWord,"page":page]
        warehouseList(dict, success: { (data) in
            self.warehourseArr.removeAll()
            let dataModel = data as! ShopWarehouseListModel
            dataModel.data?.forEach({ (model) in
                self.warehourseArr.append(model)
            })
            self.tableV.reloadData()
            self.tableV?.mj_header?.endRefreshing()
            self.page = 2
            self.tableV.performBatchUpdates({
                UIView.animate(views: self.tableV!.visibleCells,
                               animations: self.animations, completion: {
                                
                })
            }, completion: nil)
        }) { (error) in
            self.tableV?.mj_header?.endRefreshing()
        }
    }
    
    
    
    @objc func loadMoreData(){
        print("加载更多数据")
        
        let dict = ["user_token":UserToken as Any,"keyword":keyWord,"page":page]
        warehouseList(dict, success: { (data) in
            
            let dataModel = data as! ShopWarehouseListModel
            if dataModel.data!.count > 0 {
                self.page += 1
                dataModel.data?.forEach({ (model) in
                    self.warehourseArr.append(model)
                })
                self.tableV.reloadData()
                self.tableV?.mj_footer?.endRefreshing()

            }else{
                self.tableV?.mj_footer?.endRefreshingWithNoMoreData()
            }
        }) { (error) in
            self.tableV?.mj_footer?.endRefreshing()
        }
    }
    //MARK:--搜索按钮代理
    func searchBarSearchButtonClicked(_ searchBar: UISearchBar) {
        print("点击搜索进行--")
        searchBar.resignFirstResponder()
        keyWord = searchBar.text!
 
        if blackBtnView != nil {
            blackBtnView.removeFromSuperview()
        }
        self.tableV.mj_header?.beginRefreshing()
    }
    //MAKR:--调起搜索后添加个蒙版本
    var blackBtnView:UIButton! = nil
    func searchBarShouldBeginEditing(_ searchBar: UISearchBar) -> Bool {
        print("调起搜索后添加个蒙版本")
        blackBtnView = UIButton ()
        blackBtnView.backgroundColor = UIColor.init(named: "提示视图背景色")
        contentView.addSubview(blackBtnView)
        blackBtnView.snp.makeConstraints { (make) in
            make.left.right.top.bottom.equalToSuperview()
        }
        blackBtnView.addTarget(self, action: #selector(removeBlackBtnView), for: .touchUpInside)
        return true
    }
    @objc func removeBlackBtnView(){
        if blackBtnView != nil {
            blackBtnView.removeFromSuperview()
            searchV!.resignFirstResponder()
        }
    }
    //MARK:--清除搜索代理
    func clearSearchAction() {
        keyWord = ""
        self.loadData()
    }
    func searchBarTextDidEndEditing(_ searchBar: UISearchBar) {
        print("编辑即将结束了--")
        removeBlackBtnView()
    }
    //MARK:--新增代理
    @IBAction func addNewWarehose(_ sender: UIButton) {
        print("点击新增--")
        if blackBtnView != nil {
            blackBtnView.removeFromSuperview()
            searchV!.resignFirstResponder()
        }
        let vc = CheckWareHourseViewController()
        vc.titleStr = "新增仓库"
        vc.delegate = self
        
        self.navigationController?.pushViewController(vc, animated: true)
    }
    
    var warehourseArr:Array<ShopWarehouseListDataModel> = []//仓库数组
    
    var tableV :UITableView!

    private let animations = [AnimationType.from(direction: .bottom, offset: 150*glscale)]
    
    func setTabv() {
        tableV = UITableView()
        contentView.addSubview(tableV);
        tableV.snp.makeConstraints { (make) in
            make.top.left.right.bottom.equalToSuperview()
        }
        tableV.delegate = self
        tableV.dataSource = self
        tableV.separatorStyle = .none
        tableV?.register(UINib(nibName: "WarehoseMangementCell", bundle: nil), forCellReuseIdentifier: "WarehoseMangementCell")
        tableV.performBatchUpdates({
            UIView.animate(views: self.tableV!.visibleCells,
                           animations: self.animations, completion: {
                            
            })
        }, completion: nil)
        
    }
    let typeArr = ["","常温","冷藏","冷冻"]
    func tableView(_ tableView: UITableView, cellForRowAt indexPath: IndexPath) -> UITableViewCell {
        let cell = tableView.dequeueReusableCell(withIdentifier: "WarehoseMangementCell") as! WarehoseMangementCell
        cell.delegate = self
        let model = warehourseArr[indexPath.row]
        cell.nameLbl.text = model.w_name
        cell.statusLbl.text = typeArr[model.w_type!]
        cell.statusLbl.isHidden = false
        cell.adrLbl.text = model.w_address!
        cell.kuCunLbl.text = "库存位" + StringByInt(number: model.inventory_count!)
        switch model.w_type {
        case 0:
            //异常
            cell.statusLbl.isHidden = true
            break
        case 1:
            cell.statusLbl.backgroundColor = UIColor(named: "标题背景色")
            cell.statusLbl.alpha = 1
            break
        case 2:
            cell.statusLbl.backgroundColor = UIColor(named: "蓝色字体颜色")
            cell.statusLbl.alpha = 0.5
            break
        case 3:
            cell.statusLbl.backgroundColor = UIColor(named: "蓝色字体颜色")
            cell.statusLbl.alpha = 1
            break
        default:
            break
        }
        return cell
    }
    func tableView(_ tableView: UITableView, didSelectRowAt indexPath: IndexPath) {
        
        if isSelectWarehouse {
            let model = warehourseArr[indexPath.row]
            
            WarehouseDetail(["user_token":UserToken as Any,"w_id":model.w_id as Any], success: { (data) in
                var arr:Array<ShopWarehouseDetailDataPositionModel> = []
                let mo = data as! ShopWarehouseDetailModel
                mo.data?.position_res?.forEach({ (item) in
                    arr.append(item)
                })
                self.delegate?.WarehoseMangementListVCSelectFinish(sender: model, kuWeiArr: arr)
                self.navigationController?.popViewController(animated: true)
            }) { (error) in
                
            }

        }else{
            let vc = CheckWareHourseViewController()
            vc.titleStr = "编辑仓库"
            let model = warehourseArr[indexPath.row]
            vc.w_id = model.w_id
            vc.editIdx = indexPath.row
            vc.delegate = self
            
            self.navigationController?.pushViewController(vc, animated: true)
        }
    }
    
    func tableView(_ tableView: UITableView, heightForRowAt indexPath: IndexPath) -> CGFloat {
        return 94*glscale
    }
    
    //MARK:- 左滑删除
    func tableView(_ tableView: UITableView,
                   editActionsOptionsForRowAt indexPath: IndexPath,
                   for orientation: SwipeActionsOrientation) -> SwipeTableOptions {
        var options = SwipeTableOptions()
        options.transitionStyle = .border //变化样式（使用默认的不变）
        options.expansionStyle = .selection //展开样式（默认为.none）
        return options
    }
    func tableView(_ tableView: UITableView, editActionsForRowAt indexPath: IndexPath, for orientation: SwipeActionsOrientation) -> [SwipeAction]? {
        
        //创建“删除”事件按钮
        let deleteAction = SwipeAction(style: .destructive, title: nil) {
            action, indexPath in
            //将对应条目的数据删除
            
            let model = self.warehourseArr[indexPath.row]
            ShopWarehouseDel(["user_token":self.UserToken as Any,"w_id":model.w_id as Any], success: { (data) in
                let md = data as! UpDataModel
                if md.code == 1 {
                    self.warehourseArr.remove(at: indexPath.row)
                    tableView.reloadData()
                }

            }) { (error) in
                
            }
            
        }
        deleteAction.image = UIImage(named: "shanchuWhite")
        deleteAction.backgroundColor = UIColor(named: "#F57575")
        //返回右侧事件按钮
        return [deleteAction,]
    }
    func tableView(_ tableView: UITableView, numberOfRowsInSection section: Int) -> Int {
 
        return warehourseArr.count
    }
}
