//
//  XiaDanChengGongViewController.swift
//  GeliBusinessPlatform
//
//  Created by junye lu on 2020/4/30.
//  Copyright © 2020 junye lu. All rights reserved.
//

import UIKit

class XiaDanChengGongViewController: BaseViewController,UITableViewDelegate,UITableViewDataSource,BtmBtnCellDelegate {
    
    
    var orderID:String?
    var dataModel:logisticsOrderDetailsDataModel?
    
    @IBOutlet weak var listView: UITableView!
    override func viewDidLoad() {
        super.viewDidLoad()
        
        navbar.title = "下单成功"
        self.view.addSubview(navbar)
        
        SetTopFrame(view: listView, height: fullScreenHeight - NavCGRect.height)
        listView.separatorStyle = .none
        
        listView.register(UINib(nibName: "ChengGongCell", bundle: nil), forCellReuseIdentifier: "ChengGongCell")
        listView.register(UINib(nibName: "TitleAndTFCell", bundle: nil), forCellReuseIdentifier: "TitleAndTFCell")
        listView.register(UINib(nibName: "XiaDanCGDiZhiCell", bundle: nil), forCellReuseIdentifier: "XiaDanCGDiZhiCell")
        listView.register(UINib(nibName: "JiBenXinXiCell", bundle: nil), forCellReuseIdentifier: "JiBenXinXiCell")
        listView.register(UINib(nibName: "BtmBtnCell", bundle: nil), forCellReuseIdentifier: "BtmBtnCell")
        
        loadData()        
    }
    func loadData(){
        let UserToken = UserDefaults.standard.value(forKey: "user_token")
        HUD.flash(.progress)
        listView.isHidden = true
        
        logisticsOrderDetails(["user_token":UserToken as Any,"id":orderID as Any], success: { (data) in
            HUD.hide()
            
            let model = data as! logisticsOrderDetailsModel
            self.dataModel = model.data
            
            self.listView.isHidden = false
            self.listView.reloadData()
        }) { (error) in
            
        }
    }
    //MARK: - CELL DELEGATE
    func tableView(_ tableView: UITableView, heightForHeaderInSection section: Int) -> CGFloat {
        switch section {
        case 0,1:return 0.001
        default:
            return 36
        }
    }
    
    func tableView(_ tableView: UITableView, viewForHeaderInSection section: Int) -> UIView? {
        switch section {
        case 0,1:return UIView()
        default:
            let view = UIView(frame: CGRect(x: 0, y: 0, width: fullScreenWidth, height: 36))
            view.backgroundColor = UIColor.white
            let lbl = UILabel()
            lbl.text = "货物信息"
            lbl.textColor = UIColor(named: "标题字颜色")
            lbl.font = UIFont.boldSystemFont(ofSize: 15)
            view.addSubview(lbl)
            lbl.snp.makeConstraints { (make) in
                make.top.left.right.equalTo(15)
                make.height.equalTo(21)
            }
            return view
        }
    }
    func tableView(_ tableView: UITableView, viewForFooterInSection section: Int) -> UIView? {
        return UIView()
    }
    func tableView(_ tableView: UITableView, heightForFooterInSection section: Int) -> CGFloat {
        return 10
    }
    func numberOfSections(in tableView: UITableView) -> Int {
        if dataModel == nil {
            return 0
        }
        return 3
    }
    func tableView(_ tableView: UITableView, numberOfRowsInSection section: Int) -> Int {
        if dataModel == nil {
            return 0
        }
        switch section {
        case 0:return 3
        case 1:return 5
        default:return 10
        }
    }
    func tableView(_ tableView: UITableView, heightForRowAt indexPath: IndexPath) -> CGFloat {
        switch indexPath.section {
        case 0:
            if indexPath.row == 0 {
                return 136.5
            }
            return 64.5
        case 1:
            if indexPath.row == 0 {
                return 84.5
            }
            return 30
        default:
            if indexPath.row == 8{
                return UITableView.automaticDimension
            }
            if indexPath.row == 9 {
                return 108.5
            }
            return 30
        }
    }
    let p2Arr = ["关联平台：","关联订单号：","运费：","运费支付方式："]
    let p3Arr = ["寄托物：","总重量：","总件数：","体积：","温控范围：","寄件方式：","派件方式：","保价（元人民币）：","备注：","0"]
    func tableView(_ tableView: UITableView, cellForRowAt indexPath: IndexPath) -> UITableViewCell {
        switch indexPath.section {
        case 0:
            if indexPath.row == 0 {
                let cell = tableView.dequeueReusableCell(withIdentifier: "ChengGongCell") as! ChengGongCell
                return cell
            }
            let cell = tableView.dequeueReusableCell(withIdentifier: "XiaDanCGDiZhiCell") as! XiaDanCGDiZhiCell
            cell.statusLbl.text = "寄"
            cell.namelbl.text = dataModel?.s_consignee
            cell.phoneLbl.text = dataModel?.s_mobile
            cell.adrLbl.text = dataModel?.s_address
            
            if indexPath.row == 2 {
                cell.statusLbl.backgroundColor = UIColor(named: "企业、预售字体")
                cell.statusLbl.text = "收"
                
                cell.namelbl.text = dataModel?.r_consignee
                cell.phoneLbl.text = dataModel?.r_mobile
                cell.adrLbl.text = dataModel?.r_address
            }
            
            return cell
        case 1:
            if indexPath.row == 0 {
                let cell = tableView.dequeueReusableCell(withIdentifier: "JiBenXinXiCell") as! JiBenXinXiCell
                
                cell.orderStatusLbl.text = dataModel?.delivery_status_cn
                cell.payStatusLbl.text = dataModel?.pay_status_cn
                
                
                return cell
            }
            
            let cell = tableView.dequeueReusableCell(withIdentifier: "TitleAndTFCell") as! TitleAndTFCell
            cell.nameLbl.text = p2Arr[indexPath.row-1]
            
            var arrStr:[String] = []
            arrStr.append((dataModel?.sale_plat)!)
            arrStr.append((dataModel?.order_sn)!)
            arrStr.append(String(format: "%.2f", (dataModel?.freight_pre)!))
            arrStr.append((dataModel?.fc_flag_cn)!)
            
            cell.textTF.text = arrStr[indexPath.row-1]
            
            cell.textTF.isUserInteractionEnabled = false
            cell.line.isHidden = true
            return cell
            
        default:
            if indexPath.row == 9 {
                let cell = tableView.dequeueReusableCell(withIdentifier: "BtmBtnCell") as! BtmBtnCell
                cell.delegate = self
                return cell
            }
            let cell = tableView.dequeueReusableCell(withIdentifier: "TitleAndTFCell") as! TitleAndTFCell
            cell.textTF.isUserInteractionEnabled = false
            cell.line.isHidden = true
            cell.nameLbl.text = p3Arr[indexPath.row]
            
            var arrStr:[String] = []
            arrStr.append((dataModel?.express_item_name)!)
            arrStr.append(String(format: "%.2f", (dataModel?.weight)!))
            arrStr.append(StringByInt(number: (dataModel?.express_item_qty)!))
            arrStr.append(String(format: "%.2f", (dataModel?.volume)!))
            arrStr.append((dataModel?.tempture_num)!)
            arrStr.append((dataModel?.home_delivery_on_cn)!)
            arrStr.append((dataModel?.site_delivery_cn)!)
            arrStr.append(String(format: "%.2f", (dataModel?.guarantee_value)!))
            arrStr.append((dataModel?.remark)!)
            
            cell.textTF.text = arrStr[indexPath.row]
            return cell
        }
    }
    
    func selectBtmBtnCellBy(index: Int) {
        switch index {
        case 0:
            let vc = XiaYunDanViewController()
            self.navigationController?.pushViewController(vc, animated: true)
        case 1:
            let vc = YunDanXiangQingViewController()
            self.navigationController?.pushViewController(vc, animated: true)
        case 2:
            let vc = YDLBVc()
            self.navigationController?.pushViewController(vc, animated: true)
        default:
            break
        }
    }
    
}
