//
//  JiTuoWuXinXiView.swift
//  GeliBusinessPlatform
//
//  Created by junye lu on 2020/4/24.
//  Copyright © 2020 junye lu. All rights reserved.
//

import UIKit
protocol JiTuoWuXinXiViewDelegate {
    func JiTuoWuXinXiViewClose()
    func JiTuoWuXinXiViewSubmit(itemName:String,tiJi:Float,weight:Float,count:Int,isCheck:Bool,chang:String?,kuang:String?,gao:String?)
}
class JiTuoWuXinXiView: UIView,UITextFieldDelegate{
    var contentView:UIView!
    var delegate:JiTuoWuXinXiViewDelegate?
    @IBOutlet weak var infoSw: UISwitch!
    @IBOutlet weak var bottomView: UIView!
    
    @IBAction func closeAction(_ sender: Any) {
        delegate?.JiTuoWuXinXiViewClose()
    }
    @IBOutlet weak var countTf: UITextField!
    @IBOutlet weak var weightTf: UITextField!
    @IBOutlet weak var gaoTf: UITextField!
    @IBOutlet weak var kuanTf: UITextField!
    @IBOutlet weak var changTf: UITextField!
    @IBAction func jiaJianMethod(_ sender: UIButton) {
        
        switch sender.tag {
        case 0:
            changTf.text = ""
            kuanTf.text = ""
            gaoTf.text = ""
            var str = tiJiTF.text as! NSString
            str = "\(str.integerValue + 1)" as NSString
            tiJiTF.text = str as String
            break
        case 1:
            changTf.text = ""
            kuanTf.text = ""
            gaoTf.text = ""
            var str = tiJiTF.text as! NSString
            if str.integerValue > 1 {
                str = "\(str.integerValue - 1)" as NSString
                tiJiTF.text = str as String
            }
            break
        case 2:
            var str = countTf.text as! NSString
            str = "\(str.integerValue + 1)" as NSString
            countTf.text = str as String
            break
        default:
            var str = countTf.text as! NSString
            if str.integerValue > 1 {
                str = "\(str.integerValue - 1)" as NSString
                countTf.text = str as String
            }
            break
        }
        
    }
    @IBAction func submitAction(_ sender: Any) {
//        delegate?.JiTuoWuXinXiViewSubmit()
        if itemNameTF.text!.count == 0 {
            HUD.flash(.label("请输入寄托物名称"), delay: 1.2)
            return
        }
        if tiJiTF.text!.count == 0 {
            HUD.flash(.label("请输入体积"), delay: 1.2)
            return
        }
        if weightTf.text!.count == 0 {
            HUD.flash(.label("请输入重量"), delay: 1.2)
            return
        }
        if countTf.text!.count == 0 {
            HUD.flash(.label("请输入数量"), delay: 1.2)
            return
        }
        let tiji = tiJiTF.text as! NSString
        let weight = weightTf.text as! NSString
        let count = countTf.text as! NSString
        delegate?.JiTuoWuXinXiViewSubmit(itemName: itemNameTF.text!, tiJi: tiji.floatValue, weight: weight.floatValue, count: count.integerValue, isCheck: infoSw.isOn,chang: changTf.text,kuang: kuanTf.text,gao: gaoTf.text)
    }
    @IBOutlet weak var tiJiTF: UITextField!
    @IBOutlet weak var itemNameTF: UITextField!
    func setUI(){
        weightTf.keyboardType = .decimalPad
        countTf.keyboardType = .numberPad
        tiJiTF.keyboardType = .decimalPad
        infoSw.transform = CGAffineTransform(scaleX: 0.8, y: 0.8)
        let maskPath = UIBezierPath(roundedRect: bottomView.bounds,
        byRoundingCorners:[.topLeft, .topRight], cornerRadii:CGSize(width:3, height:3))
        let masklayer = CAShapeLayer()
        masklayer.frame = bottomView.bounds
        masklayer.path = maskPath.cgPath
        bottomView.layer.mask = masklayer
        
        changTf.delegate = self
        kuanTf.delegate = self
        gaoTf.delegate = self
        tiJiTF.delegate = self
        changTf.keyboardType = .numberPad
        kuanTf.keyboardType = .numberPad
        gaoTf.keyboardType = .numberPad
    }
    
    func textFieldDidEndEditing(_ textField: UITextField) {
        if textField == tiJiTF {
            changTf.text = ""
            kuanTf.text = ""
            gaoTf.text = ""
        }
        if changTf.text!.count > 0 && kuanTf.text!.count > 0 && gaoTf.text!.count > 0 {
            let chang = changTf.text as! NSString
            let kuan = kuanTf.text as! NSString
            let gao = gaoTf.text as! NSString
            let c = chang.floatValue / 100
            let k = kuan.floatValue / 100
            let g = gao.floatValue / 100
            tiJiTF.text = String(format: "%.2f", c * k * g)
        }
    }
    
    //初始化时将xib中的view添加进来
    override init(frame: CGRect) {
        super.init(frame: frame)
        contentView = loadViewFromNib()
        addSubview(contentView)
        contentView.snp.makeConstraints { (make) in
            make.left.top.right.bottom.equalToSuperview()
        }
        self.setUI()
    }
    
    //    /初始化时将xib中的view添加进来
    required init?(coder aDecoder: NSCoder) {
        super.init(coder: aDecoder)
        contentView = loadViewFromNib()
        addSubview(contentView)
        contentView.snp.makeConstraints { (make) in
            make.left.top.right.bottom.equalToSuperview()
        }
        self.setUI()
    }
    //加载xib
    func loadViewFromNib() -> UIView {
        let className = type(of: self)
        let bundle = Bundle(for: className)
        let name = NSStringFromClass(className).components(separatedBy: ".").last
        let nib = UINib(nibName: name!, bundle: bundle)
        let view = nib.instantiate(withOwner: self, options: nil).first as! UIView
        self.setUI()
        return view
    }

}
