//
//  YunDanXiangQingViewController.swift
//  GeliBusinessPlatform
//
//  Created by junye lu on 2020/4/30.
//  Copyright © 2020 junye lu. All rights reserved.
//

import UIKit

class YunDanXiangQingViewController: BaseViewController,UITableViewDelegate,UITableViewDataSource,PaymentViewDelegate, GeliAlertViewDelegate{
    func sureGeliAlertViewAction(sender: UIButton) {
        print("取消订单")
        HUD.flash(.progress)
        cancelLogisticsOrder(["wb_no":dataModel?.wb_no,"user_token":UserToken], success: { (data) in
            //通知刷新
            HUD.hide()
            self.navigationController?.popViewController(animated: true)
            NotificationCenter.default.post(name: NSNotification.Name(rawValue: "logistDetail"), object: nil, userInfo: nil)
        }) { (err) in
            
        }
    }
    
    func PaymentViewClose() {
        paymentView?.removeFromSuperview()
        paymentView = nil
    }
    
    func PaymentViewPassInputFinish(fullpass: String) {
        HUD.flash(.progress)
        payDelivery(["wb_no":dataModel?.wb_no,"user_token":UserToken,"pwd":fullpass], success: { (data) in
            //通知刷新
            HUD.hide()
            self.navigationController?.popViewController(animated: true)
            NotificationCenter.default.post(name: NSNotification.Name(rawValue: "logistDetail"), object: nil, userInfo: nil)
        }) { (err) in
            
        }
        paymentView?.removeFromSuperview()
        paymentView = nil
    }
    
    
    var orderID:Int?
    var dataModel:logisticsOrderDetailsDataModel?
    let UserToken = UserDefaults.standard.value(forKey: "user_token")
    @IBOutlet weak var listView: UITableView!
    @IBOutlet weak var btmView: UIView!
    var btnTitleArr:Array<String> = []
    override func viewDidLoad() {
        super.viewDidLoad()
        navbar.title = "运单详情"
        self.view.addSubview(navbar)
        listView.separatorStyle = .none
        SetTopFrameView(view: listView, btmView: btmView)
        //        listView.register(UINib(nibName: "TitleAndTFCell", bundle: nil), forCellReuseIdentifier: "TitleAndTFCell")
        listView.register(UINib(nibName: "XiaDanCGDiZhiCell", bundle: nil), forCellReuseIdentifier: "XiaDanCGDiZhiCell")
        listView.register(UINib(nibName: "JiBenXinXiCell", bundle: nil), forCellReuseIdentifier: "JiBenXinXiCell")
        
        listView.register(UINib(nibName: "TitleAndLblCell", bundle: nil), forCellReuseIdentifier: "TitleAndLblCell")
        
        loadData()
        
        
        self.bottomH.constant = 83
        if ScreenHeight < 896 {
            self.bottomH.constant = 49
        }
    }
    
    @IBOutlet weak var bottomH: NSLayoutConstraint!
    func setBtns(){
        for i in 0 ..< btnTitleArr.count {
            let btn = UIButton()
            let idx = btnTitleArr.count-i-1
            btn.tag = idx
            btn.setTitle(btnTitleArr[idx], for: .normal)
            btn.titleLabel?.font = UIFont.systemFont(ofSize: 15)
            btn.setTitleColor(UIColor(named: "蓝色字体颜色"), for: .normal)
            btn.layer.cornerRadius = 15
            btn.layer.masksToBounds = true
            btn.layer.borderColor = UIColor(named: "蓝色字体颜色")?.cgColor
            btn.layer.borderWidth = 1
            if btn.titleLabel!.text == "支付运费" {
                btn.backgroundColor = UIColor(named: "蓝色字体颜色")
                btn.setTitleColor(UIColor.white, for: .normal)
            }
            btn.addTarget(self, action: #selector(btnClick(sender:)), for: .touchUpInside)
            btmView.addSubview(btn)
            let x = -i * 105 - 15
            btn.snp.makeConstraints { (make) in
                make.width.equalTo(90)
                make.height.equalTo(30)
                make.top.equalTo(9.5)
                make.right.equalTo(x)
            }
            
        }
    }
    func loadData(){
        
        HUD.flash(.progress)
        listView.isHidden = true
        
        logisticsOrderDetails(["user_token":UserToken as Any,"id":orderID as Any], success: { (data) in
            HUD.hide()
            
            let model = data as! logisticsOrderDetailsModel
            self.dataModel = model.data
            
            if model.data?.delivery_status != 5 {
                self.btnTitleArr.append("物流跟踪")
            }
            
            if model.data?.delivery_status == 1 {
                self.btnTitleArr.append("取消运单")
            }
            
            if ((model.data?.freight)! > 0) && model.data?.pay_status == 1 {
                self.btnTitleArr.append("支付运费")
            }
            
            if self.btnTitleArr.count > 0 {
                self.setBtns()
            }else{
                self.bottomH.constant = 0
            }
            self.listView.isHidden = false
            self.listView.reloadData()
        }) { (error) in
            
        }
    }
    @objc func closeAction(sender:UIButton){
        sender.removeFromSuperview()
    }
    
    var paymentView:PaymentView?
    @objc func btnClick(sender:UIButton){
        switch sender.titleLabel?.text {
        case "支付运费":
            if paymentView == nil{
                paymentView = PaymentView(frame: view.bounds)
                paymentView?.delegate = self
                paymentView?.price = dataModel?.freight
                view.addSubview(paymentView!)
            }
            break
        case "物流跟踪":
            let vc = WuLiuGenZongViewController()
            vc.orderId = dataModel?.id
            self.navigationController?.pushViewController(vc, animated: true)
            break
        case "取消运单":
            let alertView = GeliAlertView(frame: self.view.window!.bounds)
            alertView.delegate = self;
            alertView.tishiLbl.text = ""
            alertView.titileLbl.text = "是否取消运单？"
            alertView.rightBtn.setAttributedTitle(NSAttributedString(string: "确定"), for: .normal)
            self.view.window?.addSubview(alertView)
            break
        default:
            break
        }
        
        
    }
    //MARK: - CELL DELEGATE
    func tableView(_ tableView: UITableView, heightForHeaderInSection section: Int) -> CGFloat {
        switch section {
        case 0:return 0.001
        case 1:return 10
        default:
            return 36
        }
    }
    
    func tableView(_ tableView: UITableView, viewForHeaderInSection section: Int) -> UIView? {
        switch section {
        case 0:return UIView()
        case 2:
            let view = UIView(frame: CGRect(x: 0, y: 0, width: fullScreenWidth, height: 36))
            view.backgroundColor = UIColor.white
            let lbl = UILabel()
            lbl.text = "货物信息"
            lbl.textColor = UIColor(named: "标题字颜色")
            lbl.font = UIFont.boldSystemFont(ofSize: 15)
            view.addSubview(lbl)
            lbl.snp.makeConstraints { (make) in
                make.top.left.right.equalTo(15)
                make.height.equalTo(21)
            }
            return view
        default:
            let view = UIView(frame: CGRect(x: 0, y: 0, width: fullScreenWidth, height: 10))
            view.backgroundColor = UIColor.white
            return view
        }
    }
    func tableView(_ tableView: UITableView, viewForFooterInSection section: Int) -> UIView? {
        if section == 1 {
            let view = UIView(frame: CGRect(x: 0, y: 0, width: fullScreenWidth, height: 20))
            let line = UIView(frame: CGRect(x: 0, y: 0, width: fullScreenWidth, height: 10))
            line.backgroundColor = UIColor.white
            view.addSubview(line)
            return view
        }
        return UIView()
    }
    func tableView(_ tableView: UITableView, heightForFooterInSection section: Int) -> CGFloat {
        if section == 0 {
            return 0.001
        }
        if section == 1 {
            return 20
        }
        return 10
    }
    func numberOfSections(in tableView: UITableView) -> Int {
        if dataModel == nil {
            return 0
        }
        return 3
    }
    func tableView(_ tableView: UITableView, numberOfRowsInSection section: Int) -> Int {
        if dataModel == nil {
            return 0
        }
        if section == 0 {
            return 3
        }
        if section == 1 {
            return 4
        }
        return 9
    }
    func tableView(_ tableView: UITableView, heightForRowAt indexPath: IndexPath) -> CGFloat {
        if indexPath.section == 0 {
            switch indexPath.row {
            case 0:
                return 86
            default:
                return 66
            }
        }
        if indexPath.section == 1 {
            return 30
        }
        if indexPath.section == 2 {
            if indexPath.row == 8 {
                return UITableView.automaticDimension
            }
        }
        return 30
    }
    let p2Arr = ["关联平台：","关联订单号：","运费：","运费支付方式："]
    let p3Arr = ["寄托物：","总重量：","总件数：","体积：","温控范围：","寄件方式：","派件方式：","保价（元人民币）：","备注："]
    func tableView(_ tableView: UITableView, cellForRowAt indexPath: IndexPath) -> UITableViewCell {
        if indexPath.section == 0 {
            switch indexPath.row {
            case 0:
                let cell = tableView.dequeueReusableCell(withIdentifier: "JiBenXinXiCell") as! JiBenXinXiCell
                cell.orderStatusLbl.text = dataModel?.delivery_status_cn
                cell.payStatusLbl.text = dataModel?.pay_status_cn
                return cell
            case 1,2:
                let cell = tableView.dequeueReusableCell(withIdentifier: "XiaDanCGDiZhiCell") as! XiaDanCGDiZhiCell
                cell.statusLbl.text = "寄"
                cell.namelbl.text = dataModel?.s_consignee
                cell.phoneLbl.text = dataModel?.s_mobile
                cell.adrLbl.text = dataModel?.s_address
                if indexPath.row == 2 {
                    cell.statusLbl.backgroundColor = UIColor(named: "企业、预售字体")
                    cell.statusLbl.text = "收"
                    cell.namelbl.text = dataModel?.r_consignee
                    cell.phoneLbl.text = dataModel?.r_mobile
                    cell.adrLbl.text = dataModel?.r_address
                }
                return cell
            default:
                break
            }
        }
        if indexPath.section == 1 {
            let cell = tableView.dequeueReusableCell(withIdentifier: "TitleAndLblCell") as! TitleAndLblCell
            cell.nameLbl.text = p2Arr[indexPath.row]
            var arrStr:[String] = []
            arrStr.append((dataModel?.sale_plat)!)
            arrStr.append((dataModel?.order_sn)!)
            arrStr.append(String(format: "%.2f", (dataModel?.freight)!))
            arrStr.append((dataModel?.fc_flag_cn)!)
            var str = arrStr[indexPath.row]
            if str == "" {
                str = "-"
            }
            cell.contentLbl.text = str
            cell.imgRight.constant = 0
            cell.btmLine.isHidden = true
            return cell
        }
        let cell = tableView.dequeueReusableCell(withIdentifier: "TitleAndLblCell") as! TitleAndLblCell
        cell.nameLbl.text = p3Arr[indexPath.row]
        var arrStr:[String] = []
        arrStr.append((dataModel?.express_item_name)!)
        arrStr.append(String(format: "%.2f", (dataModel?.weight)!))
        arrStr.append(StringByInt(number: (dataModel?.express_item_qty)!))
        arrStr.append(String(format: "%.2f", (dataModel?.volume)!))
        arrStr.append((dataModel?.tempture_num)!)
        arrStr.append((dataModel?.home_delivery_on_cn)!)
        arrStr.append((dataModel?.site_delivery_cn)!)
        arrStr.append(String(format: "%.2f", (dataModel?.guarantee_value)!))
        arrStr.append((dataModel?.remark)!)
        var str = arrStr[indexPath.row]
        if str == "" {
            str = "-"
        }
        cell.contentLbl.text = str
        cell.imgRight.constant = 0
        cell.btmLine.isHidden = true
        return cell
    }
}
