//
//  DaiKeXiaDanGouWuViewController.swift
//  GeliBusinessPlatform
//
//  Created by junye lu on 2020/4/27.
//  Copyright © 2020 junye lu. All rights reserved.
//

import UIKit
import IQKeyboardManagerSwift

class DaiKeXiaDanGouWuViewController: BaseViewController,UITableViewDataSource,UITableViewDelegate,DaiKeXiaDanFooterViewDelegate,TitleAndBtnCellDelegate,GLAlertSelectViewDelegate,DZGLViewControllerDelegate,XuanZeShangPinViewControllerDelegate,DaiKeXiaDanGouWuCellDelegate,GuanLianKehuVCDelegate,XiuGaiYuShouJiaViewControllerDelegate,TitleAndTFCellDelegate, GeliAlertViewDelegate,UITextFieldDelegate{
    
    let ddTypeArr = ["普通订单","预售下单"]
    let zfTypeArr = ["未付款","欠款","月结","已付款"]
    let zfWayArr =  ["未支付","现金","转账（私）","转账（公）","转账（微信）","转账（支付宝）"]
    let thArr = ["自提","派送"]
    let ckArr = ["暂不出库","直接出库"]
    var holderArr = ["未支付","未付款","自提","","暂不出库","0","0"]
    let p2Arr = ["定金支付方式","定金支付状态"]
    var holder2Arr = ["未支付","未付款"]
    var p3Arr = ["支付方式","支付状态","提货方式","选择地址","出货状态","运费","其他费用"]
    //客户model
    var cusModel:CusListAllDataModel?//客户资料
    var zhiFuStatus = 0 //普通支付状态 & 尾款支付状态
    var zhiFuWay = 0//普通支付方式 & 尾款支付方式
    var tiHuoWay = 0//提货方式选择
    var chuHuoWay = 0//出货方式选择
    var cellDataArr:Array<GetGoodsInfoDataModel> = []//回调选择记录
    var dj_payStatus = 0//定金支付状态
    var dj_payWay = 0//定金支付方式
    var logistics_price = ""//运费
    var other_price = ""//其他费用
    
    var orderType:Int?  = 0//订单类型默认进入系统自动选择普通订单
    var adrData:GetAddrsInfoDataModel?//地址数据
    
    var glSelectView:GLAlertSelectView? = nil
    var footerView:DaiKeXiaDanFooterView?
    @IBOutlet weak var listView: UITableView!
    @IBOutlet weak var btmView: UILabel!
    
    //MARK: - 提交订单-立即下单
    @IBAction func submitAction(_ sender: Any) {
        print("提交订单")
        //暂时不做判断处理
        //待补充
        if cusModel == nil {
            HUD.flash(.label("请选择关联客户"), delay: 1.2)
            return
        }
        if orderType == nil{
            HUD.flash(.label("请选择订单类型"), delay: 1.2)
            return
        }
        if cellDataArr.count == 0 {
            HUD.flash(.label("请添加商品"), delay: 1.2)
            return
        }
        if tiHuoWay == 1 && adrData == nil{
            HUD.flash(.label("请选择地址"), delay: 1.2)
            return
        }
        
        if orderType == 1  {
            
            if djTFstr.count == 0 || wkTFstr.count == 0 {
                HUD.flash(.label("请修改相应的定金和尾款"), delay: 1.2)
                return
            }
        }
        
 
        if logistics_price.count > 0 {
            if !isPurnNumber(str: logistics_price) {
                HUD.flash(.label("请填写正确的运费价格"), delay: 1.2)
                return;
            }
        }
        
        if other_price.count > 0 {
            if !isPurnNumber(str: other_price) {
                HUD.flash(.label("请填写正确的费用价格"), delay: 1.2)
                return;
            }
        }
        let goods_info = getGoodsInfo()
        let order_info = getOrderInfo()
        var is_adsale = 0
        if orderType == 1 {
            is_adsale = 1
        }
        let UserToken = UserDefaults.standard.value(forKey: "user_token")
        let order = ["user_token":UserToken as Any,
                     "is_adsale":is_adsale as Any,
                     "goods_info":goods_info as Any,
                     "order_info":order_info as Any] as [String : Any]
        print(order)
        orderData = order
        let alertView = GeliAlertView(frame: self.view.window!.bounds)
        alertView.delegate = self;
        alertView.tishiLbl.text = ""
        alertView.titileLbl.text = "是否立即下单？"
        alertView.rightBtn.setAttributedTitle(NSAttributedString(string: "确认"), for: .normal)
        alertView.rightBtn.tag = 1001
        self.view.window?.addSubview(alertView)

    }
    var orderData:[String:Any]? = nil
    
    func sureGeliAlertViewAction(sender: UIButton) {
        if sender.tag == 1001 {
            HUD.flash(.progress)
            addOrder(orderData!, success: { (data) in
                let dataM = data as! UpDataModel
                if dataM.code == 1 {
                    HUD.flash(.label("提交成功"), delay: 1.2)
                    NotificationCenter.default.post(name: NSNotification.Name(rawValue: "orderChange"), object: nil)
                    self.navigationController?.popViewController(animated: true)
                }else{
                    HUD.hide()
                }
            }) { (error) in
                
            }
        }

    }
    
    override func viewDidLoad() {
        super.viewDidLoad()
        navbar.title = "代客下单"
        self.view.addSubview(navbar)
        listView.snp.makeConstraints { (make) in
            make.top.equalTo(NavCGRect.height)
            make.left.right.equalTo(0)
            make.bottom.equalTo(btmView.snp_top)
        }
        
        listView.separatorStyle = .none
        listView.register(UINib(nibName: "TitleAndBtnCell", bundle: nil), forCellReuseIdentifier: "TitleAndBtnCell")
        listView.register(UINib(nibName: "TitleAndTFCell", bundle: nil), forCellReuseIdentifier: "TitleAndTFCell")
        listView.register(UINib(nibName: "DaiKeXiaDanGouWuCell", bundle: nil), forCellReuseIdentifier: "DaiKeXiaDanGouWuCell")
        listView.register(UINib(nibName: "DKXDAdrCell", bundle: nil), forCellReuseIdentifier: "DKXDAdrCell")
        
        //TitleAndBtnCell TitleAndTFCell
        // Do any additional setup after loading the view.
        
    }
    
    func tableView(_ tableView: UITableView, cellForRowAt indexPath: IndexPath) -> UITableViewCell {
        switch indexPath.section {
        case 0:
            let cell = tableView.dequeueReusableCell(withIdentifier: "TitleAndBtnCell") as! TitleAndBtnCell
            if indexPath.row == 0 {
                cell.nameLbl.text = "客户："
                cell.contentLbl.text = "请选择关联客户"
                if cusModel != nil {
                    cell.contentLbl.text = cusModel?.cus_name
                }
            }
            if indexPath.row == 1 {
                cell.nameLbl.text = "订单类型："
                cell.contentLbl.text = "请选择订单类型"
                if orderType != nil {
                    cell.contentLbl.text = ddTypeArr[orderType!]
                }
            }
            cell.btn.isUserInteractionEnabled = false
            return cell
        case 1:
            let cell = tableView.dequeueReusableCell(withIdentifier: "DaiKeXiaDanGouWuCell") as! DaiKeXiaDanGouWuCell
            cell.tag = indexPath.row
            cell.delegate = self
            let cellData = cellDataArr[indexPath.row]
            cell.imgView.sd_setImage(with: URL(string:SERVERCE_ImageHost +  cellData.goods_img!))
            cell.titleLbl.text = cellData.goods_name
            cell.detailLbl.text = "\(cellData.spec_str!)/\(cellData.unit!)"
            cell.detailLbl2.text = "￥" + cellData.target_Price! + "x\(cellData.target_Count!)"
            let priceStr = cellData.target_Price?.replacingOccurrences(of: "", with: ",") as! NSString
            let totalP = priceStr.floatValue * Float(cellData.target_Count!)
            cell.totalPriceLbl.text = "\(totalP)"
            
            if orderType == 1 {
                cell.diLbl.isHidden = false
                cell.diLbl.text = "定金:￥" + djTFstr
                cell.totalPriceLbl.text = "尾款:￥" + wkTFstr
                
            }else {
//                cell.totalPriceLbl.text = "¥\(priceStr.floatValue * countStr.floatValue)"
                cell.diLbl.isHidden = true
                
            }
            
            return cell
        case 2:
            let cell = tableView.dequeueReusableCell(withIdentifier: "TitleAndBtnCell") as! TitleAndBtnCell
            cell.btn.isUserInteractionEnabled = false
            cell.delegate = self
            cell.nameLbl.text = p2Arr[indexPath.row]
            cell.contentLbl.text = holder2Arr[indexPath.row]
            cell.tag = indexPath.row
            return cell
        default:
            if indexPath.row < 5 {
                let cell = tableView.dequeueReusableCell(withIdentifier: "TitleAndBtnCell") as! TitleAndBtnCell
                cell.btn.isUserInteractionEnabled = false
                cell.delegate = self
                cell.nameLbl.text = p3Arr[indexPath.row]
                
                if indexPath.row == 0 {
                    if orderType == 1 {
                        cell.nameLbl.text = "尾款支付方式"
                    }else{
                        cell.nameLbl.text = "支付方式"
                    }
                    p3Arr.insert(cell.nameLbl.text!, at: 0)
                    p3Arr.remove(at: 1)
                }
                if indexPath.row == 1 {
                    if orderType == 1 {
                        cell.nameLbl.text = "尾款支付状态"
                    }else{
                        cell.nameLbl.text = "支付状态"
                    }
                    p3Arr.insert(cell.nameLbl.text!, at: 1)
                    p3Arr.remove(at: 2)
                }
                
                cell.contentLbl.text = holderArr[indexPath.row]
                cell.tag = indexPath.row
                if adrData != nil {
                    if indexPath.row == 3 {
                        let cell = tableView.dequeueReusableCell(withIdentifier: "DKXDAdrCell") as! DKXDAdrCell
                        cell.nameLbl.text = p3Arr[indexPath.row]
                        cell.contentLbl.text = (adrData?.consignee)! + " " + (adrData?.mobile)!
                        
                        cell.adrLbl.text = adrData?.addr_cn
                        cell.tag = indexPath.row
                        return cell
                    }
                }
                return cell
            }
            let cell = tableView.dequeueReusableCell(withIdentifier: "TitleAndTFCell") as! TitleAndTFCell
            cell.nameLbl.text = p3Arr[indexPath.row]
            cell.textTF.snp.makeConstraints { (make) in
                make.centerY.equalTo(cell.snp_centerY)
                make.right.equalTo(-15)
                make.width.equalTo(95)
                make.height.equalTo(32)
            }
            cell.textTF.layer.cornerRadius = 3
            cell.textTF.layer.masksToBounds = true
            cell.textTF.layer.borderWidth = 1
            cell.textTF.returnKeyType = .done
            cell.textTF.layer.borderColor = UIColor(named: "灰色字体颜色")?.cgColor
            cell.textTF.placeholder = "请输入费用"
            cell.textTF.keyboardType = .decimalPad
            cell.textTF.textColor = UIColor(named: "蓝色字体颜色")
            cell.textTF.tag = 1002

            if indexPath.row == 5 {
                cell.textTF.placeholder = "请输入运费"
                cell.textTF.tag = 1001
            }
            cell.textTF.textAlignment = .center
            cell.delegate = self
            cell.textTF.delegate = self

            return cell
        }
    }
    
    
    //MARK: - didselectRow
    func tableView(_ tableView: UITableView, didSelectRowAt indexPath: IndexPath) {
        if orderType == nil  && indexPath.section != 0{
            HUD.flash(.label("请选择订单类型"), delay: 1.2)
            return
        }
        switch indexPath.section {
        case 0:
            if indexPath.row == 0 {
                let vc = GuanLianKehuVC()
                vc.delegate = self
                self.navigationController?.pushViewController(vc, animated: true)
            }else{
                if glSelectView == nil {
                    let view = GLAlertSelectView(frame: self.view.bounds)
                    if orderType != nil {
                        view.selectNum = orderType!
                        view.tempNum = view.selectNum
                    }
                    view.tag = 100
                    view.delegate = self
                    view.titleLbl.text = "请选择订单类型"
                    view.dataArr = ddTypeArr
                    self.view.addSubview(view)
                    glSelectView = view
                }
            }
            break
        case 2:
            if glSelectView == nil {
                let view = GLAlertSelectView(frame: self.view.bounds)
                view.delegate = self
                if indexPath.row == 0{
                    view.tag = 1011
                    view.selectNum = dj_payWay
                    view.tempNum = view.selectNum
                    view.titleLbl.text = "请选择\(p2Arr[indexPath.row])"
                    view.dataArr = zfWayArr
                }
                if indexPath.row == 1 {
                    view.tag = 1021
                    if dj_payWay == 0{
                        view.deSelectArr = [3]
                    }else{
                        dj_payStatus = 3
                        view.deSelectArr = [0,1,2]
                    }
                    view.selectNum = dj_payStatus
                    view.tempNum = view.selectNum
                    view.titleLbl.text = "请选择\(p2Arr[indexPath.row])"
                    if orderType == 1 {
                        if dj_payWay == 0{
                            view.deSelectArr = [1,2,3]
                        }else{
                            view.deSelectArr = [0,1,2]
                        }
                    }
                    view.dataArr = zfTypeArr
                }
                self.view.addSubview(view)
                glSelectView = view
            }
            break
        case 3:
            if indexPath.row == 3 || indexPath.row > 4{
                if indexPath.row == 3 {
                    if cusModel == nil {
                        HUD.flash(.label("请先关联客户"),delay: 1.2)
                        return
                    }
                    let vc = DZGLViewController()
                    vc.cus_id = cusModel?.cus_id
                    vc.isSelectMotion = true
                    vc.delegate = self
                    self.navigationController?.pushViewController(vc, animated: true)
                }
                return
            }
            if glSelectView == nil {
                let view = GLAlertSelectView(frame: self.view.bounds)
                view.delegate = self
                switch indexPath.row {
                case 0://支付方式
                    view.tag = 101
                    view.selectNum = zhiFuWay
                    
                    view.tempNum = view.selectNum
                    view.titleLbl.text = "请选择\(p3Arr[indexPath.row])"
                    view.dataArr = zfWayArr
                    break
                case 1://支付状态
                    view.tag = 102
                    if zhiFuWay == 0{
                        view.deSelectArr = [3]
                    }else{
                        zhiFuStatus = 3
                        view.deSelectArr = [0,1,2]
                    }
                    view.selectNum = zhiFuStatus
                    view.tempNum = view.selectNum
                    view.titleLbl.text = "请选择\(p3Arr[indexPath.row])"
                    if orderType == 1 {
                        if zhiFuWay == 0{
                            view.deSelectArr = [1,2,3]
                        }else{
                            view.deSelectArr = [0,1,2]
                        }
                    }
                    view.dataArr = zfTypeArr
                    
                    break
                case 2://提货方式
                    view.tag = 103
                    view.selectNum = tiHuoWay
                    view.tempNum = view.selectNum
                    view.titleLbl.text = "请选择\(p3Arr[indexPath.row])"
                    view.dataArr = thArr
                    break
                case 4://出货状态
                    view.tag = 104
                    view.selectNum = chuHuoWay
                    view.tempNum = view.selectNum
                    view.titleLbl.text = "请选择\(p3Arr[indexPath.row])"
                    view.dataArr = ckArr
                    break
                default:
                    break
                }
                self.view.addSubview(view)
                glSelectView = view
            }
            break
        default:
            break
        }
    }
    
    //MARK: - 跳转修改价格
    var djTFstr:String = "";
    var wkTFstr:String = "";
    
    @objc func jumpToEditPrice(){
        if orderType == 1 {//预售
            let vc = XiuGaiYuShouJiaViewController()
            vc.inputData = cellDataArr
            vc.djTFstr = djTFstr
            vc.wkTFstr = wkTFstr
            let item = cellDataArr[0];
            let price = item.target_Price?.replacingOccurrences(of: "", with: ",") as! NSString
            let tp = price.floatValue * Float(item.target_Count!)
            vc.totalPrice = tp
            vc.delegate = self
            self.navigationController?.pushViewController(vc, animated: true)
        }else{//普通
            let vc = XuanZeShangPinViewController()
            vc.delegate = self
            vc.barTitle = "修改价格"
            vc.selectArr = cellDataArr
            self.navigationController?.pushViewController(vc, animated: true)
        }
    }
    //MARK: -  关联客户
    func GuanLianKehuSelect(keHuData: CusListAllDataModel) {
        cusModel = keHuData
        listView.reloadData()
    }
    
    
    //MARK: - 商品选择（普通）
    func XuanZeShangPinViewControllerSubmitAction(selectArr: Array<GetGoodsInfoDataModel>) {
        for item in selectArr{
            cellDataArr.append(item)
        }
        listView.reloadData()
    }
    //MARK: -  修改数据（普通）
    func XuanZeShangPinViewControllerEdit(selectArr: Array<GetGoodsInfoDataModel>) {
        cellDataArr = selectArr
        listView.reloadData()
    }
    //MARK:-- 修改价格（预售）回调
    func changeYuShouGoodsByData(sender: EditOGPAdDataModel?, djText: String, wkText: String) {
        djTFstr = djText
        wkTFstr = wkText
        listView.reloadData()
    }
    
    //MARK: - glalertSelectViewSelect
    func GLAlertSelectViewClick(selectNum: Int, view: GLAlertSelectView) {
        switch view.tag {
        case 1011:
            dj_payWay = selectNum
            holder2Arr.insert(zfWayArr[selectNum], at: 0)
            holder2Arr.remove(at:1)
            if dj_payWay != 0{
                dj_payStatus = 3
                holder2Arr.insert(zfTypeArr[dj_payStatus], at: 1)
                holder2Arr.remove(at: 2)
            }else{
                dj_payStatus = 0
                holder2Arr.insert(zfTypeArr[dj_payStatus], at: 1)
                holder2Arr.remove(at: 2)
            }
            break
        case 1021:
            dj_payStatus = selectNum
            holder2Arr.insert(zfTypeArr[selectNum], at: 1)
            holder2Arr.remove(at: 2)
            break
        case 100://状态
            orderType = selectNum
            cellDataArr.removeAll()
            zhiFuWay = 0
            zhiFuStatus = 0
            holderArr.insert("未支付", at: 0)
            holderArr.remove(at: 1)
            holderArr.insert("未付款", at: 1)
            holderArr.remove(at: 2)
            listView.reloadData()
            break
        case 101:
            zhiFuWay = selectNum
            holderArr.insert(zfWayArr[selectNum], at: 0)
            holderArr.remove(at:1)
            if zhiFuWay != 0{
                zhiFuStatus = 3
                holderArr.insert(zfTypeArr[zhiFuStatus], at: 1)
                holderArr.remove(at: 2)
            }else{
                zhiFuStatus = 0
                holderArr.insert(zfTypeArr[zhiFuStatus], at: 1)
                holderArr.remove(at: 2)
            }
            break
        case 102:
            zhiFuStatus = selectNum
            holderArr.insert(zfTypeArr[selectNum], at: 1)
            holderArr.remove(at: 2)
            break
        case 103:
            tiHuoWay = selectNum
            holderArr.insert(thArr[selectNum], at: 2)
            holderArr.remove(at: 3)
            break
        case 104:
            chuHuoWay = selectNum
            holderArr.insert(ckArr[selectNum], at: 4)
            holderArr.remove(at: 5)
            break
        default:
            break
        }
        glSelectView?.removeFromSuperview()
        glSelectView = nil
        listView.reloadData()
    }
    //MARK: - 删除已选商品
    func DaiKeXiaDanGouWuCellDelAction(cell: DaiKeXiaDanGouWuCell) {
        if orderType == 1 {
            djTFstr = ""
            wkTFstr = ""
        }
        cellDataArr.remove(at: cell.tag)
        listView.reloadData()
    }
    //MARK: - 商品选择（预售）
    func XuanZeShangPinViewControllerYuShou(YuShouData:Array<GetGoodsInfoDataModel>) {
        cellDataArr.removeAll()
        cellDataArr = YuShouData
        print(cellDataArr.count)
        listView.reloadData()
    }
    
    //MARK: - 选择地址
    func DZGLViewControllerSelect(data: GetAddrsInfoDataModel) {
        adrData = data
        listView.reloadData()
    }
    //MARK: - 添加商品
    func addAction() {
        if orderType == nil {
            HUD.flash(.label("请选择订单类型"), delay: 1.2)
            return
        }
        let vc = XuanZeShangPinViewController()
        vc.delegate = self
        vc.barTitle = "选择商品"
        vc.is_adsale = orderType
//        vc.selectArr = cellDataArr
        if orderType == 1 {
            vc.isYuShou = true
        }
        self.navigationController?.pushViewController(vc, animated: true)
    }
    
    //MARK: - tableView header&footer
    //footer
    func tableView(_ tableView: UITableView, viewForFooterInSection section: Int) -> UIView? {
        if section == 1{//220 142
            let view = DaiKeXiaDanFooterView(frame: CGRect(x: 0, y: 0, width: fullScreenWidth, height: 220))
            view.topView.isHidden = false
            
            var pArr:Array<CGFloat> = []
            var totalC:Int = 0
            for item in cellDataArr{
                let price = item.target_Price?.replacingOccurrences(of: "", with: ",") as! NSString
                let tp = price.floatValue * Float(item.target_Count!)
                pArr.append(CGFloat(tp))
                totalC = totalC + item.target_Count!
            }
            var tp:CGFloat = 0
            for item in pArr {
                tp = tp + item
            }
            
            view.countLbl.text = "\(totalC)"
            let tpStr = String(format: "%.2f", tp)
            view.totalPriceLbl.text = "¥" + tpStr
            
            if cellDataArr.count == 0 {
                view.topView.isHidden = true
                view.topViewHeight.constant = 0.01
            }
            if orderType == 1 && cellDataArr.count > 0{
                view.btnH.constant = 0
                view.img.isHidden = true
            }
            view.delegate = self
            footerView = view
            return footerView
        }
        let view = UIView(frame: CGRect(x: 0, y: 0, width: fullScreenWidth, height: 10))
        view.backgroundColor = UIColor(named: "app底色")
        return view
    }
    //header
    func tableView(_ tableView: UITableView, viewForHeaderInSection section: Int) -> UIView? {
        if section == 1 {
            let  view = UIView(frame: CGRect(x: 0, y: 0, width: fullScreenWidth, height: 39))
            view.backgroundColor = UIColor.white
            let lbl = UILabel()
            lbl.text = "商品清单"
            lbl.textColor = UIColor(named: "标题字颜色")
            lbl.font = UIFont.boldSystemFont(ofSize: 15)
            view.addSubview(lbl)
            lbl.snp.makeConstraints { (make) in
                make.bottom.right.equalTo(0)
                make.left.equalTo(15)
            }
            if cellDataArr.count > 0 {
                let btn = UIButton()
                btn.setTitle("修改价格", for: .normal)
                btn.setTitleColor(UIColor(named: "蓝色字体颜色"), for: .normal)
                btn.titleLabel?.font = UIFont.systemFont(ofSize: 13)
                btn.addTarget(self, action: #selector(jumpToEditPrice), for: .touchUpInside)
                view.addSubview(btn)
                btn.snp.makeConstraints { (make) in
                    make.top.equalTo(9)
                    make.right.equalTo(0)
                    make.height.equalTo(30)
                    make.width.equalTo(82)
                }
                
            }
            return view
        }
        return UIView()
    }
    func tableView(_ tableView: UITableView, numberOfRowsInSection section: Int) -> Int {
        switch section {
        case 0:return 2
        case 1:return cellDataArr.count
        case 2: return 2
        default:return p3Arr.count
        }
    }
    
    func tableView(_ tableView: UITableView, heightForRowAt indexPath: IndexPath) -> CGFloat {
        if indexPath.section == 1 {
            return 120
        }
        if indexPath.section == 2 {//新增预售
            if orderType == 1 {
                return 49
            }else{
                return 0.001
            }
        }
        if indexPath.section == 3{
            if indexPath.row == 3 {
                if tiHuoWay != 1 {
                    return 0.001
                }
                if adrData != nil {
                    return 70
                }
            }
        }
        return 49
    }
    func tableView(_ tableView: UITableView, heightForHeaderInSection section: Int) -> CGFloat {
        if section == 1 {
            
            return 39
        }
        return 0.01
    }
    func numberOfSections(in tableView: UITableView) -> Int {
        return 4
    }
    
    func tableView(_ tableView: UITableView, heightForFooterInSection section: Int) -> CGFloat {
        if section == 1{
            if cellDataArr.count == 0 {
                return 142
            }
            if orderType == 1 {
                return 87
            }
            return 220
        }
        if section == 2 {
            return 0.001
        }
        
        return 10
    }
    //MARK: - 不选择下关闭glalertSelectView
    func GLASClose(view: GLAlertSelectView, selectnum: Int, selectArr: Array<Int>) {
        if selectnum != 10086 {
            if view.titleLbl.text == "请选择支付状态" {
                zhiFuStatus = selectnum
            }
            if view.titleLbl.text == "请选择支付方式" {
                zhiFuWay = selectnum
            }
            
            if view.titleLbl.text == "请选择提货方式" {
                tiHuoWay = selectnum
            }
            if view.titleLbl.text == "请选择出货状态" {
                chuHuoWay = selectnum
            }
        }
        view.removeFromSuperview()
        glSelectView = nil
    }
    
    //MARK:--处理提交数据GoodsInfo
    func getGoodsInfo() -> String {
        var goodsInfo:String = ""
        var goodsArr : Array<Any> = []
        if orderType == 1{
            cellDataArr.forEach { (item) in
                let priceStr = item.target_Price! as NSString
                let subtoal = priceStr.floatValue * Float(item.target_Count!)
                let goods = ["goods_name":item.goods_name as Any, //商品名称
                    "dj_amount":djTFstr as Any,//    定金金额【预售订单才传
                    "wk_amount":wkTFstr as Any,//尾款金额【预售订单才传】
                    "sku_attr":item.sku_attr as Any,//规格
                    "adsale_inventory":item.adsale_inventory as Any,//库存【预售订单才传】
                    "number":item.target_Count as Any,//购买数量
                    "unit":item.unit as Any,//单位
                    "price":item.price as Any,//价格
                    "r_price":item.target_Price as Any,//售价
                    "is_gift":0,//是否搭赠，1是0非，现版本固定0
                    "subtotal":subtoal,//总价
                    "goods_id":item.goods_id as Any,//商品ID
                    "sku_id":item.sku_id as Any] as [String : Any]
                goodsArr.append(goods)
            }
        }else{
            cellDataArr.forEach { (item) in
                
                 let priceStr = item.target_Price! as NSString
                 let subtoal = priceStr.floatValue * Float(item.target_Count!)
                let goods = ["goods_name":item.goods_name as Any,
                             "sku_attr":item.sku_attr as Any,
                             "inventory":item.inventory as Any,//库存【普通订单才传】
                    "number":item.target_Count as Any,
                    "unit":item.unit as Any,
                    "price":item.price as Any,
                    "r_price":item.target_Price as Any,
                    "is_gift":0,
                    "subtotal":subtoal,
                    "goods_id":item.goods_id as Any,
                    "sku_id":item.sku_id as Any] as [String : Any]
                
                goodsArr.append(goods)
            }
        }
        goodsInfo = dataChangeString(sender: goodsArr)
        return goodsInfo
    }
    //MARK:--处理提交数据OrderInfo
    func getOrderInfo() -> String {
        
        var orderInfo:String = ""
        var payType = 0
        if zhiFuWay == 0 {
            payType = zhiFuWay
        }else if zhiFuWay == 1 {
            payType = 7
        }else{
            payType = zhiFuWay + 7
        }
        var payStatus = 0
        if zhiFuStatus == 2 {
            payStatus = 10 //月结
        }else if zhiFuStatus == 3 {
            payStatus = 2 //已付款
        }else{
            payStatus = zhiFuStatus
        }
        var shipping_type =  0
        if tiHuoWay == 0 {
            shipping_type = 2
        }else if tiHuoWay == 1 {
            shipping_type = 1
        }
        
        var caddrId = 0
        if shipping_type == 1 {
            if adrData != nil {
                caddrId = adrData?.caddr_id! as! Int
            }
        }
        
        
        if orderType == 1 {
            
            var djpayType = 0
            if dj_payWay == 0 {
                djpayType = dj_payWay
            }else if dj_payWay == 1 {
                djpayType = 7
            }else{
                djpayType = dj_payWay + 7
            }
            var djpayStatus = 0
            if dj_payStatus == 2 {
                djpayStatus = 10 //月结
            }else if dj_payStatus == 3 {
                djpayStatus = 2 //已付款
            }else{
                djpayStatus = dj_payStatus
            }
            
            let dic =  ["cus_id":cusModel?.cus_id as Any, //客户ID
                "dj_pay_type":djpayType as Any,//支付类型,0未支付7现金9转账(私)10转账(公)11转账(微信)12转账(支付宝)
                "dj_pay_status":djpayStatus as Any,//支付状态,0未付款;1欠款;2已付款10月结
                "wk_pay_type":payType as Any,
                "wk_pay_status":payStatus as Any,
                "need_check":0,//付款是否需要审核 1是 0否
                "s_status":(chuHuoWay + 1) as Any,//是否出库 1 暂不出库 2直接出库
                "shipping_type":shipping_type as Any, //提货方式 1派送 2自提
                "caddr_id":caddrId as Any,//客户地址id，无地址填0，一定要根据客户获取这个地址ID
                "logistics_price":logistics_price as Any,//运费
                "other_price":other_price as Any] as [String : Any]
            
            orderInfo = dictChangeString(sender: dic)
        }else{
            let dic =  ["cus_id":cusModel?.cus_id as Any,
                        "pay_type":payType  as Any,
                        "pay_status":payStatus  as Any,
                        "need_check":0,
                        "s_status":(chuHuoWay + 1) as Any,
                        "shipping_type":shipping_type as Any,
                        "caddr_id":caddrId as Any,
                        "logistics_price":logistics_price as Any,
                        "other_price":other_price as Any] as [String : Any]
            orderInfo = dictChangeString(sender: dic)
        }
        
        return orderInfo
    }
    //MARK:--运费 & 其他费用
    func textFieldContent(content: String, cell: TitleAndTFCell) {
   
        if cell.nameLbl.text == "运费"  {
            logistics_price = content
        }else if cell.nameLbl.text == "其他费用" {
            other_price = content
        }
        
    }
    //运费费用金额格式化
    func textFieldDidEndEditing(_ textField: UITextField) {
        let content = formatShowNumber(value: textField.text!)
        if textField.tag == 1001 {
            logistics_price = content
            textField.text = content
        }else if textField.tag == 1002 {
            other_price = content
            textField.text = content
        }
    }
}
