//
//  XuanZeShangPinViewController.swift
//  GeliBusinessPlatform
//
//  Created by junye lu on 2020/4/28.
//  Copyright © 2020 junye lu. All rights reserved.
//

import UIKit

protocol XuanZeShangPinViewControllerDelegate {
    func XuanZeShangPinViewControllerSubmitAction(selectArr:Array<GetGoodsInfoDataModel>)
    func XuanZeShangPinViewControllerYuShou(YuShouData:Array<GetGoodsInfoDataModel>)
    func XuanZeShangPinViewControllerEdit(selectArr:Array<GetGoodsInfoDataModel>)
}

class XuanZeShangPinViewController: BaseViewController,UITableViewDelegate,UITableViewDataSource,XuanZeShangPinCellDelegate,UISearchBarDelegate,SearchBarViewDelegate,UITextFieldDelegate{
    
    var isCG = false
    var searchV : SearchBarView? = nil
    var delegate:XuanZeShangPinViewControllerDelegate?
    var is_adsale:Int?
    //XuanZeShangPinCell
    @IBAction func submitAction(_ sender: Any) {
        print("submit")
        
        //        for item in selectArr{
        //            if item.priceTF.text!.count == 0 {
        //                HUD.flash(.label("请输入商品单价"),delay: 1.2)
        //                return
        //            }
        //        }
        
        if barTitle == "修改价格"
        {
            if selectArr.count != 0 {
                delegate?.XuanZeShangPinViewControllerEdit(selectArr:selectArr)
            }else{
                HUD.flash(.label("请选择商品"), delay: 1.2)
                return
            }
        }else{
            if isYuShou {
                if selectArr.count != 0 {
                    delegate?.XuanZeShangPinViewControllerYuShou(YuShouData: selectArr)
                    self.navigationController?.popViewController(animated: true)
                }else{
                    HUD.flash(.label("请选择商品"), delay: 1.2)
                    return
                }
            }else{
                var PASS = true
                if selectArr.count != 0 {
                    selectArr.forEach { (model) in
                        if model.target_Price == "0" {
                            HUD.flash(.label("采购价格不能为0"), delay: 1.2)
                            PASS = false
                            return
                        }
                        if model.target_Count == 0 {
                            HUD.flash(.label("采购数量不能为0"), delay: 1.2)
                            PASS = false
                            return
                        }
                    }
                    if PASS {
                        delegate?.XuanZeShangPinViewControllerSubmitAction(selectArr: selectArr)
                        self.navigationController?.popViewController(animated: true)
                    }
                }else{
                    HUD.flash(.label("请选择商品"), delay: 1.2)
                    return
                }
            }
        }
        
    }
    
    var barTitle:String?//
    
    @IBOutlet weak var btmLbl: UILabel!
    @IBOutlet weak var listView: UITableView!
    @IBOutlet weak var topView: UIView!
    var idx:IndexPath?
    //是否预售
    var isYuShou = false
    var datas:Array<GetGoodsInfoDataModel> = []//数据
    var selectArr:Array<GetGoodsInfoDataModel> = []
    var selectIdxArr:Array<IndexPath> = []
    var isSearch:Bool = false
    var seacrchArr:Array<GetGoodsInfoDataModel> = [] //搜索数据
    
    override func viewDidLoad() {
        super.viewDidLoad()
        navbar.title = barTitle
        self.view.addSubview(navbar)
        
        
        if barTitle != "修改价格"{
            headerMJ.setRefreshingTarget(self, refreshingAction: #selector(loadData))
            self.listView!.mj_header = headerMJ
            self.listView.mj_header?.beginRefreshing()
            
        }
        
        listView.separatorStyle = .none
        SetTopFrame(view: topView, height: 44)
        
        
        let searchBr = SearchBarView.init()
        topView.addSubview(searchBr)
        searchBr.snp.makeConstraints { (make) in
            make.left.equalTo(10)
            make.right.equalTo(-10)
            make.centerY.equalToSuperview()
            make.height.equalTo(30)
        }
        searchV = searchBr
        searchBr.placeholderStr = "请输入商品名称"
        searchBr.cornerRadius = 35/2.0
        searchBr.delegate = self
        searchBr.delegateL = self
        
        listView.register(UINib(nibName: "XuanZeShangPinCell", bundle: nil), forCellReuseIdentifier: "XuanZeShangPinCell")
        
        
    }
    
    @objc func loadData(){
        let UserToken = UserDefaults.standard.value(forKey: "user_token")
        getGoodsInfo(["user_token":UserToken,"is_adsale":is_adsale], success: { (data) in
            let model = data as! GetGoodsInfoModel
            self.datas = model.data!
            self.listView.reloadData()
            self.listView.mj_header?.endRefreshing()
        }) { (error) in
            
        }
    }
    
    func clearSearchAction() {
        print("清楚搜索文字")
        isSearch = false
        listView.reloadData()
    }
    func searchBarSearchButtonClicked(_ searchBar: UISearchBar) {
        print("点击搜索进行--")
        isSearch =  true
        getSearch(sender: searchBar.text!)
        listView.reloadData()
        
        searchBar.resignFirstResponder()
    }
    
    
    func getSearch(sender:String) {
        seacrchArr.removeAll()
        datas.forEach { (md) in
            if md.goods_name!.contains(sender) {
                seacrchArr.append(md)
            }
        }
    }
    //MARK: - textfield编辑结束
    func textFieldDidEndEditing(_ textField: UITextField) {
        
        if barTitle == "修改价格"{
            let model = selectArr[textField.tag]
            let idx = IndexPath(row: textField.tag, section: 0)
            let cell = listView.cellForRow(at: idx) as! XuanZeShangPinCell
            if textField == cell.countTF{//数量
                if isPurnInt(string: textField.text!){
                    if Int(textField.text!)! > cell.maxNum! {
                        if isCG == false {
                            HUD.flash(.label("超出最大数量\(cell.maxNum!)"), delay: 1.2)
                            model.target_Count = cell.maxNum!
                            textField.text = "\(cell.maxNum!)"
                        }else{
                            model.target_Count = Int(textField.text!.replacingOccurrences(of: ",", with: ""))
                            textField.text = formatShowNumber(value: textField.text!)
                        }
                    }else if Int(textField.text!) == 0{
                        HUD.flash(.label("数量不小于1"), delay: 1.2)
                        model.target_Count = 1
                        textField.text = "1"
                    }else{
                        
                        model.target_Count = Int(textField.text!.replacingOccurrences(of: ",", with: ""))
                        textField.text = formatShowNumber(value: textField.text!)
                    }
                }else{
                    HUD.flash(.label("请输入正确的数量"), delay: 1.2)
                    model.target_Count = model.origin_number!
                    textField.text = StringByInt(number: (model.origin_number!))
                }
            }else{//价格
                if isPurnNumber(str: textField.text!){
                    model.target_Price = formatShowNumber(value: textField.text!)
                    textField.text = formatShowNumber(value: textField.text!)
                }else{
                    HUD.flash(.label("请输入正确的价格"), delay: 1.2)
                    textField.text = model.price!
                    model.target_Price = model.price!
                }
            }
            
        }else{
            
            let idx = IndexPath(row: textField.tag, section: 0)
            let cell = listView.cellForRow(at: idx) as! XuanZeShangPinCell
            if textField == cell.countTF{//数量
                if isPurnInt(string: textField.text!){
                    if Int(textField.text!)! > cell.maxNum! {
                        if isCG == false {
                            HUD.flash(.label("超出最大数量\(cell.maxNum!)"), delay: 1.2)
                            cell.model!.target_Count = cell.maxNum!
                            textField.text = "\(cell.maxNum!)"
                        }else{
                            textField.text = formatShowNumber(value: textField.text!)
                            
                            cell.model?.target_Count = Int(textField.text!.replacingOccurrences(of: ",", with: ""))
                        }
                    }else if Int(textField.text!) == 0{
                        HUD.flash(.label("数量不小于1"), delay: 1.2)
                        cell.model!.target_Count = 1
                        textField.text = "1"
                    }else{
                        textField.text = formatShowNumber(value: textField.text!)
                        cell.model?.target_Count = Int(textField.text!.replacingOccurrences(of: ",", with: ""))
                    }
                }else{
                    HUD.flash(.label("请输入正确的数量"), delay: 1.2)
                    textField.text = StringByInt(number: (cell.model?.origin_number!)!)
                    cell.model?.target_Count = cell.model?.origin_number!
                }
            }else{//价格
                if isPurnNumber(str: textField.text!){
                    cell.model?.target_Price = formatShowNumber(value: textField.text!)
                    textField.text = formatShowNumber(value: textField.text!)
                }else{
                    HUD.flash(.label("请输入正确的价格"), delay: 1.2)
                    textField.text = cell.model?.price!
                    cell.model?.target_Price = cell.model?.price!
                }
            }
        }
    }
    
    func XuanZeShangPinCellTextChange(index: IndexPath,sender:XuanZeShangPinCell,senderTF:UITextField) {
        
        
        
    }
    
    //MARK: - 阶梯价
    //    func textFieldShouldReturn(_ textField: UITextField) -> Bool {
    //        textField.resignFirstResponder()
    
    //        if barTitle == "修改价格"{
    //            let idx = IndexPath(row: textField.tag, section: 0)
    //            let cell = listView.cellForRow(at: idx) as! XuanZeShangPinCell
    //            let data = selectArr[textField.tag]
    //
    //
    //        }else{
    //            let idx = IndexPath(row: textField.tag, section: 0)
    //            let cell = listView.cellForRow(at: idx) as! XuanZeShangPinCell
    //
    //            let data = datas[textField.tag]
    //            if cell.priceTF.text != "0" {
    //                if data.tiered_pri! != nil && data.tiered_pri!.count > 0 {
    //                    let dict = getDictionaryFromJSONString(jsonString: data.tiered_pri!)
    //                    let arr = dict.allKeys
    //                    var strArr:Array<Int>? = []
    //                    for item in arr {
    //                        let str = item as! NSString
    //                        strArr?.append(str.integerValue)
    //                    }
    //                    let new = strArr?.sorted(by: { (num1, num2) -> Bool in
    //                        return num1 > num2 ? true : false
    //                    })
    //                    let countStr = cell.countTF.text as! NSString
    //                    for i in 0 ..< new!.count{
    //                        if countStr.integerValue > new![i]{
    //                            cell.priceTF.text = dict["\(new![i])"] as! String
    //                            break
    //                        }else{
    //                            cell.priceTF.text = data.price
    //                        }
    //                    }
    //                }
    //            }
    //        }
    //
    //        return true
    //    }
    func tableView(_ tableView: UITableView, cellForRowAt indexPath: IndexPath) -> UITableViewCell {
        let cell = tableView.dequeueReusableCell(withIdentifier: "XuanZeShangPinCell") as! XuanZeShangPinCell
        cell.delegate = self
        cell.priceTF.delegate = self
        cell.countTF.delegate = self
        cell.idx = indexPath
        cell.countTF.tag = indexPath.row
        cell.priceTF.tag = indexPath.row
        cell.countTF.keyboardType = .numberPad
        cell.priceTF.keyboardType = .decimalPad
        cell.priceTF.returnKeyType = .done
        cell.countTF.returnKeyType = .done
        cell.isCg = isCG
        
        if barTitle == "修改价格"{
            let model = selectArr[indexPath.row]
            cell.sku_id = model.sku_id
            cell.nameLbl.text = model.goods_name
            cell.cellModel = model
            cell.detailLbl.text = "\(model.spec_str!)/\(model.unit!)"
            cell.detailLbl2.text = "库存：\(model.inventory!)"
            cell.iconImg.sd_setImage(with: URL(string: SERVERCE_ImageHost + model.goods_img!))
            cell.countTF.text = StringByInt(number: (model.target_Count!))
            cell.priceTF.text = model.target_Price
            cell.maxNum = model.inventory
            cell.selectBtn.isHidden = true
            cell.btmView.isHidden = false
            cell.btmViewHeight.constant = 89
            
        }else{
            cell.idx = indexPath
            let model = datas[indexPath.row]
            cell.model = model
            cell.nameLbl.text = model.goods_name
            cell.cellModel = model
            cell.detailLbl.text = "\(model.spec_str!)/\(model.unit!)"
            cell.detailLbl2.text = "库存：\(model.inventory!)"
            cell.iconImg.sd_setImage(with: URL(string: SERVERCE_ImageHost + model.goods_img!))
            cell.imgUrlPath = SERVERCE_ImageHost + model.goods_img!
            cell.sku_id = model.sku_id
            cell.countTF.text = StringByInt(number: model.origin_number!)
            cell.priceTF.text = model.price!
            model.target_Count = model.origin_number!
            model.target_Price = model.price
            if isYuShou {//预售
                
                cell.maxNum = model.adsale_inventory
                
                var isSelectByData = false
                selectArr.forEach { (md) in
                    if md.sku_id == model.sku_id {
                        isSelectByData = true
                    }
                }
                if isSelectByData {
                    cell.selectBtn.isSelected = true
                    cell.btmView.isHidden = false
                    cell.btmViewHeight.constant = 89
                }else{
                    cell.selectBtn.isSelected = false
                    cell.btmView.isHidden = true
                    cell.btmViewHeight.constant = 0
                }
            }else{//非预售
                cell.maxNum = model.inventory
                cell.selectBtn.isSelected = false
                cell.btmView.isHidden = true
                cell.btmViewHeight.constant = 0
                var isSelectByData = false
                selectArr.forEach { (md) in
                    if md.sku_id == model.sku_id {
                        isSelectByData = true
                    }
                }
                if isSelectByData {
                    cell.selectBtn.isSelected = true
                    cell.btmView.isHidden = false
                    cell.btmViewHeight.constant = 89
                }
            }
        }
        return cell
    }
    
    
    
    
    func tableView(_ tableView: UITableView, heightForRowAt indexPath: IndexPath) -> CGFloat {
        if barTitle == "修改价格"{
            return 210
        }
        if idx != nil {
            if indexPath == idx {
                return 210
            }
        }
        for idx in selectIdxArr {
            if indexPath == idx {
                return 210
            }
        }
        return 120
    }
    
    //MARK: - SELF DELEGATE
    
    
    func XuanZeShangPinCellBtnClick(index:IndexPath) {
        let model = datas[index.row]
        if isYuShou{//预售
            if isCG == false {
                if model.adsale_inventory == 0 {
                    HUD.flash(.label("库存为0，无法下单"),delay: 1.2)
                    return
                }
            }
            idx = index
            selectArr.removeAll()
            selectArr.append(model)
        }else{//非预售
            let data = datas[index.row]
            if isCG == false {
                if data.inventory == 0 {
                    HUD.flash(.label("库存为0，无法下单"),delay: 1.2)
                    return
                }
            }
            let idx = selectArr.firstIndex { (model) -> Bool in
                return (data.sku_id == model.sku_id)
            }
            if idx != nil {
                selectArr.remove(at: idx!)
            }else{
                selectArr.append(data)
            }
            //
            if selectIdxArr.contains(index){
                selectIdxArr.remove(at: idx!)
            }else{
                selectIdxArr.append(index)
            }
            if selectArr.count > 0 {
                btmLbl.text = "确定(\(selectArr.count))"
            }else{
                btmLbl.text = "确定"
            }
        }
        listView.reloadData()
    }
    func XuanZeShangPinCellCountChange(sender: XuanZeShangPinCell, senderTF: UITextField) {
        if barTitle == "修改价格"{
            let model = selectArr[sender.tag]
            if isPurnInt(string: senderTF.text!){
                
                if Int(senderTF.text!)! > sender.maxNum! {
                    if isCG == false {
                        HUD.flash(.label("超出最大数量\(sender.maxNum!)"), delay: 1.2)
                        model.target_Count = sender.maxNum!
                        senderTF.text = "\(sender.maxNum!)"
                    }else{
                        senderTF.text = formatShowNumber(value: senderTF.text!)
                        model.target_Count = Int(senderTF.text!.replacingOccurrences(of: ",", with: ""))
                        print("model 1= ",model.target_Count)
                    }
                }else if Int(senderTF.text!) == 0{
                    HUD.flash(.label("数量不小于1"), delay: 1.2)
                    model.target_Count = 1
                    senderTF.text = "1"
                }else{
                    model.target_Count = Int(senderTF.text!.replacingOccurrences(of: ",", with: ""))
                    senderTF.text = formatShowNumber(value: senderTF.text!)
                    print("model2= ",model.target_Count)
                }
            }else{
                HUD.flash(.label("请输入正确的数量"), delay: 1.2)
                model.target_Count = model.origin_number!
                senderTF.text = StringByInt(number: (model.origin_number!))
            }
        }else{
            if isPurnInt(string: senderTF.text!){
                if Int(senderTF.text!)! > sender.maxNum! {
                    if isCG == false {
                        HUD.flash(.label("超出最大数量\(sender.maxNum!)"), delay: 1.2)
                        sender.model!.target_Count = sender.maxNum!
                        senderTF.text = "\(sender.maxNum!)"
                    }else{
                        senderTF.text = formatShowNumber(value: senderTF.text!)
                        sender.model?.target_Count = Int(senderTF.text!.replacingOccurrences(of: ",", with: ""))
                    }
                }else if Int(senderTF.text!) == 0{
                    HUD.flash(.label("数量不小于1"), delay: 1.2)
                    sender.model!.target_Count = 1
                    senderTF.text = "1"
                }else{
                    senderTF.text = formatShowNumber(value: senderTF.text!)
                    sender.model?.target_Count = Int(senderTF.text!.replacingOccurrences(of: ",", with: ""))
                }
            }else{
                HUD.flash(.label("请输入正确的数量"), delay: 1.2)
                senderTF.text = StringByInt(number: (sender.model?.origin_number!)!)
                sender.model?.target_Count = sender.model?.origin_number!
            }
        }
    }
    //MARK: - cell delegate
    func tableView(_ tableView: UITableView, numberOfRowsInSection section: Int) -> Int {
        if barTitle == "修改价格"{
            return selectArr.count
        }
        
        if isSearch {
            return seacrchArr.count
        }
        
        return datas.count
        
    }
    
    
}
