//
//  GYSGLViewController.swift
//  GeliBusinessPlatform
//
//  Created by junye lu on 2020/4/29.
//  Copyright © 2020 junye lu. All rights reserved.
//

import UIKit
import LGButton
import SwiftyJSON
import Photos
protocol GYSGLViewControllerDelegate {
    func GYSGLViewControllerFinish()
}
class GYSGLViewController: BaseViewController,UITableViewDelegate,UITableViewDataSource,TitleAndTFAndBtnCellDelegate,TitleAndOnlyBtnCellDelegate,SJMapViewControllerDelegate, UIPickerViewDelegate, UIPickerViewDataSource,GeliAlertViewDelegate,UITextFieldDelegate{
    func sureGeliAlertViewAction(sender: UIButton) {
        HUD.flash(.progress)
        let proDict = addressArray[provinceIndex] as! Dictionary<String,Any>
               var cityDict:Dictionary<String,Any> = Dictionary()
               var areaDict:Dictionary<String,Any> = Dictionary()
               cityDict["area_id"] = ""
               areaDict["area_id"] = ""
               if (proDict["city_list"] as! NSArray).count > 0 {
                   cityDict = (proDict["city_list"] as! NSArray)[cityIndex] as! Dictionary<String, Any>
                   if (cityDict["district_list"] as! NSArray).count > 0 {
                       areaDict = (cityDict["district_list"] as! NSArray)[areaIndex] as! Dictionary<String,Any>
                   }
               }
        var dict = ["user_token":UserToken as Any,
                    "ven_name":gysName as Any,
                    "province":proDict["area_id"] as Any,
                    "city":cityDict["area_id"] as Any,
                    "district":areaDict["area_id"] as Any,
                    "address":detailDzStr as Any,
                    "contacts_name":nameStr as Any,
                    "contacts_phone":telNum as Any,
                    "contacts_mobile":phoneNum as Any,
                    "zhizhao":zhizhao as Any,
                    "food_production_license":food_production_license as Any
        ]
        
        switch sender.tag {
        case 100:
            editField(["user_token":UserToken as Any,"function_id":48 as Any,"prval":ven_id as Any,"value":2 as Any], success: { (data) in
                HUD.hide()
                self.delegate?.GYSGLViewControllerFinish()
                self.navigationController?.popViewController(animated: true)}) { (error) in }
            break
        case 101:
            dict["ven_id"] = ven_id
            vendorEdit(dict, success: { (data) in
                HUD.hide()
                HUD.flash(.labeledSubSuccess(subtitle: "编辑成功"), delay: 1.2)
                self.delegate?.GYSGLViewControllerFinish()
                self.navigationController?.popViewController(animated: true)
            }) { (err) in
                
            }
            break
        case 102:
            vendorAdd(dict, success: { (data) in
                HUD.hide()
                HUD.flash(.labeledSubSuccess(subtitle: "提交成功"), delay: 1.2)
                self.delegate?.GYSGLViewControllerFinish()
                self.navigationController?.popViewController(animated: true)
            }) { (err) in
                
            }
            break
        default:
            break
        }
        
    }
    var delegate:GYSGLViewControllerDelegate?
    
    func SJMapViewControllerSelectArd(adr: String) {
        detailDzStr = adr
        listView.reloadData()
    }
    var btmView:UIView?
    var bgBtn:UIButton?
    //选择的省索引
    var provinceIndex = 0
    //选择的市索引
    var cityIndex = 0
    //选择的区（县）索引
    var areaIndex = 0
    var gysName:String = ""
    var dzStr:String = ""
    var detailDzStr:String = ""
    var nameStr:String = ""
    var phoneNum:String = ""
    var telNum:String = ""
    var img1 = UIImageView()
    var img2 = UIImageView()
    
    var zhizhao = ""
    var food_production_license = ""
    var ven_id:Int?
    var barT = ""
    let UserToken = UserDefaults.standard.value(forKey: "user_token")
    
    @IBOutlet weak var listView: UITableView!
    
    @IBOutlet weak var btmBtn: LGButton!
    func rightBtnClick() {
        
        let alertView = GeliAlertView(frame: self.view.window!.bounds)
        alertView.delegate = self;
        alertView.tishiLbl.text = ""
        alertView.titileLbl.text = "是否删除供应商？"
        alertView.rightBtn.setAttributedTitle(NSAttributedString(string: "确定"), for: .normal)
        alertView.rightBtn.tag = 100
        self.view.window?.addSubview(alertView)
    }
    override func viewDidLoad() {
        super.viewDidLoad()
        navbar.title = barT
        if barT.contains("编辑"){
            navbar.rightTitle = "删除"
            navbar.rightBtnColor = UIColor(named: "#F57575")
        }
        self.view.addSubview(navbar)
        
        getIndex()
        
        listView.separatorStyle = .none
        
        SetTopFrameView(view: listView, btmView: btmBtn)
        listView.register(UINib(nibName: "TitleAndTFCell", bundle: nil), forCellReuseIdentifier: "TitleAndTFCell")
        listView.register(UINib(nibName: "TitleAndOnlyBtnCell", bundle: nil), forCellReuseIdentifier: "TitleAndOnlyBtnCell")
        listView.register(UINib(nibName: "TitleAndTFAndBtnCell", bundle: nil), forCellReuseIdentifier: "TitleAndTFAndBtnCell")
        
    }
    let titleArr = ["基本信息","联系人信息","其它信息"]
    //MARK: - cell delegate
    func tableView(_ tableView: UITableView, heightForFooterInSection section: Int) -> CGFloat {
        return 10
    }
    func tableView(_ tableView: UITableView, viewForFooterInSection section: Int) -> UIView? {
        let view = UIView(frame: CGRect(x: 0, y: 0, width: fullScreenWidth, height: 10))
        return view
    }
    func tableView(_ tableView: UITableView, heightForHeaderInSection section: Int) -> CGFloat {
        return 36
    }
    func tableView(_ tableView: UITableView, viewForHeaderInSection section: Int) -> UIView? {
        let view = UIView(frame: CGRect(x: 0, y: 0, width: fullScreenWidth, height: 36))
        view.backgroundColor = UIColor.white
        let title = UILabel()
        title.text = titleArr[section]
        title.textColor = UIColor(named: "标题字颜色")
        title.font = UIFont.boldSystemFont(ofSize: 15)
        view.addSubview(title)
        title.snp.makeConstraints { (make) in
            make.top.left.right.equalTo(15)
            make.height.equalTo(21)
        }
        return view
    }
    func tableView(_ tableView: UITableView, heightForRowAt indexPath: IndexPath) -> CGFloat {
        if indexPath.section == 2 {
            if zhizhao.count > 0 {
                if indexPath.row == 0 {
                    return 100
                }
            }
            if food_production_license.count > 0 {
                if indexPath.row == 1 {
                    return 100
                }
            }
        }
        return 49
    }
    func numberOfSections(in tableView: UITableView) -> Int {
        return 3
    }
    func tableView(_ tableView: UITableView, numberOfRowsInSection section: Int) -> Int {
        switch section {
        case 0:return 3
        case 1:return 3
        default:return 2
        }
    }
    let sec1Arr = ["供应商名称：","地址：","详细地址："]
    let hold1Arr = ["请输入供应商名称","请选择供应商地址","请输入供应商详细地址"]
    let sec2Arr = ["姓名：","手机：","电话："]
    let hold2Arr = ["请输入联系人姓名","请输入联系人手机号码","请输入联系电话"]
    let sec3Arr = ["营业资格证：","食品流通许可证："]
    func tableView(_ tableView: UITableView, cellForRowAt indexPath: IndexPath) -> UITableViewCell {
        switch indexPath.section {
        case 0:
            if indexPath.row == 2 {
                let cell = tableView.dequeueReusableCell(withIdentifier: "TitleAndTFAndBtnCell") as! TitleAndTFAndBtnCell
                cell.titleLbl.text = sec1Arr[indexPath.row]
                cell.textTF.placeholder = hold1Arr[indexPath.row]
                cell.textTF.delegate = self
                cell.textTF.tag = 2
                if barT.contains("编辑"){
                    cell.textTF.clearButtonMode = .always
                }else{
                    cell.textTF.clearButtonMode = .whileEditing
                }
                if detailDzStr.count > 0 {
                    cell.textTF.text = detailDzStr
                }
                cell.delegate = self
                return cell
            }
            let cell = tableView.dequeueReusableCell(withIdentifier: "TitleAndTFCell") as! TitleAndTFCell
            cell.nameLbl.text = sec1Arr[indexPath.row]
            cell.textTF.placeholder = hold1Arr[indexPath.row]
            cell.textTF.delegate = self
            cell.textTF.tag = indexPath.row
            if indexPath.row == 0 {
                if barT.contains("编辑"){
                    cell.textTF.clearButtonMode = .always
                }else{
                    cell.textTF.clearButtonMode = .whileEditing
                }
                if gysName.count > 0 {
                    cell.textTF.text = gysName
                }
            }else{
                cell.textTF.isUserInteractionEnabled = false
                if dzStr.count > 0 {
                    cell.textTF.text = dzStr
                }
            }
            return cell
        case 1:
            let cell = tableView.dequeueReusableCell(withIdentifier: "TitleAndTFCell") as! TitleAndTFCell
            cell.nameLbl.text = sec2Arr[indexPath.row]
            cell.textTF.placeholder = hold2Arr[indexPath.row]
            if barT.contains("编辑"){
                cell.textTF.clearButtonMode = .always
            }else{
                cell.textTF.clearButtonMode = .whileEditing
            }
            cell.textTF.delegate = self
            cell.textTF.tag = indexPath.row + 100
            switch indexPath.row {
            case 0:
                if nameStr.count > 0 {
                    cell.textTF.text = nameStr
                }
                break
            case 1:
                if phoneNum.count > 0 {
                    cell.textTF.text = phoneNum
                }
                break
            default:
                if telNum.count > 0 {
                    cell.textTF.text = telNum
                }
                break
            }
            return cell
        default:
            let cell = tableView.dequeueReusableCell(withIdentifier: "TitleAndOnlyBtnCell") as! TitleAndOnlyBtnCell
            cell.titleLbl.text = sec3Arr[indexPath.row]
            cell.button.setTitle("上传", for: .normal)
            cell.delegate = self
            cell.tag = indexPath.row
            if zhizhao.count > 0 {
                if indexPath.row == 0 {
                    cell.imgBgView.isHidden = false
                    cell.imgView.sd_setImage( with: URL(string: SERVERCE_ImageHost + zhizhao))
                }
            }
            if food_production_license.count > 0 {
                if indexPath.row == 1 {
                    cell.imgBgView.isHidden = false
                    cell.imgView.sd_setImage( with: URL(string: SERVERCE_ImageHost + food_production_license))
                }
            }
            
            return cell
        }
    }
    @objc func closeAction(sender:UIButton){
        bgBtn?.removeFromSuperview()
        btmView?.subviews.forEach({ (view) in
            view.removeFromSuperview()
        })
        btmView?.removeFromSuperview()
        btmView = nil
        bgBtn = nil
    }
    @objc func adrSelectFinish(sender:UIButton){
        
        var proName = ""
        var cityName = ""
        var areaName = ""
        let proDict = addressArray[provinceIndex] as! Dictionary<String,Any>
        proName = proDict["area_name"] as! String
        if (proDict["city_list"] as! NSArray).count > 0 {
            let cityDict = (proDict["city_list"] as! NSArray)[cityIndex] as! [String: AnyObject]
            cityName = cityDict["area_name"] as! String
            if (cityDict["district_list"] as! NSArray).count > 0 {
                let areaDict = (cityDict["district_list"] as! NSArray)[areaIndex] as! Dictionary<String,Any>
                areaName = areaDict["area_name"] as! String
            }
        }
        
        
        var selectAdr = proName
        if cityName.count > 0 {
            selectAdr = proName + "-" + cityName
            if areaName.count > 0 {
                selectAdr = proName + "-" + cityName + "-" + areaName
            }
        }
        
        dzStr = selectAdr
        bgBtn?.removeFromSuperview()
        btmView?.subviews.forEach({ (view) in
            view.removeFromSuperview()
        })
        btmView?.removeFromSuperview()
        btmView = nil
        bgBtn = nil
        listView.reloadData()
    }
    func tableView(_ tableView: UITableView, didSelectRowAt indexPath: IndexPath) {
        if indexPath.section == 0 {
            if indexPath.row == 1 {
                if bgBtn == nil {
                    let btn = UIButton()
                    self.view.addSubview(btn)
                    btn.backgroundColor = UIColor.black
                    btn.alpha = 0.4
                    btn.addTarget(self, action: #selector(closeAction(sender:)), for: .touchUpInside)
                    btn.snp.makeConstraints { (make) in
                        make.top.right.bottom.left.equalTo(0)
                    }
                    bgBtn = btn
                }
                if btmView == nil {
                    let view = UIView()
                    view.backgroundColor = UIColor.white
                    btmView = view
                    self.view.addSubview(btmView!)
                    btmView!.snp.makeConstraints { (make) in
                        make.left.bottom.right.equalTo(0)
                        make.height.equalTo(230)
                    }
                    showAreaSelect(view:btmView!)
                    
                    let rightBtn = UIButton()
                    rightBtn.setTitle("确定", for: .normal)
                    rightBtn.setTitleColor(UIColor(named: "蓝色字体颜色"), for: .normal)
                    rightBtn.titleLabel?.font = UIFont.systemFont(ofSize: 15)
                    rightBtn.addTarget(self, action: #selector(adrSelectFinish(sender:)), for: .touchUpInside)
                    btmView?.addSubview(rightBtn)
                    rightBtn.snp.makeConstraints { (make) in
                        make.right.equalTo(-15)
                        make.top.equalTo(0)
                        make.height.equalTo(30)
                        make.width.equalTo(50)
                    }
                    
                    let leftBtn = UIButton()
                    leftBtn.setTitle("取消", for: .normal)
                    leftBtn.setTitleColor(UIColor(named: "多选按钮字体颜色"), for: .normal)
                    leftBtn.titleLabel?.font = UIFont.systemFont(ofSize: 15)
                    leftBtn.addTarget(self, action: #selector(closeAction(sender:)), for: .touchUpInside)
                    btmView?.addSubview(leftBtn)
                    leftBtn.snp.makeConstraints { (make) in
                        make.left.equalTo(15)
                        make.top.equalTo(0)
                        make.height.equalTo(30)
                        make.width.equalTo(50)
                    }
                }
            }
        }
        if indexPath.section == 2 {
            _ = self.presentHGImagePicker(maxSelected:1) { (assets) in
                //结果处理
                print("共选择了\(assets.count)张图片，分别如下：")
                let option = PHImageRequestOptions()
                option.isSynchronous = true
                option.isNetworkAccessAllowed = true
                for asset in assets {
                    PHImageManager.default().requestImage(for: asset, targetSize: PHImageManagerMaximumSize , contentMode:  .default , options: option, resultHandler: { (image,  _: [AnyHashable : Any]?) in
                        //                    print("上传图片==\(image)")
                        
                        self.uploadImg(imge: image!, isOriginal: true, tag: indexPath.row)
                        
                    })
                }
                self.listView.reloadData()
            }
        }
    }
    func uploadImg(imge:UIImage,isOriginal:Bool,tag:Int){
        
        let upLoadImg = imge as! UIImage
        HUD.show(.progress)
        saveFile(image: upLoadImg, ["user_token":UserToken as Any,"path":"purchaseorder" as Any], success: { (data) in
            let dataM = data as! SaveFileModel
            if dataM.code == 1 {
                print("图片上传成功\(dataM.data?.url)")
                if tag == 0 {
                    self.zhizhao = dataM.data?.url! as! String
                    self.img1.image = upLoadImg
                }else{
                    self.food_production_license = dataM.data?.url! as! String
                    self.img2.image = upLoadImg
                }
                self.listView.reloadData()
                HUD.hide()
            }
            
        }) { (error) in
            print("图片上传失败\(error)")
        }
        
    }
    //自定义cell delegate
    func TitleAndOnlyBtnCellEditBtnClick(cell: TitleAndOnlyBtnCell) {
        _ = self.presentHGImagePicker(maxSelected:1) { (assets) in
            //结果处理
            print("共选择了\(assets.count)张图片，分别如下：")
            let option = PHImageRequestOptions()
            option.isSynchronous = true
            option.isNetworkAccessAllowed = true
            for asset in assets {
                PHImageManager.default().requestImage(for: asset, targetSize: PHImageManagerMaximumSize , contentMode:  .default , options: option, resultHandler: { (image,  _: [AnyHashable : Any]?) in
                    //                    print("上传图片==\(image)")
                    
                    self.uploadImg(imge: image!, isOriginal: true, tag: cell.tag)
                    
                })
            }
            self.listView.reloadData()
        }
    }
    func TitleAndOnlyBtnCellBtnClick(cell: TitleAndOnlyBtnCell) {
        _ = self.presentHGImagePicker(maxSelected:1) { (assets) in
            //结果处理
            print("共选择了\(assets.count)张图片，分别如下：")
            let option = PHImageRequestOptions()
            option.isSynchronous = true
            option.isNetworkAccessAllowed = true
            for asset in assets {
                PHImageManager.default().requestImage(for: asset, targetSize: PHImageManagerMaximumSize , contentMode:  .default , options: option, resultHandler: { (image,  _: [AnyHashable : Any]?) in
                    //                    print("上传图片==\(image)")
                    self.uploadImg(imge: image!, isOriginal: true, tag: cell.tag)
                })
            }
            self.listView.reloadData()
        }
    }
    func TitleAndTFAndBtnCellBtnClick() {
        let vc = SJMapViewController()
        vc.delegate = self
        self.navigationController?.pushViewController(vc, animated: true)
    }
    
    func getIndex(){
        let path = Bundle.main.path(forResource: "address_new", ofType: "json")
        let url = URL(fileURLWithPath: path!)
        // 带throws的方法需要抛异常
        do {
            let data = try Data(contentsOf: url)
            let jsonData = JSON(data)
            print("地址文件数据",jsonData["data"])
            
            self.addressArray = jsonData["data"].arrayObject!
            
            for i in 0 ..< addressArray.count {
                let item = addressArray[i] as! Dictionary<String,Any>
                if item["area_id"] as! Int == provinceIndex {
                    let citys = item["city_list"] as! Array<Dictionary<String,Any>>
                    if citys.count == 0 {
                        provinceIndex = i
                        dzStr = item["area_name"]! as! String
                    }
                    for j in 0 ..< citys.count {
                        let cItem = citys[j]
                        if cItem["area_id"] as! Int == cityIndex {
                            let districts = cItem["district_list"] as! Array<Dictionary<String,Any>>
                            if districts.count == 0 {
                                cityIndex = j
                                dzStr = "\(item["area_name"]!)-\(cItem["area_name"]!)"
                            }
                            for k in 0 ..< districts.count{
                                let dItem = districts[k]
                                if dItem["area_id"] as! Int == areaIndex{
                                    provinceIndex = i
                                    cityIndex = j
                                    areaIndex = k
                                    dzStr = "\(item["area_name"]!)-\(cItem["area_name"]!)-\(dItem["area_name"]!)"
                                    break
                                }
                            }
                            
                        }
                    }
                }
            }
        } catch let error as Error? {
            print("读取本地数据出现错误!",error as Any)
        }
    }
    //MARK:--地址选择器
    func showAreaSelect(view:UIView){
        //创建选择器
        
        pickerView=UIPickerView()
        //将dataSource设置成自己
        pickerView.dataSource=self
        //将delegate设置成自己
        pickerView.delegate=self
        view.addSubview(pickerView)
        pickerView.snp.makeConstraints { (make) in
            make.top.equalTo(30)
            make.left.right.bottom.equalTo(0)
        }
        pickerView.selectRow(provinceIndex, inComponent: 0, animated: false)
        pickerView(pickerView, didSelectRow: provinceIndex, inComponent: 0)
        pickerView.selectRow(cityIndex, inComponent: 1, animated: false)
        pickerView(pickerView, didSelectRow: cityIndex, inComponent: 1)
        pickerView.selectRow(areaIndex, inComponent: 2, animated: false)
        pickerView(pickerView, didSelectRow: areaIndex, inComponent: 2)
        
        
    }
    //选择器
    var pickerView:UIPickerView!
    //所以地址数据集合
    var addressArray:Array<Any> = []
    
    //设置选择框的列数为3列,继承于UIPickerViewDataSource协议
    func numberOfComponents(in pickerView: UIPickerView) -> Int {
        return 3
    }
    
    //设置选择框的行数，继承于UIPickerViewDataSource协议
    func pickerView(_ pickerView: UIPickerView,
                    numberOfRowsInComponent component: Int) -> Int {
        if component == 0 {
            return self.addressArray.count
        } else if component == 1 {
            print("alkjdflkasd == ",provinceIndex)
            let province = self.addressArray[provinceIndex] as! Dictionary<String,Any>
            
            return (province["city_list"]! as! NSArray).count
        } else {
            let province = self.addressArray[provinceIndex] as! Dictionary<String,Any>
            if  (province["city_list"] as! NSArray).count == 0 {
                return 0
            }
            if let city = (province["city_list"] as! NSArray)[cityIndex]
                as? [String: AnyObject] {
                print(city["district_list"] as Any)
                return (city["district_list"]! as! NSArray).count
            } else {
                return 0
            }
        }
    }
    //设置选择框各选项的内容，继承于UIPickerViewDelegate协议
    func pickerView(_ pickerView: UIPickerView, titleForRow row: Int,
                    forComponent component: Int) -> String? {
        if component == 0 {
            let rowDic = self.addressArray[row] as! Dictionary<String,Any>
            return rowDic["area_name"] as? String
        }else if component == 1 {
            let province = self.addressArray[provinceIndex] as! Dictionary<String,Any>
            let city = (province["city_list"] as! NSArray)[row]
                as! [String: AnyObject]
            return city["area_name"] as? String
        }else {
            let province = self.addressArray[provinceIndex] as! Dictionary<String,Any>
            let city = (province["city_list"] as! NSArray)[cityIndex]
                as! [String: AnyObject]
            let area = (city["district_list"] as! NSArray)[row] as! Dictionary<String,Any>
            return area["area_name"] as? String
        }
    }
    
    //选中项改变事件（将在滑动停止后触发）
    func pickerView(_ pickerView: UIPickerView, didSelectRow row: Int,
                    inComponent component: Int) {
        //根据列、行索引判断需要改变数据的区域
        switch (component) {
        case 0:
            provinceIndex = row;
            pickerView.reloadComponent(1);
            pickerView.reloadComponent(2);
            pickerView.selectRow(cityIndex, inComponent: 1, animated: false)
            pickerView.selectRow(areaIndex, inComponent: 2, animated: false)
        case 1:
            cityIndex = row;
            pickerView.reloadComponent(2);
            pickerView.selectRow(areaIndex, inComponent: 2, animated: false)
        case 2:
            areaIndex = row;
        default:
            break;
        }
    }
    //自定义UIPickerView
    func pickerView(_ pickerView: UIPickerView, viewForRow row: Int, forComponent component: Int, reusing view: UIView?) -> UIView {
        let genderLbl = UILabel()
        genderLbl.textAlignment = .center
        genderLbl.font = UIFont.systemFont(ofSize: 15)
        genderLbl.textColor = UIColor.init(named: "标题字颜色")
        
        if component == 0 {
            let rowDic = self.addressArray[row] as! Dictionary<String,Any>
            genderLbl.text = rowDic["area_name"] as? String
        }else if component == 1 {
            let province = self.addressArray[provinceIndex] as! Dictionary<String,Any>
            let city = (province["city_list"] as! NSArray)[row]
                as! [String: AnyObject]
            genderLbl.text = city["area_name"] as? String
        }else {
            let province = self.addressArray[provinceIndex] as! Dictionary<String,Any>
            let city = (province["city_list"] as! NSArray)[cityIndex]
                as! [String: AnyObject]
            let area = (city["district_list"] as! NSArray)[row] as! Dictionary<String,Any>
            genderLbl.text = area["area_name"] as? String
        }
        
        return genderLbl
    }
    @IBAction func submitAction(_ sender: Any) {
        if gysName.count == 0 {
            HUD.flash(.label("请填写供应商名称"), delay: 1.2)
            return
        }
        if dzStr.count == 0 {
            HUD.flash(.label("请选择地址"), delay: 1.2)
            return
        }
        if detailDzStr.count == 0 {
            HUD.flash(.label("请填写详细地址"), delay: 1.2)
            return
        }
        if nameStr.count == 0 {
            HUD.flash(.label("请填写联系人姓名"), delay: 1.2)
            return
        }
        if phoneNum.count == 0 {
            HUD.flash(.label("请填写手机号码"), delay: 1.2)
            return
        }
        if isTelNumber(num: phoneNum as NSString) == false{
            HUD.flash(.label("请填写正确的手机号码"), delay: 1.2)
            return
        }
//        if zhizhao.count == 0 {
//            HUD.flash(.label("请上传营业资格证"), delay: 1.2)
//            return
//        }
//        if food_production_license.count == 0 {
//            HUD.flash(.label("请上传视频流通许可证"), delay: 1.2)
//            return
//        }
        let alertView = GeliAlertView(frame: self.view.window!.bounds)
        alertView.delegate = self;
        alertView.tishiLbl.text = ""
        alertView.rightBtn.setAttributedTitle(NSAttributedString(string: "确定"), for: .normal)
        if barT.contains("编辑"){
            alertView.titileLbl.text = "是否完成编辑？"
            alertView.rightBtn.tag = 101
        }else{
            alertView.titileLbl.text = "是否添加至供应商列表？"
            alertView.rightBtn.tag = 102
        }
        self.view.window?.addSubview(alertView)
    }
    func textFieldDidEndEditing(_ textField: UITextField) {
        if textField.text!.containsEmoji {
            HUD.flash(.label("输入不可包含表情符号"), delay: 1.2)
            return
        }
        switch textField.tag {
        case 0:
            gysName = textField.text!
            break
        case 2:
            detailDzStr = textField.text!
            break
        case 100:
            nameStr = textField.text!
            break
        case 101:
            phoneNum = textField.text!
            break
        case 102:
            telNum = textField.text!
            break
        default:
            break
        }
        
        
    }
}
