//
//  GYSListViewController.swift
//  GeliBusinessPlatform
//
//  Created by junye lu on 2020/5/8.
//  Copyright © 2020 junye lu. All rights reserved.
//

import UIKit
protocol GYSListViewControllerDelegate {
    func GYSListViewControllerGetGYS(sender:VendorListDataModel)
}
class GYSListViewController: BaseViewController,UITableViewDataSource,UITableViewDelegate,UISearchBarDelegate,SearchBarViewDelegate,GYSGLViewControllerDelegate{
    func GYSGLViewControllerFinish() {
        listView.mj_header?.beginRefreshing()
    }
    
    var delegate:GYSListViewControllerDelegate?
    var searchV : SearchBarView? = nil
    var selectTarget:VendorListDataModel?
    @IBOutlet weak var topView: UIView!
    @IBOutlet weak var btmLbl: UILabel!
    @IBOutlet weak var listView: UITableView!
    var barTitle:String?
    var keyWord = ""
    var page = 0
    var datas:Array<VendorListDataModel> = []
    let UserToken = UserDefaults.standard.value(forKey: "user_token")
    @objc func loadData(){
        print("加载数据")
        page = 1
        let dict = [
            "user_token":UserToken as Any,
            "keyword":keyWord as Any,
            "page":page as Any
        ]
        vendorList(dict, success: { (data) in
            self.datas.removeAll()
            let model = data as! VendorListModel
            self.listView.mj_header?.endRefreshing()
            self.page = 2
            model.data?.forEach({ (item) in
                self.datas.append(item)
            })
            self.listView.reloadData()
            if model.data?.count == 0 {
                self.listView?.mj_footer?.endRefreshingWithNoMoreData()
            }else{
                self.listView?.mj_footer?.endRefreshing()
            }
        }) { (error) in
            
        }
    }
    //MARK:--加载更多数据
    @objc func loadMoreData(){
        print("加载更多数据")
        
        let dict = [
            "user_token":UserToken as Any,
            "keyword":keyWord as Any,
            "page":page as Any
        ]
        vendorList(dict, success: { (data) in
            let dataM = data as! VendorListModel
            if dataM.data?.count == 0{
                self.listView?.mj_footer?.endRefreshingWithNoMoreData()
            }else{
                self.page += 1
                dataM.data?.forEach({ (model) in
                    self.datas.append(model)
                })
                self.listView.reloadData()
                self.listView?.mj_footer?.endRefreshing()
            }
        }) { (error) in
            self.listView?.mj_footer?.endRefreshing()
            
        }
        
    }
    override func viewDidLoad() {
        super.viewDidLoad()
        navbar.title = barTitle
        if barTitle != "供应商管理" {
            btmLbl.text = "确定"
        }
        self.view.addSubview(navbar)
        
        let searchBr = SearchBarView.init()
        topView.addSubview(searchBr)
        searchBr.snp.makeConstraints { (make) in
            make.left.equalTo(10)
            make.right.equalTo(-10)
            make.centerY.equalToSuperview()
            make.height.equalTo(30)
        }
        searchV = searchBr
        searchBr.placeholderStr = "供应商名称/联系人/电话号码"
        searchBr.cornerRadius = 35/2.0
        searchBr.delegate = self
        searchBr.delegateL = self
        
        SetTopFrame(view: topView, height: 44)
        listView.separatorStyle = .none
        listView.register(UINib(nibName: "GYSGLCell", bundle: nil), forCellReuseIdentifier: "GYSGLCell")
        // Do any additional setup after loading the view.
        
        //下拉刷新相关设置
        headerMJ.setRefreshingTarget(self, refreshingAction: #selector(loadData))
        self.listView!.mj_header = headerMJ
        //上拉加载相关设置
        footerMJ.setRefreshingTarget(self, refreshingAction: #selector(loadMoreData))
        self.listView!.mj_footer = footerMJ
        self.listView?.mj_header?.beginRefreshing()
    }
    
    @IBAction func addAction(_ sender: Any) {
        if barTitle != "供应商管理" {
            if selectTarget != nil {
                delegate?.GYSListViewControllerGetGYS(sender: selectTarget!)
                self.navigationController?.popViewController(animated: true)
            }else{
                HUD.flash(.label("请选择供应商"), delay: 1.2)
                return
            }
        }else{
            let vc = GYSGLViewController()
            vc.delegate = self
            vc.barT = "新增供应商信息"
            self.navigationController?.pushViewController(vc, animated: true)
        }
    }
    //MARK:--搜索模块
    //MAKR:--调起搜索后添加个蒙版本
    var blackBtnView:UIButton! = nil
    func searchBarShouldBeginEditing(_ searchBar: UISearchBar) -> Bool {
        print("调起搜索后添加个蒙版本")
        blackBtnView = UIButton ()
        blackBtnView.backgroundColor = UIColor.init(named: "提示视图背景色")
        view.addSubview(blackBtnView)
        blackBtnView.snp.makeConstraints { (make) in
            make.left.right.bottom.equalToSuperview()
            make.top.equalTo(topView.snp_bottom)
        }
        blackBtnView.addTarget(self, action: #selector(removeBlackBtnView), for: .touchUpInside)
        return true
    }
    @objc func removeBlackBtnView(){
        if blackBtnView != nil {
            blackBtnView.removeFromSuperview()
            searchV!.resignFirstResponder()
        }
    }
    
    //MARK:--搜索按钮代理
    func searchBarSearchButtonClicked(_ searchBar: UISearchBar) {
        print("点击搜索关键字进行--\(searchBar.text)")
        searchBar.resignFirstResponder()
        if blackBtnView != nil {
            blackBtnView.removeFromSuperview()
        }
        
        keyWord = searchBar.text!
        listView.mj_header?.beginRefreshing()
    }
    
    //MARK:--清空搜索代理
    func clearSearchAction() {
        
    }
    //MARK:--编辑即将结束
    func searchBarTextDidEndEditing(_ searchBar: UISearchBar) {
        print("编辑即将结束了--")
        removeBlackBtnView()
        if keyWord.count > 0 {
            keyWord = searchBar.text!
            if keyWord.count == 0 {
                listView.mj_header?.beginRefreshing()
            }
        }
    }
    //MARK: - CELL DELEGATE
    func tableView(_ tableView: UITableView, didSelectRowAt indexPath: IndexPath) {
        if barTitle == "供应商管理" {
            let data = datas[indexPath.row]
            let vc = GYSGLViewController()
            vc.delegate = self
            vc.barT = "编辑供应商信息"
            vc.gysName = data.ven_name!
            vc.provinceIndex = data.province!
            vc.cityIndex = data.city!
            vc.areaIndex = data.district!
            vc.detailDzStr = data.address!
            if data.contacts_phone != nil {
                vc.telNum = data.contacts_phone!
            }
            vc.ven_id = data.ven_id!
            vc.nameStr = data.contacts_name!
            vc.phoneNum = data.contacts_mobile!
            vc.zhizhao = data.zhizhao!
            vc.food_production_license = data.food_production_license!
          
//            vc.img1.sd_setImage(with: URL(string: SERVERCE_ImageHost + data.zhizhao!), placeholderImage: UIImage(named: "dowPhone"))
//            
//            
//            vc.img2.sd_setImage(with: URL(string: SERVERCE_ImageHost + data.food_production_license!), placeholderImage: UIImage(named: "dowPhone"))
            
            self.navigationController!.pushViewController(vc, animated: true)
        }else{
            selectTarget = datas[indexPath.row]
            listView.reloadData()
        }
        
    }
    func tableView(_ tableView: UITableView, heightForRowAt indexPath: IndexPath) -> CGFloat {
        return 105.5
    }
    func tableView(_ tableView: UITableView, numberOfRowsInSection section: Int) -> Int {
        return datas.count
    }
    
    func tableView(_ tableView: UITableView, cellForRowAt indexPath: IndexPath) -> UITableViewCell {
        let cell = tableView.dequeueReusableCell(withIdentifier: "GYSGLCell") as! GYSGLCell
        let model = datas[indexPath.row]
        if barTitle != "供应商管理" {
            cell.selectTypeBtn.isSelected = false
            cell.selectTypeView.isHidden = false
            cell.selectTypeBtn.isUserInteractionEnabled = false
            if selectTarget?.ven_id == model.ven_id {
                cell.selectTypeBtn.isSelected = true
            }
        }else{
            cell.selectTypeView.isHidden = true
        }
        
        cell.Lbl1.text = model.ven_name!
        cell.Lbl2.text = model.contacts_name! + " " + model.contacts_phone!
        
        cell.Lbl3.text = model.p_cn! + model.address!
        if model.c_cn != nil {
            cell.Lbl3.text = model.p_cn! + model.c_cn! +  model.address!
            if model.d_cn != nil {
                cell.Lbl3.text = model.p_cn! + model.c_cn! + model.d_cn! +  model.address!
            }
        }
        
        return cell
    }
}
