//
//  ChangePassViewController.swift
//  GeliBusinessPlatform
//
//  Created by junye lu on 2020/4/16.
//  Copyright © 2020 junye lu. All rights reserved.
//

import UIKit
import LGButton

class ChangePassViewController: BaseViewController {
    
    @IBOutlet weak var newPBtn: UIButton!
    @IBOutlet weak var oldPBtn: UIButton!
    @IBOutlet weak var newPassTF: UITextField!
    @IBOutlet weak var oldPassTF: UITextField!
    @IBOutlet weak var fisrtView: UIView!
    @IBOutlet weak var submitBtn: LGButton!
    
    override func viewDidLoad() {
        super.viewDidLoad()
        navbar.title = "修改密码"
        self.view.addSubview(navbar)
        
        newPassTF.isSecureTextEntry = true
        oldPassTF.isSecureTextEntry = true
        
        newPassTF.addTarget(self, action: #selector(tfChange(sender:)), for: .editingChanged)
        oldPassTF.addTarget(self, action: #selector(tfChange(sender:)), for: .editingChanged)
        
        // Do any additional setup after loading the view.
        fisrtView.snp.makeConstraints({ (make) in
            make.top.equalTo(NavCGRect.height)
            make.left.right.equalTo(0)
            make.height.equalTo(50)
        })
        // Do any additional setup after loading the view.
    }
    //MARK: -方法
    @objc func tfChange(sender:UITextField){
        if oldPassTF.textColor == UIColor(named: "密码错误字体颜色") {
            oldPassTF.textColor = UIColor(named: "标题字颜色")
        }
        if oldPassTF.text!.count > 0 && newPassTF.text!.count > 0 {
            submitBtn.alpha = 1
        }else{
            submitBtn.alpha = 0.45
        }
    }
    
    @IBAction func newPassAction(_ sender: UIButton) {
        newPBtn.isSelected = !newPBtn.isSelected
        newPassTF.isSecureTextEntry = !newPBtn.isSelected
    }
    @IBAction func oldPassAction(_ sender: UIButton) {
        oldPBtn.isSelected = !oldPBtn.isSelected
        oldPassTF.isSecureTextEntry = !oldPBtn.isSelected
    }
    @IBAction func submitAction(_ sender: Any) {
        let UserToken = UserDefaults.standard.value(forKey: "user_token")

        changePwd(["user_token":UserToken as Any,"pwd":oldPassTF.text as Any,"new_pwd":newPassTF.text as Any], success: { (data) in
            HUD.flash(.labeledSubSuccess(subtitle: "修改成功"),delay: 1.5)
            delay(1.5) {
                HUD.flash(.label("请重新登录"), delay: 1.5)
                delay(1.5){
                    UserDefaults.standard.removeObject(forKey: "user_token")
                    NotificationCenter.default.post(name: Notification.Name(rawValue: "logout"), object: nil)
                }
                
            }
            
        }) { (error) in
            
        }
    }
    
    
    
}
