//
//  PiCiXuanZeViewController.swift
//  GeliBusinessPlatform
//
//  Created by junye lu on 2020/4/28.
//  Copyright © 2020 junye lu. All rights reserved.
//

import UIKit
protocol PiCiXuanZeViewControllerDelegate {
    func PiCiXuanZeViewControllerPiCiSelect(data:Array<GetGoodBatchDataModel>,p_id:Int)
}
class PiCiXuanZeViewController: BaseViewController,UITableViewDelegate,UITableViewDataSource,PiCiXuanZeCellDelegate{
    
    
    var first = true
    var p_id:Int?
    var sku_id:Int?
    var tag:Int?
    var totalCount = 0
    var selectArr:Array<Int> = []
    var recordArr:Array<GetGoodBatchDataModel> = []
    var dataArray:Array<GetGoodBatchDataModel> = []
    @IBOutlet weak var topView: UIView!
    @IBOutlet weak var btmLbl: UILabel!
    var delegate:PiCiXuanZeViewControllerDelegate?
    @IBAction func submitAction(_ sender: Any) {
        for item in recordArr {
            
            if item.chuHuoLiang == nil {
                HUD.flash(.label("请输入数量"), delay: 1.2)
                return
            }
        }
        delegate?.PiCiXuanZeViewControllerPiCiSelect(data: recordArr,p_id: tag!)
        self.navigationController?.popViewController(animated: true)
    }
    @IBOutlet weak var listView: UITableView!
    override func viewDidLoad() {
        super.viewDidLoad()
        if recordArr.count == 0 {
            first = false
        }
        navbar.title = "批次选择"
        self.view.addSubview(navbar)
        topView.snp.makeConstraints { (make) in
            make.top.equalTo(NavCGRect.height)
            make.left.right.equalTo(0)
            make.height.equalTo(44)
        }
        listView.separatorStyle = .none
        
        listView.register(UINib(nibName: "PiCiXuanZeCell", bundle: nil), forCellReuseIdentifier: "PiCiXuanZeCell")
        listView.register(UINib(nibName: "CRKSumCell", bundle: nil), forCellReuseIdentifier: "CRKSumCell")
        let UserToken = UserDefaults.standard.value(forKey: "user_token")
        let dic = ["user_token":UserToken as Any,"sku_id":sku_id as Any]
        
        listView.isHidden = true
        HUD.flash(.progress)
        GetGoodBatch(dic, success: { (data) in
            let model = data as! GetGoodBatchModel
            model.data?.forEach({ (item) in
                self.dataArray.append(item)
            })
            if self.recordArr.count > 0 {
                for item in self.dataArray{
                    for model in self.recordArr{
                        if item.batch_id == model.batch_id{
                            item.chuHuoLiang = model.chuHuoLiang
                        }
                    }
                }
            }
            self.listView.reloadData()
            self.listView.isHidden = false
            HUD.hide()
        }) { (error) in
            
        }
        
        totalCount = 0
        if recordArr.count > 0 {
            for item in recordArr{
                totalCount += item.chuHuoLiang!
            }
        }
    }
    
    
    //MARK: - CELL DELEGATE
    func tableView(_ tableView: UITableView, heightForRowAt indexPath: IndexPath) -> CGFloat {
        return 49
    }
    func tableView(_ tableView: UITableView, numberOfRowsInSection section: Int) -> Int {
        if section == 1 {
            return 1
        }
        return dataArray.count
    }
 
    func tableView(_ tableView: UITableView, cellForRowAt indexPath: IndexPath) -> UITableViewCell {
        if indexPath.section == 1 {
            let cell = tableView.dequeueReusableCell(withIdentifier: "CRKSumCell") as! CRKSumCell
            
            cell.countLbl.text = "\(totalCount)"
            return cell
        }
        let cell = tableView.dequeueReusableCell(withIdentifier: "PiCiXuanZeCell") as! PiCiXuanZeCell
        cell.tag = indexPath.row
        let model = dataArray[indexPath.row]
        cell.delegate = self
        var name = ""
        switch model.status {
        case 1:
            name = "正常"
            break
        case 2:
            name = "临期"
            break
        default:
            name = "过期"
            break
        }
        cell.nameLbl.text = name
        cell.SLLbl.text = "\(model.inventory!)"
        cell.dateLbl.text = dayByDouble(sender: model.production_data!)
        if recordArr.count > 0 {
            for item in recordArr {
                if model.batch_id == item.batch_id {
                    if item.chuHuoLiang != nil {
                        cell.textTF.text = "\(item.chuHuoLiang!)"
                    }
                    cell.iconBtn.isSelected = true
                    if first {
                        first = false
                        selectArr.append(cell.tag)
                    }
                }
            }
        }
        
        return cell
    }
    
    func PiCiXuanZeCellBtnTextChange(sender: String, cell: PiCiXuanZeCell) {
        
        let num = sender as NSString
        let data = dataArray[cell.tag]
        data.chuHuoLiang = num.integerValue
    }
    
    func PiCiXuanZeCellRefreshCount(cell:PiCiXuanZeCell) {
       
        if selectArr.contains(cell.tag) == false {
            selectArr.append(cell.tag)
        }
        print(selectArr.count)
        let data = dataArray[cell.tag]
        let idx = recordArr.firstIndex { (model) -> Bool in
            return data.batch_id == model.batch_id
        }
        if idx == nil {
            recordArr.append(data)
        }
        print(recordArr.count)
        totalCount = 0
        for item in selectArr{
            let data = dataArray[item]
            if data.chuHuoLiang != nil {
                print(data.chuHuoLiang)
                totalCount += data.chuHuoLiang!
            }
        }
        listView.reloadData()
    }
    
    func PiCiXuanZeCellBtnSelect(cell: PiCiXuanZeCell) {
        //已选择cell
        if selectArr.contains(cell.tag){
            let idx = selectArr.index(of: cell.tag)
            selectArr.remove(at: idx!)
        }else{
            selectArr.append(cell.tag)
        }
        //数据
        let data = dataArray[cell.tag]
        let idx = recordArr.firstIndex { (model) -> Bool in
            return data.batch_id == model.batch_id
        }
        if idx != nil {
            recordArr.remove(at: idx!)
        }else{
            recordArr.append(data)
        }
        
        totalCount = 0
        
        for item in recordArr{
            if item.chuHuoLiang != nil {
                totalCount += item.chuHuoLiang!
            }
        }
        let index = IndexPath(row: 0, section: 1)
        listView.reloadRows(at: [index], with: .none)
    }
    
    
    func numberOfSections(in tableView: UITableView) -> Int {
        return 2
    }
    
    func tableView(_ tableView: UITableView, viewForFooterInSection section: Int) -> UIView? {
        return UIView()
    }
    func tableView(_ tableView: UITableView, heightForFooterInSection section: Int) -> CGFloat {
        return 10
    }
    
}
