//
//  GoodsClassViewController.swift
//  GeliBusinessPlatform
//
//  Created by 刘俊宏 on 2020/5/7.
//  Copyright © 2020 junye lu. All rights reserved.
//

import UIKit
import Dollar
protocol GoodsClassViewControllerDelegate {
    func blackGoodsClass(sender:GoodsClassModel)
}
class GoodsClassViewController: BaseViewController , UITableViewDelegate, UITableViewDataSource{
    var delegate : GoodsClassViewControllerDelegate?
    var dataModelArray : Array<GeneralInfoCatsModel>? = []

    override func viewDidLoad() {
        super.viewDidLoad()
        navbar.title = "请选择商品分类"
        self.view.addSubview(navbar)
        
        //先分级
        var levelArr_0  : Array<GeneralInfoCatsModel>? = []
        var levelArr_1  : Array<GeneralInfoCatsModel>? = []
        var levelArr_2  : Array<GeneralInfoCatsModel>? = []

        dataModelArray?.forEach({ (model) in
            if model.level == 0 {
                levelArr_0?.append(model)
            }else if model.level == 1 {
                levelArr_1?.append(model)
            }else if model.level == 2 {
                levelArr_2?.append(model)
            }
        })
        for i in 0..<levelArr_0!.count {
            let dataModel_1 = levelArr_0![i]
            //model_1
            let model_1 = GoodsClassModel()
            model_1.cat_name = dataModel_1.cat_name
            model_1.isExpand = false
            model_1.isCanExpand = false
            model_1.isCanSelect = false
            model_1.isSelect = false
            model_1.level = dataModel_1.level
            model_1.cat_id = dataModel_1.cat_id
            
            levelArr_1?.forEach({ (dataModel_2) in
                
                if dataModel_2.parent_id == model_1.cat_id {
                    model_1.isCanExpand = true
                    //model_2
                    let model_2 = GoodsClassModel()
                    model_2.cat_name = dataModel_2.cat_name
                    model_2.isExpand = false
                    model_2.isCanExpand = false
                    model_2.isCanSelect = false
                    model_2.isSelect = false
                    model_2.level = dataModel_2.level
                    model_2.cat_id = dataModel_2.cat_id
                    
                    levelArr_2?.forEach({ (dataModel_3) in
                        
                        if dataModel_3.parent_id == model_2.cat_id {
                            model_2.isCanExpand = true
                            //model_3
                            let model_3 = GoodsClassModel()
                            model_3.cat_name = dataModel_3.cat_name
                            model_3.isExpand = false
                            model_3.isCanExpand = false
                            model_3.isCanSelect = true
                            model_3.isSelect = false
                            model_3.level = dataModel_3.level
                            model_3.cat_id = dataModel_3.cat_id
                            
                            if selectModel != nil {
                                if model_3.cat_id == selectModel?.cat_id {
                                    model_3.isSelect = true
                                }
                            }
                            //添加
                            model_2.modelS?.append(model_3)
                        }
                        
                    })
                    
                    if !model_2.isCanExpand! {
                        model_2.isCanSelect = true
                    }
                    if selectModel != nil {
                        if model_2.cat_id == selectModel?.cat_id {
                            model_2.isSelect = true
                        }
                    }
                    model_1.modelS?.append(model_2)
                    
                }
            })
            if !model_1.isCanExpand! {
                model_1.isCanSelect = true
            }
            if selectModel != nil {
                if model_1.cat_id == selectModel?.cat_id {
                    model_1.isSelect = true
                }
            }
            var arrs:Array<Any> = []
            arrs.append(model_1)
            dataArr.append(arrs)
        }
 
        setTabv()
        
    }
    @IBOutlet weak var sureBtn: UIButton!
    //MARK:--确定按钮
    @IBAction func sureBtnAcion(_ sender: UIButton) {
        if selectModel == nil {
            HUD.flash(.label("请选择商品分类"), delay: 1.2)
        }else{
            //返回确定数据
            self.delegate?.blackGoodsClass(sender: selectModel!)
            self.navigationController?.popViewController(animated: true)
        }
    }
    var tableV :UITableView!
    var dataArr:Array<Any> = []
    func setTabv() {
        tableV = UITableView()
        view.addSubview(tableV);
        tableV.snp.makeConstraints { (make) in
            make.left.right.equalToSuperview()
            make.bottom.equalTo(sureBtn.snp_top)
            make.top.equalTo(navbar.snp_bottom)
        }
        tableV.backgroundColor = UIColor.init(named: "app底色")
        tableV.delegate = self
        tableV.dataSource = self
        tableV.separatorStyle = .none
        tableV?.register(UINib(nibName: "FirstCell", bundle: nil), forCellReuseIdentifier: "FirstCell")
        tableV?.register(UINib(nibName: "SecondCell", bundle: nil), forCellReuseIdentifier: "SecondCell")
        tableV?.register(UINib(nibName: "ThirdCell", bundle: nil), forCellReuseIdentifier: "ThirdCell")
        
    }
    func numberOfSections(in tableView: UITableView) -> Int {
        return dataArr.count
    }
    func tableView(_ tableView: UITableView, numberOfRowsInSection section: Int) -> Int {
        let arrs = dataArr[section] as! Array<Any>
        
        return arrs.count
    }
    
    func tableView(_ tableView: UITableView, cellForRowAt indexPath: IndexPath) -> UITableViewCell {
        
        let arrs = dataArr[indexPath.section] as! Array<Any>
        let rowModel = arrs[indexPath.row] as! GoodsClassModel
 
        if rowModel.level == 1 {
            let cell = tableView.dequeueReusableCell(withIdentifier: "SecondCell") as! SecondCell
            cell.nameLbl.text = rowModel.cat_name
            if rowModel.isCanExpand! {
                if rowModel.isExpand! {
                    cell.imgView.image = UIImage.init(named: "2")
                    cell.nameLbl.textColor = UIColor.init(named: "标题字颜色")
                }else{
                    cell.imgView.image = UIImage.init(named: "3")
                    cell.nameLbl.textColor = UIColor.init(named: "标题字颜色")
                }
            }else{
                if rowModel.isSelect! {
                    cell.imgView.image = UIImage.init(named: "yuxuan")
                    cell.nameLbl.textColor = UIColor.init(named: "蓝色字体颜色")
                }else{
                    cell.imgView.image = UIImage.init(named: "daixuan")
                    cell.nameLbl.textColor = UIColor.init(named: "标题字颜色")
                }
            }
            return cell
        }
        if rowModel.level == 2 {
            let cell = tableView.dequeueReusableCell(withIdentifier: "ThirdCell") as! ThirdCell
            cell.nameLbl.text = rowModel.cat_name
            if rowModel.isSelect! {
                cell.imgView.image = UIImage.init(named: "yuxuan")
                cell.nameLbl.textColor = UIColor.init(named: "蓝色字体颜色")
            }else{
                cell.imgView.image = UIImage.init(named: "daixuan")
                cell.nameLbl.textColor = UIColor.init(named: "标题字颜色")
            }
            return cell
        }
        let cell = tableView.dequeueReusableCell(withIdentifier: "FirstCell") as! FirstCell
        if rowModel.isCanExpand! {
            if rowModel.isExpand! {
                cell.imgView.image = UIImage.init(named: "1")
                cell.nameLbl.textColor = UIColor.init(named: "蓝色字体颜色")
            }else{
                cell.imgView.image = UIImage.init(named: "3")
                cell.nameLbl.textColor = UIColor.init(named: "标题字颜色")
            }
        }else{
            if rowModel.isSelect! {
                cell.imgView.image = UIImage.init(named: "yuxuan")
                cell.nameLbl.textColor = UIColor.init(named: "蓝色字体颜色")
            }else{
                cell.imgView.image = UIImage.init(named: "daixuan")
                cell.nameLbl.textColor = UIColor.init(named: "标题字颜色")
            }
        }
        cell.nameLbl.text = rowModel.cat_name
        
        return cell
    }
    
    var selectModel: GoodsClassModel? = nil
 
    func tableView(_ tableView: UITableView, didSelectRowAt indexPath: IndexPath) {
        let arrs = dataArr[indexPath.section] as! Array<Any>
        let rowModel = arrs[indexPath.row] as! GoodsClassModel
        
        if rowModel.level != 2 && rowModel.isCanExpand!
        {
            rowModel.isExpand = !rowModel.isExpand!
            
            reloadSection(section: indexPath.section, model: rowModel, isExpand: rowModel.isExpand!)
        }else{
            rowModel.isSelect = !rowModel.isSelect!
            
            //MARK:--如果是单选，那么就要更改别的数据源
            if rowModel.isSelect! {
                if selectModel == nil {
                    selectModel = rowModel
                }else{
                    selectModel?.isSelect = false
                    selectModel = rowModel
                }
            }else{
                 selectModel = nil
            }
    
            let reloadSet = IndexSet.init(arrayLiteral: indexPath.section)
            tableV.reloadData()
 
        }
    }
    //MARK:--展开或收起（利用数据）
    func reloadSection(section:Int,model:GoodsClassModel,isExpand:Bool) {
        var arrs = dataArr[section] as! Array<GoodsClassModel>
        let index = Dollar.indexOf(arrs, value: model)
        if isExpand {
            //这一步是防止在二级展开的情况下,关闭一级展开, 则二级展开的状态还是展开,需要手动置回 NO
            model.modelS?.forEach({ (md) in
                md.isExpand = false
            })
            arrs.insert(contentsOf: model.modelS!, at: index! + 1)
            dataArr.remove(at: section)
            dataArr.insert(arrs, at: section)
            
        }else{
            let lenght = ((model.level == 0) ? (arrs.count - 1):model.modelS?.count)!
            let startIndex = index! + 1
            let lastIndex = startIndex + lenght
            for i in (startIndex..<lastIndex).reversed() {
                arrs.remove(at: (i))
            }
            dataArr.remove(at: section)
            dataArr.insert(arrs, at: section)
        }
        let reloadSet = IndexSet.init(arrayLiteral: section)
        tableV.reloadSections(reloadSet, with: .automatic)

    }
    
    
    func tableView(_ tableView: UITableView, heightForRowAt indexPath: IndexPath) -> CGFloat {
        return 50*glscale
    }
}
