//
//  ShopInfoViewController.swift
//  GeliBusinessPlatform
//
//  Created by 刘俊宏 on 2020/4/17.
//  Copyright © 2020 junye lu. All rights reserved.
//

import UIKit

class ShopInfoViewController: BaseViewController {
    @IBOutlet weak var scrollHeight: NSLayoutConstraint!
    @IBOutlet weak var scrlloV: UIScrollView!
    
    
    var dataModel : ShopInfoModel? = nil
    override func viewDidLoad() {
        super.viewDidLoad()
        navbar.title = "商家信息"
        self.view.addSubview(navbar)
        scrlloV.showsVerticalScrollIndicator = false
        scrlloV.snp.makeConstraints { (make) in
            make.top.equalTo(NavCGRect.height)
            make.left.bottom.right.equalTo(0)
        }
        loadData()
    }
    
    //MARK:--加载数据
    func loadData(){
        let UserToken = UserDefaults.standard.value(forKey: "user_token")
        
        shopInfo(["user_token":UserToken as Any], success: { (data) in
            self.dataModel = (data as! ShopInfoModel)
            self.shopNameLbl.text = self.dataModel?.data?.shop_name
            self.compAddressLbl.text = self.dataModel?.data?.addr_str
            self.addressDetLbl.text = self.dataModel?.data?.address
            self.compPhoneLbl.text = self.dataModel?.data?.shop_tel
            self.compTotalLbl.text = self.dataModel?.data?.shop_scale
            //MARK:--需要计算高度，也可以根据行数确定
            self.compInfoLbl.text = self.dataModel?.data?.shop_intro
            print("简介\(self.compInfoLbl.numberOfLines)")
            self.scrollHeight.constant = 1081 + CGFloat(self.compInfoLbl.numberOfLines) * 15*glscale
            self.stallNameLbl.text = self.dataModel?.data?.stall_name
            self.accoutLbl.text = self.dataModel?.data?.contacts_name
            self.emailLbl.text = self.dataModel?.data?.shop_email
            self.businessNumLbl.text = self.dataModel?.data?.business_licence_number
            self.businessSphereLbl.text = self.dataModel?.data?.business_sphere
            self.idCardImgV.sd_setImage(with: URL(string: SERVERCE_ImageHost + (self.dataModel?.data?.identity_card_front)!))
            
        }) { (error) in
            //缺省数据，隐藏滚动视图，展示错误视图
        }
    }
    
    @IBAction func previousAction(_ sender: UIButton) {
        self.idCardImgV.sd_setImage(with: URL(string: SERVERCE_ImageHost + (self.dataModel?.data?.identity_card_front)!))
        rightChangeImgBtn.setImage(UIImage.init(named: "idCard2"), for: .normal)
        leftChangeImgBtn.setImage(UIImage.init(named: "idCard1"), for: .normal)
    }
    @IBAction func nextAction(_ sender: UIButton) {
        self.idCardImgV.sd_setImage(with: URL(string: SERVERCE_ImageHost + (self.dataModel?.data?.identity_card_back)!))
        
        rightChangeImgBtn.setImage(UIImage.init(named: "idCard4"), for: .normal)
        leftChangeImgBtn.setImage(UIImage.init(named: "idCard3"), for: .normal)
    }
    @IBAction func checkBtnAction(_ sender: UIButton) {
        let browser = JXPhotoBrowser()
        browser.numberOfItems = {
            1
        }
        var url:URL?
        print("查看==\(sender.tag)")
        if sender.tag == 1001 {
            //商家协议
            url = URL(string:SERVERCE_ImageHost + (self.dataModel?.data?.agreement)!)
            print(SERVERCE_ImageHost + (self.dataModel?.data?.agreement)!)
            browser.reloadCellAtIndex = { context in
                let browserCell = context.cell as? JXPhotoBrowserImageCell
                // 用SDWebImage加载
                browserCell?.imageView.sd_setImage(with: url, placeholderImage: nil, options: [], completed: { (_, _, _, _) in
                    browserCell?.setNeedsLayout()
                })
            }
            
        }else if sender.tag == 1002 {
            //营业执照电子版：
            url = URL(string:SERVERCE_ImageHost + (self.dataModel?.data?.zhizhao)!)
            browser.reloadCellAtIndex = { context in
                let browserCell = context.cell as? JXPhotoBrowserImageCell
                // 用SDWebImage加载
                browserCell?.imageView.sd_setImage(with: url, placeholderImage: nil, options: [], completed: { (_, _, _, _) in
                    browserCell?.setNeedsLayout()
                })
            }
        }else if sender.tag == 1003 {
            //流通许可证：
            url = URL(string:SERVERCE_ImageHost + (self.dataModel?.data?.food_production_license)!)
            browser.reloadCellAtIndex = { context in
                let browserCell = context.cell as? JXPhotoBrowserImageCell
                // 用SDWebImage加载
                browserCell?.imageView.sd_setImage(with: url, placeholderImage: nil, options: [], completed: { (_, _, _, _) in
                    browserCell?.setNeedsLayout()
                })
            }
        }
        browser.show()
    }
    
    @IBOutlet weak var leftChangeImgBtn: UIButton!
    @IBOutlet weak var rightChangeImgBtn: UIButton!
    @IBOutlet weak var shopImgV: UIImageView!
    @IBOutlet weak var shopNameLbl: UILabel!
    @IBOutlet weak var compAddressLbl: UILabel!
    @IBOutlet weak var addressDetLbl: UILabel!
    @IBOutlet weak var compPhoneLbl: UILabel!
    @IBOutlet weak var compTotalLbl: UILabel!
    @IBOutlet weak var compInfoLbl: UILabel!
    @IBOutlet weak var stallNameLbl: UILabel!
    @IBOutlet weak var accoutLbl: UILabel!
    @IBOutlet weak var emailLbl: UILabel!
    @IBOutlet weak var businessNumLbl: UILabel!
    @IBOutlet weak var businessSphereLbl: UILabel!
    @IBOutlet weak var idCardImgV: UIImageView!
    
}
