//
//  CityListViewController.swift
//  GeliBusinessPlatform
//
//  Created by 刘俊宏 on 2020/7/22.
//  Copyright © 2020 junye lu. All rights reserved.
//

import UIKit
protocol CityListViewControllerDelegate {
    func CityListViewControllerLocSelect(loc:cityListDataModel)
}
class CityListViewController: BaseViewController ,UITableViewDelegate,UITableViewDataSource, UISearchBarDelegate, SearchBarViewDelegate{
    //MAKR:--调起搜索后添加个蒙版本
    var delegate:CityListViewControllerDelegate?
    var keyword = ""
    var blackBtnView:UIButton! = nil
    
    var searchList:UITableView!
    
    var searchArr:Array<cityListDataModel> = []
    func searchBarSearchButtonClicked(_ searchBar: UISearchBar) {
        print("点击搜索进行--")
        searchBar.resignFirstResponder()
        keyword = searchBar.text!
        searchArr.removeAll()
        for item in adrDatas {
            if (item.name?.contains(keyword))! || (item.name_en?.contains(keyword.localizedLowercase))!{
                searchArr.append(item)
            }
        }
        
        if searchList == nil {
            searchList = UITableView()
            self.view.addSubview(searchList)
            searchList.snp.makeConstraints { (make) in
                make.top.equalTo(topView.snp.bottom)
                make.left.right.bottom.equalToSuperview()
            }
            searchList.delegate = self
            searchList.dataSource = self
            searchList.register(UINib(nibName: "TitleContentCell", bundle: nil), forCellReuseIdentifier: "TitleContentCell")
        }
        searchList.isHidden = false
        searchList.reloadData()
    }
    //MARK:--取消搜索代理
    func clearSearchAction() {
        print("取消搜索代理了--")
    }
    func searchBarTextDidEndEditing(_ searchBar: UISearchBar) {
        print("编辑即将结束了--")
        removeBlackBtnView()
        if searchBar.text?.count == 0 && keyword.count != 0{
            keyword = searchBar.text!
        }
        if searchBar.text!.count == 0 {
            searchList.isHidden = true
        }
    }
    func searchBarShouldBeginEditing(_ searchBar: UISearchBar) -> Bool {
        print("调起搜索后添加个蒙版本")
        
        blackBtnView = UIButton ()
        blackBtnView.backgroundColor = UIColor.init(named: "提示视图背景色")
        self.view.addSubview(blackBtnView)
        blackBtnView.snp.makeConstraints { (make) in
            make.left.right.bottom.equalToSuperview()
            make.top.equalTo(topView!.snp_bottom)
        }
        blackBtnView.addTarget(self, action: #selector(removeBlackBtnView), for: .touchUpInside)
        
        return true
    }
    @objc func removeBlackBtnView(){
        if blackBtnView != nil {
            blackBtnView.removeFromSuperview()
            searchBr.resignFirstResponder()
        }
    }
    

    
    @IBOutlet weak var locLbl: UILabel!
    
    @IBOutlet weak var listView: UITableView!
    @IBOutlet weak var topView: UIView!
    var locatStr = ""
    let adHeaders:[String] = ["A","B","C","D","E","F","G","H","J","K","L","M","N","O","P","Q","R","S","T","U","V","W","X","Y","Z"]
    var adrDatas:Array<cityListDataModel> = []
    var datas:Array<Dictionary<String,Array<cityListDataModel>>> = []
    
    var searchBr:SearchBarView!
    override func viewDidLoad() {
        super.viewDidLoad()
        navbar.title = "城市列表"
        
        locLbl.text = locatStr
        
        for chart in adHeaders {
            var arr:Array<cityListDataModel> = []
            for item in adrDatas {
                if "\(item.name_en!.first!)" == chart.localizedLowercase {
                    arr.append(item)
                }
            }
            if arr.count > 0 {
                var dict:Dictionary<String,Array<cityListDataModel>> = Dictionary()
                dict[chart] = arr
                datas.append(dict)
            }
        }

        self.view.addSubview(navbar)

        SetTopFrame(view: topView, height: 50)
        listView.separatorStyle = .none
        listView.register(UINib(nibName: "TitleContentCell", bundle: nil), forCellReuseIdentifier: "TitleContentCell")
        searchBr = SearchBarView.init()
        searchBr.delegate = self
        searchBr.delegateL = self
        topView.addSubview(searchBr)
        searchBr.snp.makeConstraints { (make) in
            make.left.equalTo(10)
            make.right.equalTo(-10)
            make.centerY.equalToSuperview()
            make.height.equalTo(35)
        }
        searchBr.placeholderStr = "请输入城市名称或拼音"
        searchBr.cornerRadius = 35/2.0
        var titlesArr:Array<String> = []
        for item in datas {
            titlesArr.append(item.keys.first!)
        }
        listView.customIndexView(indexTitles: titlesArr)
        listView.indexView = CustomIndexView()
        
    }
    func tableView(_ tableView: UITableView, didSelectRowAt indexPath: IndexPath) {
        print(indexPath)
        if tableView == searchList {
            delegate?.CityListViewControllerLocSelect(loc: searchArr[indexPath.row])
        }else{
            let item = datas[indexPath.section]
            let key = item.keys.first
            let arr = item[key!]
            delegate?.CityListViewControllerLocSelect(loc: arr![indexPath.row])
        }
        self.navigationController?.popViewController(animated: true)
    }
    func tableView(_ tableView: UITableView, heightForRowAt indexPath: IndexPath) -> CGFloat {
        return 45
    }
    func tableView(_ tableView: UITableView, numberOfRowsInSection section: Int) -> Int {
        if tableView == searchList {
            return searchArr.count
        }
        if datas.count == 0 {
            return 0
        }
        let dict = datas[section]
        let arr = dict[dict.keys.first!]
        return arr!.count
    }
    func numberOfSections(in tableView: UITableView) -> Int {
        if tableView == searchList {
            return 1
        }
        return datas.count;
    }
   
    @IBAction func back(_ sender: Any) {
        self.navigationController?.popViewController(animated: true)
    }
    func tableView(_ tableView: UITableView, cellForRowAt indexPath: IndexPath) -> UITableViewCell {
        let cell = tableView.dequeueReusableCell(withIdentifier: "TitleContentCell") as! TitleContentCell
        cell.contentLbl.isHidden = true
        if tableView == searchList {
            let item = searchArr[indexPath.row]
            cell.titleLbl.text = item.name
        }else{
            let dict = datas[indexPath.section]
            let key = dict.keys.first
            let arr = dict[key!]
            let item = arr![indexPath.row]
            cell.titleLbl?.text = item.name
        }
        return cell
    }
    
    func tableView(_ tableView: UITableView, heightForHeaderInSection section: Int) -> CGFloat {
  
        return 30
    }
    func tableView(_ tableView: UITableView, viewForHeaderInSection section: Int) -> UIView? {
        let view = UIView()
        view.backgroundColor = UIColor.init(named: "app底色")
        let cityLbl = UILabel()
        
        cityLbl.text = self.datas[section].keys.first
        cityLbl.textColor = UIColor.init(named: "灰色字体颜色")
        cityLbl.font = UIFont.systemFont(ofSize: 11)
        view.addSubview(cityLbl)
        cityLbl.snp.makeConstraints { (make) in
            make.left.equalTo(15)
            make.top.equalTo(7)
        }

        return view
    }
 
    func tableView(_ tableView: UITableView, heightForFooterInSection section: Int) -> CGFloat {
        return 0.01
    }
    
 
}
 
