//
//  ZengZhiServicesViewController.swift
//  GeliBusinessPlatform
//
//  Created by junye lu on 2020/4/24.
//  Copyright © 2020 junye lu. All rights reserved.
//

import UIKit
protocol ZengZhiServicesViewControllerDelegate {
    func ZengZhiServicesViewControllerFinish(price:Float,content:String)
}
class ZengZhiServicesViewController: BaseViewController,UITableViewDelegate,UITableViewDataSource,TitleAndSelectCellDelegate,UITextViewDelegate, UITextFieldDelegate{
    
    
    var delegate:ZengZhiServicesViewControllerDelegate?
    //MARK: - 数据汇总提交
    @IBAction func submitAction(_ sender: Any) {
        print("submit")
        if price.count == 0 {
            HUD.flash(.label("请输入保价金额"), delay: 1.2)
            return
        }
        let str = price as NSString
        
        if str.floatValue > 200000.00 {
            HUD.flash(.label("保价金额超出范围"), delay: 1.2)
            return
        }
        
        delegate?.ZengZhiServicesViewControllerFinish(price:str.floatValue, content: commend)

        self.navigationController?.popViewController(animated: true)
    }
    
    var titleArr = ["送货入仓","清真","易污染"]
    @IBOutlet weak var topView: UIView!
    @IBOutlet weak var nBtn: UIButton!
    @IBOutlet weak var pBtn: UIButton!
    @IBOutlet weak var eBtn: UIButton!
    @IBOutlet weak var textView: UITextView!
    @IBOutlet weak var countingLbl: UILabel!
    @IBOutlet weak var textViewHolderLbl: UILabel!
    @IBOutlet weak var priceTLbl: UILabel!
    @IBOutlet weak var priceLbl: UILabel!
    @IBOutlet weak var inputTF: UITextField!
    @IBOutlet weak var holderLbl: UILabel!
    @IBOutlet weak var listView: UITableView!
    
    var selectIdx:Int?
    var fanHuanIdx = 0
    var price:String = ""
    var commend:String = ""
    override func viewDidLoad() {
        super.viewDidLoad()
        navbar.title = "增值服务"
        self.view.addSubview(navbar)
        
        topView.snp.makeConstraints { (make) in
            make.top.equalTo(NavCGRect.height)
            make.left.right.equalTo(0)
            make.height.equalTo(139.5)
        }
        listView.isScrollEnabled = false
        listView.separatorStyle = .none
        listView.register(UINib(nibName: "TitleAndSelectCell", bundle: nil), forCellReuseIdentifier: "TitleAndSelect")
        textView.delegate = self
        textView.text = commend
        if commend.count > 0 {
            textViewHolderLbl.isHidden = true

        }
        inputTF.addTarget(self, action: #selector(textViewEdit(sender:)), for: .allEditingEvents)
        inputTF.text = price
        if price.count > 0 {
            holderLbl.isHidden = true
            let inpuStr = inputTF.text as! NSString
            
            let pric = inpuStr.floatValue * 0.005
            if pric > 10.0 {
                priceLbl.text = String(format: "%.2f", (pric))
            }else {
                if pric > 0.0 {
                    priceLbl.text = "10.0"
                }else {
                    priceLbl.text = "-"
                }
            }
        }
        switch fanHuanIdx {
        case 0:
            nSet()
            break
        case 1:
            pSet()
            break
        default:
            eSet()
            break
        }
        inputTF.delegate = self
        // Do any additional setup after loading the view.
    }
    
    //MARK: - CELL DELEGATE
    func tableView(_ tableView: UITableView, cellForRowAt indexPath: IndexPath) -> UITableViewCell {
        let cell = tableView.dequeueReusableCell(withIdentifier: "TitleAndSelect") as! TitleAndSelectCell
        cell.delegate = self
        cell.tag = indexPath.row
        cell.titleLbl.text = titleArr[indexPath.row]
        cell.selectBtn.isSelected = false
        cell.selectBtn.isUserInteractionEnabled = false
        if indexPath.row == selectIdx{
            cell.selectBtn.isSelected = true
        }
        let line = UIView()
        line.backgroundColor = UIColor(named: "灰色分界线")
        cell.contentView.addSubview(line)
        line.snp.makeConstraints { (make) in
            make.bottom.right.equalTo(0)
            make.left.equalTo(15)
            make.height.equalTo(1)
        }
        return cell
    }
    func textViewDidChange(_ textView: UITextView) {

        if textView.text.count != 0 {
            textViewHolderLbl.isHidden = true
        }else{
            textViewHolderLbl.isHidden = false
        }
        if textView.markedTextRange == nil {
            if textView.text.count > 50 {
                textView.text = textView.text.subString(start: 0, length: 50)
            }
        }
        commend = textView.text

    }
    func textView(_ textView: UITextView, shouldChangeTextIn range: NSRange, replacementText text: String) -> Bool {
        countingLbl.text = "\(textView.text.count)/50"
        if (textView.text.count == 50)
        {
            textView.text = textView.text.subString(start: 0, length: 50)
        }
        return true
    }
    
    @objc func textViewEdit(sender:UITextField){
        price = sender.text!
        if price.count > 0 {
            holderLbl.isHidden = true
        }else{
            holderLbl.isHidden = false
        }
    }
    
    func textFieldDidChangeSelection(_ textField: UITextField) {
        let inpuStr = inputTF.text as! NSString
        
        let pric = inpuStr.floatValue * 0.005
        if pric > 10.0 {
            priceLbl.text = String(format: "%.2f", (pric))
        }else {
            if pric > 0.0 {
                priceLbl.text = "10.0"
            }else {
                priceLbl.text = "-"
            }
        }
    }
    
    func nSet(){
        pBtn.backgroundColor = UIColor.clear
                      pBtn.isSelected = false
                      pBtn.layer.borderWidth = 1
                      eBtn.backgroundColor = UIColor.clear
                      eBtn.isSelected = false
                      eBtn.layer.borderWidth = 1
                      
                      nBtn.isSelected = true
                      nBtn.backgroundColor = UIColor(named: "蓝色字体颜色")
                      nBtn.layer.borderWidth = 0
    }
    func pSet(){
        nBtn.backgroundColor = UIColor.clear
                       nBtn.isSelected = false
                       nBtn.layer.borderWidth = 1
                       eBtn.backgroundColor = UIColor.clear
                       eBtn.isSelected = false
                       eBtn.layer.borderWidth = 1
                       
                       pBtn.isSelected = true
                       pBtn.backgroundColor = UIColor(named: "蓝色字体颜色")
                       pBtn.layer.borderWidth = 0
    }
    func eSet(){
        nBtn.backgroundColor = UIColor.clear
        nBtn.isSelected = false
        nBtn.layer.borderWidth = 1
        pBtn.backgroundColor = UIColor.clear
        pBtn.isSelected = false
        pBtn.layer.borderWidth = 1
        
        eBtn.isSelected = true
        eBtn.backgroundColor = UIColor(named: "蓝色字体颜色")
        eBtn.layer.borderWidth = 0
    }
    @IBAction func selectAction(_ sender: UIButton) {
        fanHuanIdx = sender.tag
        if sender == nBtn{
            if nBtn.isSelected == true {
                nBtn.isSelected = false
                nBtn.backgroundColor = UIColor.clear
                nBtn.layer.borderWidth = 1
            }else{
              nSet()
            }
        }
        if sender == pBtn {
            if pBtn.isSelected == true {
                pBtn.isSelected = false
                pBtn.backgroundColor = UIColor.clear
                pBtn.layer.borderWidth = 1
            }else{
               pSet()
            }
        }
        if sender == eBtn{
            if eBtn.isSelected == true {
                eBtn.isSelected = false
                eBtn.backgroundColor = UIColor.clear
                eBtn.layer.borderWidth = 1
            }else{
                eSet()
            }
        }
    }
    
    func tableView(_ tableView: UITableView, numberOfRowsInSection section: Int) -> Int {
        return 3
    }
    func tableView(_ tableView: UITableView, heightForRowAt indexPath: IndexPath) -> CGFloat {
        return 50
    }
    func tableView(_ tableView: UITableView, didSelectRowAt indexPath: IndexPath) {
        if indexPath.section == 0 {
            if indexPath.row < 3{
                selectIdx = indexPath.row
                listView.reloadData()
            }
        }
    }
}
