//
//  BingDingKeHuViewController.swift
//  GeliBusinessPlatform
//
//  Created by junye lu on 2020/5/8.
//  Copyright © 2020 junye lu. All rights reserved.
//

import UIKit
protocol BingDingKeHuViewControllerDelegate {
    func BingDingKeHuViewControllerSelec(sender:GetBindUserDataModel)
}
class BingDingKeHuViewController: BaseViewController,UITableViewDelegate,UITableViewDataSource,UISearchBarDelegate,SearchBarViewDelegate,TitleAndSelectCellDelegate{
    var searchV : SearchBarView? = nil
    var delegate :BingDingKeHuViewControllerDelegate?
    
    @IBAction func submitAction(_ sender: Any) {
        if selectModel == nil {
            HUD.flash(.label("请选择绑定的用户"),delay: 1.2)
            return
        }else{
            delegate?.BingDingKeHuViewControllerSelec(sender: selectModel!)
            self.navigationController?.popViewController(animated: true)
        }
    }
    @IBOutlet weak var listView: UITableView!
    @IBOutlet weak var topView: UIView!
    override func viewDidLoad() {
        super.viewDidLoad()
        navbar.title = "绑定用户"
        self.view.addSubview(navbar)
        SetTopFrame(view: topView, height: 44)
        listView.separatorStyle = .none
        
        let searchBr = SearchBarView.init()
        topView.addSubview(searchBr)
        searchBr.snp.makeConstraints { (make) in
            make.left.equalTo(10)
            make.right.equalTo(-10)
            make.centerY.equalToSuperview()
            make.height.equalTo(30)
        }
        searchV = searchBr 
        searchBr.placeholderStr = "输入完整的客户名/联系人/电话号码搜索"
        searchBr.cornerRadius = 35/2.0
        searchBr.delegate = self
        searchBr.delegateL = self
        
        listView.register(UINib(nibName: "TitleAndSelectCell", bundle: nil), forCellReuseIdentifier: "TitleAndSelectCell")
        // Do any additional setup after loading the view.
        //下拉刷新相关设置
        headerMJ.setRefreshingTarget(self, refreshingAction: #selector(loadData))
        listView.mj_header = headerMJ
        listView.mj_header?.beginRefreshing()
        //上拉加载相关设置
        footerMJ.setRefreshingTarget(self, refreshingAction: #selector(loadMoreData))
        listView.mj_footer = footerMJ
    }
    var keyword: String = ""
    var dataArr:Array<GetBindUserDataModel> = []
    var page : Int = 0
    var selectModel : GetBindUserDataModel? = nil
    //MAKR:--调起搜索后添加个蒙版本
    var blackBtnView:UIButton! = nil
    func searchBarSearchButtonClicked(_ searchBar: UISearchBar) {
        print("点击搜索进行--")
        searchBar.resignFirstResponder()
        keyword = searchBar.text!
        listView.mj_header?.beginRefreshing()
        
    }
    //MARK:--取消搜索代理
    func clearSearchAction() {
        print("取消搜索代理了--")
    }
    func searchBarTextDidEndEditing(_ searchBar: UISearchBar) {
        print("编辑即将结束了--")
        removeBlackBtnView()
        if searchBar.text?.count == 0 && keyword.count != 0{
            keyword = searchBar.text!
            listView.mj_header?.beginRefreshing()
            
        }
    }
    func searchBarShouldBeginEditing(_ searchBar: UISearchBar) -> Bool {
        print("调起搜索后添加个蒙版本")
        blackBtnView = UIButton ()
        blackBtnView.backgroundColor = UIColor.init(named: "提示视图背景色")
        self.view.addSubview(blackBtnView)
        blackBtnView.snp.makeConstraints { (make) in
            make.left.right.bottom.equalToSuperview()
            make.top.equalTo(topView!.snp_bottom)
        }
        blackBtnView.addTarget(self, action: #selector(removeBlackBtnView), for: .touchUpInside)
        
        return true
    }
    @objc func removeBlackBtnView(){
        if blackBtnView != nil {
            blackBtnView.removeFromSuperview()
            searchV!.resignFirstResponder()
        }
    }
    //MARK:--加载数据
    @objc func loadData(){
        print("加载数据")
        let UserToken = UserDefaults.standard.value(forKey: "user_token")
        page = 1

        let dic = ["user_token":UserToken as Any,"keyword":keyword,"page":page]
        
        getBindUser(dic, success: { (data) in
            self.dataArr.removeAll()
            let dataM = data as! GetBindUserModel
            dataM.data?.forEach({ (model) in
                self.dataArr.append(model)
            })
            self.listView.reloadData()
            self.listView.mj_header?.endRefreshing()
            self.page = 2

            if dataM.data?.count == 0 {
                self.listView.mj_footer?.endRefreshingWithNoMoreData()
            }else{
                self.listView.mj_footer?.endRefreshing()
            }
        }) { (error) in
            self.listView.mj_header?.endRefreshing()
        }
        
    }
    
    //MARK:--加载更多数据
    @objc func loadMoreData(){
        print("加载更多数据")
        let UserToken = UserDefaults.standard.value(forKey: "user_token")
        let dic = ["user_token":UserToken as Any,"keyword":keyword,"page":page]
        
        getBindUser(dic, success: { (data) in
            let dataM = data as! GetBindUserModel
            if dataM.data?.count == 0 {
                self.listView.mj_footer?.endRefreshingWithNoMoreData()
            }else{
                self.page += 1
                dataM.data?.forEach({ (model) in
                    self.dataArr.append(model)
                })
                self.listView.reloadData()
                self.listView.mj_footer?.endRefreshing()
            }
        }) { (error) in
            self.listView.mj_footer?.endRefreshing()

        }
    }
    
    //MARK: - CELL DELEGATE
    func tableView(_ tableView: UITableView, heightForRowAt indexPath: IndexPath) -> CGFloat {
        return 49
    }
    func tableView(_ tableView: UITableView, numberOfRowsInSection section: Int) -> Int {
        return self.dataArr.count
    }
    
    func tableView(_ tableView: UITableView, cellForRowAt indexPath: IndexPath) -> UITableViewCell {
        let cell = tableView.dequeueReusableCell(withIdentifier: "TitleAndSelectCell") as! TitleAndSelectCell
        cell.selectBtn.isSelected = false
        if indexPath.row == 0 {
            cell.line.isHidden = true
 
        }
        let rowModel = self.dataArr[indexPath.row]
        cell.titleLbl.text = rowModel.user_name
        cell.delegate = self
        if selectModel != nil {
            if selectModel?.user_id == rowModel.user_id {
                cell.selectBtn.isSelected = true
            }
        }
        cell.tag = indexPath.row
        return cell
    }
    func TitleAndSelectCellClick(content: UIButton, cell: TitleAndSelectCell) {
        let rowModel = self.dataArr[cell.tag]
        selectModel = rowModel
        listView.reloadData()
    }
    func tableView(_ tableView: UITableView, didSelectRowAt indexPath: IndexPath) {
        let rowModel = self.dataArr[indexPath.row]
        selectModel = rowModel
        listView.reloadData()
    }
    
}
