//
//  KeHuListViewController.swift
//  GeliBusinessPlatform
//
//  Created by junye lu on 2020/5/8.
//  Copyright © 2020 junye lu. All rights reserved.
//

import UIKit

class KeHuListViewController: BaseViewController,UITableViewDelegate,UITableViewDataSource,UISearchBarDelegate,SearchBarViewDelegate,KeHuGuanLiCellDelegate,XinZengAndBianJiKeHuViewControllerDelegate{
    func XinZengAndBianJiKeHuViewControllerFinish() {
        listView.mj_header?.beginRefreshing()
    }
    
    
    var searchV : SearchBarView? = nil
    
    @IBOutlet weak var topView: UIView!
    
    @IBOutlet weak var topH: NSLayoutConstraint!
    @IBOutlet weak var coverBtn: UIButton!
    @IBOutlet weak var rightImg: UIImageView!
    @IBOutlet weak var leftImg: UIImageView!
    @IBOutlet weak var rightLbl: UILabel!
    @IBOutlet weak var leftLbl: UILabel!
    
    @IBOutlet weak var listView: UITableView!
    @IBOutlet weak var leftSelectView: UITableView!
    @IBOutlet weak var rightSelectView: UITableView!
    
    var selectListRecord:Array<Int> = []
    
    override func viewDidLoad() {
        super.viewDidLoad()
        selectListRecord.append(0)
        selectListRecord.append(0)
        
        
        
        navbar.title = "客户管理"
        self.view.addSubview(navbar)
        
        topH.constant = CGFloat(44)
        
        let searchBr = SearchBarView.init()
        topView.addSubview(searchBr)
        searchBr.snp.makeConstraints { (make) in
            make.left.equalTo(10)
            make.right.equalTo(-10)
            make.centerY.equalToSuperview()
            make.height.equalTo(30)
        }
        searchV = searchBr
        searchBr.placeholderStr = "客户名称/联系人/电话号码"
        searchBr.cornerRadius = 35/2.0
        searchBr.delegate = self
        searchBr.delegateL = self
        
        listView.separatorStyle = .none
        rightSelectView.separatorStyle = .none
        leftSelectView.separatorStyle = .none
        
        setYuanJiao(sender: leftSelectView)
        setYuanJiao(sender: rightSelectView)
        
        listView.register(UINib(nibName: "KeHuGuanLiCell", bundle: nil), forCellReuseIdentifier: "KeHuGuanLiCell")
        rightSelectView.register(UINib(nibName: "TitleAndTFCell", bundle: nil), forCellReuseIdentifier: "TitleAndTFCell")
        leftSelectView.register(UINib(nibName: "TitleAndTFCell", bundle: nil), forCellReuseIdentifier: "TitleAndTFCell")
        // Do any additional setup after loading the view.
        
        //下拉刷新相关设置
        headerMJ.setRefreshingTarget(self, refreshingAction: #selector(loadData))
        listView.mj_header = headerMJ
        //上拉加载相关设置
        footerMJ.setRefreshingTarget(self, refreshingAction: #selector(loadMoreData))
        listView.mj_footer = footerMJ
        listView.mj_header?.beginRefreshing()
    }
    var page : Int = 0
    var keyword: String = ""
    var sort : Int = 1 //排序，1时间倒序，2时间正序，
    var cus_type : Int = 0 //客户类型 1个人 2企业，0全部
    var dataArr:Array<CusListDataModel> = []
    //MAKR:--调起搜索后添加个蒙版本
    var blackBtnView:UIButton! = nil
    func searchBarSearchButtonClicked(_ searchBar: UISearchBar) {
        print("点击搜索进行--")
        searchBar.resignFirstResponder()
        keyword = searchBar.text!
        listView.mj_header?.beginRefreshing()
        
    }
    //MARK:--取消搜索代理
    func clearSearchAction() {
        print("取消搜索代理了--")
    }
    func searchBarTextDidEndEditing(_ searchBar: UISearchBar) {
        print("编辑即将结束了--")
        removeBlackBtnView()
        if searchBar.text?.count == 0 && keyword.count != 0{
            keyword = searchBar.text!
            listView.mj_header?.beginRefreshing()
            
        }
    }
    func searchBarShouldBeginEditing(_ searchBar: UISearchBar) -> Bool {
        print("调起搜索后添加个蒙版本")
        blackBtnView = UIButton ()
        blackBtnView.backgroundColor = UIColor.init(named: "提示视图背景色")
        self.view.addSubview(blackBtnView)
        blackBtnView.snp.makeConstraints { (make) in
            make.left.right.bottom.equalToSuperview()
            make.top.equalTo(topView!.snp_bottom)
        }
        blackBtnView.addTarget(self, action: #selector(removeBlackBtnView), for: .touchUpInside)
        coverBtn.isHidden = true
        leftSelectView.isHidden = true
        rightSelectView.isHidden = true
        leftImg.image = UIImage(named: "xiala")
        leftLbl.textColor = UIColor(named: "标题字颜色")
        rightImg.image = UIImage(named: "xiala")
        rightLbl.textColor = UIColor(named: "标题字颜色")
        return true
    }
    @objc func removeBlackBtnView(){
        if blackBtnView != nil {
            blackBtnView.removeFromSuperview()
            searchV!.resignFirstResponder()
        }
    }
    //MARK:--加载数据
    @objc func loadData(){
        print("加载数据")
        let UserToken = UserDefaults.standard.value(forKey: "user_token")
        page = 1
        cus_type = selectListRecord.first!
        sort = selectListRecord.last! + 1
        
        let dic = ["user_token":UserToken as Any,"keyword":keyword,"page":page,"sort":sort,"cus_type":cus_type]
        
        cusList(dic, success: { (data) in
            self.dataArr.removeAll()
            let dataM = data as! CusListModel
            dataM.data?.forEach({ (model) in
                self.dataArr.append(model)
            })
            self.listView.reloadData()
            self.listView.mj_header?.endRefreshing()
            self.page = 2
            if dataM.data?.count == 0 {
                self.listView.mj_footer?.endRefreshingWithNoMoreData()
            }else{
                self.listView.mj_footer?.endRefreshing()
            }
        }) { (error) in
            self.listView.mj_header?.endRefreshing()
        }
        
    }
    //MARK:--加载更多数据
    @objc func loadMoreData(){
        print("加载更多数据")
        let UserToken = UserDefaults.standard.value(forKey: "user_token")
        cus_type = selectListRecord.first!
        sort = selectListRecord.last! + 1
        let dic = ["user_token":UserToken as Any,"keyword":keyword,"page":page,"sort":sort,"cus_type":cus_type]
        
        cusList(dic, success: { (data) in
            let dataM = data as! CusListModel
            if dataM.data?.count == 0 {
                self.listView.mj_footer?.endRefreshingWithNoMoreData()
            }else{
                self.page += 1
                dataM.data?.forEach({ (model) in
                    self.dataArr.append(model)
                })
                self.listView.reloadData()
                self.listView.mj_footer?.endRefreshing()
            }
        }) { (error) in
            self.listView.mj_footer?.endRefreshing()
            
        }
    }
    
    //MARK: - method
    func setYuanJiao(sender:UIView){
        let maskPath = UIBezierPath(roundedRect: sender.bounds,
                                    byRoundingCorners:[.bottomRight, .bottomLeft], cornerRadii:CGSize(width:5, height:5))
        let masklayer = CAShapeLayer()
        masklayer.frame = sender.bounds
        masklayer.path = maskPath.cgPath
        sender.layer.mask = masklayer
    }
    @IBAction func closeAction(_ sender: Any) {
        coverBtn.isHidden = true
        leftSelectView.isHidden = true
        rightSelectView.isHidden = true
        leftImg.image = UIImage(named: "xiala")
        leftLbl.textColor = UIColor(named: "标题字颜色")
        rightImg.image = UIImage(named: "xiala")
        rightLbl.textColor = UIColor(named: "标题字颜色")
    }
    @IBAction func btnClick(_ sender: UIButton) {
        //
        
        
        //UI
        if sender.tag == 0 {
            leftLbl.textColor = UIColor(named: "蓝色字体颜色")
            rightLbl.textColor = UIColor(named: "标题字颜色")
            leftSelectView.isHidden = !leftSelectView.isHidden
            rightSelectView.isHidden = true
            coverBtn.isHidden = leftSelectView.isHidden
            if leftSelectView.isHidden == true {
                leftImg.image = UIImage(named: "xiala")
                leftLbl.textColor = UIColor(named: "标题字颜色")
            }else{
                leftImg.image = UIImage(named: "shangla")
                rightImg.image = UIImage(named: "xiala")
            }
        }else{
            leftLbl.textColor = UIColor(named: "标题字颜色")
            rightLbl.textColor = UIColor(named: "蓝色字体颜色")
            rightSelectView.isHidden = !rightSelectView.isHidden
            leftSelectView.isHidden = true
            coverBtn.isHidden = rightSelectView.isHidden
            if rightSelectView.isHidden == true {
                rightImg.image = UIImage(named: "xiala")
                rightLbl.textColor = UIColor(named: "标题字颜色")
            }else{
                rightImg.image = UIImage(named: "shangla")
                leftImg.image = UIImage(named: "xiala")
            }
        }
    }
    @IBAction func addAction(_ sender: Any) {
        let vc = XinZengAndBianJiKeHuViewController()
        vc.titleStr = "新增客户"
        vc.delegate = self
        self.navigationController?.pushViewController(vc, animated: true)
    }
    //MARK: - 自定义delegate
    func KeHuGuanLiCellEditClick(cell: KeHuGuanLiCell) {
        let model = dataArr[cell.tag]
        let vc = XinZengAndBianJiKeHuViewController()
        vc.titleStr = "编辑客户"
        vc.delegate = self
        vc.cus_id = model.cus_id!
        if model.company != nil {
            vc.companyName = model.company!
        }
        if model.cus_name != nil {
            vc.kehuName = model.cus_name!
        }
        if model.user_id != nil {
            vc.user_id = model.user_id!
        }
        if model.phone != nil {
            vc.phoneNum = model.phone!
        }
        if model.discounts_rate != nil {
            vc.discount = "\(model.discounts_rate!)"
        }
        if model.user_name != nil {
            vc.bindKehu = model.user_name!
        }
        if model.cus_type != nil {
            vc.typeSelect = model.cus_type! - 1
        }
        self.navigationController?.pushViewController(vc, animated: true)
    }
    
    //MARK: - CELL DELEGATE
    func tableView(_ tableView: UITableView, didSelectRowAt indexPath: IndexPath) {
        if tableView == leftSelectView {
            selectListRecord.insert(indexPath.row, at: 0)
            selectListRecord.remove(at: 1)
            coverBtn.isHidden = true
            leftSelectView.isHidden = true
            rightSelectView.isHidden = true
            leftImg.image = UIImage(named: "xiala")
            leftLbl.textColor = UIColor(named: "标题字颜色")
            leftSelectView.reloadData()
            listView.mj_header?.beginRefreshing()
            leftLbl.text = leftArr[indexPath.row]
            
        }
        if tableView == rightSelectView {
            selectListRecord.insert(indexPath.row, at: 1)
            selectListRecord.remove(at: 2)
            coverBtn.isHidden = true
            leftSelectView.isHidden = true
            rightSelectView.isHidden = true
            rightImg.image = UIImage(named: "xiala")
            rightLbl.textColor = UIColor(named: "标题字颜色")
            rightSelectView.reloadData()
            listView.mj_header?.beginRefreshing()
            rightLbl.text = rightArr[indexPath.row]
            
        }
        //MARK: - 跳转客户详情
        if tableView == listView {
            let model = dataArr[indexPath.row]
            let vc = KeHuXQViewController()
            vc.model = model
            self.navigationController?.pushViewController(vc, animated: true)
        }
        
    }
    func tableView(_ tableView: UITableView, heightForRowAt indexPath: IndexPath) -> CGFloat {
        if tableView == listView {
            return 100
        }
        return 49
    }
    
    func tableView(_ tableView: UITableView, numberOfRowsInSection section: Int) -> Int {
        if tableView == leftSelectView {
            return 3
        }
        if tableView == rightSelectView {
            return 2
        }
        return self.dataArr.count
    }
    let leftArr = ["全部","个人","企业"]
    let rightArr = ["新增时间倒序","新增时间正序"]
    func tableView(_ tableView: UITableView, cellForRowAt indexPath: IndexPath) -> UITableViewCell {
        if tableView == listView{
            let cell = tableView.dequeueReusableCell(withIdentifier: "KeHuGuanLiCell") as! KeHuGuanLiCell
            let rowModel = self.dataArr[indexPath.row]
            cell.tag = indexPath.row
            cell.compenyLbl.text = rowModel.company
            cell.nameLbl.text = rowModel.cus_name
            cell.delegate = self
            cell.cus_type = rowModel.cus_type!
            cell.statusLbl2.isHidden = true
            if rowModel.discounts_rate != 0 && rowModel.discounts_rate != 100{
                cell.statusLbl2.isHidden = false
                let num1 = rowModel.discounts_rate! / 10
                let num2 = rowModel.discounts_rate! % 10
                cell.statusLbl2.text = "\(num1)折"
                if num2 != 0 {
                    cell.statusLbl2.text = "\(num1).\(num2)折"
                }
            }
            cell.arrowImg.isHidden = true
            cell.nameLbl2.isHidden = true
            if rowModel.phone != nil {
                if rowModel.phone!.count > 0{
                    cell.photoIcon.isHidden = false
                    cell.phoneNum = rowModel.phone!
                }else{
                    cell.photoIcon.isHidden = true
                }
            }
            
            if rowModel.user_name != nil {
                cell.nameLbl2.isHidden = false
                cell.arrowImg.isHidden = false
                cell.nameLbl2.text = rowModel.user_name!
            }
            
            return cell
        }
        let cell = tableView.dequeueReusableCell(withIdentifier: "TitleAndTFCell") as! TitleAndTFCell
        cell.textTF.isHidden = true
        cell.textTF.isUserInteractionEnabled = false
        cell.nameLbl.textColor = UIColor(named: "标题字颜色")
        cell.tag = indexPath.row
        if tableView == leftSelectView {
            cell.nameLbl.text = leftArr[indexPath.row]
            
            if selectListRecord.first == indexPath.row {
                cell.nameLbl.textColor = UIColor(named: "蓝色字体颜色")
            }
        }
        if tableView == rightSelectView {
            cell.nameLbl.text = rightArr[indexPath.row]
            
            if selectListRecord.last == indexPath.row {
                cell.nameLbl.textColor = UIColor(named: "蓝色字体颜色")
            }
        }
        return cell
    }
    
}
