//
//  KeHuXQViewController.swift
//  GeliBusinessPlatform
//
//  Created by junye lu on 2020/4/29.
//  Copyright © 2020 junye lu. All rights reserved.
//

import UIKit
import SwiftDate

class KeHuXQViewController: BaseViewController,UITableViewDelegate,UITableViewDataSource ,WorkSelectTimeViewDelegate{
    var page = 0
    var model:CusListDataModel?
    var dataArr:Array<CusSalesStatisticsDataModel> = []
    @IBOutlet weak var btmListView: UITableView!
    @IBOutlet weak var topListView: UITableView!
    let UserToken = UserDefaults.standard.value(forKey: "user_token")
    override func viewDidLoad() {
        super.viewDidLoad()
        navbar.title = "客户详情"
        navbar.rightImg = UIImage.init(named: "ShouZhiTongJiDayEdit")

        self.view.addSubview(navbar)
        topListView.separatorStyle = .none
        btmListView.separatorStyle = .none
        SetTopFrame(view: topListView, height: 101)
        
        topListView.register(UINib(nibName: "KeHuGuanLiCell", bundle: nil), forCellReuseIdentifier: "KeHuGuanLiCell")
        btmListView.register(UINib(nibName: "KeHuXQCell", bundle: nil), forCellReuseIdentifier: "KeHuXQCell")
        //
        //下拉刷新相关设置
        headerMJ.setRefreshingTarget(self, refreshingAction: #selector(loadData))
        btmListView.mj_header = headerMJ
        //上拉加载相关设置
        footerMJ.setRefreshingTarget(self, refreshingAction: #selector(loadMoreData))
        btmListView.mj_footer = footerMJ
        btmListView.mj_header?.beginRefreshing()
    }
    
    //MARK:--加载数据
    @objc func loadData(){
        print("加载数据")
        let star_time = Int(starTime.timeIntervalSince1970)
        let end_time = Int(endTime.timeIntervalSince1970)
        page = 1
        let dic = ["user_token":UserToken as Any,"page":page as Any,"cus_id":model!.cus_id as Any,"start_time":star_time as Any,"end_time":end_time as Any]
        
        cusSalesStatistics(dic, success: { (data) in
            self.dataArr.removeAll()
            let dataM = data as! CusSalesStatisticsModel
            dataM.data?.forEach({ (model) in
                self.dataArr.append(model)
            })
            self.btmListView.reloadData()
            self.btmListView.mj_header?.endRefreshing()
            self.page = 2
            if dataM.data?.count == 0 {
                self.btmListView.mj_footer?.endRefreshingWithNoMoreData()
            }else{
                self.btmListView.mj_footer?.endRefreshing()
            }
        }) { (error) in
            self.btmListView.mj_header?.endRefreshing()
        }
        
    }
    //MARK:--加载更多数据
    @objc func loadMoreData(){
        print("加载更多数据")
        let star_time = Int(starTime.timeIntervalSince1970)
        let end_time = Int(endTime.timeIntervalSince1970)
        let dic = ["user_token":UserToken as Any,"page":page as Any,"cus_id":model!.cus_id as Any,"start_time":star_time as Any,"end_time":end_time as Any]
        
        cusSalesStatistics(dic, success: { (data) in
            let dataM = data as! CusSalesStatisticsModel
            if dataM.data?.count == 0 {
                self.btmListView.mj_footer?.endRefreshingWithNoMoreData()
            }else{
                self.page += 1
                dataM.data?.forEach({ (model) in
                    self.dataArr.append(model)
                })
                self.btmListView.reloadData()
                self.btmListView.mj_footer?.endRefreshing()
            }
        }) { (error) in
            self.btmListView.mj_footer?.endRefreshing()
            
        }
    }
    
    //MARK: - CELL DELEGATE
    //header
    func tableView(_ tableView: UITableView, viewForHeaderInSection section: Int) -> UIView? {
        if tableView == btmListView {
            let view = UIView(frame: CGRect(x: 0, y: 0, width: fullScreenWidth, height: 73.5))
            let rightLbl = UILabel()
            rightLbl.text = "商品金额"
            rightLbl.textColor = UIColor(named: "灰色字体颜色")
            rightLbl.font = UIFont.systemFont(ofSize: 11)
            rightLbl.textAlignment = .center
            view.addSubview(rightLbl)
            rightLbl.snp.makeConstraints { (make) in
                make.top.equalTo(40.5)
                make.right.bottom.equalTo(0)
                make.width.equalTo(84)
            }
            let rightLbl1 = UILabel()
            rightLbl1.text = "商品数量"
            rightLbl1.textColor = UIColor(named: "灰色字体颜色")
            rightLbl1.font = UIFont.systemFont(ofSize: 11)
            rightLbl1.textAlignment = .center
            view.addSubview(rightLbl1)
            rightLbl1.snp.makeConstraints { (make) in
                make.top.equalTo(40.5)
                make.right.equalTo(rightLbl.snp_left).offset(-10)
                make.bottom.equalTo(0)
                make.width.equalTo(84)
            }
            let rightLbl2 = UILabel()
            rightLbl2.text = "商品名称"
            rightLbl2.textColor = UIColor(named: "灰色字体颜色")
            rightLbl2.font = UIFont.systemFont(ofSize: 11)
            view.addSubview(rightLbl2)
            rightLbl2.snp.makeConstraints { (make) in
                make.left.right.equalTo(15)
                make.centerY.equalTo(rightLbl.snp_centerY)
                make.bottom.equalTo(0)
            }
            
            let title = UILabel()
            title.text = "销售统计"
            title.textColor = UIColor(named: "标题字颜色")
            title.font = UIFont.boldSystemFont(ofSize: 15)
            view.addSubview(title)
            title.snp.makeConstraints { (make) in
                make.top.left.equalTo(15)
                make.height.equalTo(21)
            }
            
            let dayLbl = UILabel()
            dayLbl.font = UIFont.boldSystemFont(ofSize: 11)
            dayLbl.textColor = UIColor(named: "灰色字体颜色")

            let start = dateConvertString(date: starTime + 8.hours, dateFormat: "yyyy年MM月dd日")
            let end = dateConvertString(date: endTime + 8.hours, dateFormat: "yyyy年MM月dd日")
            if start == end {
                dayLbl.text = "(日期统计区间: " + start + ")"
            }else{
                dayLbl.text = "(日期统计区间: " + start + " 至 " + end  + ")"
            }
            view.addSubview(dayLbl)
            dayLbl.snp.makeConstraints { (make) in
                make.centerY.equalTo(title)
                make.left.equalTo(title.snp_right).offset(3)
            }
            return view
        }
        return UIView()
    }
    func tableView(_ tableView: UITableView, heightForHeaderInSection section: Int) -> CGFloat {
        if tableView == btmListView {
            return 73.5
        }
        return 0.001
    }
    func tableView(_ tableView: UITableView, numberOfRowsInSection section: Int) -> Int {
        if tableView == topListView {
            return 1
        }
        return dataArr.count
    }
    func tableView(_ tableView: UITableView, heightForRowAt indexPath: IndexPath) -> CGFloat {
        if tableView == topListView {
            return 101
        }
        return 49
    }
    func tableView(_ tableView: UITableView, cellForRowAt indexPath: IndexPath) -> UITableViewCell {
        if tableView == topListView {
            let cell = tableView.dequeueReusableCell(withIdentifier: "KeHuGuanLiCell") as! KeHuGuanLiCell
            cell.btnWidth.constant = 0
            cell.tag = indexPath.row
            cell.compenyLbl.text = model!.company
            cell.nameLbl.text = model!.cus_name
            cell.cus_type = model!.cus_type!
            cell.statusLbl2.isHidden = true
            if model!.discounts_rate != 0 && model!.discounts_rate != 100{
                cell.statusLbl2.isHidden = false
                let num1 = model!.discounts_rate! / 10
                let num2 = model!.discounts_rate! % 10
                cell.statusLbl2.text = "\(num1)折"
                if num2 != 0 {
                    cell.statusLbl2.text = "\(num1).\(num2)折"
                }
            }
            cell.arrowImg.isHidden = true
            cell.nameLbl2.isHidden = true
            if model!.phone != nil {
                if model!.phone!.count > 0{
                    cell.photoIcon.isHidden = false
                    cell.phoneNum = model!.phone!
                }else{
                    cell.photoIcon.isHidden = true
                }
            }
            
            if model!.user_name != nil {
                cell.nameLbl2.isHidden = false
                cell.arrowImg.isHidden = false
                cell.nameLbl2.text = model!.user_name!
            }
            
            
            return cell
        }
        let model = dataArr[indexPath.row]
        let cell = tableView.dequeueReusableCell(withIdentifier: "KeHuXQCell") as! KeHuXQCell
        cell.nameLbl.text = model.goods_name!
        cell.shuLiangLbl.text = model.sum_number!
        cell.priceLbl.text = model.sum_amount!
        
        return cell
    }
    //MARK:--日期筛选按钮（右上角按钮）
    let selectV = WorkSelectTimeView()
    var selelctIndex = 1001
    var isShowSelectTimeV:Bool = false
    var endTime = DateInRegion().dateAt(.endOfDay).date  - 8.hours
    var starTime =  DateInRegion().dateAt(.startOfDay).date - 8.hours
    func rightBtnClick() {
        print("日期筛选按钮")
        if isShowSelectTimeV {
            selectV.removeFromSuperview()
            isShowSelectTimeV = false
        }else{
            selectV.delegate = self
            selectV.selectIndex = selelctIndex
            self.view.window?.addSubview(selectV)
            selectV.snp.makeConstraints { (make) in
                make.top.equalTo(navbar.snp_bottom)
                make.left.right.bottom.equalToSuperview()
            }
            selectV.BeginDate = starTime
            selectV.EndDate = endTime
            isShowSelectTimeV = true
        }
    }
    //MARK:--时间选择视图反馈
    func selectWorkIndx(sender: Int, beginDate: Date?, endginDate: Date?) {
        selelctIndex = sender;
        isShowSelectTimeV = false
        switch sender {
        case 1001:
            endTime = DateInRegion().dateAt(.endOfDay).date - 8.hours
            starTime = DateInRegion().dateAt(.startOfDay).date - 8.hours //今天开始时间
            btmListView.mj_header?.beginRefreshing()
            break
        case 1002:
            endTime = DateInRegion().dateAt(.endOfDay).date - 8.hours
            starTime = DateInRegion().dateAt(.startOfWeek).date + 1.days - 8.hours //当周周一开始时间
            btmListView.mj_header?.beginRefreshing()
            break
        case 1003:
            endTime = DateInRegion().dateAt(.endOfDay).date - 8.hours
            starTime = DateInRegion().dateAt(.startOfMonth).date - 9.hours - 1.minutes - 1.seconds //本月开始时间
            btmListView.mj_header?.beginRefreshing()
            break
        case 1004:
            if beginDate != nil && endginDate != nil {
                let timeInterval:TimeInterval = beginDate!.timeIntervalSince1970
                let timeIntervalEnd:TimeInterval = endginDate!.timeIntervalSince1970
                let timestr = dayByDouble(sender: timeInterval) + "-" + dayByDouble(sender: timeIntervalEnd)
                endTime = endginDate!
                starTime = beginDate!
                print(timestr)
                btmListView.mj_header?.beginRefreshing()
            }
            
            break
        default:
            break
        }
    }
}
