//
//  JiPaiFangShiViewController.swift
//  GeliBusinessPlatform
//
//  Created by junye lu on 2020/4/24.
//  Copyright © 2020 junye lu. All rights reserved.
//

import UIKit
protocol JiPaiFangShiViewControllerDelegate {
    //day期望上门 0今天 1明天 2后天
    func JiPaiFangShiViewControllerDelegateFinish(send:Int,receive:Int,pickup_time:String,day:Int)
}
class JiPaiFangShiViewController: BaseViewController ,SendTimeSelectViewDeleagte{
    var delegate:JiPaiFangShiViewControllerDelegate?
    var sendTimeView:SendTimeSelectView?
    @IBAction func selectTimeAction(_ sender: UIButton) {
        if sendTimeView == nil && timeData != nil {
            let view = SendTimeSelectView(frame:self.view.bounds)
            view.delegate = self
            self.view.addSubview(view)
            sendTimeView = view
            view.leftSelectIdx = self.leftSelectIdx
            view.dataModel = timeData
            view.rightSelectIdx = self.rightSelectIdx

        }
    }
    @IBAction func submitAction(_ sender: Any) {
        var send = 0
        var receive = 0
        if JLeftBtn.isSelected == false {
            send = 1
        }
        if PLeftBtn.isSelected == false {
            receive = 1
        }
        delegate?.JiPaiFangShiViewControllerDelegateFinish(send: send, receive: receive, pickup_time: self.pickup_time! , day: self.day!)
        self.navigationController?.popViewController(animated: true)
    }
    @IBOutlet weak var topView: UIView!
    @IBOutlet weak var PLBL: UILabel!
    @IBOutlet weak var JLBL: UILabel!
    @IBOutlet weak var timeLbl: UILabel!
    @IBOutlet weak var PRightBtn: UIButton!
    @IBOutlet weak var PLeftBtn: UIButton!
    @IBOutlet weak var JRightBtn: UIButton!
    @IBOutlet weak var JLeftBtn: UIButton!
    @IBOutlet weak var timeViewHeight: NSLayoutConstraint!
    
    var pickup_time : String?
    var day : Int?
    
    var timeData:appointmentTimeDataModel? = nil
    override func viewDidLoad() {
        super.viewDidLoad()
        
        self.setYuanJiao(sender: JLBL)
        self.setYuanJiao(sender: PLBL)
        
        navbar.title = "寄派方式"
        self.view.addSubview(navbar)
        JLeftBtn.isSelected = true
        JLeftBtn.backgroundColor = UIColor(named: "蓝色字体颜色")
        JLeftBtn.layer.borderWidth = 0
        timeViewHeight.constant = 45
        
        PLeftBtn.isSelected = true
        PLeftBtn.backgroundColor = UIColor(named: "蓝色字体颜色")
        PLeftBtn.layer.borderWidth = 0
        
        topView.snp.makeConstraints { (make) in
            make.top.equalTo(NavCGRect.height+15)
            make.left.equalTo(15)
            make.right.equalTo(-15)
            make.height.equalTo(55)
        }
        if self.timeData != nil {
            switch self.day {
            case 0:
                let keys = self.timeData?.today?.keys
                let keysArr = keys?.sorted(by: { (str1, str2) -> Bool in
                    let num1 = str1 as NSString
                    let num2 = str2 as NSString
                    return  num1.integerValue <  num2.integerValue ? true : false
                })
                for i in 0..<keysArr!.count {
                    let rightIndexKey = keysArr![i]
                    let rightText = self.timeData?.today![rightIndexKey as! String]
                    if self.pickup_time == rightText! {
                        leftSelectIdx = 0
                        rightSelectIdx = i
                        self.timeLbl.text = "今天" + rightText!
                    }
                }
                
            case 1:
                
                let keys = self.timeData?.tomorrow?.keys
                let keysArr = keys?.sorted(by: { (str1, str2) -> Bool in
                    let num1 = str1 as NSString
                    let num2 = str2 as NSString
                    return  num1.integerValue <  num2.integerValue ? true : false
                })
                for i in 0..<keysArr!.count {
                    let rightIndexKey = keysArr![i]
                    let rightText = self.timeData?.tomorrow![rightIndexKey as! String]
                    if self.pickup_time == rightText! {
                        if self.timeData?.today != nil{
                            leftSelectIdx = 1
                        }else{
                            leftSelectIdx = 0
                        }
                        rightSelectIdx = i
                        self.timeLbl.text = "明天" + rightText!

                    }
                }
            case 2:
                
                let keys = self.timeData?.taftert?.keys
                let keysArr = keys?.sorted(by: { (str1, str2) -> Bool in
                    let num1 = str1 as NSString
                    let num2 = str2 as NSString
                    return  num1.integerValue <  num2.integerValue ? true : false
                })
                for i in 0..<keysArr!.count {
                    let rightIndexKey = keysArr![i]
                    let rightText = self.timeData?.taftert![rightIndexKey as! String]
                    if self.pickup_time == rightText! {
                        if self.timeData?.today != nil{
                            leftSelectIdx = 2
                        }else{
                            leftSelectIdx = 1
                        }
                        rightSelectIdx = i
                        self.timeLbl.text = "后天" + rightText!

                    }
                }
            default:
                break
            }
 
        }
        
 
    }
    func setYuanJiao(sender:UIView){
        let maskPath = UIBezierPath(roundedRect: sender.bounds,
                                    byRoundingCorners:[.bottomRight, .topRight], cornerRadii:CGSize(width:2, height:2))
        let masklayer = CAShapeLayer()
        masklayer.frame = sender.bounds
        masklayer.path = maskPath.cgPath
        sender.layer.mask = masklayer
    }
    var leftSelectIdx : Int? = 0
    var rightSelectIdx : Int? = 0
    func SendTimeSelectViewSubmit(day: String, time: String, leftSelectIdx: Int, rightSelectIdx: Int) {
        timeLbl.text = day + time
        sendTimeView?.removeFromSuperview()
        sendTimeView = nil
        self.rightSelectIdx = rightSelectIdx
        self.leftSelectIdx = leftSelectIdx
        
        pickup_time = time
        switch day {
        case "今天":
            self.day = 0
        case "明天":
            self.day = 1
        case "后天":
            self.day = 2
        default:
            break
        }
    }
 
 
    func SendTimeSelectViewClose() {
        sendTimeView?.removeFromSuperview()
        sendTimeView = nil
    }
    
    @IBAction func sendAction(_ sender: UIButton) {
        if sender == PLeftBtn {
            
            PRightBtn.backgroundColor = UIColor.clear
            PRightBtn.isSelected = false
            PRightBtn.layer.borderWidth = 1
            
            PLeftBtn.isSelected = true
            PLeftBtn.backgroundColor = UIColor(named: "蓝色字体颜色")
            PLeftBtn.layer.borderWidth = 0
            
        }else{
            
            PLeftBtn.backgroundColor = UIColor.clear
            PLeftBtn.isSelected = false
            PLeftBtn.layer.borderWidth = 1
            
            PRightBtn.isSelected = true
            PRightBtn.backgroundColor = UIColor(named: "蓝色字体颜色")
            PRightBtn.layer.borderWidth = 0
            
        }
    }
    
    
    @IBAction func getAction(_ sender: UIButton) {
        if sender == JLeftBtn {
            
            JRightBtn.backgroundColor = UIColor.clear
            JRightBtn.isSelected = false
            JRightBtn.layer.borderWidth = 1
            
            JLeftBtn.isSelected = true
            JLeftBtn.backgroundColor = UIColor(named: "蓝色字体颜色")
            JLeftBtn.layer.borderWidth = 0
            timeViewHeight.constant = 45
            
        }else{
            
            JLeftBtn.backgroundColor = UIColor.clear
            JLeftBtn.isSelected = false
            JLeftBtn.layer.borderWidth = 1
            timeViewHeight.constant = 0.01
            JRightBtn.isSelected = true
            JRightBtn.backgroundColor = UIColor(named: "蓝色字体颜色")
            JRightBtn.layer.borderWidth = 0
            
            
        }
    }
}
