//
//  TimeSelectView.swift
//  GeliBusinessPlatform
//
//  Created by junye lu on 2020/4/26.
//  Copyright © 2020 junye lu. All rights reserved.
//

import UIKit
protocol SendTimeSelectViewDeleagte {
    func SendTimeSelectViewClose()
    func SendTimeSelectViewSubmit(day:String,time:String,leftSelectIdx:Int,rightSelectIdx:Int)
}
class SendTimeSelectView: UIView,UITableViewDelegate,UITableViewDataSource {
    var dataModel:appointmentTimeDataModel? = nil {
        didSet{
 
            if dataModel?.today == nil {
                leftListArr = ["明天","后天"]
                
                let keys = dataModel?.tomorrow?.keys
                let keysArr = keys?.sorted(by: { (str1, str2) -> Bool in
                    let num1 = str1 as NSString
                    let num2 = str2 as NSString
                    return  num1.integerValue <  num2.integerValue ? true : false
                })
                rightListArr = keysArr
                leftStr = "明天"
            }else{
                leftListArr = ["今天","明天","后天"]
                let keys = dataModel?.today?.keys
                let keysArr = keys?.sorted(by: { (str1, str2) -> Bool in
                    let num1 = str1 as NSString
                    let num2 = str2 as NSString
                    return  num1.integerValue <  num2.integerValue ? true : false
                })
                rightListArr = keysArr
                leftStr = "今天"

            }
            tableView(leftListView, didSelectRowAt: IndexPath(row: leftSelectIdx!, section: 0))
            leftListView.reloadData()
            rightListView.reloadData()

        }
    }
    
    var delegate:SendTimeSelectViewDeleagte?
    var leftListArr = ["今天","明天","后天"]
    var rightListArr:Array<Any>? = []
    var leftStr = "今天"

    var contentView:UIView!
    var leftSelectIdx:Int?
    var rightSelectIdx:Int? {
        didSet{
            rightListView.reloadData()
            if rightSelectIdx != nil {
                rightListView.scrollToRow(at: IndexPath.init(row: rightSelectIdx!, section: 0), at: .none, animated: false)
            }
        }
    }
    @IBAction func submitAction(_ sender: Any) {
        if rightSelectIdx == nil {
            HUD.flash(.label("请选择上门时间"), delay: 1.2)
            return
        }
        var rightText = ""
        switch leftStr {
        case "今天":
            let rightIndexKey = rightListArr![rightSelectIdx!]
            rightText = dataModel?.today![rightIndexKey as! String] as! String

        case "明天":
            let rightIndexKey = rightListArr![rightSelectIdx!]
            rightText = dataModel?.tomorrow![rightIndexKey as! String] as! String
        case "后天":
            let rightIndexKey = rightListArr![rightSelectIdx!]
            rightText = dataModel?.taftert![rightIndexKey as! String] as! String
        default:
            break
        }
         
        delegate?.SendTimeSelectViewSubmit(day:"\(leftListArr[leftSelectIdx!])",time:rightText,leftSelectIdx:leftSelectIdx!,rightSelectIdx: rightSelectIdx! )
    }
    @IBOutlet weak var rightListView: UITableView!
    @IBOutlet weak var leftListView: UITableView!
    @IBOutlet weak var bottomView: UIView!
    
    
    @IBAction func closeAction(_ sender: Any) {
        delegate?.SendTimeSelectViewClose()
    }
    func setUI(){
        let maskPath = UIBezierPath(roundedRect: bottomView.bounds,
                                    byRoundingCorners:[.topLeft, .topRight], cornerRadii:CGSize(width:3, height:3))
        let masklayer = CAShapeLayer()
        masklayer.frame = bottomView.bounds
        masklayer.path = maskPath.cgPath
        bottomView.layer.mask = masklayer
        
        leftListView.separatorStyle = .none
        rightListView.separatorStyle = .none
        
        leftListView.register(UINib(nibName: "OnlyLabelCell", bundle: nil), forCellReuseIdentifier: "OnlyLabel")
        rightListView.register(UINib(nibName: "OnlyLabelCell", bundle: nil), forCellReuseIdentifier: "OnlyLabel")
        
        
    }
    //初始化时将xib中的view添加进来
    override init(frame: CGRect) {
        super.init(frame: frame)
        contentView = loadViewFromNib()
        addSubview(contentView)
        contentView.snp.makeConstraints { (make) in
            make.left.top.right.bottom.equalToSuperview()
        }
        self.setUI()
    }
    
    //MARK: - CELL DELEGATE
    func tableView(_ tableView: UITableView, numberOfRowsInSection section: Int) -> Int {
        if tableView == leftListView {
            return leftListArr.count
        }
        
        return rightListArr!.count
    }
    
    func tableView(_ tableView: UITableView, heightForRowAt indexPath: IndexPath) -> CGFloat {
        return 49
    }
    
    func tableView(_ tableView: UITableView, cellForRowAt indexPath: IndexPath) -> UITableViewCell {
        let cell = tableView.dequeueReusableCell(withIdentifier: "OnlyLabel") as! OnlyLabelCell
        cell.tag = indexPath.row
        
        
        if tableView == leftListView {
            cell.titleLbl.text = leftListArr[indexPath.row]
            cell.titleLbl.textColor = UIColor(named: "灰色字体颜色")
            cell.titleLbl.font = UIFont.systemFont(ofSize: 13)
            cell.backgroundColor = UIColor(named: "搜索框背景色")
            if leftSelectIdx == indexPath.row{
                cell.titleLbl.textColor = UIColor(named: "标题字颜色")
                cell.titleLbl.font = UIFont.boldSystemFont(ofSize: 13)
                cell.backgroundColor = UIColor.white
            }
         }else{
            switch leftStr {
            case "今天":
                let rightIndexKey = rightListArr![indexPath.row]
                let rightText = dataModel?.today![rightIndexKey as! String]
                cell.titleLbl.text = rightText

            case "明天":
                let rightIndexKey = rightListArr![indexPath.row]
                let rightText = dataModel?.tomorrow![rightIndexKey as! String]
                cell.titleLbl.text = rightText
            case "后天":
                let rightIndexKey = rightListArr![indexPath.row]
                let rightText = dataModel?.taftert![rightIndexKey as! String]
                cell.titleLbl.text = rightText
            default:
                break
            }
             
            
            cell.titleLbl.textColor = UIColor(named: "灰色字体颜色")
            cell.titleLbl.font = UIFont.systemFont(ofSize: 13)
            if rightSelectIdx == indexPath.row{
                cell.titleLbl.textColor = UIColor(named: "蓝色字体颜色")
                cell.titleLbl.font = UIFont.systemFont (ofSize: 13)
            }
        }
        
        return cell
    }
    func tableView(_ tableView: UITableView, didSelectRowAt indexPath: IndexPath) {
        if tableView == leftListView {
            leftSelectIdx = indexPath.row
            rightSelectIdx = nil
            
            leftStr = leftListArr[indexPath.row]
            switch leftStr {
            case "今天":
                let keys = dataModel?.today?.keys
                let keysArr = keys?.sorted(by: { (str1, str2) -> Bool in
                    let num1 = str1 as NSString
                    let num2 = str2 as NSString
                    return  num1.integerValue <  num2.integerValue ? true : false
                })
                rightListArr = keysArr
            case "明天":
                let keys = dataModel?.tomorrow?.keys
                let keysArr = keys?.sorted(by: { (str1, str2) -> Bool in
                    let num1 = str1 as NSString
                    let num2 = str2 as NSString
                    return  num1.integerValue <  num2.integerValue ? true : false
                })
                rightListArr = keysArr
            case "后天":
                let keys = dataModel?.taftert?.keys
                let keysArr = keys?.sorted(by: { (str1, str2) -> Bool in
                    let num1 = str1 as NSString
                    let num2 = str2 as NSString
                    return  num1.integerValue <  num2.integerValue ? true : false
                })
                rightListArr = keysArr
            default:
                break
            }
            
            rightListView.reloadData()
            leftListView.reloadData()

        }
        
        if tableView == rightListView {
            rightSelectIdx = indexPath.row
            rightListView.reloadData()
        }
    }
    
    //    /初始化时将xib中的view添加进来
    required init?(coder aDecoder: NSCoder) {
        super.init(coder: aDecoder)
        contentView = loadViewFromNib()
        addSubview(contentView)
        contentView.snp.makeConstraints { (make) in
            make.left.top.right.bottom.equalToSuperview()
        }
        self.setUI()
    }
    //加载xib
    func loadViewFromNib() -> UIView {
        let className = type(of: self)
        let bundle = Bundle(for: className)
        let name = NSStringFromClass(className).components(separatedBy: ".").last
        let nib = UINib(nibName: name!, bundle: bundle)
        let view = nib.instantiate(withOwner: self, options: nil).first as! UIView
        self.setUI()
        return view
    }
}
