//
//  WorkItemTableViewCell.swift
//  GeliBusinessPlatform
//
//  Created by 刘俊宏 on 2020/5/6.
//  Copyright © 2020 junye lu. All rights reserved.
//

import UIKit
@objc protocol WorkItemTableViewCellDelegate {
    @objc optional func WorkItemTableViewCellBtnClick(sender:WorkItemTableViewCell,idx:IndexPath)
    @objc optional func WorkItemTableViewCellAuthId(sender:WorkItemTableViewCell,auth_id:Int)
    @objc optional func WorkItemNoDataTableViewCell()

}
class WorkItemTableViewCell: UITableViewCell , UICollectionViewDelegate, UICollectionViewDataSource {
    var delegate:WorkItemTableViewCellDelegate?
    @IBOutlet weak var collectionViewHeight: NSLayoutConstraint!
    @IBOutlet weak var collectionView: UICollectionView!
    @IBOutlet weak var titleLbl: UILabel!
    @IBOutlet weak var gotoImgV: UIImageView!
    var dataModel:WorkcenterIndexDataModel? = nil

    var dataIndexSection = 0
    //数据
    var itemArrs:[String] = []
    var itemDataArrs:[WorkcenterIndexAuthResModel] = []

    override func awakeFromNib() {
        super.awakeFromNib()
        self.selectionStyle = .none
        //设置collectionView的代理
        self.collectionView.delegate = self
        self.collectionView.dataSource = self
        
        // 注册CollectionViewCell
        self.collectionView!.register(UINib(nibName:"WorkItemCollectionViewCell", bundle:nil),
                                      forCellWithReuseIdentifier: "WorkItemCollectionViewCell")
        
        
    }
    
    //加载数据
    func reloadData(title:String, items:[String]) {
        //设置标题
        self.titleLbl.text = title
        //保存图片数据
        self.itemArrs = items
        
        //collectionView重新加载数据
        self.collectionView.reloadData()
        
        //更新collectionView的高度约束
        let contentSize = self.collectionView.collectionViewLayout.collectionViewContentSize
        collectionViewHeight.constant = contentSize.height
        
        self.collectionView.collectionViewLayout.invalidateLayout()
    }
    
    //返回collectionView的单元格数量
    func collectionView(_ collectionView: UICollectionView,
                        numberOfItemsInSection section: Int) -> Int {
  
        if dataIndexSection == 1 && itemArrs.count == 0{
            return 1 
        }
        return itemArrs.count
    }
    
    //返回对应的单元格
    func collectionView(_ collectionView: UICollectionView,
                        cellForItemAt indexPath: IndexPath) -> UICollectionViewCell {
        let cell  = collectionView.dequeueReusableCell(withReuseIdentifier: "WorkItemCollectionViewCell",
                                                       for: indexPath) as! WorkItemCollectionViewCell
 
        cell.bgImV.isHidden = true

        //常用功能无数据处理
        if dataIndexSection == 1  && itemArrs.count == 0{
            cell.itemImgV.image = UIImage.init(named: "workshangchuan")
            cell.bgImV.image = UIImage.init(named: "workkuang")
            cell.itemNameLbl.text = "添加"
            cell.bgImV.isHidden = false 
            return cell
        }
        
        if dataIndexSection == 2 {
            cell.itemImgV.image = UIImage.init(named: ("work" + itemArrs[indexPath.row]))
            switch indexPath.row {
            case 0:
                cell.countLbl.text = StringByInt(number: (self.dataModel?.shipping!)!)
                break
            case 1:
                cell.countLbl.text = StringByInt(number: (self.dataModel?.confirm!)!)
                break
            case 2:
                cell.countLbl.text = StringByInt(number: (self.dataModel?.apply_in!)!)
                break
            case 3:
                cell.countLbl.text = StringByInt(number: (self.dataModel?.apply_out!)!)
                break
            case 4:
                cell.countLbl.text = StringByInt(number: (self.dataModel?.purchase!)!)
                break
            default:
                break
            }
            if cell.countLbl.text == "0" {
                cell.countLbl.isHidden = true
            }else{
                cell.countLbl.isHidden = false
            }
             
        }else{
            cell.countLbl.isHidden = true
            let rowModel = self.itemDataArrs[indexPath.row]
        
            
            if rowModel.app_icon == nil {
                cell.itemImgV.image  = UIImage.init(named: "worktest1")

            }else{
                cell.itemImgV.sd_setImage(with:  URL(string:SERVERCE_ImageHost +  rowModel.app_icon!), placeholderImage: UIImage.init(named: "worktest1"))

            }
        }
        cell.itemNameLbl.text = itemArrs[indexPath.row]
   
        
        return cell
    }
    
    func collectionView(_ collectionView: UICollectionView, didSelectItemAt indexPath: IndexPath) {
        if dataIndexSection == 2 {
            delegate?.WorkItemTableViewCellBtnClick?(sender: self, idx: indexPath)
        }else{
            //常用功能无数据处理
            if dataIndexSection == 1  && itemArrs.count == 0{
                delegate?.WorkItemNoDataTableViewCell?()
            }else{
                let rowModel = self.itemDataArrs[indexPath.row]
                //真实数据要穿 auth_id
                delegate?.WorkItemTableViewCellAuthId?(sender: self, auth_id: rowModel.auth_id!)
            }

        }

    }
    
 
    override func setSelected(_ selected: Bool, animated: Bool) {
        super.setSelected(selected, animated: animated)
        
        // Configure the view for the selected state
    }
    
}
