//
//  EditWorkCViewController.swift
//  GeliBusinessPlatform
//
//  Created by 刘俊宏 on 2020/5/6.
//  Copyright © 2020 junye lu. All rights reserved.
//

import UIKit

protocol EditWorkCViewControllerDelegate {
    func updataUIbyEditWorkSave()
}

class EditWorkCViewController: BaseViewController, UICollectionViewDelegate, UICollectionViewDataSource ,UICollectionViewDelegateFlowLayout, GeliAlertViewDelegate{

    var delegate: EditWorkCViewControllerDelegate?
    var dataModel:WorkcenterIndexDataModel? = nil
    var oftenArr:Array<WorkcenterIndexAuthResModel>? = [] //常用功能
    //MARK:--一级分类
    var titleStrArr:[String] = []
    var pAuthResModelArr:[WorkcenterIndexAuthResModel] = []
 
    @IBOutlet weak var topLayou: NSLayoutConstraint!
    @IBOutlet weak var itemListCollectionView: UICollectionView!
    @IBOutlet weak var titleView: UIView!
    @IBOutlet weak var collectionVheight: NSLayoutConstraint!
    @IBOutlet weak var collectionView: UICollectionView!
    override func viewDidLoad() {
        super.viewDidLoad()
        

        self.dataModel?.auth_res?.forEach({ (md) in
            if md.auth_pid == 0 {
                
                var chlicdAuthResModelArr:[WorkcenterIndexAuthResModel] = []
                let pAuthModel = md//父model
                self.dataModel?.auth_res?.forEach({ (model) in //子model
                    if pAuthModel.auth_id == model.auth_pid {
                        chlicdAuthResModelArr.append(md)
                    }
                })
                if chlicdAuthResModelArr.count > 0 {
                    titleStrArr.append(md.auth_name!)
                    pAuthResModelArr.append(md)

                }
            }
        })
        
 

        navbar.title = "功能列表"
        navbar.rightTitle = "保存"
        self.view.addSubview(navbar)
        topLayou.constant = CGFloat(NavHeight)

         //设置collectionView的代理
        self.collectionView.delegate = self
        self.collectionView.dataSource = self
        
        // 注册CollectionViewCell
        self.collectionView!.register(UINib(nibName:"WorkItemCollectionViewCell", bundle:nil),
                                      forCellWithReuseIdentifier: "WorkItemCollectionViewCell")
        
        //更新collectionView的高度约束
        let contentSize = self.collectionView.collectionViewLayout.collectionViewContentSize
        collectionVheight.constant = contentSize.height
        
        self.collectionView.collectionViewLayout.invalidateLayout()
        
        let longPress = UILongPressGestureRecognizer(target: self, action: #selector(longPressGesture(_:)))
        collectionView.addGestureRecognizer(longPress)
        
        //全部item展示
         //设置collectionView的代理
        self.itemListCollectionView.delegate = self
        self.itemListCollectionView.dataSource = self
        
        // 注册CollectionViewCell
        self.itemListCollectionView!.register(UINib(nibName:"WorkItemCollectionViewCell", bundle:nil),
                                      forCellWithReuseIdentifier: "WorkItemCollectionViewCell")
        self.itemListCollectionView?.register(UICollectionReusableView.self, forSupplementaryViewOfKind: UICollectionView.elementKindSectionHeader, withReuseIdentifier: "headerIdentifier")

    }
    
    //MARK:--保存方法
    func rightBtnClick() {
        print("要记得保存哦")
        //保存本地
        let alertView = GeliAlertView(frame: self.view.window!.bounds)
        alertView.delegate = self;
        alertView.tishiLbl.text = ""
        alertView.titileLbl.text = "是否保存当前编辑？"
        alertView.rightBtn.setAttributedTitle(NSAttributedString(string: "保存"), for: .normal)
        alertView.rightBtn.tag = 1001
        self.view.window?.addSubview(alertView)

    }
    func sureGeliAlertViewAction(sender: UIButton) {
        if sender.tag == 1001 {
            let userdataStr = UserDefaults.standard.value(forKey: "WorkDataModel")
            if userdataStr != nil {
                let workTestMd = WorkDataModel(JSONString: userdataStr as! String)
                // 在一个事务中更新对象
                let oftenStr = self.oftenArr?.toJSONString()
                workTestMd!.oftenArrStr = oftenStr!
                let userDataStr = workTestMd!.toJSONString()
                UserDefaults.standard.set(userDataStr, forKey: "WorkDataModel")
                UserDefaults.standard.synchronize()
                HUD.flash(.label("保存成功"), onView: nil, delay: 0.8) { (istrue) in
                    self.delegate?.updataUIbyEditWorkSave()
                    self.navigationController?.popViewController(animated: true)
                }
            }else{
                //无此状态，等bug出现
            }
        }
    }
    
    func numberOfSections(in collectionView: UICollectionView) -> Int {
        if collectionView == self.itemListCollectionView {
            return pAuthResModelArr.count
        }
        return 1
    }
    //返回collectionView的单元格数量
    func collectionView(_ collectionView: UICollectionView,
                        numberOfItemsInSection section: Int) -> Int {
        if collectionView == self.itemListCollectionView {
            var chlicdAuthResModelArr:[WorkcenterIndexAuthResModel] = []
            let pAuthModel = pAuthResModelArr[section]//父model
            self.dataModel?.auth_res?.forEach({ (md) in //子model
                if pAuthModel.auth_id == md.auth_pid {
                    chlicdAuthResModelArr.append(md)
                }
            })
            return chlicdAuthResModelArr.count
        }
        if oftenArr!.count >= 10 {
            return 10 //最多10个
        }
        return oftenArr!.count + 1
    }
    //返回对应的单元格
    func collectionView(_ collectionView: UICollectionView,
                        cellForItemAt indexPath: IndexPath) -> UICollectionViewCell {
        let cell  = collectionView.dequeueReusableCell(withReuseIdentifier: "WorkItemCollectionViewCell",
                                                       for: indexPath) as! WorkItemCollectionViewCell
        
        if collectionView == self.itemListCollectionView {
     

            cell.bgImV.image = UIImage.init(named: "workjia")
            //MARK:--如果oftenArr（常用有，这边就显示添加icon）
            var chlicdAuthResModelArr:[WorkcenterIndexAuthResModel] = []
            let pAuthModel = pAuthResModelArr[indexPath.section]//父model
            self.dataModel?.auth_res?.forEach({ (md) in //子model
                if pAuthModel.auth_id == md.auth_pid {
                    chlicdAuthResModelArr.append(md)
                }
            })
            let rowModel = chlicdAuthResModelArr[indexPath.row]
            if rowModel.app_icon == nil {
                    cell.itemImgV.image  = UIImage.init(named: "worktest1")

                }else{
                    cell.itemImgV.sd_setImage(with:  URL(string:SERVERCE_ImageHost +  rowModel.app_icon!), placeholderImage: UIImage.init(named: "worktest1"))

                }
            
            cell.itemNameLbl.text = rowModel.auth_name
            oftenArr?.forEach({ (md) in
                if md.auth_id == rowModel.auth_id {
                    cell.bgImV.image = UIImage.init(named: "workjian")
                }
            })

            
        }else{
            
            if indexPath.row == oftenArr!.count {
                cell.itemNameLbl.isHidden = true
                cell.itemImgV.isHidden = true
                cell.bgImV.image = UIImage.init(named: "workkuang")
            }else{
                cell.itemNameLbl.isHidden = false
                cell.itemImgV.isHidden = false
                let rowModel = oftenArr![indexPath.row]
                if rowModel.app_icon == nil {
                    cell.itemImgV.image  = UIImage.init(named: "worktest1")
                    
                }else{
                    cell.itemImgV.sd_setImage(with:  URL(string:SERVERCE_ImageHost +  rowModel.app_icon!), placeholderImage: UIImage.init(named: "worktest1"))
                    
                }
                cell.itemNameLbl.text = rowModel.auth_name
                cell.bgImV.image = UIImage.init(named: "workjian")
            }
            
        }
  
        return cell
        
    }
    func collectionView(_ collectionView: UICollectionView, viewForSupplementaryElementOfKind kind: String, at indexPath: IndexPath) -> UICollectionReusableView {
        if collectionView == self.itemListCollectionView {
            
            //MARK:--一级分类
            let headerV = collectionView.dequeueReusableSupplementaryView(ofKind: UICollectionView.elementKindSectionHeader, withReuseIdentifier: "headerIdentifier", for: indexPath)
            
            headerV.subviews.forEach { (view) in
                view.removeFromSuperview()
            }
            let headerLbl = UILabel(frame: CGRect(x: 15*glscale, y: 10*glscale, width: 360*glscale, height: 20*glscale))
            headerLbl.text = titleStrArr[indexPath.section]
            headerLbl.textColor = UIColor.init(named: "标题字颜色")
            headerLbl.font = UIFont.systemFont(ofSize: 13)
            headerV.addSubview(headerLbl)
            return headerV
        }
        let view = UIView()
        return view as! UICollectionReusableView

    }
    func collectionView(_ collectionView: UICollectionView, layout collectionViewLayout: UICollectionViewLayout, referenceSizeForHeaderInSection section: Int) -> CGSize {
        if collectionView == self.itemListCollectionView {
            return CGSize.init(width: self.view.bounds.width, height: 30*glscale)

        }
        return CGSize.zero
    }
    func collectionView(_ collectionView: UICollectionView, didSelectItemAt indexPath: IndexPath) {
        print("选中item=\(indexPath.section)=\(indexPath.row)")
        if collectionView == self.itemListCollectionView {
            //MARK:--需要判断加还是减
            var chlicdAuthResModelArr:[WorkcenterIndexAuthResModel] = []
            let pAuthModel = pAuthResModelArr[indexPath.section]//父model
            self.dataModel?.auth_res?.forEach({ (md) in //子model
                if pAuthModel.auth_id == md.auth_pid {
                    chlicdAuthResModelArr.append(md)
                }
            })
            var dataIndex = 0
            let rowModel = chlicdAuthResModelArr[indexPath.row]
            var isJia:Bool = true
            oftenArr?.forEach({ (md) in
                if md.auth_id == rowModel.auth_id {
                    isJia = false
                }
                if isJia {
                    dataIndex += 1
                }
            })
            
            if isJia {
                //添加
                if oftenArr!.count < 10 {
                    oftenArr!.append(rowModel)
                    self.collectionView.reloadData()
                    //更新collectionView的高度约束
                    let contentSize = self.collectionView.collectionViewLayout.collectionViewContentSize
                    collectionVheight.constant = contentSize.height
                    self.collectionView.collectionViewLayout.invalidateLayout()
                }else{
                    HUD.flash(.label("最多10个常用功能"),delay: 1.2)
                }
            }else{
                //删除
                oftenArr!.remove(at: dataIndex)
                self.collectionView.reloadData()
                //更新collectionView的高度约束
                let contentSize = self.collectionView.collectionViewLayout.collectionViewContentSize
                collectionVheight.constant = contentSize.height
                self.collectionView.collectionViewLayout.invalidateLayout()
            }
            
            self.itemListCollectionView.reloadData()

        }else{
            if indexPath.row < oftenArr!.count {
                oftenArr!.remove(at: indexPath.row)
                self.collectionView.reloadData()
                //更新collectionView的高度约束
                let contentSize = self.collectionView.collectionViewLayout.collectionViewContentSize
                collectionVheight.constant = contentSize.height
                self.collectionView.collectionViewLayout.invalidateLayout()
                self.itemListCollectionView.reloadData()
            }


        }

    }

    //MARK:--长按所需的参数
    var indexPath: IndexPath?
    var targetIndexPath: IndexPath?
    private lazy var dragingItem: WorkItemCollectionViewCell = {
        let nib = UINib(nibName:"WorkItemCollectionViewCell", bundle:nil)
        let cell = nib.instantiate(withOwner: self, options: nil).first as! WorkItemCollectionViewCell
        cell.isHidden = true
        return cell
    }()
    //MARK:--长按方法
    @objc func longPressGesture(_ sender: UILongPressGestureRecognizer){
        print("长按···")
        let point = sender.location(in: collectionView)
        switch sender.state {
        case .began:
            dragBegan(point: point)
            break
        case .changed:
            drageChanged(point: point)
            break
        case .ended:
            drageEnded(point: point)
            break
        case .cancelled:
            drageEnded(point: point)
            break
        default: break
            
        }
        
    }
    
    //MARK: - 长按开始
    private func dragBegan(point: CGPoint) {
        dragingItem.removeFromSuperview()
        collectionView.addSubview(dragingItem)

        indexPath = collectionView.indexPathForItem(at: point)
        //最后一个是否可以拖动+当为10个时候，提示框不显示，全部都可以拖地，当小于10后，显示提示框 最后那个不能拖动
        var endCount = 0
        if oftenArr!.count >= 10 {
            endCount = 11 //不存在的数
        }else{
            endCount = oftenArr!.count
        }
        if indexPath == nil || (indexPath?.section)! > 0 || indexPath?.row == endCount
        {return}
        
        let item = collectionView.cellForItem(at: indexPath!) as! WorkItemCollectionViewCell
        item.isHidden = true
        dragingItem.isHidden = false
        dragingItem.frame = (item.frame)
        //配置一样的item
        dragingItem.itemNameLbl.text = item.itemNameLbl.text
        dragingItem.itemImgV.image = item.itemImgV.image
        dragingItem.bgImV.image = item.bgImV.image
        
        dragingItem.transform = CGAffineTransform(scaleX: 1.1, y: 1.1)
    }
    //MARK: - 长按过程
    private func drageChanged(point: CGPoint) {
        if indexPath == nil || (indexPath?.section)! > 0 {return}
        dragingItem.center = point
        targetIndexPath = collectionView.indexPathForItem(at: point)
        //最后一个是否可以拖动+当为10个时候，提示框不显示，全部都可以拖地，当小于10后，显示提示框 最后那个不能拖动
        var endCount = 0
        if oftenArr!.count >= 10 {
            endCount = 11 //不存在的数
        }else{
            endCount = oftenArr!.count
        }
        if targetIndexPath == nil || (targetIndexPath?.section)! > 0 || indexPath == targetIndexPath  || targetIndexPath?.row == endCount {return}
        // 更新数据
        let obj = oftenArr![indexPath!.item]
        oftenArr!.remove(at: indexPath!.row)
        oftenArr!.insert(obj, at: targetIndexPath!.item)
        //交换位置
        collectionView.moveItem(at: indexPath!, to: targetIndexPath!)
        indexPath = targetIndexPath
    }
    //MARK: - 长按结束
    private func drageEnded(point: CGPoint) {
        var endCount = 0
        if oftenArr!.count >= 10 {
            endCount = 11 //不存在的数
        }else{
            endCount = oftenArr!.count
        }
        if indexPath == nil || (indexPath?.section)! > 0  || indexPath?.row == endCount {return}
        let endCell = collectionView.cellForItem(at: indexPath!)
        
        UIView.animate(withDuration: 0.25, animations: {
            
            self.dragingItem.transform = CGAffineTransform.identity
            self.dragingItem.center = (endCell?.center)!
            
        }, completion: {
            
            (finish) -> () in
            
            endCell?.isHidden = false
            self.dragingItem.isHidden = true
            self.indexPath = nil
            
        })
        
    }
}
