//
//  BindingViewController.swift
//  GeliBusinessPlatform
//
//  Created by junye lu on 2020/4/15.
//  Copyright © 2020 junye lu. All rights reserved.
//

import UIKit
import LGButton

class BindViewController: BaseViewController, GeliAlertViewDelegate {
    
    @IBOutlet weak var submitBtn: LGButton!
    @IBOutlet weak var accountTF: UITextField!
    @IBOutlet weak var phoneTF: UITextField!
    @IBOutlet weak var codeTF: UITextField!
    @IBOutlet weak var codeBtn: UIButton!
    @IBOutlet weak var topPinkHeight: NSLayoutConstraint!
    
    var isNewBind = false
    
    override func viewDidLoad() {
        super.viewDidLoad()
        if isNewBind {
            navbar.title = "绑定支付账户"
        }else{
            navbar.title = "换绑支付账户"
        }
        self.view.addSubview(navbar)
        if isNewBind {
            topPinkHeight.constant = 44
        }else{
            topPinkHeight.constant = 44 - 38
        }
        
        
        // Do any additional setup after loading the view.
    }
    //MARK: -绑定、获取验证码
    //
    let UserToken = UserDefaults.standard.value(forKey: "user_token")
          
    @IBAction func registerPayAccountAction(_ sender: Any) {
        print("注册支付账号")
        HUD.flash(.progress)
      
        locationGeliPay(["user_token":UserToken as Any,"type":"3"], success: { (data) in
            HUD.hide(animated: true)
            let dataM = data as! LocationGeliPayModel
            let vc = WebViewController()
            vc.urlStr = dataM.data?.url 
            self.navigationController?.pushViewController(vc, animated: true)
        }) { (error) in
            
        }
    }
    @IBAction func getCodeAction(_ sender: UIButton) {
        print("获取验证码")
        sendSmsCaptcha(["phone":phoneTF.text as Any,"type":"5"], success: { (data) in
            let dataM = data as! UpDataModel
            if dataM.code == 1 {
                sender.isUserInteractionEnabled = false
                sender.setTitle("60s", for: .normal);
                Timer.scheduledTimer(timeInterval: 1, target: self, selector: #selector(self.timeCounting), userInfo: nil, repeats: true);
            }
            
        }) { (error) in
            
        }
    }
    var timeCount:Int = 60
    
    @objc func timeCounting(sender:Timer){
        timeCount -= 1
        codeBtn.setTitle("\(timeCount)"+"s", for: .normal)
        if timeCount == 0{
            codeBtn.setTitle("获取验证码", for: .normal)
            codeBtn.isUserInteractionEnabled = true
            timeCount = 60
            sender.invalidate()
        }
    }
    
    @IBAction func submitBindingAction(_ sender: Any) {
        print("确认绑定账号")
        if accountTF.text?.count == 0 {
            HUD.flash(.label("请填写换绑的格利支付账号"),delay: 1.2)
            return
        }
        if codeTF.text?.count == 0 {
            HUD.flash(.label("请填写验证码"),delay: 1.2)
            return
        }
        let alertView = GeliAlertView(frame: self.view.window!.bounds)
        alertView.delegate = self;
        alertView.tishiLbl.text = ""
        alertView.titileLbl.text = "确定更绑格利支付账号？"
        alertView.rightBtn.setAttributedTitle(NSAttributedString(string: "确认"), for: .normal)
        alertView.rightBtn.tag = 1001
        self.view.window?.addSubview(alertView)

    }
    func sureGeliAlertViewAction(sender: UIButton) {
        if sender.tag == 1001 {
            HUD.flash(.progress)
            
            bindGeliPay(["user_token":UserToken as Any,"geli_pay_user":accountTF.text as Any], success: { (data) in
                let dataM = data as! UpDataModel
                if dataM.code == 1{
                    HUD.flash(.label("修改成功"),delay: 1.2)
                    self.navigationController?.popToRootViewController(animated: true)
                }else{
                    HUD.hide()
                }
            }) { (error) in
                
            }
        }
    }
}
