//
//  BindStepTwoViewController.swift
//  GeliBusinessPlatform
//
//  Created by junye lu on 2020/4/21.
//  Copyright © 2020 junye lu. All rights reserved.
//

import UIKit
import LGButton

class BindStepTwoViewController: BaseViewController,UITextFieldDelegate {
    var phoneStr : String
        = ""
    var isNewBind = false

    @IBOutlet weak var accountLbl: UILabel!
    
    @IBOutlet weak var codeBtn: UIButton!
    
    @IBAction func nextStep(_ sender: Any) {
        HUD.flash(.progress)
        verifyMmsCaptcha(["phone":phoneStr,"type":"4","code":inputTF.text! as String], success: { (data) in
            HUD.hide(animated: true)
            let vc = BindViewController()
            vc.isNewBind = self.isNewBind
            self.navigationController?.pushViewController(vc, animated: true)
        }) { (error) in
            
        }
        
    }
    
    @IBOutlet weak var topView: UIView!
    @IBOutlet weak var inputTF: UITextField!
    @IBOutlet weak var nextBtn: LGButton!
    override func viewDidLoad() {
        super.viewDidLoad()
        if isNewBind {
            navbar.title = "绑定支付账户"
        }else{
            navbar.title = "换绑支付账户"
        }
        self.view.addSubview(navbar)
        
        topView.snp.makeConstraints { (make) in
            make.top.equalTo(NavCGRect.height)
            make.left.right.equalTo(0)
            make.height.equalTo(99)
        }
        inputTF.delegate = self
        self.accountLbl.text = phoneStr
        nextBtn.alpha = 0.5
        nextBtn.isUserInteractionEnabled = false
        
        // Do any additional setup after loading the view.
    }
    
    func textFieldDidBeginEditing(_ textField: UITextField) {
        changeBtnCanSelect (sender: textField)
    }
    func textFieldDidEndEditing(_ textField: UITextField) {
        changeBtnCanSelect (sender: textField)
    }
    func textField(_ textField: UITextField, shouldChangeCharactersIn range: NSRange, replacementString string: String) -> Bool {
        changeBtnCanSelect (sender: textField)
        return true
    }
    func changeBtnCanSelect (sender:UITextField){
        if sender.text?.count == 0 {
            nextBtn.alpha = 0.5
            nextBtn.isUserInteractionEnabled = false
        }else{
            nextBtn.alpha = 1
            nextBtn.isUserInteractionEnabled = true
        }
    }
    
    
    @IBAction func getCodeAction(_ sender: UIButton) {
        //        HUD.flash(.labeledSubSuccess(subtitle: "发送成功"),delay: 1.2)
        sendSmsCaptcha(["phone":phoneStr,"type":"4"], success: { (data) in
            let dataM = data as! UpDataModel
            if dataM.code == 1 {
                sender.isUserInteractionEnabled = false
                sender.setTitle("60s", for: .normal);
                Timer.scheduledTimer(timeInterval: 1, target: self, selector: #selector(self.timeCounting), userInfo: nil, repeats: true);
            }
            
        }) { (error) in
            
        }
        
    }
    var timeCount:Int = 60
    
    @objc func timeCounting(sender:Timer){
        timeCount -= 1
        codeBtn.setTitle("\(timeCount)"+"s", for: .normal)
        if timeCount == 0{
            codeBtn.setTitle("获取验证码", for: .normal)
            codeBtn.isUserInteractionEnabled = true
            timeCount = 60
            sender.invalidate()
        }
    }
    
    
}
