//
//  PayViewController.swift
//  GeliBusinessPlatform
//
//  Created by junye lu on 2020/4/16.
//  Copyright © 2020 junye lu. All rights reserved.
//

import UIKit
import LGButton

class PayViewController: BaseViewController ,GeliAlertViewDelegate{
    
    @IBOutlet weak var enterBtnFrameBtn: UIButton!
    @IBOutlet weak var enterBtn: LGButton!
    @IBOutlet weak var changeBindBtn: UIButton!
    @IBOutlet weak var pinkView: UIView!
    
    @IBOutlet weak var passBtn: UIButton!
    
    @IBOutlet weak var accountLbl: UILabel!
     let UserToken = UserDefaults.standard.value(forKey: "user_token")
    @IBOutlet weak var userEnShowView: UIView!
    
    override func viewDidLoad() {
        super.viewDidLoad()
        
        navbar.title = "支付账号"
        self.view.addSubview(navbar)
       
        HUD.flash(.progress)

        geliPayInfo(["user_token":UserToken as Any], success: { (data) in
            let dataM = data as! GeliPayInfoModel
            if dataM.code == 2 {
                self.enterBtnFrameBtn.isHidden = false
                self.enterBtn.isHidden = true
                self.passBtn.isHidden = true
                self.changeBindBtn.isHidden = true
            }else{
                self.accountLbl.text = dataM.data?.gelipay_username
            }
            self.userEnShowView.isHidden = true
            HUD.hide(animated: true)
         }) { (error) in
 
        }
 
        pinkView.snp.makeConstraints { (make) in
            make.top.equalTo(NavCGRect.height)
            make.left.right.equalTo(0)
            make.height.equalTo(22.5)
        }
        // Do any additional setup after loading the view.
    }
    //MARK: -方法
    
    @IBAction func bindAction(_ sender: Any) {
        print("换绑账号")
        
         getShopAdministratorInfo(["user_token":UserToken as Any], success: { (data) in
             let dataM = data as! ShopAdministratorInfoModel
             if dataM.code != 2 {
                 //跳转下一页
                 let vc = BindStepTwoViewController()
                 vc.phoneStr = dataM.data?.mobile as! String
                 self.navigationController?.pushViewController(vc, animated: true)
             }
         }) { (error) in

         }
    }
    @IBAction func passwordAction(_ sender: UIButton) {
        HUD.flash(.progress)
         
         
         locationGeliPay(["user_token":UserToken as Any,"type":"2"], success: { (data) in
             HUD.hide(animated: true)
             let dataM = data as! LocationGeliPayModel
             let vc = WebViewController()
             vc.urlStr = dataM.data?.url
             self.navigationController?.pushViewController(vc, animated: true)
         }) { (error) in
             
         }
    }
    @IBAction func enterInGLPayAction(_ sender: Any) {
        print("进入格利支付")
        HUD.flash(.progress)
         
         
         locationGeliPay(["user_token":UserToken as Any,"type":"1"], success: { (data) in
             HUD.hide(animated: true)
             let dataM = data as! LocationGeliPayModel
             let vc = WebViewController()
             vc.urlStr = dataM.data?.url
             self.navigationController?.pushViewController(vc, animated: true)
         }) { (error) in
             
         }
    }
    
    @IBAction func enterBindAction(_ sender: UIButton) {
        print("未绑定--")
        
        getShopAdministratorInfo(["user_token":UserToken as Any], success: { (data) in

            let dataM = data as! ShopAdministratorInfoModel
            if dataM.code != 2 {
                //跳转下一页
                let vc = BindStepTwoViewController()
                vc.isNewBind = true
                vc.phoneStr = dataM.data?.mobile as! String
                self.navigationController?.pushViewController(vc, animated: true)
            }else{
                let alertView = GeliAlertView(frame: self.view.window!.bounds)
                alertView.delegate = self;
                alertView.tishiLbl.text = "020-81338860"
                alertView.titileLbl.text = "亲爱的格利商户，您未绑定手机号，无法绑定格利账号，请联系："
                self.view.window?.addSubview(alertView)
            }
        }) { (error) in

        }
 
    }
    func sureGeliAlertViewAction(sender: UIButton) {
        UIApplication.shared.openURL(NSURL.init(string: "tel://020-81338860")! as URL)

    }
}
