//
//  ShouZhiTongJiViewController.swift
//  GeliBusinessPlatform
//
//  Created by junye lu on 2020/5/7.
//  Copyright © 2020 junye lu. All rights reserved.
//

import UIKit
import SwiftDate

class ShouZhiTongJiViewController: BaseViewController,UITableViewDelegate,UITableViewDataSource, WorkSelectTimeViewDelegate {
    
    @IBOutlet weak var dayLbl: UILabel!
    @IBOutlet weak var scrollView: UIScrollView!
    @IBOutlet weak var bottomListView: UITableView!
    @IBOutlet weak var topListView: UITableView!
    @IBOutlet weak var zhiChuSmallLbl: UILabel!
    @IBOutlet weak var zhiChuBigLbl: UILabel!
    @IBOutlet weak var shouRuSmallLbl: UILabel!
    @IBOutlet weak var shouRuBigLbl: UILabel!
    
    
    override func viewDidLoad() {
        super.viewDidLoad()
        navbar.title = "收支统计"
        navbar.rightImg = UIImage.init(named: "ShouZhiTongJiDayEdit")
        self.view.addSubview(navbar)
        SetTopFrame(view: dayLbl, height:20)
        
        loadData()
        
        // Do any additional setup after loading the view.
        topListView.separatorStyle = .none
        bottomListView.separatorStyle = .none
        topListView.isScrollEnabled = false
        bottomListView.isScrollEnabled = false
        
        topListView.register(UINib(nibName: "TitleAndTFCell", bundle: nil), forCellReuseIdentifier: "TitleAndTFCell")
        bottomListView.register(UINib(nibName: "TitleAndTFCell", bundle: nil), forCellReuseIdentifier: "TitleAndTFCell")
    }
    var topArr = ["主营收入","其它收入"]
    var bottomArr = ["固定采购","临时采购","员工工资","运输费","租金费","冷藏费","其它费","样品"]
    var topHolder = ["-","-"]
    var bottomHolder = ["-","-","-","-","-","-","-","-"]
    func loadData(){
        print("abc == ",starTime)
        let start = dateConvertString(date: starTime + 8.hours, dateFormat: "yyyy年MM月dd日")
        let end = dateConvertString(date: endTime + 8.hours, dateFormat: "yyyy年MM月dd日")
        if start == end {
            dayLbl.text = "   日期统计区间: " + start
        }else{
            dayLbl.text = "   日期统计区间: " + start + " 至 " + end
        }
        let UserToken = UserDefaults.standard.value(forKey: "user_token")
        let star_time = Int(starTime.timeIntervalSince1970)
        let end_time = Int(endTime.timeIntervalSince1970)
        
        Statistics(["user_token":UserToken as Any,"start_time":star_time as Any,"end_time":end_time as Any], success: { (data) in
            let model = (data as! StatisticsModel)
            if model.data?.order_amount_sum != nil {
                self.topHolder.insert("\(String(describing: model.data!.order_amount_sum!))", at: 0)
                self.topHolder.remove(at: 1)
            }
            if  model.data?.finance_income != nil {
                self.topHolder.insert("\(String(describing: model.data!.finance_income!))", at: 1)
                self.topHolder.remove(at: 2)
            }
            
            if model.data?.expend?.fixed_purchase != nil {
                self.bottomHolder.insert("\(model.data!.expend!.fixed_purchase!)", at: 0)
                self.bottomHolder.remove(at: 1)
            }
            if model.data?.expend?.temp_purchase != nil {
                self.bottomHolder.insert("\(model.data!.expend!.temp_purchase!)", at: 1)
                self.bottomHolder.remove(at: 2)
            }
            if model.data?.expend?.salary != nil {
                self.bottomHolder.insert("\(model.data!.expend!.salary!)", at: 2)
                self.bottomHolder.remove(at: 3)
            }
            if model.data?.expend?.logistics != nil {
                self.bottomHolder.insert("\(model.data!.expend!.logistics!)", at: 3)
                self.bottomHolder.remove(at: 4)
            }
            if model.data?.expend?.rental != nil {
                self.bottomHolder.insert("\(model.data!.expend!.rental!)", at: 4)
                self.bottomHolder.remove(at: 5)
            }
            if model.data?.expend?.refrigeration != nil {
                self.bottomHolder.insert("\(model.data!.expend!.refrigeration!)", at: 5)
                self.bottomHolder.remove(at: 6)
            }
            if model.data?.expend?.other != nil {
                self.bottomHolder.insert("\(model.data!.expend!.other!)", at: 6)
                self.bottomHolder.remove(at: 7)
            }
            if model.data!.expend!.boon != nil {
                self.bottomHolder.insert("\(model.data!.expend!.boon!)", at: 7)
                self.bottomHolder.remove(at: 8)
            }
            
            
            let income_sum = "\(String(describing: model.data!.income_sum!))"
            if income_sum.contains("."){
                let incomeArr = income_sum.components(separatedBy: ".")
                self.shouRuBigLbl.text = incomeArr.first!
                self.shouRuSmallLbl.text = "."+incomeArr.last!
            }else{
                self.shouRuBigLbl.text = income_sum
            }
            let expend_sum = "\(String(describing: model.data!.expend_sum!))"
            if expend_sum.contains("."){
                let expendArr = expend_sum.components(separatedBy: ".")
                self.zhiChuBigLbl.text = expendArr.first!
                self.zhiChuSmallLbl.text = "."+expendArr.last!
            }else{
                self.zhiChuBigLbl.text = expend_sum
            }
            self.topListView.reloadData()
            self.bottomListView.reloadData()
        }) { (error) in
            
        }
    }
    
    //MARK:--日期筛选按钮（右上角按钮）
    let selectV = WorkSelectTimeView()
    var selelctIndex = 1001
    var isShowSelectTimeV:Bool = false
    var endTime = DateInRegion().dateAt(.endOfDay).date  - 8.hours
    var starTime =  DateInRegion().dateAt(.startOfDay).date - 8.hours
    func rightBtnClick() {
        print("日期筛选按钮")
        if isShowSelectTimeV {
            selectV.removeFromSuperview()
        }else{
            selectV.delegate = self
            selectV.selectIndex = selelctIndex
            self.view.window?.addSubview(selectV)
            selectV.snp.makeConstraints { (make) in
                make.top.equalTo(navbar.snp_bottom)
                make.left.right.bottom.equalToSuperview()
            }
            selectV.BeginDate = starTime
            selectV.EndDate = endTime
        }
    }
    //MARK:--时间选择视图反馈
    func selectWorkIndx(sender: Int, beginDate: Date?, endginDate: Date?) {
        selelctIndex = sender;
        isShowSelectTimeV = false
        switch sender {
        case 1001:
            //               topNavBtn.setTitle("今日", for: .normal)
            endTime = DateInRegion().dateAt(.endOfDay).date - 8.hours
            starTime = DateInRegion().dateAt(.startOfDay).date - 8.hours //今天开始时间
            loadData()
            break
        case 1002:
            //               topNavBtn.setTitle("本周", for: .normal)
            endTime = DateInRegion().dateAt(.endOfDay).date - 8.hours
            starTime = DateInRegion().dateAt(.startOfWeek).date + 1.days - 8.hours //当周周一开始时间
            loadData()
            break
        case 1003:
            //               topNavBtn.setTitle("本月", for: .normal)
            endTime = DateInRegion().dateAt(.endOfDay).date - 8.hours
            starTime = DateInRegion().dateAt(.startOfMonth).date - 9.hours - 1.minutes - 1.seconds //本月开始时间
            loadData()
            break
        case 1004:
            if beginDate != nil && endginDate != nil {
                let timeInterval:TimeInterval = beginDate!.timeIntervalSince1970
                let timeIntervalEnd:TimeInterval = endginDate!.timeIntervalSince1970
                let timestr = dayByDouble(sender: timeInterval) + "-" + dayByDouble(sender: timeIntervalEnd)
                //                   topNavBtn.setTitle(timestr, for: .normal)
                endTime = endginDate!
                starTime = beginDate!
                print(timestr)
                loadData()
            }
            
            break
        default:
            break
        }
    }
    
    //MARK: - cell delegate
    func tableView(_ tableView: UITableView, viewForHeaderInSection section: Int) -> UIView? {
        let view = UIView(frame: CGRect(x: 0, y: 0, width: fullScreenWidth, height: 37))
        let title = UILabel(frame: CGRect(x: 15, y: 0, width: fullScreenWidth, height: 37))
        if tableView == topListView {
            title.text = "收入概括"
        }else{
            title.text = "支出概括"
        }
        title.textColor = UIColor(named: "标题字颜色")
        title.font = UIFont.boldSystemFont(ofSize: 15)
        view.addSubview(title)
        return view
    }
    func tableView(_ tableView: UITableView, heightForHeaderInSection section: Int) -> CGFloat {
        return 37
    }
    func tableView(_ tableView: UITableView, heightForRowAt indexPath: IndexPath) -> CGFloat {
        return 49
    }
    
    func tableView(_ tableView: UITableView, numberOfRowsInSection section: Int) -> Int {
        if tableView == topListView {
            return topArr.count
        }else{
            return bottomArr.count
        }
    }
    func tableView(_ tableView: UITableView, cellForRowAt indexPath: IndexPath) -> UITableViewCell {
        let cell = tableView.dequeueReusableCell(withIdentifier: "TitleAndTFCell") as! TitleAndTFCell
        cell.textTF.isUserInteractionEnabled = false
        if tableView == topListView {
            cell.nameLbl.text = topArr[indexPath.row]
            cell.textTF.text = topHolder[indexPath.row]
        }else{
            cell.nameLbl.text = bottomArr[indexPath.row]
            cell.textTF.text = bottomHolder[indexPath.row]
        }
        return cell
    }
    
}
