//
//  PinPaiListViewController.swift
//  GeliBusinessPlatform
//
//  Created by junye lu on 2020/5/8.
//  Copyright © 2020 junye lu. All rights reserved.
//

import UIKit
protocol PinPaiListViewControllerDelegate {
    func blackSelectPinPaiData(sender:GeneralInfoBrandModel)
}
class PinPaiListViewController: BaseViewController,UISearchBarDelegate,SearchBarViewDelegate,UITableViewDelegate,UITableViewDataSource,TitleAndSelectCellDelegate,XinZengPinPaiViewControllerDelegate{
    func XinZengPinPaiViewControllerFinsih() {
        self.listView.mj_header?.beginRefreshing()
    }
    
    var dataModelArray : Array<GeneralInfoBrandModel>? = []
    var isSelectData : Bool = false
    var delegate : PinPaiListViewControllerDelegate?
    @IBOutlet weak var sureTop: NSLayoutConstraint!
    @IBOutlet weak var tableBottom: NSLayoutConstraint!
    @IBOutlet weak var sureLbl: UILabel!
    @IBOutlet weak var sureBtn: UIButton!
    @IBOutlet weak var topView: UIView!
    @IBOutlet weak var listView: UITableView!
    
    let UserToken = UserDefaults.standard.value(forKey: "user_token")
    var keyWord = ""
    var page = 0
    
    var tempArr:Array<GeneralInfoBrandModel>? = []
    var searchV : SearchBarView? = nil
    override func viewDidLoad() {
        super.viewDidLoad()
        if isSelectData {
            navbar.title = "请选择品牌"
            tableBottom.constant = CGFloat(TabHeight)
        }else{
            navbar.title = "品牌列表"
            navbar.rightTitle = "新增"
            sureBtn.isHidden = true
            sureLbl.isHidden = true
            //下拉刷新相关设置
            headerMJ.setRefreshingTarget(self, refreshingAction: #selector(loadData))
            listView.mj_header = headerMJ
            //上拉加载相关设置
            footerMJ.setRefreshingTarget(self, refreshingAction: #selector(loadMoreData))
            listView.mj_footer = footerMJ
            listView.mj_header?.beginRefreshing()
        }
        
        self.view.addSubview(navbar)
        SetTopFrame(view: topView, height: 44)
        listView.separatorStyle = .none
        
        let searchBr = SearchBarView.init()
        topView.addSubview(searchBr)
        searchBr.snp.makeConstraints { (make) in
            make.left.equalTo(10)
            make.right.equalTo(-10)
            make.centerY.equalToSuperview()
            make.height.equalTo(30)
        }
        searchV = searchBr
        searchBr.placeholderStr = "请输入品牌名称"
        searchBr.cornerRadius = 35/2.0
        searchBr.delegate = self
        searchBr.delegateL = self
        tempArr = dataModelArray
        listView.register(UINib(nibName: "TitleAndSelectCell", bundle: nil), forCellReuseIdentifier: "TitleAndSelectCell")
        // Do any additional setup after loading the view.
        
        
    }
    func rightBtnClick() {
        let vc = XinZengPinPaiViewController()
        vc.navTitle = "新增品牌"
        vc.delegate = self
        self.navigationController?.pushViewController(vc, animated: true)
    }
    
    
    
    func tableView(_ tableView: UITableView, heightForRowAt indexPath: IndexPath) -> CGFloat {
        return 49
    }
    func tableView(_ tableView: UITableView, numberOfRowsInSection section: Int) -> Int {
        if isSelectData{
            return dataModelArray!.count
        }else{
            return datas.count
        }
    }
    func tableView(_ tableView: UITableView, cellForRowAt indexPath: IndexPath) -> UITableViewCell {
        
        let cell = tableView.dequeueReusableCell(withIdentifier: "TitleAndSelectCell") as! TitleAndSelectCell
        cell.delegate = self
        cell.tag = indexPath.row
        
        if isSelectData {
            let rowModel = dataModelArray![indexPath.row]
            
            cell.titleLbl.text = rowModel.brand_name
            cell.titleLbl.textColor = UIColor(named: "标题字颜色")
            cell.selectBtn.isSelected = false
            if selectModel != nil {
                if rowModel.brand_id == selectModel?.brand_id {
                    cell.titleLbl.textColor = UIColor(named: "蓝色字体颜色")
                    cell.selectBtn.isSelected = true
                }
            }
        }else{
            cell.selectBtn.isHidden = true
            if datas.count > 0 {
                let rowModel = datas[indexPath.row]
                cell.titleLbl.text = rowModel.brand_name
            }
        }
        
        return cell
        
    }
    var selectModel : GeneralInfoBrandModel? = nil
    func tableView(_ tableView: UITableView, didSelectRowAt indexPath: IndexPath) {
        if isSelectData {
            let rowModel = dataModelArray![indexPath.row] as! GeneralInfoBrandModel
            selectModel = rowModel
            listView.reloadData()
        }else{
            let model = datas[indexPath.row]
            let vc = XinZengPinPaiViewController()
            vc.navTitle = "品牌详情"
            //            vc.navTitle = "编辑品牌"
            vc.iconUrl = model.brand_img!
            vc.pinPaiUrl = model.site_url!
            vc.commend = model.brand_desc!
            vc.pinPaiName = model.brand_name!
            self.navigationController?.pushViewController(vc, animated: true)
        }
        
    }
    //MARK:--选择品牌确定按钮
    @IBAction func sureAction(_ sender: UIButton) {
        print("选择品牌确定按钮")
        if selectModel == nil {
            HUD.flash(.label("请选择品牌"), delay: 1.2)
        }else{
            self.delegate?.blackSelectPinPaiData(sender: selectModel!)
            self.navigationController?.popViewController(animated: true)
            
        }
    }
    //MARK:--自定义celldelegate
    func TitleAndSelectCellClick(content: UIButton, cell: TitleAndSelectCell) {
        print(cell.tag)
        let rowModel = dataModelArray![cell.tag] as! GeneralInfoBrandModel
        selectModel = rowModel
        listView.reloadData()
        
    }
    var datas:Array<brandListDataModel> = []
    //MARK:--加载数据
    @objc func loadData(){
        print("加载数据")
        page = 1
        let dic = ["user_token":UserToken as Any,"keyword":keyWord as Any,"page":page as Any]
        brandList(dic, success: { (data) in
            let model = data as! brandListModel
            self.datas.removeAll()
            model.data?.forEach({ (item) in
                self.datas.append(item)
            })
            self.listView.reloadData()
            self.listView.mj_header?.endRefreshing()
            self.page = 2
            if model.data?.count == 0 {
                self.listView.mj_footer?.endRefreshingWithNoMoreData()
            }else{
                self.listView.mj_footer?.endRefreshing()
            }
        }) { (error) in
            self.listView.mj_header?.endRefreshing()
            
        }
        
    }
    //MARK:--加载更多数据
    @objc func loadMoreData(){
        print("加载更多数据")
        let dic = ["user_token":UserToken as Any,"keyword":keyWord as Any,"page":page as Any]
        brandList(dic, success: { (data) in
            let model = data as! brandListModel
            if model.data?.count == 0 {
                self.listView.mj_footer?.endRefreshingWithNoMoreData()
            }else{
                self.page += 1
                model.data?.forEach({ (item) in
                    self.datas.append(item)
                })
                self.listView.reloadData()
                self.listView.mj_footer?.endRefreshing()
            }
        }) { (error) in
            self.listView.mj_footer?.endRefreshing()
            
        }
        
    }
    
    //MAKR:--调起搜索后添加个蒙版本
    var blackBtnView:UIButton! = nil
    func searchBarSearchButtonClicked(_ searchBar: UISearchBar) {
        print("点击搜索进行--")
        searchBar.resignFirstResponder()
        if isSelectData {
            if searchBar.text!.count > 0{
                dataModelArray?.removeAll()
                let str = searchBar.text
                for item in tempArr! {
                    let strName = item.brand_name as! NSString
                    if strName.contains(str!){
                        dataModelArray?.append(item)
                    }
                }
            }
            listView.reloadData()
        }else{
            keyWord = searchBar.text!
            listView.mj_header?.beginRefreshing()
        }
        
        removeBlackBtnView()
        if searchBar.text?.count == 0 && keyWord.count != 0{
            keyWord = searchBar.text!
            listView.mj_header?.beginRefreshing()
        }
        
        
    }
    //MARK:--取消搜索代理
   
    func searchBarTextDidEndEditing(_ searchBar: UISearchBar) {
        print("编辑即将结束了--")
        if isSelectData == false {
        removeBlackBtnView()
            if searchBar.text?.count == 0 && keyWord.count != 0{
                keyWord = searchBar.text!
                listView.mj_header?.beginRefreshing()
            }
        }
    }
    func clearSearchAction() {
        print("清楚搜索文字")
        if isSelectData {
        dataModelArray?.removeAll()
        dataModelArray = tempArr
        listView.reloadData()
        }
    }
    func searchBarShouldBeginEditing(_ searchBar: UISearchBar) -> Bool {
        print("调起搜索后添加个蒙版本")
        blackBtnView = UIButton ()
        blackBtnView.backgroundColor = UIColor.init(named: "提示视图背景色")
        self.view.addSubview(blackBtnView)
        blackBtnView.snp.makeConstraints { (make) in
            make.left.right.bottom.equalToSuperview()
            make.top.equalTo(topView!.snp_bottom)
        }
        blackBtnView.addTarget(self, action: #selector(removeBlackBtnView), for: .touchUpInside)
        
        return true
    }
    @objc func removeBlackBtnView(){
        if blackBtnView != nil {
            blackBtnView.removeFromSuperview()
            searchV!.resignFirstResponder()
        }
    }
}
