//
//  XinZengPinPaiViewController.swift
//  GeliBusinessPlatform
//
//  Created by junye lu on 2020/4/26.
//  Copyright © 2020 junye lu. All rights reserved.
//

import UIKit
import LGButton
import Photos
protocol XinZengPinPaiViewControllerDelegate {
    func XinZengPinPaiViewControllerFinsih()
}
class XinZengPinPaiViewController: BaseViewController,UITableViewDataSource,UITableViewDelegate,TitleAndBtnCellDelegate,TitleAndTFCellDelegate,TilteAndTextViewCellDelegate{
    var delegate:XinZengPinPaiViewControllerDelegate?
    let titleArr = ["品牌名称","品牌图标","站点地址","品牌描述"]
    let holderArr = ["请输入品牌名称","0","请输入站点地址如：www.gelifood.com","0"]
    
    @IBOutlet weak var lgBtn: LGButton!
    let UserToken = UserDefaults.standard.value(forKey: "user_token")
    @IBOutlet weak var btnTitleLbl: UILabel!
    @IBOutlet weak var listView: UITableView!
    
    @IBOutlet weak var btmLblH: NSLayoutConstraint!
    var iconUrl = ""
    var pinPaiName = ""//品牌名字
    var pinPaiUrl = ""//品牌连接
    var commend = ""//品牌描述
    
    var navTitle:String?
    override func viewDidLoad() {
        super.viewDidLoad()
        navbar.title = navTitle
        if navTitle == "编辑品牌" {
            navbar.rightTitle = "删除"
        }
        if (navTitle?.contains("详情"))!{
            lgBtn.isHidden = true
            btnTitleLbl.isHidden = true
            btmLblH.constant = 0
        }
        self.view.addSubview(navbar)
        SetTopFrameView(view: listView, btmView: btnTitleLbl)
        
        listView.separatorStyle = .none
        listView.isScrollEnabled = false
        listView.register(UINib(nibName: "TitleAndTFCell", bundle: nil), forCellReuseIdentifier: "TitleAndTF")
        listView.register(UINib(nibName: "TitleAndBtnCell", bundle: nil), forCellReuseIdentifier: "TitleAndBtn")
        listView.register(UINib(nibName: "TilteAndTextViewCell", bundle: nil), forCellReuseIdentifier: "TilteAndTextView")
        // Do any additional setup after loading the view.
    }
    //MARK: - 删除
    func rightBtnClick() {
        
    }
    //MARK: - 提交
    @IBAction func btnAction(_ sender: Any) {
        print("提交")
        if pinPaiName.count == 0 {
            HUD.flash(.label("请输入品牌名称"), delay: 1.2)
            return
        }
//        if iconUrl.count == 0 {
//            HUD.flash(.label("请选择图片"), delay: 1.2)
//            return
//        }
//        if pinPaiUrl.count == 0 {
//            HUD.flash(.label("请输入品牌链接"), delay: 1.2)
//            return
//        }
//        if commend.count == 0 {
//            HUD.flash(.label("请填写品牌描述"), delay: 1.2)
//            return
//        }
        let dict = [
            "user_token":UserToken as Any,
            "brand_name":pinPaiName as Any,
            "brand_logo":iconUrl as Any,
            "brand_desc":commend as Any,
            "site_url":pinPaiUrl as Any
        ]
        brandAdd(dict, success: { (data) in
            self.delegate?.XinZengPinPaiViewControllerFinsih()
            self.navigationController?.popViewController(animated: true)
        }) { (err) in
            
        }
    }
    //MARK: - cell delegate
    func tableView(_ tableView: UITableView, cellForRowAt indexPath: IndexPath) -> UITableViewCell {
        switch indexPath.row {
        case 0,2:
            let cell = tableView.dequeueReusableCell(withIdentifier: "TitleAndTF") as! TitleAndTFCell
            cell.nameLbl.text = titleArr[indexPath.row]
            cell.textTF.placeholder = holderArr[indexPath.row]
            if (navTitle?.contains("详情"))!{
                cell.textTF.isUserInteractionEnabled = false
            }
            cell.delegate = self
            cell.tag = indexPath.row
            switch indexPath.row {
            case 0:
                cell.textTF.text = pinPaiName
                break
            case 2:
                cell.textTF.text = pinPaiUrl
                break
            default:
                break
            }
            return cell
        case 1:
            let cell = tableView.dequeueReusableCell(withIdentifier: "TitleAndBtn") as! TitleAndBtnCell
            cell.nameLbl.text = titleArr[indexPath.row]
            cell.contentLbl.text = "上传图片"
            cell.delegate = self
            if iconUrl.count > 0 {
                cell.imgView.sd_setImage(with:  URL(string:SERVERCE_ImageHost + iconUrl), placeholderImage: UIImage.init(named: "worktest1"))
                cell.imgView.isHidden = false
                cell.contentLbl.isHidden = true
            }
            return cell
        default:
            let cell = tableView.dequeueReusableCell(withIdentifier: "TilteAndTextView") as! TilteAndTextViewCell
            cell.titleLbl.text = titleArr[indexPath.row]
            cell.holderLbl.text = "简述品牌特征。"
            cell.holderLbl.isHidden = false
            if commend.count > 0 {
                cell.holderLbl.isHidden = true
            }
            cell.textView.text = commend
            cell.delegate = self
            if (navTitle?.contains("详情"))!{
                cell.textView.isUserInteractionEnabled = false
            }
            return cell
        }
    }
    func textFieldContent(content: String, cell: TitleAndTFCell) {
        if cell.tag == 0 {
            pinPaiName = content
        }else{
            pinPaiUrl = content
        }
    }
    func TilteAndTextViewCellResponseStr(str: String, cell: TilteAndTextViewCell) {
        commend = str
    }
    
    func tableView(_ tableView: UITableView, heightForRowAt indexPath: IndexPath) -> CGFloat {
        if indexPath.row == 3 {
            return 173.5*glscale
        }
        if indexPath.row == 1 {
            if iconUrl.count > 0 {
                return 100
            }
        }
        return 49*glscale
    }
    func tableView(_ tableView: UITableView, numberOfRowsInSection section: Int) -> Int {
        return titleArr.count
    }
    func btnClick(content: String, cell: TitleAndBtnCell) {
        if (navTitle?.contains("详情"))!{
            return
        }
        _ = self.presentHGImagePicker(maxSelected:1) { (assets) in
            //结果处理
            print("共选择了\(assets.count)张图片，分别如下：")
            let option = PHImageRequestOptions()
            option.isSynchronous = true
            option.isNetworkAccessAllowed = true
            for asset in assets {
                PHImageManager.default().requestImage(for: asset, targetSize: PHImageManagerMaximumSize , contentMode:  .default , options: option, resultHandler: { (image,  _: [AnyHashable : Any]?) in
                    //                    print("上传图片==\(image)")
                    self.uploadImg(imge: image!, isOriginal: true, tag: 0)
                })
            }
            self.listView.reloadData()
        }
    }
    func uploadImg (imge:UIImage,isOriginal:Bool,tag:Int){
        
        let upLoadImg = imge as! UIImage
        HUD.show(.progress)
        saveFile(image: upLoadImg, ["user_token":UserToken as Any], success: { (data) in
            let dataM = data as! SaveFileModel
            if dataM.code == 1 {
                
                print("图片上传成功\(dataM.data?.url)")
                self.iconUrl = dataM.data!.url!
                self.listView.reloadData()
                HUD.hide()
            }
            
        }) { (error) in
            print("图片上传失败\(error)")
        }
        
    }
}
