//
//  CheckWareHourseViewController.swift
//  GeliBusinessPlatform
//
//  Created by junye lu on 2020/4/18.
//  Copyright © 2020 junye lu. All rights reserved.
//

import UIKit
import LGButton
import IQKeyboardManagerSwift

protocol CheckWareHourseViewControllerDelegate {
    func CheckWareHourseViewControllerRefresh()
}

class CheckWareHourseViewController: BaseViewController,UITableViewDelegate,UITableViewDataSource,WareHouseSpCellDelegate,GLAlertSelectViewDelegate,UITextFieldDelegate,GeliAlertViewDelegate{
    var delegate:CheckWareHourseViewControllerDelegate?
    var dataModel:ShopWarehouseDetailModel?
    var w_id:Int?//仓库id
    var editIdx:Int?
       let UserToken = UserDefaults.standard.value(forKey: "user_token")
    @IBOutlet weak var btnTitleLbl: UILabel!
    @IBOutlet weak var listView: UITableView!
    var titleStr:String?
    let titleArr = ["仓库名称：","仓库类型：","包含库位：","仓库地址：","仓库容积：","仓库面积：","联系人：","联系人电话："]
    let placeHArr = ["请输入仓库名称","请选择仓库类型","请输入库位名","请输入仓库地址","请输入仓库容积","请输入仓库面积","请输入联系人","请输入联系人电话"]
    
    var kuWeiArr:Array<ShopWarehouseDetailDataPositionModel>? = []
    
    var listArray = ["常温","冷藏","冷冻"]
    var glSelectView:GLAlertSelectView?
    var btnArray:Array<UIButton> = []
    var statusStr = ""
    
    var warehourseType:Int?
    var cangKuName = ""//仓库名称
    var kuWeiName = ""//库位名
    var cangKuAdr = ""//仓库地址
    var rongJi = ""//容积
    var mianJi = ""//面积
    var lianXiRen = ""//联系人
    var phone = ""//电话
    var shiFouMoRen = false//是否默认
    //    var kuWeiSelect:Int? //库位选择
    
    override func viewDidLoad() {
        super.viewDidLoad()
        navbar.title = titleStr
        self.view.addSubview(navbar)
        if titleStr != "新增仓库" {
            btnTitleLbl.text = "编辑"
            navbar.rightTitle = "删除"
        }
        listView.delegate = self
        listView.dataSource = self
        listView.separatorStyle = .none
        listView?.register(UINib(nibName: "WareHouseSpCell", bundle: nil), forCellReuseIdentifier: "WareHouse")
        listView.isScrollEnabled = false
        
        listView.snp.makeConstraints { (make) in
            make.top.equalTo(NavCGRect.height)
            make.left.right.equalTo(0)
            make.bottom.equalTo(btnTitleLbl.snp_top)
        }
        
    }
    override func viewWillAppear(_ animated: Bool) {
        super.viewWillAppear(animated)
        
        loadData()
    }
    func loadData(){
        //加载数据
        if w_id != nil {
         
            WarehouseDetail(["user_token":UserToken as Any,"w_id":w_id as Any], success: { (data) in
                let dataModel = data as! ShopWarehouseDetailModel
                //                self.dataModel = dataModel
                self.shiFouMoRen = false
                if dataModel.data!.warehouse_res!.is_default! == 1 {
                    self.shiFouMoRen = true
                }
                self.lianXiRen = dataModel.data!.warehouse_res!.contact!
                self.mianJi = "\(dataModel.data!.warehouse_res!.area!)"
                self.rongJi = "\(dataModel.data!.warehouse_res!.volume!)"
                self.phone = dataModel.data!.warehouse_res!.contact_number!
                let strArr = NSMutableArray()
                for item in dataModel.data!.position_res! {
                    strArr.add(item.p_name!)
                }
                self.kuWeiName = strArr.componentsJoined(by: ",")
                self.cangKuAdr = dataModel.data!.warehouse_res!.w_address!
                self.cangKuName = dataModel.data!.warehouse_res!.w_name!
                if dataModel.data?.warehouse_res?.w_type != 0 {
                    self.warehourseType = dataModel.data!.warehouse_res!.w_type! - 1
                }else{
                    self.warehourseType = 0
                }
                
                self.kuWeiArr = dataModel.data?.position_res
                self.listView.reloadData()
            }) { (error) in
                
            }
        }
    }
    //MARK: - cell delegate
    func tableView(_ tableView: UITableView, cellForRowAt indexPath: IndexPath) -> UITableViewCell {
        
        let cell = tableView.dequeueReusableCell(withIdentifier: "WareHouse") as! WareHouseSpCell
        cell.clickBtn.isHidden = true
        cell.detailTF.isUserInteractionEnabled = false
        cell.tag = indexPath.row
        cell.delegate = self
        if indexPath.section == 0 {//仓库名称等
            cell.whSwitch.isHidden = true
            cell.titleLbl.text = titleArr[indexPath.row]
            cell.detailTF.placeholder = placeHArr[indexPath.row]
            cell.btnImg.isHidden = true
            cell.detailTF.returnKeyType = .done
            //cell ui 布局
            self.setCellLayout(cell: cell, indexPath: indexPath)
            switch indexPath.row {
            case 0:
                cell.detailTF.text = cangKuName
                break
            case 1:
                cell.hiddenBtn.isHidden = false
                if warehourseType != nil {
                    cell.detailTF.text = listArray[warehourseType!]
                }
                break
            case 2:
                cell.detailTF.isUserInteractionEnabled = false
                cell.detailTF.text = kuWeiName
                break
            case 3:
                cell.detailTF.text = cangKuAdr
                break
            case 4:
                cell.detailTF.text = rongJi
                break
            case 5:
                cell.detailTF.text = mianJi
                break
            case 6:
                cell.detailTF.text = lianXiRen
                break
            case 7:
                cell.detailTF.keyboardType = .numberPad
                cell.detailTF.text = phone
                break
            default:
                break
            }
            if cell.detailTF.text?.count == 0 && w_id != nil {
                cell.detailTF.text = "-"
            }

        }else{//默认仓库
            cell.titleLbl.text = "默认仓库"
            if btnTitleLbl.text == "编辑"{
                cell.whSwitch.isUserInteractionEnabled = false
            }else{
                cell.whSwitch.isUserInteractionEnabled = true
            }
            cell.detailTF.isHidden = true
            cell.clickBtn.isHidden = true
            cell.btnImg.isHidden = true
            cell.whSwitch.isOn = shiFouMoRen
        }
        return cell
    }
    //MARK: -方法
    func whTextChange(sender: String, cell: WareHouseSpCell) {
        switch cell.tag {
        case 0:
            cangKuName = sender
            break
        case 2:
            kuWeiName = sender
            break
        case 3:
            cangKuAdr = sender
            break
        case 4:
            rongJi = sender
            break
        case 5:
            mianJi = sender
            break
        case 6:
            lianXiRen = sender
            break
        case 7:
            phone = sender
            break
        default:
            break
        }
    }
    func pdContent(sender:String,str:String) -> Bool{
        if sender.count == 0 {
            HUD.flash(.label(str), delay: 1.2)
            return false
        }
        return true
    }
    func pdSelect(select:Int?,str:String) -> Bool{
        if select == nil {
            HUD.flash(.label(str), delay: 1.2)
            return false
        }
        return true
    }
    @IBAction func submitAction(_ sender: LGButton) {
        if !pdContent(sender: cangKuName, str: "请填写仓库名称") {
            return
        }
        if !pdSelect(select: warehourseType, str: "请选择仓库类型") {
            return
        }
        if !pdSelect(select: warehourseType, str: "请选择仓库类型") {
            return
        }
        if !pdContent(sender: kuWeiName, str: "请选择库位") {
            return
        }
        let alertView = GeliAlertView(frame: self.view.window!.bounds)
        alertView.delegate = self;
        alertView.tishiLbl.text = ""
        if titleStr == "新增仓库" {
            alertView.titileLbl.text = "是否保存仓库信息？"
        }else{
            if btnTitleLbl.text == "保存" {
                alertView.titileLbl.text = "是否保存仓库信息？"

            }else{
                alertView.titileLbl.text = "是否打开编辑仓库信息？"

            }
        }
        alertView.rightBtn.setAttributedTitle(NSAttributedString(string: "确认"), for: .normal)
        alertView.rightBtn.tag = 1001
        self.view.window?.addSubview(alertView)

    }
    
    //库位
    func GLAlertSelectViewClick(selectNum:Int,view:GLAlertSelectView){
        warehourseType = selectNum
        glSelectView?.removeFromSuperview()
        glSelectView = nil
        listView.reloadData()
    }
    
    
    func GLAlertSelectDelAction(sender:Array<Any>) {
        print(sender)
    }
    func GLAlertSelectEditAction(sender: Int) {
        print(sender)
    }
    
    
    //MARK: - delegate
    func rightBtnClick() {
        print("删除")
        let alertView = GeliAlertView(frame: self.view.window!.bounds)
        alertView.delegate = self
        alertView.tishiLbl.text = ""
        alertView.titileLbl.text = "是否确认删除仓库？"
        alertView.rightBtn.setAttributedTitle(NSAttributedString(string: "确认"), for: .normal)
        alertView.rightBtn.tag = 1000
        self.view.window?.addSubview(alertView)
        
    }
    
    func sureGeliAlertViewAction(sender: UIButton) {
        if sender.tag == 1000 {
            
            ShopWarehouseDel(["user_token":UserToken,"w_id":w_id], success: { (data) in
                self.delegate?.CheckWareHourseViewControllerRefresh()
                self.navigationController?.popViewController(animated: true)
            }) { (Error) in
            }
        }else if sender.tag == 1001{
            
            let rj = rongJi as NSString
            let mj = mianJi as NSString
            var num = 0
            if shiFouMoRen == true {
                num = 1
            }
            
            if titleStr == "新增仓库" {
                let dict = ["user_token":UserToken,"w_name":cangKuName,"w_type":(warehourseType! + 1),"position_str":kuWeiName,"w_address":cangKuAdr,"volume":rj.floatValue,"area":mj.floatValue,"contact":lianXiRen,"contact_number":phone,"mail":"","is_default":num]
                ShopWarehouseAdd(dict, success: { (data) in
                    self.delegate!.CheckWareHourseViewControllerRefresh()
                    self.navigationController?.popViewController(animated: true)
                }) { (error) in
                }
                
            }else{
                if btnTitleLbl.text == "保存" {
                    var dataArr:Array<Any> = []
                    kuWeiArr?.forEach({ (md) in
                        var data:Dictionary<String, Any> = [:]
                        data.updateValue(md.p_name, forKey: "p_name")
                        data.updateValue(md.p_id, forKey: "p_id")
                        data.updateValue(md.status, forKey: "status")
                        dataArr.append(data)
                    })
                    
                    var jsonStr = ""
                    if dataArr.count > 0 {
                        jsonStr =  dataChangeString(sender: dataArr)
                    }
                    ShopWarehouseEdit(["user_token":UserToken,"w_name":cangKuName,"w_type":(warehourseType! + 1),"position_str":kuWeiName,"w_id":w_id,"w_address":cangKuAdr,"volume":rj.floatValue,"area":mj.floatValue,"contact":lianXiRen,"contact_number":phone,"mail":"","is_default":num,"warehouse_position":jsonStr], success: { (data) in
                        self.delegate?.CheckWareHourseViewControllerRefresh()
                        self.navigationController?.popViewController(animated: true)
                    }) { (error) in
                        
                    }
                }else{
                    btnTitleLbl.text = "保存"
                    statusStr = btnTitleLbl.text!
                    listView.reloadData()
                }
                
            }
        }

    }
    
    func sureAction(sender: UIButton) {
        print("sureAction")
    }
    
    @objc func removeActin(sender:UIButton){
        sender.superview?.removeFromSuperview()
        
    }
    
    
    func clickAction(sender: UIButton) {
        IQKeyboardManager.shared.resignFirstResponder()
        if sender.tag == 1 {
            if glSelectView == nil {
                let view = GLAlertSelectView(frame: self.view.bounds)
                view.titleLbl.text = "请选择仓库类型"
                view.delegate = self
                view.dataArr = listArray
                if warehourseType != nil {
                    view.selectNum = warehourseType
                    view.tempNum = warehourseType
                }
                self.view.addSubview(view)
                glSelectView = view
            }
        }
        if sender.tag == 2 {//MARK: -包含库位
            if glSelectView == nil {
                let view = GLAlertSelectView(frame: self.view.bounds,title:"请选择或填写库位资料")
                view.delegate = self
                view.kuWeiArr = kuWeiArr!
                self.view.addSubview(view)
                glSelectView = view
            }
        }
    }
    
    func setBtn(tagView:UIView,title:String,tag:Int)->UIView{
        let view = UIView(frame: CGRect(x: 0, y: tagView.frame.maxY, width: fullScreenWidth, height: 49*glscale))
        
        let title1 = UILabel(frame: CGRect(x: 15, y: 0, width: fullScreenWidth, height: 49*glscale))
        title1.text = title
        title1.font = UIFont.systemFont(ofSize: 13)
        title1.textColor = UIColor(named: "标题字颜色")
        view.addSubview(title1)
        let btn = UIButton(frame: CGRect(x: fullScreenWidth-34*glscale, y: (49-19)*0.5*glscale, width: 19*glscale, height: 19*glscale))
        btn.setImage(UIImage(named: "daixuan"), for: .normal)
        btn.setImage(UIImage(named: "yuxuan"), for: .selected)
        btn.tag = tag
        btn.addTarget(self, action: #selector(typeSelect(sender:)), for: .touchUpInside)
        view.addSubview(btn)
        btnArray.append(btn)
        
        let line = UIView(frame: CGRect(x: 15, y: title1.frame.maxY, width: fullScreenWidth-30, height: 1))
        line.backgroundColor = UIColor(named: "灰色分界线")
        view.addSubview(line)
        
        return view
    }
    @objc func typeSelect(sender:UIButton){
        for item in btnArray {
            let btn:UIButton = item as! UIButton
            if sender.tag == btn.tag {
                btn.isSelected = true
                warehourseType = btn.tag
            }else{
                btn.isSelected = false
            }
        }
    }
    // MARK: - cell delegate
    func numberOfSections(in tableView: UITableView) -> Int {
        if tableView == listView {
            return 2
        }
        return 1
    }
    func tableView(_ tableView: UITableView, numberOfRowsInSection section: Int) -> Int {
        
        if section == 0 {
            return titleArr.count
        }
        return 1
        
    }
    
    
    func setCellLayout(cell:WareHouseSpCell,indexPath:IndexPath){
        cell.detailTF.snp.updateConstraints{ (make) in
            make.left.equalTo(cell.titleLbl.snp_right)
            make.top.bottom.equalTo(0)
            make.right.equalTo(-15)
        }
        if titleStr == "新增仓库" || statusStr == "保存"{
            cell.detailTF.isUserInteractionEnabled = true
            cell.whSwitch.isUserInteractionEnabled = true
            cell.btnImg.isHidden = true
            cell.clickBtn.isHidden = false
            if indexPath.row == 1 || indexPath.row == 2 {
                cell.btnImg.isHidden = false
                cell.clickBtn.isHidden = false
                cell.clickBtn.tag = indexPath.row
                cell.hiddenBtn.tag = indexPath.row
                cell.detailTF.snp.updateConstraints { (make) in
                    make.left.equalTo(cell.titleLbl.snp_right)
                    make.top.bottom.equalTo(0)
                    make.right.equalTo(-45)
                }
                if indexPath.row == 1 {
                    cell.btnImg.image = UIImage(named: "jinru")
                    cell.btnImg.snp.makeConstraints { (make) in
                        make.centerY.equalTo(cell.titleLbl.snp_centerY)
                        make.right.equalTo(-15)
                        make.width.equalTo(5)
                        make.height.equalTo(9)
                    }
                    cell.detailTF.snp.updateConstraints { (make) in
                        make.left.equalTo(cell.titleLbl.snp_right)
                        make.top.bottom.equalTo(0)
                        make.right.equalTo(-35)
                    }
                }
            }
        }
    }
    
    //footer
    func tableView(_ tableView: UITableView, viewForFooterInSection section: Int) -> UIView? {
        
        let view = UIView(frame: CGRect(x: 0, y: 0, width: self.view.bounds.size.width, height: 10))
        view.backgroundColor = UIColor(named: "app背景色")
        return view
    }
    func tableView(_ tableView: UITableView, heightForFooterInSection section: Int) -> CGFloat {
        
        return 10
    }
    func tableView(_ tableView: UITableView, heightForRowAt indexPath: IndexPath) -> CGFloat {
        return 49
    }
 
    func KuWeiDataArr(sender: Array<Any>) {
        if (titleStr?.contains("新增"))! {
            kuWeiArr = sender as! Array<ShopWarehouseDetailDataPositionModel>
            let arr = NSMutableArray()
            for item in kuWeiArr!{
                arr.add(item.p_name)
            }
            kuWeiName = arr.componentsJoined(by: ",")
            listView.reloadData()
        }else{//编辑
            kuWeiArr = sender as! Array<ShopWarehouseDetailDataPositionModel>
            let arr = NSMutableArray()
            for item in kuWeiArr!{
                print("item == ",item.status)
                arr.add(item.p_name)
            }
            kuWeiName = arr.componentsJoined(by: ",")
            listView.reloadData()
        }
        
        glSelectView!.removeFromSuperview()
        glSelectView = nil
    }
    func whSwitchChange(sender: UISwitch) {
        shiFouMoRen = sender.isOn
    }
    func GLASClose(view: GLAlertSelectView, selectnum: Int, selectArr: Array<Int>) {
        if view.titleLbl.text == "请选择仓库类型"{
            if selectnum != 10086 {
                warehourseType = selectnum
            }
        }
        view.removeFromSuperview()
        glSelectView = nil
    }
}
