//
//  YuShouCell.swift
//  GeliBusinessPlatform
//
//  Created by junye lu on 2020/4/21.
//  Copyright © 2020 junye lu. All rights reserved.
//

import UIKit
@objc protocol YuShouCellDelegate {
    @objc optional func YuShouCellSwitchStatus(sender:UISwitch)
    @objc optional func YuShouCellTFContent(Price:NSString)
}
class YuShouCell: UITableViewCell,UITextFieldDelegate {
    var delegate:YuShouCellDelegate?
    @IBOutlet weak var inputTF3: UITextField!
    @IBOutlet weak var inputTF2: UITextField!
    @IBOutlet weak var inputTF1: UITextField!
    @IBOutlet weak var infoSw: UISwitch!
    override func awakeFromNib() {
        super.awakeFromNib()
        self.selectionStyle = .none
        infoSw.transform = CGAffineTransform(scaleX: 0.8, y: 0.8)
        
        infoSw.addTarget(self, action: #selector(switchChange(sender:)), for: .valueChanged)
        inputTF3.returnKeyType = .done
        inputTF1.returnKeyType = .done
        inputTF3.keyboardType = .decimalPad
        inputTF1.keyboardType = .decimalPad
        inputTF1.delegate = self
        inputTF3.delegate = self
        inputTF2.keyboardType = .numberPad
        inputTF1.delegate = self
        inputTF2.delegate = self
        inputTF3.delegate = self

    }
    
    func textFieldDidEndEditing(_ textField: UITextField) {
        textField.text = formatShowNumber(value: textField.text!)
        if textField == inputTF3{
            let str = textField.text as! NSString
            if str.floatValue > 20{
                HUD.flash(.label("预售定金比例不高于20%"), delay: 1.2)
                inputTF3.text = "20"
            }
        }
        delegate?.YuShouCellTFContent?(Price:"\(inputTF1.text!)_\(inputTF2.text!)_\(inputTF3.text!)" as NSString)
    }

    
    @objc func switchChange(sender:UISwitch){
        delegate?.YuShouCellSwitchStatus?(sender: sender)
    }
    override func setSelected(_ selected: Bool, animated: Bool) {
        super.setSelected(selected, animated: animated)
        
        // Configure the view for the selected state
    }
    
}
