//
//  NewCreateHeader.swift
//  GeliBusinessPlatform
//
//  Created by junye lu on 2020/4/22.
//  Copyright © 2020 junye lu. All rights reserved.
//

import UIKit
@objc protocol NewCreateHeaderDelegate {
    @objc optional func newCreateSwitchStatus(sender:UISwitch)
}
class NewCreateHeader: UIView {

    @IBOutlet weak var infoSw: UISwitch!
      var contentView:UIView!
      var delegate:NewCreateHeaderDelegate?

      //初始化时将xib中的view添加进来
         override init(frame: CGRect) {
             super.init(frame: frame)
             contentView = loadViewFromNib()
             addSubview(contentView)
          infoSw.transform = CGAffineTransform(scaleX: 0.8, y: 0.8)
         
         infoSw.addTarget(self, action: #selector(switchChange(sender:)), for: .valueChanged)
          contentView.snp.makeConstraints { (make) in
                 make.left.top.right.bottom.equalToSuperview()
             }
         }
         //    /初始化时将xib中的view添加进来
         required init?(coder aDecoder: NSCoder) {
             super.init(coder: aDecoder)
             contentView = loadViewFromNib()
             addSubview(contentView)
             contentView.snp.makeConstraints { (make) in
                 make.left.top.right.bottom.equalToSuperview()
             }
         }
         //加载xib
         func loadViewFromNib() -> UIView {
             let className = type(of: self)
             let bundle = Bundle(for: className)
             let name = NSStringFromClass(className).components(separatedBy: ".").last
             let nib = UINib(nibName: name!, bundle: bundle)
             let view = nib.instantiate(withOwner: self, options: nil).first as! UIView
             return view
         }
      @objc func switchChange(sender:UISwitch){
          delegate?.newCreateSwitchStatus?(sender: sender)
      }

}
