//
//  MsgCenterViewController.swift
//  GeliBusinessPlatform
//
//  Created by junye lu on 2020/4/16.
//  Copyright © 2020 junye lu. All rights reserved.
//

import UIKit
import ViewAnimator

class MsgCenterViewController: BaseViewController,UITableViewDelegate,UITableViewDataSource {
    
    //MARK: -animateView
    
    private let animations = [AnimationType.from(direction: .bottom, offset: 300*glscale)]

    var msgTbv:UITableView?
    
    override func viewDidLoad() {
        super.viewDidLoad()
        navbar.title = "消息中心"
        self.view.addSubview(navbar)
        
        // Do any additional setup after loading the view.
        msgTbv = UITableView()
        msgTbv?.backgroundColor = UIColor(named: "app底色")
        msgTbv?.delegate = self
        msgTbv?.separatorStyle = .none
        msgTbv?.dataSource = self
        self.view.addSubview(msgTbv!)
        msgTbv?.snp.makeConstraints({ (make) in
            make.top.equalTo(NavCGRect.height)
            make.left.right.bottom.equalTo(0)
        })
        
        msgTbv?.estimatedRowHeight = 30
        msgTbv!.rowHeight = UITableView.automaticDimension
        
        msgTbv?.register(UINib(nibName: "MsgCenterCell", bundle: nil), forCellReuseIdentifier: "MsgCenterCell")
        //下拉刷新相关设置
        headerMJ.setRefreshingTarget(self, refreshingAction: #selector(loadData))
        self.msgTbv!.mj_header = headerMJ
        //上拉加载相关设置
        footerMJ.setRefreshingTarget(self, refreshingAction: #selector(loadMoreData))
        self.msgTbv!.mj_footer = footerMJ
        self.msgTbv?.mj_header?.beginRefreshing()
        
    }
    var dataModelArr:Array<MessageListDataModel> = []
    var page = 1
  let UserToken = UserDefaults.standard.value(forKey: "user_token")
    //加载数据
    @objc func loadData(){
        page = 1
        
        messageList(["page":page as Any,"user_token":UserToken as Any], success: { (data) in
            let dataM = data as! MessageListModel
            self.dataModelArr.removeAll()
            dataM.data?.forEach({ (model) in
                self.dataModelArr.append(model)
            })
            
            self.msgTbv?.reloadData()
            self.page = 2
            self.msgTbv?.mj_header?.endRefreshing()

            self.msgTbv?.performBatchUpdates({
                 UIView.animate(views: self.msgTbv!.visibleCells,
                                animations: self.animations, completion: {
                                 
                 })
             }, completion: nil)
             if dataM.data?.count == 0 {
                 self.msgTbv?.mj_footer?.endRefreshingWithNoMoreData()
             }else{
                 self.msgTbv?.mj_footer?.endRefreshing()
             }
        }) { (error) in
            self.msgTbv?.mj_header?.endRefreshing()

        }
    }
    //加载更多数据
    @objc func loadMoreData() {
        
        messageList(["page":page as Any,"user_token":UserToken as Any], success: { (data) in
            let dataM = data as! MessageListModel
            if dataM.data?.count == 0 {
                self.msgTbv?.mj_footer?.endRefreshingWithNoMoreData()
            }else{
                self.page += 1
                dataM.data?.forEach({ (model) in
                    self.dataModelArr.append(model)
                })
                self.msgTbv?.reloadData()
                self.msgTbv?.mj_footer?.endRefreshing()
            }
        }) { (error) in
            self.msgTbv?.mj_footer?.endRefreshing()
        }
    }
    
    
    //MARK: -Cell delegate方法
    
    func tableView(_ tableView: UITableView, heightForRowAt indexPath: IndexPath) -> CGFloat {
        return tableView.rowHeight
    }

    func tableView(_ tableView: UITableView, numberOfRowsInSection section: Int) -> Int {
        return  self.dataModelArr.count
    }
    
    func tableView(_ tableView: UITableView, cellForRowAt indexPath: IndexPath) -> UITableViewCell {
        let cell = tableView.dequeueReusableCell(withIdentifier: "MsgCenterCell") as! MsgCenterCell
//        if cell.isShow == false {//未显示
//            cell.titleLbl.showSkeleton(transition: .crossDissolve(0.25))
//            cell.dateLbl.showSkeleton(transition: .crossDissolve(0.25))
//            cell.contentLbl.showSkeleton(transition: .crossDissolve(0.25))
//            DispatchQueue.main.asyncAfter(deadline: .now() + 0.33) {
//                cell.isShow = true//已显示
//                cell.titleLbl.hideSkeleton(reloadDataAfter: true, transition: .crossDissolve(0.25))
//                cell.dateLbl.hideSkeleton(reloadDataAfter: true, transition: .crossDissolve(0.25))
//                cell.contentLbl.hideSkeleton(reloadDataAfter: true, transition: .crossDissolve(0.25))
//            }
//        }
        let rowModel = self.dataModelArr[indexPath.row]
        
        cell.titleLbl.text = rowModel.title
        cell.dateLbl.text = TimeByDouble(sender: rowModel.create_time!)
        cell.contentLbl.text = rowModel.message
        
        return cell
    }
    
    
}
