//
//  WuLiuGenZongViewController.swift
//  GeliBusinessPlatform
//
//  Created by junye lu on 2020/4/27.
//  Copyright © 2020 junye lu. All rights reserved.
//

import UIKit

class WuLiuGenZongViewController: BaseViewController,UITableViewDelegate,UITableViewDataSource {
    
    
    var dataArr:Array<Any> = []
    @IBOutlet weak var listView: UITableView!
    override func viewDidLoad() {
        super.viewDidLoad()
        navbar.title = "物流跟踪"
        self.view.addSubview(navbar)
        
        listView.separatorStyle = .none
        listView.snp.makeConstraints { (make) in
            make.top.equalTo(NavCGRect.height)
            make.left.right.bottom.equalTo(0)
        }
        listView.register(UINib(nibName: "WLGZCell", bundle: nil), forCellReuseIdentifier: "WLGZCell")
        listView.register(UINib(nibName: "YunDanLieBiaoCell", bundle: nil), forCellReuseIdentifier: "YunDanLieBiaoCell")
        
        
        loadData()
        
    }
    var orderId:Int?
    var dataModel:LogisticsTrackingDataModel? = nil
    func loadData() {
        
        HUD.flash(.progress)
        let UserToken = UserDefaults.standard.value(forKey: "user_token")

        LogisticsTracking(["user_token":UserToken as Any,"id":orderId as Any], success: { (data) in
            let model = data as! LogisticsTrackingModel
            self.dataModel = model.data
            self.dataArr.removeAll()
            if self.dataModel?.lc_name == "京东冷链" {
                self.dataArr = self.dataModel?.jd_tracking! as! Array<Any>
            }else if self.dataModel?.lc_name == "顺丰冷运" {
                if self.dataModel?.sf_tracking?.code == 200 {
                    self.dataArr = self.dataModel?.sf_tracking?.model! as! Array<Any>

                }
            }
            self.listView.reloadData()
            HUD.hide()
        }) { (error) in
            HUD.hide()

        }
    }
    
    //cell
    func tableView(_ tableView: UITableView, heightForRowAt indexPath: IndexPath) -> CGFloat {
        if indexPath.section == 0 {
            return 227
        }
        return 70
    }
    func tableView(_ tableView: UITableView, numberOfRowsInSection section: Int) -> Int{
        if section == 0 {
            return 1
        }
        return dataArr.count
        
    }
    func numberOfSections(in tableView: UITableView) -> Int {
        return 2
    }
    
    func tableView(_ tableView: UITableView, cellForRowAt indexPath: IndexPath) -> UITableViewCell {
        if indexPath.section == 0 {
            let cell = tableView.dequeueReusableCell(withIdentifier: "YunDanLieBiaoCell") as! YunDanLieBiaoCell
            if self.dataModel != nil {
                cell.title1.text = "运单号：" + dataModel!.lwb_no!
                cell.title2.text = dataModel!.lc_name
                cell.senderLbl.text = dataModel!.s_city_name
                cell.receiverLbl.text = dataModel!.r_city_name
                cell.statusLbl.text = dataModel?.delivery_status_cn
                
                cell.productNameLbl.text = "寄托物：" + dataModel!.express_item_name!
                cell.signLbl.text = "签收状态：-"
                cell.standerLbl.text = "订单平台：" + dataModel!.sale_plat!
                
                if dataModel!.sale_plat?.count == 0 {
                    cell.standerLbl.text = "订单平台：-"
                }
                cell.timeLbl.text = "签收时间：" + dayByDouble(sender: dataModel!.sign_time!)
                if dataModel!.sign_time! == 0 {
                    cell.timeLbl.text = "签收时间：-"
                }
                cell.orderNumLbl.text = "订单号：" + dataModel!.order_sn!
                if dataModel!.order_sn?.count == 0 {
                    cell.orderNumLbl.text = "订单号：-"
                }
            }
            return cell
        }
        let cell = tableView.dequeueReusableCell(withIdentifier: "WLGZCell") as! WLGZCell
        if indexPath.row == 0 {
            cell.topLine.isHidden = true
            cell.firstLbl.isHidden = false
        }
        if dataArr.count > 0 {
            if indexPath.row == dataArr.count-1 {
                cell.bottomLine.isHidden = true
            }
        }
        if self.dataModel?.lc_name == "京东冷链" {

            let rowModel = self.dataArr[indexPath.row] as! LogisticsJdTrackingModel
            cell.contentLbl.text = rowModel.opeRemark
            cell.dateLbl.text = rowModel.opeTime
        }else if self.dataModel?.lc_name == "顺丰冷运" {
            if self.dataModel?.sf_tracking?.code == 200 {
                
                let rowModel = self.dataArr[indexPath.row] as! LogisticsSFTrackingDataModel

                cell.contentLbl.text = rowModel.owsRemark
                cell.dateLbl.text = rowModel.barScanTm
                
            }
        }
        return cell
    }
    
    
}
