//
//  LoginViewController.swift
//  GeliBusinessPlatform
//
//  Created by junye lu on 2020/4/14.
//  Copyright © 2020 junye lu. All rights reserved.
//

import UIKit
import Alamofire
import CryptoSwift
import LGButton

protocol loginDelegate {
    func successLogin()
}
class LoginViewController: BaseViewController, CodeViewDelegate,GeliAlertViewDelegate {
    @IBOutlet weak var phoneLoginBG: UIView!
    @IBOutlet weak var passLoginBg: UIView!
    var delegate :loginDelegate?
    @IBOutlet weak var bannerImg: UIImageView!
    @IBOutlet weak var topImg: UIImageView!
    //MARK: - 输入账号、密码、验证码
    
    @IBOutlet weak var loginBtn: LGButton!
    @IBOutlet weak var forgetPassBtn: UIButton!
    
    
    @IBOutlet weak var phoneTF: UITextField!
    @IBOutlet weak var passTF: UITextField!
    @IBOutlet weak var codeView: UIView!
    @IBOutlet weak var codeTF: UITextField!
    
    
    @IBOutlet weak var rightBtn: UIButton!
    @IBOutlet weak var leftBtn: UIButton!
    @IBOutlet weak var selectLineView: UIView!
    
    @IBOutlet weak var btnLayoutConstraint: NSLayoutConstraint!
    @IBOutlet weak var shImg: UIImageView!
    //MARK: - 验证码登录
    @IBOutlet weak var phoneLogInputTF: UITextField!
    @IBOutlet weak var phoneLogCodeTF: UITextField!
    @IBOutlet weak var lineView: UIView!
    var codeNum: String = ""
    //MARK: - viewWillAppear
    override func viewWillAppear(_ animated: Bool) {
        super.viewWillAppear(animated)
        self.view.backgroundColor = UIColor(named:"白色背景色")
          print("f = ",fullScreenHeight)
    }
    
    @IBAction func selectLoginAction(_ sender: UIButton) {
        if sender.tag == 0 {//验证码登录
            leftBtn.isSelected = true
            rightBtn.isSelected = false
            selectLineView.snp.updateConstraints { (make) in
                make.left.equalTo(0)
                make.bottom.equalTo(lineView.snp_bottom)
                make.width.equalTo(fullScreenWidth*0.5)
                make.height.equalTo(3)
            }
            phoneLoginBG.isHidden = false
            passLoginBg.isHidden = true
            forgetPassBtn.isHidden = true
            btnLayoutConstraint.constant = 8
        }else{//密码登录
            leftBtn.isSelected = false
            rightBtn.isSelected = true
            selectLineView.snp.updateConstraints { (make) in
                make.left.equalTo(fullScreenWidth*0.5)
                make.bottom.equalTo(lineView.snp_bottom)
                make.width.equalTo(fullScreenWidth*0.5)
                make.height.equalTo(3)
            }
            phoneLoginBG.isHidden = true
            passLoginBg.isHidden = false
            forgetPassBtn.isHidden = false
            btnLayoutConstraint.constant = 54.5
        }
    }
    override func viewDidLoad() {
        super.viewDidLoad()
        
        //测试
//        phoneTF.text = "Liangyuepf"
//        passTF.text = "zxcvbnm"
        
        
        passTF.isSecureTextEntry = true
        
        
        bannerImg.snp.makeConstraints { (make) in
            make.top.left.right.equalTo(0)
            make.height.equalTo(234*glscale)
        }
        topImg.snp.makeConstraints { (make) in
            make.bottom.equalTo(bannerImg.snp_top)
            make.left.right.equalTo(0)
            make.height.equalTo(60)
        }
        let codeV = CaptchaView(frame:codeView.bounds)
        codeV.delegate = self
        codeView.addSubview(codeV);
        codeV.changeCaptcha()
        leftBtn.isSelected = true
        
        passTF.keyboardType = .default
        codeTF.keyboardType = .default
        
        codeTF.autocorrectionType = .no
        codeTF.autocapitalizationType = .none
        passTF.autocorrectionType = .no
        passTF.autocapitalizationType = .none
        phoneTF.autocorrectionType = .no
        phoneTF.autocapitalizationType = .none
        
        passTF.isSecureTextEntry = true
        
    }
    //MARK: - 手机登录，获取验证码方法
    @IBOutlet weak var phoneCodeBtn: UIButton!
    
    @IBAction func getLoginCodeAction(_ sender: UIButton) {
        print("get phone login Code")
        if phoneLogInputTF.text?.count == 0 {
            HUD.flash(.label("请填写手机号码"), delay: 1.2)
            return
        }
        sendSmsCaptcha(["phone":phoneLogInputTF.text as Any,"type":"3"], success: { (data) in
            let dataM = data as! UpDataModel
            if dataM.code == 1 {
                sender.isUserInteractionEnabled = false
                sender.setTitle("60s", for: .normal);
                Timer.scheduledTimer(timeInterval: 1, target: self, selector: #selector(self.timeCounting), userInfo: nil, repeats: true);
            }
            
        }) { (error) in
            
        }
    }
    var timeCount:Int = 60

    @objc func timeCounting(sender:Timer){
        timeCount -= 1
        phoneCodeBtn.setTitle("\(timeCount)"+"s", for: .normal)
        if timeCount == 0{
            phoneCodeBtn.setTitle("获取验证码", for: .normal)
            phoneCodeBtn.isUserInteractionEnabled = true
            timeCount = 60
            sender.invalidate()
        }
    }
    //MARK: -跳转忘记密码,登录
    @IBAction func forgetPasswordAction(_ sender: Any) {
        let alertView = GeliAlertView(frame: self.view.window!.bounds)
        alertView.delegate = self;
        alertView.tishiLbl.text = "020-81338860"
        alertView.titileLbl.text = "如忘记密码，请联系后台人员修改密码，请联系："
        self.view.window?.addSubview(alertView)
    }
    func sureGeliAlertViewAction(sender: UIButton) {
        UIApplication.shared.openURL(NSURL.init(string: "tel://020-81338860")! as URL)
    }
    
    @IBAction func shPassAction(_ sender: UIButton) {
        sender.isSelected = !sender.isSelected
        if sender.isSelected {
            passTF.isSecureTextEntry = false
            shImg.image = UIImage(named: "xianshi")
        }else{
            shImg.image = UIImage(named: "guanbi")
            passTF.isSecureTextEntry = true
        }
    }
    func getCodeNum(num: String) {
        codeNum = num
    }
    @IBAction func loginAction(_ sender: Any) {
        
        if rightBtn.isSelected {//MARK:- 密码登录
            
            
            //MARK:--登录接口样式
            print("\(codeNum) == \(codeTF.text)")
            //    zxpf
            //    123456
            if phoneTF.text?.count == 0 {
                HUD.flash(.label("请填写用户名"), delay: 1.2)
                return
            }
            if passTF.text?.count == 0 {
                HUD.flash(.label("请填写密码"), delay: 1.2)
                return
            }
            if codeTF.text?.count == 0 {
                HUD.flash(.label("请填写验证码"), delay: 1.2)
                return
            }
            if codeNum == codeTF.text {
                //登录中状态
                loginBtn.isLoading = true
                login(["user_name":phoneTF.text as Any,"pwd":passTF.text as Any], success: { (data) in
                    let dataM = data as! LoginModel
                    UserDefaults.standard.set(dataM.data?.user_token, forKey: "user_token")
                    UserDefaults.standard.synchronize()
                    self.loginBtn.isLoading = false
                    self.delegate?.successLogin()
                    
                    JPUSHService.setAlias(self.phoneTF.text, completion: { (resCode, alias, num) in
                        
                    }, seq: 1433223)
                }) { (error) in
                    self.loginBtn.isLoading = false
                }
            }else{
                HUD.flash(.label("请填写正确的验证码"), delay: 1.2)
            }
        }else{
            //MARK:- 手机验证码登录
            
            if phoneLogInputTF.text?.count == 0 {
                HUD.flash(.label("请填写手机号码"), delay: 1.2)
                return
            }
            if phoneLogCodeTF.text?.count == 0 {
                HUD.flash(.label("请填写验证码"), delay: 1.2)
                return
            }
            
            loginBtn.isLoading = true
            mobileLogin(["mobile":phoneLogInputTF.text as Any,"auth_code":phoneLogCodeTF.text as Any], success: { (data) in
                let dataM = data as! LoginModel
                UserDefaults.standard.set(dataM.data?.user_token, forKey: "user_token")
                UserDefaults.standard.synchronize()
                self.loginBtn.isLoading = false
                self.delegate?.successLogin()
                
                JPUSHService.setAlias(dataM.data?.user_name, completion: { (resCode, alias, num) in
                    
                }, seq: 1433223)

            }) { (error) in
                self.loginBtn.isLoading = false
            }
            
        }
        
    }
    
    
}
