//
//  GuanLianKehuVC.swift
//  GeliBusinessPlatform
//
//  Created by 刘俊宏 on 2020/4/26.
//  Copyright © 2020 junye lu. All rights reserved.
//

import UIKit
import ViewAnimator
import LGButton

protocol GuanLianKehuVCDelegate {
    func GuanLianKehuSelect(keHuData:CusListAllDataModel)
}
class GuanLianKehuVC: BaseViewController , UITableViewDelegate, UITableViewDataSource,GeliAlertViewDelegate{
    var delegate:GuanLianKehuVCDelegate?
    
    @IBOutlet weak var btnLblH: NSLayoutConstraint!
    let UserToken = UserDefaults.standard.value(forKey: "user_token")
    @IBOutlet weak var btn: LGButton!
    var selectIdx:Int?//暂代关联客户数据
    
    var order_id:Int? = 0
    
    @IBAction func submitAction(_ sender: LGButton) {
        print("确定")
        
        if order_id == 0 {
            //MARK:--代客下单流程的关联客服
            if selectIdx != nil {
                self.delegate?.GuanLianKehuSelect(keHuData: self.dataArr[self.selectIdx!])
                self.navigationController?.popViewController(animated: true)
            }else{
                HUD.flash(.label("请选择关联客户"), delay: 1.2)
            }
            return
        }
        
        if selectIdx != nil{
            HUD.flash(.progress)
            let model = self.dataArr[self.selectIdx!]
            
            
            bindCus(["cus_id":model.cus_id as Any,"user_token":UserToken as Any,"order_id":order_id as Any], success: { (data) in
                
                let dataM = data as! UpDataModel
                if dataM.code == 1 {
                    
                    self.delegate?.GuanLianKehuSelect(keHuData: self.dataArr[self.selectIdx!])
                    self.navigationController?.popViewController(animated: true)
                    
                }
                
            }) { (error) in
                
            }
            
        }else{
            HUD.flash(.label("请选择关联客户"), delay: 1.2)
        }
    }
    
    @IBOutlet weak var contentView: UIView!
    override func viewDidLoad() {
        super.viewDidLoad()
        navbar.title = "关联客户"
        self.view.addSubview(navbar)
        self.view.backgroundColor = UIColor.white
        
      
        
        setTabv()
        
        
        
    }
    //MARK:--传入已选客户
    var cus_id:Int? = nil
    //MARK:--列表数据源
    var dataArr:Array<CusListAllDataModel> = []
    //MARK:--加载数据
    @objc func loadData () {
        
        cusListAll(["user_token":UserToken as Any], success: { (data) in
            self.dataArr.removeAll()
            let dataM = data as! CusListAllModel
            dataM.data?.forEach({ (model) in
                self.dataArr.append(model)
            })
            for i in 0 ..< self.dataArr.count {
                let item = self.dataArr[i]
                if self.cus_id == item.cus_id {
                        self.selectIdx = i
                      }
                  }
            if self.dataArr.count == 0 {
                self.btn.isHidden = true
                self.btnLblH.constant = 0
                
                let alertView = GeliAlertView(frame: self.view.window!.bounds)
                alertView.delegate = self;
                alertView.tishiLbl.text = ""
                alertView.titileLbl.text = "请登录cms.gelifood.com/market进行添加"
                alertView.rightBtn.setAttributedTitle(NSAttributedString(string: "跳转"), for: .normal)
                self.view.window?.addSubview(alertView)
                
            }else{
                self.btn.isHidden = false
                self.btnLblH.constant = 49
            }
            self.tableV.reloadData()
            self.tableV?.mj_header?.endRefreshing()
        }) { (error) in
            
        }
    }
    //MARK: - alertView delegate
    func sureGeliAlertViewAction(sender: UIButton) {
        let url:URL?=URL.init(string: "https://cms.gelifood.com/market/")
        UIApplication.shared.open(url!, options: [:], completionHandler: nil)
    }
    
    var tableV :UITableView!
    
    private let animations = [AnimationType.from(direction: .bottom, offset: 150*glscale)]
    func setTabv() {
        tableV = UITableView()
        contentView.addSubview(tableV);
        tableV.snp.makeConstraints { (make) in
            make.left.right.bottom.equalToSuperview()
            make.top.equalTo(navbar.snp_bottom)
        }
        tableV.backgroundColor = UIColor.init(named: "白色背景色")
        tableV.delegate = self
        tableV.dataSource = self
        tableV.separatorStyle = .none
        tableV?.register(UINib(nibName: "GuanLianKeHuCell", bundle: nil), forCellReuseIdentifier: "GuanLianKeHuCell")
        
        let footerTbV = UIView(frame: CGRect(x: 0, y: 0, width: view.frame.size.width, height: 15*glscale))
        footerTbV.backgroundColor = UIColor.init(named: "白色背景色")
        tableV.tableFooterView = footerTbV
        
        //下拉刷新相关设置
        headerMJ.setRefreshingTarget(self, refreshingAction: #selector(loadData))
        self.tableV!.mj_header = headerMJ
        self.tableV.mj_header?.beginRefreshing()
    }
    func tableView(_ tableView: UITableView, numberOfRowsInSection section: Int) -> Int {
        
        return dataArr.count
    }
    
    func tableView(_ tableView: UITableView, cellForRowAt indexPath: IndexPath) -> UITableViewCell {
        let cell = tableView.dequeueReusableCell(withIdentifier: "GuanLianKeHuCell") as! GuanLianKeHuCell
        
        cell.tag = indexPath.row
        cell.imgBtn.isSelected = false
        
        
        
        let rowModel = self.dataArr[indexPath.row]
        cell.senderLbl.text = rowModel.cus_name
        
        if rowModel.user_name == nil {
            cell.arrowImg.isHidden = true
            cell.receiverLbl.text = ""
        }else{
            cell.arrowImg.isHidden = false
            cell.receiverLbl.text = rowModel.user_name
        }
        
        if rowModel.cus_type == 1 {
            cell.personLbl.isHidden = false
            cell.companyLbl.isHidden = true
        }else{
            cell.personLbl.isHidden = true
            cell.companyLbl.isHidden = false
        }
        cell.detailLbl.text = rowModel.company
        
        if selectIdx == indexPath.row {
            cell.imgBtn.isSelected = true
        }
        
        
        return cell
    }
    func tableView(_ tableView: UITableView, didSelectRowAt indexPath: IndexPath) {
        print(indexPath)
        selectIdx = indexPath.row
        tableV.reloadData()
    }
    
    func tableView(_ tableView: UITableView, heightForRowAt indexPath: IndexPath) -> CGFloat {
        return 100*glscale
    }
    
}
