//
//  ChangeGoodsPriceVC.swift
//  GeliBusinessPlatform
//
//  Created by 刘俊宏 on 2020/4/26.
//  Copyright © 2020 junye lu. All rights reserved.
//

import UIKit
import ViewAnimator
import LGButton
import IQKeyboardManagerSwift

protocol ChangeGoodsPriceVCDelegate {
    func changeGoodsPriByData(sender:Array<OrderDetailGoodsModel>)
}

class ChangeGoodsPriceVC: BaseViewController  , UITableViewDelegate, UITableViewDataSource,UITextFieldDelegate,TitleAndTfYuanCellDelegate {
    @IBOutlet weak var btnTitle: UILabel!
    func TitleAndTfYuanCellGetData(price: String, idx: Int) {
        if idx == 0 {
            wlPrice = price
        }else{
            qtPrice = price
        }
        print("abc == ",wlPrice)
        var total = Float(0)
        dataArr?.forEach({ (item) in
            let price = item.goods_subtotal as! NSString
            total += price.floatValue
        })
        let wl = wlPrice as NSString
        let qt = qtPrice as NSString
        btnTitle.text = String(format: "确定（合计¥%.2f）", total + wl.floatValue + qt.floatValue)
        tableV.reloadData()
    }
    
    var orderID:Int? = 0
    var delegate:ChangeGoodsPriceVCDelegate?
    var dataArr : Array<OrderDetailGoodsModel>? = []
    override func viewDidLoad() {
        super.viewDidLoad()
        
        navbar.title = "修改价格"
        self.view.addSubview(navbar)
        setTabv()
        var total = Float(0)
        dataArr?.forEach({ (item) in
            let price = item.goods_subtotal as! NSString
            total += price.floatValue
        })
        let wl = wlPrice as NSString
        let qt = qtPrice as NSString
        btnTitle.text = String(format: "确定（合计¥%.2f）", total + wl.floatValue + qt.floatValue)
        
    }
    
    var wlPrice:String = ""
    var qtPrice:String = ""
    
    @IBOutlet weak var sureBtn: LGButton!
    //MARK:--确认修改价格
    @IBAction func sureAction(_ sender: LGButton) {
        
        
        let UserToken = UserDefaults.standard.value(forKey: "user_token")
        
        var order_goodsArr:Array<Any>? = []
        dataArr?.forEach({ (md) in
            var dic:[String:Any] = [:]
            dic.updateValue(md.og_id as Any, forKey: "og_id")
            dic.updateValue(md.cart_number as Any, forKey: "cart_number")
            dic.updateValue(md.goods_price as Any, forKey: "goods_price")
            dic.updateValue(md.is_edit as Any, forKey: "is_edit")
            order_goodsArr?.append(dic)
        })
        let order_goods = dataChangeString(sender: order_goodsArr!)
        
        editOrderGoodsPrice(["user_token":UserToken as Any,"order_id":orderID as Any,"order_goods":order_goods as Any,"logistics_price":wlPrice as Any,"other_price":qtPrice as Any], success: { (data) in
            let dataM = data as! UpDataModel
            if dataM.code == 1 {
                NotificationCenter.default.post(name: NSNotification.Name(rawValue: "orderChange"), object: nil)
                
                self.delegate?.changeGoodsPriByData(sender: self.dataArr!)
                self.navigationController?.popViewController(animated: true)
            }
            
        }) { (error) in
            
            
        }
        
    }
    
    deinit {
        NotificationCenter.default.removeObserver(self)
    }
    func textFieldDidEndEditing(_ textField: UITextField) {
        var total = Float(0)
        for i in 0..<dataArr!.count {
            if i == textField.tag {
                let md = dataArr![i]
                if isPurnNumber(str: textField.text!) {
                    md.goods_price = formatShowNumber(value: textField.text!)
                    //记录哪个更改了
                    md.is_edit = 1
                }
                let p = md.goods_price as! NSString
                total += Float(md.cart_number!) * p.floatValue
            }else{
                let md = dataArr![i]
                let price = md.goods_subtotal as! NSString
                total += price.floatValue
            }
        }
        let wl = wlPrice as NSString
        let qt = qtPrice as NSString
        btnTitle.text = String(format: "确定（合计¥%.2f）", total + wl.floatValue + qt.floatValue)
        
        self.tableV.reloadData()
    }
    
    
    var tableV :UITableView!
    
    private let animations = [AnimationType.from(direction: .bottom, offset: 150*glscale)]
    func setTabv() {
        tableV = UITableView()
        view.addSubview(tableV);
        tableV.snp.makeConstraints { (make) in
            make.left.right.equalToSuperview()
            make.top.equalTo(navbar.snp_bottom)
            make.bottom.equalTo(sureBtn.snp_top)
        }
        tableV.backgroundColor = UIColor.init(named: "白色背景色")
        tableV.delegate = self
        tableV.dataSource = self
        tableV.separatorStyle = .none
        tableV?.register(UINib(nibName: "ChangePriceNormalCell", bundle: nil), forCellReuseIdentifier: "ChangePriceNormalCell")
        
        tableV?.register(UINib(nibName: "TitleAndTfYuanCell", bundle: nil), forCellReuseIdentifier: "TitleAndTfYuanCell")
    }
    
    func tableView(_ tableView: UITableView, numberOfRowsInSection section: Int) -> Int {
        
        if section == 0{
            return dataArr!.count
        }
        return 2
    }
    func numberOfSections(in tableView: UITableView) -> Int {
        return 2
    }
    func tableView(_ tableView: UITableView, cellForRowAt indexPath: IndexPath) -> UITableViewCell {
        
        if indexPath.section == 1 {
            let cell = tableView.dequeueReusableCell(withIdentifier: "TitleAndTfYuanCell") as! TitleAndTfYuanCell
            cell.tag = indexPath.row
            cell.delegate = self
            cell.nameLbl.text = "物流费用"
            cell.textTF.text = wlPrice
            if indexPath.row == 1 {
                cell.line.isHidden = false
                cell.nameLbl.text = "其他费用"
                cell.textTF.text = qtPrice
            }
            return cell
        }
        
        let cell = tableView.dequeueReusableCell(withIdentifier: "ChangePriceNormalCell") as! ChangePriceNormalCell
        
        let rowModel = dataArr![indexPath.row]
        cell.goodsImgVire.sd_setImage(with: URL(string:SERVERCE_ImageHost +  rowModel.goods_thumb!))
        cell.goodsNameLbl.text = rowModel.goods_name
        if rowModel.goods_attr != nil {
            cell.attrrLbl.text = rowModel.goods_attr
            
        }else{
            cell.attrrLbl.text = "-"
            
        }
        cell.priceTf.text = rowModel.goods_price
        cell.detailLbl.isHidden = true
        cell.priceTf.delegate = self
        cell.priceTf.returnKeyType = .done
        cell.priceTf.keyboardType = .decimalPad
        cell.priceTf.tag = indexPath.row
        return cell
    }
    
    func tableView(_ tableView: UITableView, viewForFooterInSection section: Int) -> UIView? {
        let view = UIView(frame: CGRect(x: 0, y: 0, width: fullScreenWidth, height: 5))
        view.backgroundColor = UIColor(named: "app底色")
        return view
    }
    func tableView(_ tableView: UITableView, heightForFooterInSection section: Int) -> CGFloat {
        if section == 0{
            return 5
        }
        return 0
    }
    
    func tableView(_ tableView: UITableView, heightForRowAt indexPath: IndexPath) -> CGFloat {
        if indexPath.section == 0{
            return 120*glscale
        }
        return 49*glscale
    }
    func scrollViewDidScroll(_ scrollView: UIScrollView) {
        IQKeyboardManager.shared.resignFirstResponder()
        //MARK:--滚动不修改数据
    }
}
