//
//  XiuGaiYuShouJiaViewController.swift
//  GeliBusinessPlatform
//
//  Created by junye lu on 2020/4/18.
//  Copyright © 2020 junye lu. All rights reserved.
//

import UIKit
import LGButton
protocol XiuGaiYuShouJiaViewControllerDelegate {
    func changeYuShouGoodsByData(sender:EditOGPAdDataModel?,djText:String,wkText:String)
}

class XiuGaiYuShouJiaViewController: BaseViewController, UITextFieldDelegate {
    var dataModel : OrderDetailDataModel?
    var orderID:Int? = 0
    var delegate : XiuGaiYuShouJiaViewControllerDelegate?
    var inputData:Array<GetGoodsInfoDataModel> = []
    var djTFstr:String = "";
    var wkTFstr:String = "";
    var totalPrice: Float? = 0
    
    @IBOutlet weak var firstView: UIView!
    @IBOutlet weak var weiKuanTF: UITextField!
    @IBOutlet weak var dingJinTF: UITextField!
    @IBOutlet weak var icomImg: UIImageView!
    @IBOutlet weak var countLbl: UILabel!
    @IBOutlet weak var detailLbl: UILabel!
    @IBOutlet weak var titleLbl: UILabel!
    @IBOutlet weak var submitBtn: LGButton!
    var imgUrlstr = ""
    
    override func viewDidLoad() {
        super.viewDidLoad()
        navbar.title = "修改价格"
        self.view.addSubview(navbar)
        self.view.backgroundColor = UIColor.white
        
        firstView.snp.makeConstraints { (make) in
            make.top.equalTo(NavCGRect.height)
            make.left.right.equalTo(0)
            make.height.equalTo(120*glscale)
        }
        if orderID != 0{
            if (dataModel?.order_goods!.count)! > 0 {
                let rowModel = dataModel?.order_goods![0]
                titleLbl.text = rowModel!.goods_name
                if rowModel?.goods_attr != nil {
                    detailLbl.text = "规格:" + (rowModel?.goods_attr)!
                    
                }else{
                    detailLbl.text = "规格:" + "-"
                    
                }
                dingJinTF.text = dataModel?.order_res?.sale_res?.dj_amount
                weiKuanTF.text = dataModel?.order_res?.sale_res?.wk_amount
                countLbl.text = "￥" +  (dataModel?.order_res?.goods_amount)!
                icomImg.sd_setImage(with: URL(string:imgUrlstr))
            }
        }else{
            //MARK:--代客下单流程
            if inputData.count > 0 {
                
                let item = inputData[0]
                titleLbl.text  = item.goods_name
                detailLbl.text = item.spec_str
                icomImg.sd_setImage(with: URL(string:SERVERCE_ImageHost +  item.goods_img!))
                dingJinTF.text = djTFstr
                weiKuanTF.text = wkTFstr
                countLbl.text = "￥" + item.target_Price! + "x\(item.target_Count!)"
            }
            
        }
        //MARK:--输入框代理
        dingJinTF.delegate = self
        dingJinTF.tag = 1001
        weiKuanTF.delegate = self
        weiKuanTF.tag = 1002
        dingJinTF.keyboardType = .decimalPad
        weiKuanTF.keyboardType = .decimalPad
        
    }
    func textFieldDidEndEditing(_ textField: UITextField) {
        if textField.tag == 1001 {
            //            print(dingJinTF.text)
            let dingj = dingJinTF.text! as NSString
            if isPurnNumber(str: dingJinTF.text!) {
                //                if dingj.floatValue > (totalPrice! * 0.2) {
                //                    HUD.flash(.label("定金不得高于总价20%"),delay: 1.2)
                //                    dingJinTF.text = String(format: "%.2f", (totalPrice! * 0.2))
                //                }else{
                dingJinTF.text = String(format: "%.2f", dingj.floatValue)
                //                }
                //                let lastDj = dingJinTF.text! as NSString
                //                let weiku = totalPrice! - lastDj.floatValue
                //                weiKuanTF.text = String(format: "%.2f",weiku)
            }else{
                HUD.flash(.label("请填写正确的定金数值"),delay: 1.2)
                dingJinTF.text = ""
            }
        }else if textField.tag == 1002{
            let weiku = weiKuanTF.text! as NSString
            if isPurnNumber(str: weiKuanTF.text!) {
                //                if weiku.floatValue > totalPrice! {
                //                    HUD.flash(.label("尾款不得高于总价"),delay: 1.2)
                //                    weiKuanTF.text = String(format: "%.2f", totalPrice!)
                //                }else if weiku.floatValue < (totalPrice! * 0.8){
                //                    HUD.flash(.label("尾款不得低于总价的80%"),delay: 1.2)
                //                    weiKuanTF.text = String(format: "%.2f", (totalPrice! * 0.8))
                //                }else{
                weiKuanTF.text = String(format: "%.2f", weiku.floatValue)
                //                }
                //                let lastWeiku = weiKuanTF.text! as NSString
                //                let dingj = totalPrice! - lastWeiku.floatValue
                //                dingJinTF.text = String(format: "%.2f",dingj)
            }else{
                HUD.flash(.label("请填写正确的尾款数值"),delay: 1.2)
                weiKuanTF.text = ""
            }
        }
    }
    
    
    
    @IBAction func submitACTION(_ sender: Any) {
        print("预售返回上一级且提交了数据")
        //        let weiku = weiKuanTF.text! as NSString
        //        let dingj = dingJinTF.text! as NSString
        //        if (weiku.floatValue + dingj.floatValue)
        //            != totalPrice {
        //            let total = String(format: "%.2f", totalPrice!)
        //            HUD.flash(.label("填写的定金和尾款总价应为" + total),delay: 1.2)
        //            return;
        //        }
        
        if orderID != 0 {
            //MARK:--需要对输入是否为金额判断
            let UserToken = UserDefaults.standard.value(forKey: "user_token")
            let rowModel = dataModel?.order_goods![0]
            
            editOrderGoodsPriceAd(["user_token":UserToken as Any,"order_id":orderID as Any,"og_id":rowModel?.og_id as Any,"dj_amount":dingJinTF.text as Any,"wk_amount":weiKuanTF.text as Any], success: { (data) in
                let dataM = data as! EditOGPAdModel
                if dataM.code == 1 {
                    NotificationCenter.default.post(name: NSNotification.Name(rawValue: "orderChange"), object: nil)
                    
                    self.delegate?.changeYuShouGoodsByData(sender:  dataM.data!, djText: self.dingJinTF.text!, wkText: self.weiKuanTF.text!)
                    self.navigationController?.popViewController(animated: true)
                }
                
            }) { (error) in
                
            }
        }else{
            //MARK:--代客下单流程
            self.delegate?.changeYuShouGoodsByData(sender:nil, djText: dingJinTF.text!, wkText: weiKuanTF.text!)
            self.navigationController?.popViewController(animated: true)
        }
        
    }
    deinit {
        NotificationCenter.default.removeObserver(self)
    }
    
}
