//
//  AccountViewController.swift
//  GeliBusinessPlatform
//
//  Created by junye lu on 2020/4/16.
//  Copyright © 2020 junye lu. All rights reserved.
//

import UIKit

class AccountViewController: BaseViewController{

    @IBOutlet weak var phoneLbl: UILabel!
    @IBOutlet weak var accountLbl: UILabel!
    @IBOutlet weak var nameLbl: UILabel!
    @IBOutlet weak var firstView: UIView!

    var dataModel: AdminInfoModel? = nil
    
    override func viewDidLoad() {
        super.viewDidLoad()
        navbar.title = "账号信息"
        self.view.addSubview(navbar)
        // Do any additional setup after loading the view.
        firstView?.snp.makeConstraints({ (make) in
            make.top.equalTo(NavCGRect.height)
            make.left.right.equalTo(0)
            make.height.equalTo(50)
        })
        if dataModel?.data?.admin_name?.count == 0 {
            nameLbl.text = "-"
        }else{
            nameLbl.text = dataModel?.data?.admin_name
        }
        accountLbl.text = dataModel?.data?.user_name
        phoneLbl.text = dataModel?.data?.phone
    }
    //MARK: -方法
    
    @IBAction func gotoDetailAction(_ sender: Any) {
        print("进入商家详情")
        let vc = ShopInfoViewController()
        self.navigationController?.pushViewController(vc, animated: true)

    }
    @IBAction func changPassAction(_ sender: Any) {
        print("修改密码")
        let vc = ChangePassViewController()
        self.navigationController?.pushViewController(vc, animated: true)

    }
    @IBAction func logOutAction(_ sender: Any) {
        print("退出登录")
        //模拟退出登录
        UserDefaults.standard.removeObject(forKey: "WorkDataModel")
        UserDefaults.standard.removeObject(forKey: "user_token")
        NotificationCenter.default.post(name: Notification.Name(rawValue: "logout"), object: nil)
        JPUSHService.deleteAlias({ (resCode, alias, num) in
            
        }, seq: 1433223)
    }
 
}
