//
//  XiaDanUserInfoViewController.swift
//  GeliBusinessPlatform
//
//  Created by 刘俊宏 on 2020/7/23.
//  Copyright © 2020 junye lu. All rights reserved.
//

import UIKit
import LGButton
import ContactsUI
protocol XiaDanUserInfoViewControllerDelegate {
    func XiaDanUserInfoViewControllerData(str:NSString)
}
class XiaDanUserInfoViewController: BaseViewController , CNContactPickerDelegate,UITextViewDelegate{
    var delegate:XiaDanUserInfoViewControllerDelegate?
    @IBOutlet weak var messageCountLbl: UILabel!
    @IBOutlet weak var messageTV: UITextView!
    @IBOutlet weak var userPhoneTF: UITextField!
    @IBOutlet weak var userNameTF: UITextField!
    @IBOutlet weak var orderTimeLbl: UILabel!
    @IBOutlet weak var contentV: UIView!
    
    var str:NSString?
    override func viewDidLoad() {
        super.viewDidLoad()
        navbar.title = "下单联系人信息"
        self.view.addSubview(navbar)
        
        SetTopFrame(view: contentV, height: 370)

        messageTV.delegate = self
        
        orderTimeLbl.text = getTimeNow()

        if str != nil && str!.length > 0{
            let arr = str?.components(separatedBy: "_")
            userNameTF.text = arr![0]
            userPhoneTF.text = arr![1]
            messageTV.text = arr![2]
        }
//        messageTV.text = "格利食品"
     }


        func gotoPhoneAccoutAction(_ sender: UIButton) {
        print("gotoPhoneAccoutAction-获取通讯录")
        //联系人选择控制器
        let contactPicker = CNContactPickerViewController()
        //设置代理
        contactPicker.delegate = self
        //弹出控制器
        self.present(contactPicker, animated: true, completion: nil)
    }
    
    
    
    //单选联系人
    func contactPicker(_ picker: CNContactPickerViewController,
                       didSelect contact: CNContact) {
        //获取联系人的姓名
        let lastName = contact.familyName
        let firstName = contact.givenName
        //获取联系人电话号码
        let phones = contact.phoneNumbers
        userNameTF.text = lastName + firstName
        if phones.count > 0 {
            var phone = phones[0].value.stringValue
            if phone.contains("-") {
                let phonestr = phone
                let strarr = phonestr.components(separatedBy: "-")
                phone = ""
                for str in strarr {
                    phone = phone + str
                }
            }
            userPhoneTF.text = phone
        }
        
    }
    @IBAction func sureUserInfoAction(_ sender: LGButton) {
        if userPhoneTF.text!.count == 0 || userPhoneTF.text!.count == 0 {
            HUD.flash(.label("请填写联系人及联系电话"), delay: 1.2)
            return
        }
        print("sureUserInfoAction-确定")
        delegate?.XiaDanUserInfoViewControllerData(str: "\(userNameTF!.text!)_\(userPhoneTF!.text!)_\(messageTV!.text!)" as NSString)
        self.navigationController?.popViewController(animated: true)
    }
    func textView(_ textView: UITextView, shouldChangeTextIn range: NSRange, replacementText text: String) -> Bool {
        messageCountLbl.text = "(\(textView.text.count)/200)"
        if (textView.text.count == 200)
        {
            textView.text = textView.text.subString(start: 0, length: 200)
        }
        return true
    }
    func textViewDidChange(_ textView: UITextView) {
        
        if textView.markedTextRange == nil {
            if textView.text.count > 200 {
                textView.text = textView.text.subString(start: 0, length: 200)
            }
        }
        

    }
}
