//
//  ToAndFormSelectViewController.swift
//  GeliBusinessPlatform
//
//  Created by 刘俊宏 on 2020/7/25.
//  Copyright © 2020 junye lu. All rights reserved.
//

import UIKit
import LGButton
import AMapLocationKit
import AMapFoundationKit
import MAMapKit
import AMapSearchKit
import IQKeyboardManagerSwift
import JZLocationConverter

protocol ToAndFormSelectViewControllerDelegate {
    func ToAndFormSelectViewControllerSelectAdr(dict:Dictionary<String,Any>,idx:Int)
}
class ToAndFormSelectViewController: BaseViewController, MAMapViewDelegate, CLLocationManagerDelegate, AMapSearchDelegate, UISearchBarDelegate, SearchBarViewDelegate,UITableViewDelegate,UITableViewDataSource,CityListViewControllerDelegate,HuoLaLaDiZhiCellDelegate{
    func clearSearchAction() {
        
    }
    
    
    var tempLat:CLLocationDegrees = 0
    var tempLng:CLLocationDegrees = 0
    var tempCityName = ""
    var detailAdrStr = ""
    
    func mapView(_ mapView: MAMapView!, regionWillChangeAnimated animated: Bool) {
        if titleLbl != nil {
            titleLbl!.text = ""
            introView?.isHidden = true
            sjImg?.isHidden = true
        }
    }
    func mapView(_ mapView: MAMapView!, regionDidChangeAnimated animated: Bool) {
        if titleLbl != nil {
            titleLbl!.text = ""
            introView?.isHidden = true
            sjImg?.isHidden = true
        }
    }
    func mapView(_ mapView: MAMapView!, mapWillMoveByUser wasUserAction: Bool) {
        if titleLbl != nil {
            titleLbl!.text = ""
            introView?.isHidden = true
            sjImg?.isHidden = true
        }
    }
    
    @objc func backToCurrentLoc(_ sender: Any) {
        cityName = tempCityName as NSString
        lat = tempLat
        lng = tempLng
        print("返回当前位置",lat,lng)
        
        mapView.centerCoordinate = CLLocationCoordinate2D(latitude: lat, longitude: lng)
        searchList.isHidden = true
        closeBtn.isHidden = true
        listViewBG.isHidden = true
        keyword = ""
        searchBr.text = ""
        
        IQKeyboardManager.shared.resignFirstResponder()
    }
    
    func HuoLaLaDiZhiCellBtnClick(model: citySearchDataPoiChildrenModel,cityStr:String) {
        citySelectBtn.setTitle(cityStr, for: .normal)
        mapView.centerCoordinate = JZLocationConverter.wgs84(toGcj02: CLLocationCoordinate2D(latitude: model.location!.lat!, longitude: model.location!.lon!))
        lat = mapView.centerCoordinate.latitude
        lng = mapView.centerCoordinate.longitude
        isMove = false
        adrName = model.name!
        detailAdr = model.address!
        searchList.isHidden = true
        closeBtn.isHidden = true
        listViewBG.isHidden = true
        keyword = ""
        searchBr.text = ""
        IQKeyboardManager.shared.resignFirstResponder()
    }
    
    func CityListViewControllerLocSelect(loc: cityListDataModel) {
        citySelectBtn.setTitle(loc.name, for: .normal)
        self.loc = loc
        let location = JZLocationConverter.wgs84(toGcj02: CLLocationCoordinate2D(latitude: (loc.lat_lon?.lat)!, longitude: (loc.lat_lon?.lon)!))
        lat = location.latitude as! CLLocationDegrees
        lng = location.longitude as! CLLocationDegrees
        mapView.setCenter(location, animated: false)
        
    }
    
    
    
    @IBAction func citySelectClick(_ sender: UIButton) {
        
        let vc = CityListViewController()
        vc.adrDatas = adrDatasArr!
        vc.locatStr = cityName as String
        vc.delegate = self
        self.navigationController?.pushViewController(vc, animated: true)
        
    }
    
    func tableView(_ tableView: UITableView, numberOfRowsInSection section: Int) -> Int {
        if tableView == searchList {
            return searchAdrDatas.count
        }
        return historyArr.count
    }
    var delegate:ToAndFormSelectViewControllerDelegate?
    
    let UserToken = UserDefaults.standard.value(forKey: "user_token")
    var loc:cityListDataModel!
    var nameStr = ""
    var phoneNum = ""
    var adrStr = ""
    
    var idx:Int?
    func tableView(_ tableView: UITableView, heightForRowAt indexPath: IndexPath) -> CGFloat {
        
        return UITableView.automaticDimension
    }
    
    func tableView(_ tableView: UITableView, cellForRowAt indexPath: IndexPath) -> UITableViewCell {
        
        let cell = tableView.dequeueReusableCell(withIdentifier: "HuoLaLaDiZhiCell") as! HuoLaLaDiZhiCell
        
        if tableView == searchList {
            let model = searchAdrDatas[indexPath.row]
            cell.nameLbl.text = model.name!
            cell.contentLbl.text = model.city! + model.area! + model.address!
            cell.delegate = self
            cell.cityStr = model.city!
            if model.children != nil {
                if model.children!.count  == 0 {
                    cell.marginValue.constant = 0
                    cell.btnViewH.constant = 0
                    cell.btnViewBG.isHidden = true
                    cell.btmH.constant = 12
                }else{
                    cell.btnViewBG.isHidden = false
                    cell.btmH.constant = 3
                    cell.children = model.children!
                    cell.marginValue.constant = 10
                    
                    let rows = (model.children!.count + 3 - 1) / 3
                    
                    cell.btnViewH.constant = CGFloat(rows) * 40
                }
            }
        }else{
            cell.marginValue.constant = 0
            cell.btnViewH.constant = 0
            cell.btmH.constant = 12
            
            let data = historyArr[indexPath.row]
            let dict = getDicFromJSONString(jsonString: data.poi!)
            let poiData = poiDataModel(JSON: dict)
            cell.nameLbl.text = poiData?.name
            cell.contentLbl.text = (poiData?.city)! as String + (poiData?.district)! as String + (poiData?.address)! as String
            if data.contact_name!.count > 0 || data.contact_phone_no!.count > 0 || data.house_number!.count > 0 {
                let str = cell.contentLbl.text! + "\n" + data.contact_name! + data.contact_phone_no! + data.house_number!
                cell.contentLbl.text = str
            }
            
        }
        
        return cell
    }
    
    @IBOutlet weak var navBgView: UIView!
    @IBOutlet weak var citySelectBtn: UIButton!
    
    @IBAction func backAction(_ sender: Any) {
        self.navigationController?.popViewController(animated: true)
    }
    @IBOutlet weak var phoneTF: UITextField!
    @IBOutlet weak var nameTF: UITextField!
    @IBOutlet weak var addressDetailTF: UITextField!
    @IBOutlet weak var toFormTitleLbl: UILabel!
    @IBOutlet weak var sureSelectLbl: UILabel!
    @IBOutlet weak var MapBgView: UIView!
    
    @IBOutlet weak var selectListV: UITableView!
    //高德地图
    var mapView: MAMapView!
    var search: AMapSearchAPI!
    var lat:CLLocationDegrees = 0
    var lng:CLLocationDegrees = 0
    var manger:CLLocationManager = CLLocationManager()
    
    @IBOutlet weak var lineX: NSLayoutConstraint!
    @IBOutlet weak var closeBtn: UIButton!
    @IBAction func closeAction(_ sender: Any) {
        closeBtn.isHidden = true
        listViewBG.isHidden = true
        keyword = ""
        searchBr.text = ""
        IQKeyboardManager.shared.resignFirstResponder()
    }
    
    
    @IBOutlet weak var leftBtn: UIButton!
    @IBAction func listViewRefresh(_ sender: UIButton) {
        //        if sender == leftBtn {
        //            leftBtn.isSelected = true
        //            rightBtn.isSelected = false
        //            lineX.constant = 0
        //        }else{
        //            leftBtn.isSelected = false
        //            rightBtn.isSelected = true
        //            lineX.constant = fullScreenWidth * 0.5
        //        }
    }
    @IBOutlet weak var listViewBG: UIView!
    
    @IBOutlet weak var searchList: UITableView!
    @IBAction func backToUserLocation(_ sender: Any) {
        
    }
    
    override func viewDidLayoutSubviews() {
        super.viewDidLayoutSubviews()
        listViewBG.layer.cornerRadius = 5
        listViewBG.layer.maskedCorners = [CACornerMask.layerMinXMinYCorner,CACornerMask.layerMaxXMinYCorner]
    }
    
    func tableView(_ tableView: UITableView, didSelectRowAt indexPath: IndexPath) {
        if tableView == searchList {
            searchSelect = indexPath.row
            historySelect = 10086
            let model = searchAdrDatas[indexPath.row]
            citySelectBtn.setTitle(model.city!, for: .normal)
            let locData = JZLocationConverter.wgs84(toGcj02: CLLocationCoordinate2D(latitude: (model.location?.lat)!, longitude: (model.location?.lon)!))
            isMove = false
            
            adrName = model.name!
            detailAdr = model.address!
            mapView.setCenter(CLLocationCoordinate2DMake(locData.latitude,locData.longitude), animated: false)
            searchList.isHidden = true
            closeBtn.isHidden = true
            listViewBG.isHidden = true
            keyword = ""
            isHistory = true
            searchBr.text = ""
            IQKeyboardManager.shared.resignFirstResponder()
        }else{
            historySelect = indexPath.row
            searchSelect = 10086
            
            let data = historyArr[indexPath.row]
            let dict = getDicFromJSONString(jsonString: data.poi!)
            let poiData = poiDataModel(JSON: dict)
            citySelectBtn.setTitle(poiData?.city, for: .normal)
            let locData = getDictionaryFromJSONString(jsonString: (poiData?.location)!)
            isHistory = true
            isMove = false 
            adrName = poiData!.name!
            detailAdr = poiData!.address!
            let locD = JZLocationConverter.wgs84(toGcj02: CLLocationCoordinate2D(latitude: locData["lat"] as! CLLocationDegrees, longitude: locData["lon"] as! CLLocationDegrees))
            mapView.setCenter(CLLocationCoordinate2DMake(locD.latitude,locD.longitude), animated: false)
            searchList.isHidden = true
            closeBtn.isHidden = true
            listViewBG.isHidden = true
            keyword = ""
            searchBr.text = ""
            IQKeyboardManager.shared.resignFirstResponder()
        }
    }
    
    let searchBr = SearchBarView.init()
    override func viewDidLoad() {
        super.viewDidLoad()
        
        navBgView.addSubview(searchBr)
        searchBr.snp.makeConstraints { (make) in
            make.left.equalTo(citySelectBtn.snp_right).offset(5)
            make.right.equalTo(-10)
            make.centerY.equalToSuperview()
            make.height.equalTo(35)
        }
        searchBr.placeholderStr = "从哪儿发货"
        searchBr.cornerRadius = 35/2.0
        searchBr.delegate = self
        searchBr.delegateL = self
        searchBr.returnKeyType = .done
        
        if idx != 0 {
            sureSelectLbl.text = "确认收货地"
            toFormTitleLbl.text = "收货人信息（选填）"
            nameTF.placeholder = "收货人姓名"
        }
        
        selectListV.register(UINib(nibName: "HuoLaLaDiZhiCell", bundle: nil), forCellReuseIdentifier: "HuoLaLaDiZhiCell")
        selectListV.separatorStyle = .none
        
        AMapServices.shared().apiKey = "ca417b43e3d031db9c29382cc09a174a"
        
        
        manger.delegate = self
        manger.requestAlwaysAuthorization()
        manger.requestWhenInUseAuthorization()
        manger.startUpdatingLocation()
        
        initMapView()
        initSearch()
        
        searchList.layer.cornerRadius = 5
        searchList.layer.maskedCorners = [CACornerMask.layerMinXMinYCorner,CACornerMask.layerMaxXMinYCorner]
        searchList.register(UINib(nibName: "HuoLaLaDiZhiCell", bundle: nil), forCellReuseIdentifier: "HuoLaLaDiZhiCell")
        
        nameTF.text = nameStr
        phoneTF.text = phoneNum
        addressDetailTF.text = adrStr
        
    }
    
    func initMapView(){
        AMapServices.shared().enableHTTPS = true
        mapView = MAMapView(frame:MapBgView.bounds)
        mapView.delegate = self
        mapView.zoomLevel = 16
        mapView.isZoomEnabled = true
        
        self.mapView.centerCoordinate = CLLocationCoordinate2DMake(lat,lng)
        
        MapBgView.addSubview(mapView!)
        let tap = UITapGestureRecognizer(target: self, action: #selector(cancelKeyboard))
        mapView.addGestureRecognizer(tap)
        
    }
    
    func locationManager(_ manager: CLLocationManager, didUpdateLocations locations: [CLLocation]) {
        manger.stopUpdatingLocation()
        let location = locations.last
        if lat == 0 && lng == 0 {
            lat = location?.coordinate.latitude as! CLLocationDegrees
            lng = location?.coordinate.longitude as! CLLocationDegrees
            mapView.centerCoordinate = CLLocationCoordinate2DMake((lat),(lng))
        }
        tempLat = location?.coordinate.latitude as! CLLocationDegrees
        tempLng = location?.coordinate.longitude as! CLLocationDegrees
    }
    
    func setMapCenter(lat:CLLocationDegrees,lng:CLLocationDegrees) {
        mapView.setCenter(CLLocationCoordinate2D(latitude: lat, longitude: lng), animated: false)
    }
    
    @objc func cancelKeyboard(){
        IQKeyboardManager.shared.resignFirstResponder()
    }
    var adrDatasArr:Array<cityListDataModel>?
    func initSearch() {
        search = AMapSearchAPI()
        search.delegate = self
        let request = AMapPOIAroundSearchRequest()
        //地址
        
        request.location = AMapGeoPoint.location(withLatitude: CGFloat(mapView.centerCoordinate.latitude), longitude: CGFloat(mapView.centerCoordinate.longitude))
        request.requireExtension = true
        search.aMapPOIAroundSearch(request)
    }
    
    
    var historySelect = 10086
    var searchSelect = 10086
    
    
    var adrDataModel:cityListDataModel?
    var cityName:NSString = ""
    
    var city = ""
    var ad = ""
    var districet = ""
    
    
    //MARK: -- 地址选择完成
    @IBAction func sureSelectAddressAction(_ sender: LGButton) {
        print("sureSelectAddressAction")
        
        if titleLbl?.text == "" {
            return
        }
        var dict:Dictionary<String,Any> = Dictionary()
        dict["menPai"] = addressDetailTF.text
        dict["shouHuoRen"] = nameTF.text
        dict["phoneNum"] = phoneTF.text
        
        dict["detailAdr"] = detailAdrStr
        dict["lat_lon"] = "\(lat)_\(lng)"
        if locName.count > 0  {
            dict["locName"] = titleLbl!.text
            var sr_type = 1
            if idx != 0 {
                sr_type = 2
            }
            
            
            if searchSelect != 10086 {
                let model = searchAdrDatas[searchSelect]
                let d = ["lat_lon":["lat":model.location?.lat,"lon":model.location?.lon],
                         "name":model.name,
                         "city_id":model.city_id
                    ] as [String : Any]
                adrDataModel = cityListDataModel(JSON: d)
                
            }
            
            
            if historySelect != 10086 {
                let data = historyArr[historySelect]
                let dict = getDicFromJSONString(jsonString: data.poi!)
                let poiData = poiDataModel(JSON: dict)
                citySelectBtn.setTitle(poiData?.city, for: .normal)
                let locData = getDictionaryFromJSONString(jsonString: (poiData?.location)!)
                var city_id = 0
                for item in adrDatasArr! {
                    if (poiData?.city?.contains(item.name!))! {
                        city_id = item.city_id!
                    }
                }
                let d = ["lat_lon":["lat":locData["lat"],"lon":locData["lon"]],
                         "name":poiData!.name!,
                         "city_id":city_id
                    ] as [String : Any]
                adrDataModel = cityListDataModel(JSON: d)
                
            }
            
            
            let ll = ["lat":adrDataModel?.lat_lon?.lat as Any,
                      "lon":adrDataModel?.lat_lon?.lon as Any]
            let lldata = dictChangeString(sender: ll)
            if adrName.count > 0 {
                moveAdrName = adrName
            }
            
            dict["adr"] = adrDataModel
            let poiData = [
                "city":city as Any,
                "address":ad as Any,
                "district":districet as Any,
                "city_id":adrDataModel?.city_id as Any,
                "location":lldata as Any,
                "wgs84_location":lldata as Any,
                "name":moveAdrName as Any
            ]
            let poiStr = dictChangeString(sender: poiData)
            let dic = ["user_token":UserToken as Any,
                       "poi":poiStr as Any,
                       "house_number":addressDetailTF.text as Any,
                       "contact_name":nameTF.text as Any,
                       "contact_phone_no": phoneTF.text as Any,
                       "sr_type":sr_type as Any
            ]
            HUD.flash(.progress)
            setSearchLog(dic, success: { (data) in
                HUD.hide()
                self.delegate?.ToAndFormSelectViewControllerSelectAdr(dict: dict,idx:self.idx!)
                self.navigationController?.popViewController(animated: true)
            }) { (err) in
                
            }
            
        }
        
    }
    //MARK: - 高德地图delegate
    var introView:UIView?
    var sjImg:UIImageView?
    var titleLbl:UILabel?
    var contentLbl:UILabel?
    
    var keyword = ""
    var locName = ""
    var adrName:String = ""
    var detailAdr:String = ""
    var moveAdrName = ""
    var isMove = false
    
    
    var specRecord = ""
    
    func onPOISearchDone(_ request: AMapPOISearchBaseRequest!, response: AMapPOISearchResponse!) {
        print("mapDidMoveByUser3",isMove)
        if response.count == 0 {
            return
        }
        
        lat = mapView.centerCoordinate.latitude
        lng = mapView.centerCoordinate.longitude
        
        //解析response获取POI信息，具体解析见 Demo
        //        adrArr.removeAll()
        //        response.pois.forEach { (poi) in
        //            adrArr.append(poi)
        //        }
        
        if introView == nil {
            introView = UIView()
            MapBgView.addSubview(introView!)
            introView?.backgroundColor = UIColor.white
            introView?.layer.cornerRadius = 5
            introView?.layer.masksToBounds = true
            titleLbl = UILabel()
            titleLbl?.textColor = UIColor.black
            titleLbl?.font = UIFont.systemFont(ofSize: 13)
            titleLbl?.numberOfLines = 0
            introView?.addSubview(titleLbl!)
            contentLbl = UILabel()
            contentLbl?.textColor = UIColor.lightGray
            contentLbl?.font = UIFont.systemFont(ofSize: 11)
            contentLbl?.numberOfLines = 0
            contentLbl?.lineBreakMode = .byCharWrapping
            introView?.addSubview(contentLbl!)
            
            let img = UIImageView()
            img.image = UIImage(named: "矩形")
            MapBgView.addSubview(img)
            sjImg = img
        }

        titleLbl!.text = response.pois.first?.name
        if titleLbl!.text!.count > 0 {
            introView?.isHidden = false
            sjImg?.isHidden = false
        }
        
        cityName = response.pois.first?.city as! NSString
        if tempCityName == ""{
            tempCityName = cityName as String
        }
        
        locName = response.pois.first?.name as! String
        if loc == nil {
            citySelectBtn.setTitle(cityName as String, for: .normal)
        }
        
        specRecord = cityName as String + (response.pois.first?.district)!
        //通过富文本来设置行间距
        let paraph = NSMutableParagraphStyle()
        //将行间距设置为28
        paraph.lineSpacing = 3
        
        var str = "\(String(describing: response.pois.first!.province!))\(String(describing: response.pois.first!.city!))\(String(describing: response.pois.first!.district!))\( String(describing: response.pois.first!.address!))"
        
        city = response.pois.first!.city
        ad = response.pois.first?.address as! String
        districet = response.pois.first?.district as! String
        moveAdrName = response.pois.first?.name as! String
        
        if adrName.count > 0 {
           
            isMove = true
            titleLbl!.text = adrName
            str = detailAdr
        }
        
        detailAdrStr = "\(city)_\(districet)_\(ad)_\(titleLbl!.text!)"
        var city_id = 0
        for item in adrDatasArr! {
            
            if detailAdrStr.contains(item.name!) || detailAdrStr.contains(item.name_en!) {
                city_id = item.city_id!
            }
        }
        
        if isHistory == false {
            let coordinate = JZLocationConverter.gcj02(toWgs84: CLLocationCoordinate2D(latitude: lat, longitude: lng))
            let d = ["lat_lon":["lat":coordinate.latitude,"lon":coordinate.longitude],
                     "name":titleLbl!.text,
                     "city_id":city_id
                ] as [String : Any]
            adrDataModel = cityListDataModel(JSON: d)
        }
        
        isHistory = false
        
        let attributes = [NSAttributedString.Key.font:UIFont.systemFont(ofSize: 11),
                          NSAttributedString.Key.paragraphStyle: paraph]
        contentLbl!.attributedText = NSAttributedString(string: str, attributes: attributes)
        
        let t = getStrHeight(str: titleLbl!.text!, fontSize: 13)
        let c = getStrHeight(str: str, fontSize: 11)
        let h = t+c
        
        titleLbl?.snp_updateConstraints({ (make) in
            make.top.equalTo(7)
            make.left.equalTo(10)
            make.right.equalTo(-10)
            make.height.equalTo(t)
        })
        
        contentLbl?.snp_updateConstraints({ (make) in
            make.top.equalTo(titleLbl!.snp_bottom).offset(5)
            make.left.equalTo(10)
            make.right.equalTo(-10)
            make.height.equalTo(c)
        })
        
        let lbl = UILabel()
        lbl.text = contentLbl?.text
        lbl.font = UIFont.systemFont(ofSize: 11)
        lbl.sizeToFit()
        
        let lbl2 = UILabel()
        lbl2.text = titleLbl!.text
        lbl2.font = UIFont.systemFont(ofSize: 13)
        lbl2.sizeToFit()
        
        var w = lbl.bounds.size.width + 20
        if w < lbl2.bounds.size.width + 20 {
            w = lbl2.bounds.size.width + 20
        }
        
        if  w > fullScreenWidth * 0.75 {
            w = fullScreenWidth * 0.75 + 20
        }
        
        
        
        introView?.snp_updateConstraints({ (make) in
            make.centerX.equalTo(MapBgView.snp_centerX)
            make.centerY.equalTo(MapBgView.snp_centerY).offset(-(h+45))
            make.width.equalTo(w)
            make.height.equalTo(h+20)
        })
        
        sjImg?.snp.makeConstraints { (make) in
            make.centerX.equalTo(introView!.snp.centerX)
            make.top.equalTo(introView!.snp.bottom)
            make.height.equalTo(7.25)
            make.width.equalTo(13.68)
        }
    }
    
    func getStrHeight(str:String,fontSize:CGFloat) -> CGFloat{
        let lbl = UILabel()
        lbl.text = str
        lbl.font = UIFont.systemFont(ofSize: fontSize+2)
        lbl.sizeToFit()
        var w = lbl.bounds.size.width
        if  w > fullScreenWidth * 0.75 {
            w = fullScreenWidth * 0.75 + 20
        }
        
        let viewSize = CGSize(width:w , height: CGFloat(MAXFLOAT))
        
        let font = UIFont.systemFont(ofSize: fontSize+2)
        return (str as NSString).boundingRect(with: viewSize, options: [.usesLineFragmentOrigin], attributes: [NSAttributedString.Key.font:font], context: nil).height
    }
    
    //移动后刷新
    func mapView(_ mapView: MAMapView!, mapDidMoveByUser wasUserAction: Bool) {
        let req = AMapPOIAroundSearchRequest()
        //地址
        print("mapDidMoveByUser2",isMove)
        if isMove {
            adrName = ""
            detailAdr = ""
            searchSelect = 10086
            historySelect = 10086
        }
        
        req.location = AMapGeoPoint.location(withLatitude: CGFloat(mapView.centerCoordinate.latitude), longitude: CGFloat(mapView.centerCoordinate.longitude))
        req.requireExtension = true
        search.aMapPOIAroundSearch(req)
        
        
    }
    
    
    var isHistory = false
    var annotation:MAPointAnnotation? = nil
    func mapViewRegionChanged(_ mapView: MAMapView!) {
        
        let request = AMapReGeocodeSearchRequest()
        
        request.location = AMapGeoPoint.location(withLatitude: CGFloat(mapView.centerCoordinate.latitude), longitude: CGFloat(mapView.centerCoordinate.longitude))
        
        search.aMapReGoecodeSearch(request)
        request.requireExtension = true
        
        if annotation == nil
        {
            let pointAnnotation = MAPointAnnotation()
            annotation = pointAnnotation
            mapView.addAnnotation(annotation)
        }
        annotation!.coordinate = CLLocationCoordinate2D(latitude: mapView.centerCoordinate.latitude, longitude: mapView.centerCoordinate.longitude)
    }
    
    func mapView(_ mapView: MAMapView!, viewFor annotation: MAAnnotation!) -> MAAnnotationView! {
        if annotation.isKind(of: MAPointAnnotation.self) {
            let pointReuseIndetifier = "pointReuseIndetifier"
            var annotationView: MAAnnotationView? = mapView.dequeueReusableAnnotationView(withIdentifier: pointReuseIndetifier)
            
            if annotationView == nil {
                annotationView = MAAnnotationView(annotation: annotation, reuseIdentifier: pointReuseIndetifier)
            }
            
            if idx != 0{
                annotationView!.image = UIImage(named: "redLoc")
            }else{
                annotationView!.image = UIImage(named: "dingzhen")
            }
            //设置中心点偏移，使得标注底部中间点成为经纬度对应点
            annotationView!.centerOffset = CGPoint(x: 0, y: -15);
            
            return annotationView!
        }
        return nil
    }
    
    var searchAdrDatas:Array<citySearchDataPoiModel> = []
    func searchBarSearchButtonClicked(_ searchBar: UISearchBar) {
        
        keyword = searchBar.text!
        print("点击搜索进行--")
        if searchBar.text!.count == 0 {
            searchList.isHidden = true
            backToCenterBtn.isHidden = false
        }
        searchBar.resignFirstResponder()
        
        
        
    }
    func searchBar(_ searchBar: UISearchBar, textDidChange searchText: String) {
        keyword = searchText
        if keyword.count > 0 {
            backToCenterBtn.isHidden = true
            searchList.isHidden = false
            let dict = ["user_token":UserToken as Any,
                        "nonce_str":String.randomStr(len: 30) as Any,
                        "kw":keyword as Any
            ]
            
            citySearch(dict, success: { (data) in
                let model = data as! citySearchModel
                self.searchAdrDatas.removeAll()
                if (model.data?.poi!.count)! > 0 {
                    for item in model.data!.poi! {
                        self.searchAdrDatas.append(item)
                    }
                    self.searchList.isHidden = false
                    self.backToCenterBtn.isHidden = true
                    self.searchList.reloadData()
                }
            }) { (err) in
                
            }
        }else{
            searchList.isHidden = true
            backToCenterBtn.isHidden = false
        }
    }
    
    @IBOutlet weak var targetLbl: UILabel!
    var historyArr:Array<getSearchLogListDataModel> = []
    var backToCenterBtn:UIButton!
    func searchBarShouldBeginEditing(_ searchBar: UISearchBar) -> Bool {
        print("调起搜索后添加个蒙版本")
        closeBtn.isHidden = false
        listViewBG.isHidden = false
        
        if backToCenterBtn == nil {
            backToCenterBtn = UIButton()
            listViewBG.addSubview(backToCenterBtn)
            backToCenterBtn.addTarget(self, action: #selector(backToCurrentLoc(_:)), for: .touchUpInside)
            backToCenterBtn.snp.makeConstraints { (make) in
                make.centerY.equalTo(targetLbl.snp.centerY)
                make.left.right.equalTo(0)
                make.height.equalTo(40)
            }
        }
        
        var type = 1
        if idx != 0 {
            type = 2
        }
        historyArr.removeAll()
        getSearchLogList(["user_token":UserToken as Any,"sr_type":type as Any], success: { (data) in
            let model = data as! getSearchLogListModel
            for item in model.data! {
                self.historyArr.append(item)
            }
            self.selectListV.reloadData()
        }) { (err) in
            
        }
        
        return true
    }
    
}
