//
//  LogisticsCostDetailViewController.swift
//  GeliBusinessPlatform
//
//  Created by 刘俊宏 on 2020/7/23.
//  Copyright © 2020 junye lu. All rights reserved.
//

import UIKit

class LogisticsCostDetailViewController: BaseViewController {
    var model:orderPriceCalculateModel?
//    var carModel:vehicle_arr_data?
    @IBOutlet weak var lineView: UIView!
    @IBOutlet weak var contentV: UIView!
    
    @IBOutlet weak var priceLbl: UILabel!
    
    
    @IBOutlet weak var roadKM: UILabel!
    override func viewDidLoad() {
        super.viewDidLoad()

        navbar.title = "费用明细"
        self.view.addSubview(navbar)

        priceLbl.text = "\(model!.data!.total_price_fen!/100.0)"
        roadKM.text = "(总里程\(Double(model!.data!.distance_total!)/1000.0)公里)"
        
        SetTopFrameView(view: contentV, btmView: self.view)
        
        setCostDetailView()
     }
    
    //临时UI，待数据,可能有多个，多到要滚动（暂时先考虑够显示）
    func setCostDetailView() {
        
        let leftLbl = UILabel()
        leftLbl.textAlignment = .left
        leftLbl.textColor = UIColor.init(named: "灰色字体颜色")
        leftLbl.font = UIFont.init(name: "PingFang SC", size: 13)
        contentV.addSubview(leftLbl)
        
        let rightLbl = UILabel()
        rightLbl.textAlignment = .right
        rightLbl.textColor = UIColor.init(named: "灰色字体颜色")
        rightLbl.font = UIFont.init(name: "PingFang SC", size: 13)
        contentV.addSubview(rightLbl)
        
        leftLbl.snp.makeConstraints { (make) in
            make.left.equalTo(45)
            make.top.equalTo(lineView.snp_bottom).offset(30)
        }
        rightLbl.snp.makeConstraints { (make) in
            make.right.equalTo(-45)
            make.top.equalTo(lineView.snp_bottom).offset(30)
        }

        leftLbl.text = "起步价（\(model!.data!.order_vehicle_name!)）"
        for item in model!.data!.order_price_arr! {
            if item.type == 1 {
                rightLbl.text = "¥\(String(describing: item.price_fen!/100))"
            }
        }
        
        for i in 0 ..< model!.data!.spec_req_price_arr!.count {
            let leftL = UILabel()
            leftL.textAlignment = .left
            leftL.textColor = UIColor.init(named: "灰色字体颜色")
            leftL.font = UIFont.init(name: "PingFang SC", size: 13)
            contentV.addSubview(leftL)
            
            let rightL = UILabel()
            rightL.textAlignment = .right
            rightL.textColor = UIColor.init(named: "灰色字体颜色")
            rightL.font = UIFont.init(name: "PingFang SC", size: 13)
            contentV.addSubview(rightL)
            
            let y = 5 + CGFloat(25) * CGFloat(i)
            leftL.snp.makeConstraints { (make) in
                make.left.equalTo(45)
                make.top.equalTo(leftLbl.snp_bottom).offset(y)
            }
            rightL.snp.makeConstraints { (make) in
                make.right.equalTo(-45)
                make.centerY.equalTo(leftL.snp_centerY)
            }
         
            let mo = model?.data?.spec_req_price_arr![i]
            leftL.text = mo?.name!
            let price = mo!.price_fen!/100
            rightL.text = "\(price)"
            
        }
        
    }
 
}
