//
//  WaybillDetailViewController.swift
//  GeliBusinessPlatform
//
//  Created by 刘俊宏 on 2020/7/24.
//  Copyright © 2020 junye lu. All rights reserved.
//

import UIKit
import LGButton

class WaybillDetailViewController: BaseViewController ,UITableViewDelegate,UITableViewDataSource,BtmBtnCellDelegate,PaymentViewDelegate{
  
    
    @IBOutlet weak var bottomLheight: NSLayoutConstraint!
    @IBOutlet weak var bottomLbl: UILabel!
    @IBOutlet weak var bottomBtn: LGButton!
    //测试数据
    var isYDBc = false
    var lwb_no = ""

    var dataModel:getHllOrderDetailsDataModel? = nil
    @IBOutlet weak var listView: UITableView!
    override func viewDidLoad() {
        super.viewDidLoad()
        
        navbar.title = "运单详情"
        self.view.addSubview(navbar)
        SetTopFrameView(view: listView, btmView: self.view)
        listView.register(UINib(nibName: "WayBillAddressItemCell", bundle: nil), forCellReuseIdentifier: "WayBillAddressItemCell")
        listView.register(UINib(nibName: "DriverItemTableViewCell", bundle: nil), forCellReuseIdentifier: "DriverItemTableViewCell")
        listView.register(UINib(nibName: "TitleAndTFCell", bundle: nil), forCellReuseIdentifier: "TitleAndTFCell")
        listView.register(UINib(nibName: "WayBillStautsTableViewCell", bundle: nil), forCellReuseIdentifier: "WayBillStautsTableViewCell")
        listView.register(UINib(nibName: "BtmBtnCell", bundle: nil), forCellReuseIdentifier: "BtmBtnCell")
        listView.register(UINib(nibName: "TitleHeaderCell", bundle: nil), forCellReuseIdentifier: "TitleHeaderCell")
        listView.register(UINib(nibName: "TitleAndLblCell", bundle: nil), forCellReuseIdentifier: "TitleAndLblCell")
        listView.register(UINib(nibName: "LalamoveBillTableViewCell", bundle: nil), forCellReuseIdentifier: "LalamoveBillTableViewCell")
        
        loadData()
        if !isYDBc {
            NotificationCenter.default.addObserver(self, selector: #selector(getNoti(noti:)), name: NSNotification.Name(rawValue: "HuolalaOrderChange"), object: nil)
        }
        
        bottomLheight.constant = 0
        bottomLbl.isHidden = true
        bottomBtn.isHidden = true
 
    }
    var notiObj = ""
    @objc func getNoti(noti:Notification){
        notiObj = noti.object as! String
        print("abc == ",notiObj)
        NotificationCenter.default.post(name: NSNotification.Name(rawValue: "logistDetail"), object: nil, userInfo: nil)

        loadData()
    }
    @objc func loadData(){
        indexNext = 0
        HUD.show(.progress)
        let UserToken = UserDefaults.standard.value(forKey: "user_token")
        bottomLheight.constant = 0
        bottomLbl.isHidden = true
        bottomBtn.isHidden = true
        
        getHllOrderDetails(["user_token":UserToken as Any,"lwb_no":lwb_no as Any], success: { (data) in
            HUD.hide()
            let model = data as! getHllOrderDetailsModel
            if model.data?.order_detail_item != nil {
                if (model.data?.order_detail_item?.order_item?.order_status == 0 || model.data?.order_detail_item?.order_item?.order_status == 1) && self.notiObj.count > 0 {
                    self.loadData()
                    return
                }
                self.notiObj = ""

                self.dataModel = model.data!
                
                
                if !self.isYDBc {
                    switch self.dataModel?.order_detail_item?.order_item?.order_status {
                    case 0:
                        print("等待司机接单")
                        self.bottomLheight.constant = 49
                        self.bottomLbl.isHidden = false
                        self.bottomBtn.isHidden = false
                        self.bottomLbl.text = "取消订单"
                    case 1:
                        print("待装货")
                        self.bottomLheight.constant = 49
                        self.bottomLbl.isHidden = false
                        self.bottomBtn.isHidden = false
                        self.bottomLbl.text = "取消订单"
                    case 13,2:
                        print("已完成")
                        if self.dataModel?.delivery?.hll_pay_status_two == 1 {

                            self.bottomLheight.constant = 49
                            self.bottomLbl.isHidden = false
                            self.bottomBtn.isHidden = false
                            self.bottomLbl.text = "立即支付" + String(format: "%.2f", ((self.dataModel?.order_detail_item?.order_item?.price_fen)!/100.0)) + "元"
                        }
                    default:
                        break
                    }
                }
                self.orderPeiceStrAndName()
                self.listView.reloadData()
            }else {
                self.loadData()
            }
        }) { (error) in
            HUD.hide()
        }
    }
    override func backAction() {
        if isYDBc {
            self.navigationController?.popToRootViewController(animated: true)
        }else{
            self.navigationController?.popViewController(animated: true)

        }
    }
    var ispayHllOrder = false
    
    @IBAction func bottomAction(_ sender: LGButton) {
        if bottomLbl.text == "取消订单" {
            let vc = HuolalaCancelViewController()
            vc.lwbno = lwb_no
            self.navigationController?.pushViewController(vc, animated: true)
        }else if (bottomLbl.text?.contains("立即支付"))!{
            if dataModel?.delivery?.hll_pay_status_two == 1 &&  dataModel?.order_detail_item?.order_item?.order_status == 13{
                if !ispayHllOrder {
                    let UserToken = UserDefaults.standard.value(forKey: "user_token")

                    payHllOrder(["user_token":UserToken as Any,"lwb_no":lwb_no as Any,"nonce_str":String.randomStr(len:30) as Any], success: { (data) in
                        self.ispayHllOrder = true
                        self.setPaymentUI(data:self.orderPriceArrName)
                    }) { (error) in

                    }
                }else{
                    self.setPaymentUI(data:self.orderPriceArrName)
                }

            }else{
                setPaymentUI(data:orderPriceArrName)
            }

            
        }
    }
    func selectBtmBtnCellBy(index: Int) {
        switch index {
        case 0:
            let vc = XiaYunDanViewController()
            self.navigationController?.pushViewController(vc, animated: true)
        case 1:
            let vc = WaybillDetailViewController()
            vc.lwb_no = lwb_no
            self.navigationController?.pushViewController(vc, animated: true)
        case 2:
            let vc = YDLBVc()
            self.navigationController?.pushViewController(vc, animated: true)
        default:
            break
        }
    }
    func tableView(_ tableView: UITableView, numberOfRowsInSection section: Int) -> Int {
        if tableView.tag == 99 {
            return orderPriceArrName.count
        }
        if dataModel == nil {
            return 0
        }
        
        if section == 0 || section == 1 || section == 7 {
            return 1
        }
        if section == 3 {
            if (dataModel?.order_detail_item?.bill_price_arr?.count)! > 0 {
                var isUrl = false
                dataModel?.order_detail_item?.bill_price_arr?.forEach({ (model) in
                    if model.img_url?.count != 0 {
                        isUrl = true
                    }
                })
                if isUrl {
                    return 1
                }
                return 0
            }
            return 0
        }
        
        if section == 5 || section == 6{
            return 2
        }
        if section == 4 {
             return orderPriceArrName.count
        }
        return (dataModel?.order_detail_item?.order_item?.addr_info_arr!.count)!
    }
    var orderPriceArrStr: [String] = []
    var orderPriceArrName: [String] = []
    //MARK:--处理订单费用数据展示
    func orderPeiceStrAndName() {
        orderPriceArrName.removeAll()
        orderPriceArrStr.removeAll()
        dataModel?.order_detail_item?.order_item?.order_price_arr?.forEach({ (rowModel) in
            switch rowModel.type {
            case 1:
                orderPriceArrName.append("起步价" + "(" + (dataModel?.order_detail_item?.order_item?.vehicle_type_name)! + ")")
                orderPriceArrStr.append("¥" + String(format: "%.2f", (rowModel.price_fen!/100.0)))
            case 2:
                let distance = CGFloat((dataModel?.order_detail_item?.exceed_distance)!) / 1000.0
                orderPriceArrName.append("超里程价"  + "(" + String(format: "%.d", distance) + "公里" + ")")
                orderPriceArrStr.append("¥" + String(format: "%.2f", (rowModel.price_fen!/100.0)))
            case 4:
                dataModel?.order_detail_item?.spec_req_price_arr?.forEach({ (specModel) in
                    if specModel.price_fen! != 0 {
                        orderPriceArrName.append(specModel.name!)
                        orderPriceArrStr.append("¥" + String(format: "%.2f", (specModel.price_fen!/100.0)))
                    }
                })
            case 15:
                orderPriceArrName.append("货物保障（0元最高保5万）")
                orderPriceArrStr.append("¥" + String(format: "%.2f", (rowModel.price_fen!/100.0)))
            default:
                break
            }
        })
        if (dataModel?.order_detail_item?.bill_price_arr!.count)! > 0 {
            orderPriceArrName.append("额外费用")
            orderPriceArrStr.append("")
        }
        dataModel?.order_detail_item?.bill_price_arr?.forEach({ (rowModel) in
            orderPriceArrName.append(rowModel.name!)
            orderPriceArrStr.append("¥" + String(format: "%.2f", (rowModel.price_fen!/100.0)))
        })
 
    }
    func numberOfSections(in tableView: UITableView) -> Int {
        if tableView.tag == 99 {
            return 1
        }
        if dataModel == nil {
            return 0
        }
        if !isYDBc {
            return 7
        }
        return 8;
    }
    func tableView(_ tableView: UITableView, heightForRowAt indexPath: IndexPath) -> CGFloat {
        if tableView.tag == 99 {
            return 30
        }
        if indexPath.section == 0 {
            return 60
        }
        if indexPath.section == 1 {
            if dataModel?.driver_info == nil {
                return 0
            }
            return 103
        }
        if indexPath.section == 3 {
            return 120
        }
        
        if indexPath.section == 4 {
            return 30
        }
        if indexPath.section == 5 {
            return 35
        }
        if indexPath.section == 6{
            if indexPath.row == 1 {
                return UITableView.automaticDimension
                
            }
            return 35
        }
        
        if indexPath.section == 7 {
            return 108
        }
        
        return UITableView.automaticDimension
    }
    var indexNext = 0
    func tableView(_ tableView: UITableView, cellForRowAt indexPath: IndexPath) -> UITableViewCell {
        if tableView.tag == 99 {
            let cell = tableView.dequeueReusableCell(withIdentifier: "TitleAndLblCell") as! TitleAndLblCell
            
            cell.nameLbl.text = "\(orderPriceArrName[indexPath.row])"
            cell.contentLbl.text = "\(orderPriceArrStr[indexPath.row])"
            if orderPriceArrName[indexPath.row] == "额外费用" {
                let cell = tableView.dequeueReusableCell(withIdentifier: "TitleHeaderCell") as! TitleHeaderCell
                cell.nameLbl.text = orderPriceArrName[indexPath.row]
                return cell
            }
            //cellUI设置
            cell.btmLine.isHidden = true
            cell.imgRight.constant = 0
            cell.nameLbl.textColor = UIColor(named: "多选按钮字体颜色")
            cell.contentLbl.textColor = cell.nameLbl.textColor
            return cell
            
        }
        if indexPath.section == 0 {
            let cell = tableView.dequeueReusableCell(withIdentifier: "WayBillStautsTableViewCell") as! WayBillStautsTableViewCell
            
            
            switch dataModel?.order_detail_item?.order_item?.order_status {
            case 0:
                cell.statusLbl.text  = "等待司机接单"
                cell.statusImgV.image = UIImage.init(named: "货拉拉待接单")
            case 1:
                cell.statusLbl.text  = "待装货"
                cell.statusImgV.image = UIImage.init(named: "货拉拉待装货")
            case 15:
                cell.statusLbl.text  = "待装中"
                cell.statusImgV.image = UIImage.init(named: "货拉拉运输中")
            case 7:
                cell.statusLbl.text  = "运输中"
                cell.statusImgV.image = UIImage.init(named: "货拉拉运输中")
            case 10,11,13,2,14:
                cell.statusLbl.text  = "已完成"
                cell.statusImgV.image = UIImage.init(named: "货拉拉运单完成")
            case 3,4,5,8:
                cell.statusLbl.text  = "已取消"
                cell.statusImgV.image = UIImage.init(named: "货拉拉运单取消")
            default:
                break
            }
            if isYDBc {
                cell.statusLbl.text = "下单成功"
                cell.statusImgV.image = UIImage.init(named: "货拉拉下单成功")
            }
            
            return cell
        }
        if indexPath.section == 1 {
            let cell = tableView.dequeueReusableCell(withIdentifier: "DriverItemTableViewCell") as! DriverItemTableViewCell
            if dataModel?.driver_info != nil {
                cell.driverNameLbl.text = dataModel?.driver_info?.name
                cell.driverNumLbL.text = dataModel?.driver_info?.license_plate
                cell.driverTypeLbl.text = "联系方式：" + (dataModel?.driver_info?.phone_no)!
                cell.driverTypeLbl.isHidden = true
                cell.callPhoneStr = (dataModel?.driver_info?.phone_no)!
                cell.callBtn.setTitle(" 联系方式：" + (dataModel?.driver_info?.phone_no)!, for: .normal)
            }
            
            return cell
        }
        if indexPath.section == 3 {
            let cell = tableView.dequeueReusableCell(withIdentifier: "LalamoveBillTableViewCell") as! LalamoveBillTableViewCell
            var dataStrArr:[String] = []
            
            dataModel?.order_detail_item?.bill_price_arr?.forEach({ (model) in
                if model.img_url?.count != 0 {
                    dataStrArr.append(model.img_url!)
                }
            })
            cell.datasArr = dataStrArr
            
            return cell
        }
        if indexPath.section == 4 || indexPath.section == 5  || indexPath.section == 6{
            
            let cell = tableView.dequeueReusableCell(withIdentifier: "TitleAndTFCell") as! TitleAndTFCell
            
            cell.textTF.isUserInteractionEnabled = false
            cell.line.isHidden = true
            
            if indexPath.section == 4 {
     
                let indexName = orderPriceArrName[indexPath.row]
                if indexName == "额外费用" {
                    let cell = tableView.dequeueReusableCell(withIdentifier: "TitleHeaderCell") as! TitleHeaderCell
                    cell.nameLbl.text = indexName
                    return cell
                }
                cell.nameLbl.text = indexName
                cell.textTF.text = orderPriceArrStr[indexPath.row]
                cell.nameLbl.textColor = UIColor.init(named: "标题字颜色")
                cell.textTF.textColor = UIColor.init(named: "标题字颜色")
                
            }else if indexPath.section == 5 {
                cell.textTF.text = "-"
                cell.nameLbl.text = "关联平台："
                if dataModel?.delivery?.sale_plat != nil {
                    cell.textTF.text = dataModel?.delivery?.sale_plat
                    if dataModel?.delivery?.sale_plat?.count == 0 {
                        cell.textTF.text = "-"
                        
                    }
                }
                if indexPath.row == 1 {
                    cell.nameLbl.text = "关联订单号："
                    if dataModel?.delivery?.order_sn != nil {
                        
                        cell.textTF.text = dataModel?.delivery?.order_sn
                        if dataModel?.delivery?.order_sn?.count == 0 {
                            cell.textTF.text = "-"
                        }
                    }
                    
                    
                }
                
                cell.nameLbl.textColor = UIColor.init(named: "标题字颜色")
                cell.textTF.textColor = UIColor.init(named: "标题字颜色")
                
            }else if indexPath.section == 6 {
                cell.nameLbl.textColor = UIColor.init(named: "标题字颜色")
                cell.textTF.textColor = UIColor.init(named: "灰色字体颜色")
                cell.nameLbl.text = "货物保障"
                cell.textTF.text = "-"
                if indexPath.row == 1 {
                    let cell1 = tableView.dequeueReusableCell(withIdentifier: "TitleAndLblCell") as! TitleAndLblCell
                    cell1.nameLbl.text = "备注"
                    cell1.contentLbl.text = dataModel?.order_detail_item?.order_item?.remark
                    if dataModel?.order_detail_item?.order_item?.remark?.count == 0 {
                        cell1.contentLbl.text = "-"
                    }
                    cell1.contentLbl.textColor = UIColor.init(named: "灰色字体颜色")
                    cell1.btmLine.isHidden = true
                    cell1.contentRight.constant = 0
                    return cell1
                }
            }
            return cell
        }
        if indexPath.section == 7 {
            let cell = tableView.dequeueReusableCell(withIdentifier: "BtmBtnCell") as! BtmBtnCell
            
            cell.delegate = self
            
            return cell
        }
        let cell = tableView.dequeueReusableCell(withIdentifier: "WayBillAddressItemCell") as! WayBillAddressItemCell
        
        cell.iconW.constant = 22
        cell.iconH.constant = 22
        cell.iconLbl.layer.cornerRadius = 11
        cell.lineTopView.isHidden = false
        
        let rowModel = dataModel?.order_detail_item?.order_item?.addr_info_arr![indexPath.row]
        cell.addressDetailLbl.text = (rowModel?.addr)! + (rowModel?.house_number)!
        cell.namePhoneLbl.text = (rowModel?.contact_name)! + " " +  (rowModel?.contact_phone_no)!
        cell.addressLbl.text = rowModel?.name
        
        if indexPath.row == 0 {
            cell.iconLbl.text = "发"
            cell.iconLbl.backgroundColor = UIColor.init(named: "蓝色字体颜色")
            cell.lineTopView.isHidden = true
        }
        if (dataModel?.order_detail_item?.order_item?.addr_info_arr!.count)! > 2 {
            if indexPath.row != 0 && indexPath.row != ((dataModel?.order_detail_item?.order_item?.addr_info_arr!.count)!  - 1){
                cell.iconLbl.text = ""
                cell.iconLbl.backgroundColor = UIColor.init(named: "虚线分界线颜色")
                cell.iconW.constant = 12
                cell.iconH.constant = 12
                cell.iconLbl.layer.cornerRadius = 6
            }
            
        }
        
        if indexPath.row == ((dataModel?.order_detail_item?.order_item?.addr_info_arr!.count)!  - 1){
            //最后的不显示lineview
            cell.lineView.isHidden = true
            cell.iconLbl.text = "收"
            cell.iconLbl.backgroundColor = UIColor.init(named: "企业、预售字体")
        }else{
            cell.lineView.isHidden = false
        }
        
        return cell
    }
    
    func tableView(_ tableView: UITableView, heightForHeaderInSection section: Int) -> CGFloat {
        if section == 2{
            return 35
        }
        if  section == 4{
            return 35
        }
        if section == 3 {
            if (dataModel?.order_detail_item?.bill_price_arr?.count)! > 0 {
                var isUrl = false
                 dataModel?.order_detail_item?.bill_price_arr?.forEach({ (model) in
                     if model.img_url?.count != 0 {
                         isUrl = true
                     }
                 })
                 if isUrl {
                     return 10
                 }
                return 0.01
            }
            return 0.01
        }
        if section == 5  || section == 6{
            return 10
        }
        
        return 0.01
    }
    func tableView(_ tableView: UITableView, viewForHeaderInSection section: Int) -> UIView? {
        let headerView = UIView()
        for subV in headerView.subviews {
            subV.removeFromSuperview()
        }
        headerView.backgroundColor = UIColor.white
        
        if section == 2  || section == 4 {
            let headerV = TitleTimeHeaderFooterView()
            headerView.addSubview(headerV)
            headerV.snp.makeConstraints { (make) in
                make.left.top.right.bottom.equalTo(0);
            }
            if section == 2 {
                headerV.titleLbl.text = dataModel?.order_detail_item?.order_item?.order_time
                headerV.fuTitleLbl.text = "#" + (dataModel?.order_detail_item?.order_item?.order_display_id!)!
            }
            if section == 4 {
                headerV.titleLbl.text = "订单费用"
                headerV.fuTitleLbl.text = "总计¥" + String(format: "%.2f", ((dataModel?.order_detail_item?.order_item?.price_fen!)!/100.0))
                headerV.titleLbl.font = UIFont.boldSystemFont(ofSize: 15)
                headerV.fuTitleLbl.font = UIFont.boldSystemFont(ofSize: 15)
                
            }
        }
        
        return headerView
    }
    func tableView(_ tableView: UITableView, heightForFooterInSection section: Int) -> CGFloat {
        if section == 2 {
            if dataModel?.order_detail_item?.spec_req_price_arr?.count == 0 {
                return 65
            }
            return 95
        }
        if section == 4 {
            return 60
        }
        if section == 3 {
            if (dataModel?.order_detail_item?.bill_price_arr?.count)! > 0 {
                var isUrl = false
                 dataModel?.order_detail_item?.bill_price_arr?.forEach({ (model) in
                     if model.img_url?.count != 0 {
                         isUrl = true
                     }
                 })
                 if isUrl {
                     return 10
                 }
                return 0.01
            }
            return 0.01
        }
        if section == 5 || section == 6{
            return 10
        }
        
        return 0.01
    }
    func tableView(_ tableView: UITableView, viewForFooterInSection section: Int) -> UIView? {
        let footerView = UIView()
        for subV in footerView.subviews {
            subV.removeFromSuperview()
        }
        footerView.backgroundColor = UIColor.white
        
        let lineView = UIView()
        lineView.backgroundColor = UIColor.init(named: "灰色分界线")
        if section == 2 {
            let footerV = TitleTimeHeaderFooterView()
            footerView.addSubview(footerV)
            footerV.snp.makeConstraints { (make) in
                make.left.top.right.bottom.equalTo(0);
            }
            footerV.titleLbl.text = "联系人："
            footerV.fuTitleLbl.text = (dataModel?.order_detail_item?.contact_name)! + " " +  (dataModel?.order_detail_item?.contact_phone_no)!
            
            footerV.driveTypeNameLbl.text = dataModel?.order_detail_item?.order_item?.vehicle_type_name
            
            for i in 0..<(dataModel?.order_detail_item?.spec_req_price_arr?.count)! {
                let model = dataModel?.order_detail_item?.spec_req_price_arr![i]
                switch i {
                case 0:
                    footerV.specLbl0.isHidden = false
                    footerV.specLbl0.text = model?.name
                case 1:
                    footerV.specLbl1.isHidden = false
                    footerV.specLbl1.text = model?.name
                case 2:
                    footerV.specLbl2.isHidden = false
                    footerV.specLbl2.text = model?.name
                case 3:
                    footerV.specLbl3.isHidden = false
                    footerV.specLbl3.text = model?.name
                case 4:
                    footerV.specLbl4.isHidden = false
                    footerV.specLbl4.text = model?.name
                case 5:
                    footerV.specLbl5.isHidden = false
                    footerV.specLbl5.text = model?.name
                default:
                    break
                }
            }
            
            footerView.addSubview(lineView)
            lineView.snp.makeConstraints { (make) in
                make.left.bottom.right.equalTo(0)
                make.height.equalTo(5)
            }
        }
        if section == 4 {
            let tishiLbl = UILabel()
            tishiLbl.text = "若产生消费、高速费、停车费、逾时等候费和搬运费，需要您额外支付。额外费用不可使用赠金支付"
            tishiLbl.numberOfLines = 0
            tishiLbl.textColor = UIColor.init(named: "提示语字体颜色")
            tishiLbl.font = UIFont.init(name: "PingFang SC", size: 11)
            footerView.addSubview(tishiLbl)
            tishiLbl.snp.makeConstraints { (make) in
                make.top.equalTo(10)
                make.left.equalTo(15)
                make.right.equalTo(-20)
            }
            tishiLbl.backgroundColor = UIColor.white
            
            footerView.addSubview(lineView)
            lineView.snp.makeConstraints { (make) in
                make.left.bottom.right.equalTo(0)
                make.height.equalTo(5)
            }
        }
        if section == 5 || section == 3 {
            footerView.addSubview(lineView)
            lineView.snp.makeConstraints { (make) in
                make.left.bottom.right.equalTo(0)
                make.height.equalTo(5)
            }
        }
        return footerView
        
    }
    //MARK: - 提醒支付订单费用
    var cBtn:UIButton?
    var pView:UIView?
    func setPaymentUI(data:Array<Any>){
        let h = 49 + Float(data.count * 30) + 48 + Float(TabHeight)
        if cBtn == nil {
            cBtn = UIButton(frame: CGRect(x: 0, y: 0, width: fullScreenWidth, height: fullScreenHeight))
            cBtn?.backgroundColor = UIColor.black
            cBtn?.alpha = 0.4
            cBtn?.addTarget(self, action: #selector(closeAc), for: .touchUpInside)
            self.view.addSubview(cBtn!)
            
            pView = UIView(frame: CGRect(x: 0, y: fullScreenHeight - CGFloat(h), width: fullScreenWidth, height: CGFloat(h)))
            pView?.backgroundColor = UIColor.white
            pView?.layer.cornerRadius = 5
            pView?.layer.maskedCorners = [CACornerMask.layerMinXMinYCorner,CACornerMask.layerMaxXMinYCorner]
            self.view.addSubview(pView!)
            
            let titleBtn = UIButton(frame: CGRect(x: 0, y: 0, width: fullScreenWidth, height: 49))
            titleBtn.setImage(UIImage(named: "编组 4备份"), for: .normal)
            titleBtn.setTitle("  该订单已完成，请尽快支付～", for: .normal)
            titleBtn.setTitleColor(UIColor(named: "蓝色字体颜色"), for: .normal)
            titleBtn.titleLabel?.font = UIFont(name: "PingFangSC-Medium", size: 15)
            titleBtn.isUserInteractionEnabled = false
            pView?.addSubview(titleBtn)

            let titiOutImgBtn = UIButton()
            titiOutImgBtn.setImage( UIImage.init(named: "alterCodeOut"), for: .normal)
            pView?.addSubview(titiOutImgBtn)
            titiOutImgBtn.snp.makeConstraints { (make) in
                make.right.equalTo(-15)
                make.top.equalTo(15)
            }
            titiOutImgBtn.addTarget(self, action: #selector(closeAc), for: .touchUpInside)

            let line = UIButton(frame: CGRect(x: 0, y: 49, width: fullScreenWidth, height: 1))
            line.backgroundColor = UIColor(named: "灰色分界线")
            pView?.addSubview(line)
            
         
            let btmBtn = UIButton(frame: CGRect(x: 0, y: CGFloat(h)-CGFloat(TabHeight), width: fullScreenWidth, height: CGFloat(TabHeight)))
            btmBtn.backgroundColor = UIColor(named: "按钮渐变色上")
            btmBtn.setTitle("确认支付" + String(format: "%.2f", ((self.dataModel?.order_detail_item?.order_item?.price_fen)!/100.0)) + "元", for: .normal)
            btmBtn.setTitleColor(UIColor.white, for: .normal)
            btmBtn.titleLabel?.font = UIFont(name: "PingFangSC-Medium", size: 15)
            btmBtn.addTarget(self, action: #selector(payAc), for: .touchUpInside)
            pView?.addSubview(btmBtn)
            
            let listV = UITableView(frame: CGRect(x: 0, y: line.frame.maxY, width: fullScreenWidth, height: CGFloat(h) - CGFloat(TabHeight) - 49 - 48))
            listV.tag = 99
            listV.separatorStyle = .none
            listV.bounces = false
            listV.delegate = self
            listV.dataSource = self
            pView?.addSubview(listV)
            listV.register(UINib(nibName: "TitleAndLblCell", bundle: nil), forCellReuseIdentifier: "TitleAndLblCell")
            listV.register(UINib(nibName: "TitleHeaderCell", bundle: nil), forCellReuseIdentifier: "TitleHeaderCell")

   
            let tishiLbl = UILabel(frame: CGRect(x: 15, y: listV.frame.maxY+8, width: fullScreenWidth - 30, height: 40))
            tishiLbl.text = "若产生消费、高速费、停车费、逾时等候费和搬运费，需要您额外支付。额外费用不可使用赠金支付"
            tishiLbl.numberOfLines = 0
            tishiLbl.textColor = UIColor.init(named: "提示语字体颜色")
            tishiLbl.font = UIFont.init(name: "PingFang SC", size: 11)
            pView?.addSubview(tishiLbl)
 
        }
        
        cBtn?.isHidden = false
        pView?.isHidden = false
    }
    var paymentView:PaymentView?

    @objc func payAc(){
        print("payAc")
        if paymentView == nil{
            paymentView = PaymentView(frame: view.bounds)
            paymentView?.delegate = self
            paymentView?.price = ((dataModel?.order_detail_item?.order_item?.price_fen!)!/100.0)
            view.addSubview(paymentView!)
        }
        

    }
    @objc func closeAc(){
        cBtn?.isHidden = true
        pView?.isHidden = true
    }
    func PaymentViewPassInputFinish(fullpass: String) {
        HUD.flash(.progress)

        let UserToken = UserDefaults.standard.value(forKey: "user_token")
        
        payHllDelivery(["user_token":UserToken as Any,"wb_no":dataModel?.delivery?.wb_no as Any, "pwd":fullpass as Any], success: { (data) in
            HUD.hide()
            self.loadData()
            NotificationCenter.default.post(name: NSNotification.Name(rawValue: "logistDetail"), object: nil, userInfo: nil)
            self.closeAc()
        }) { (error) in
            HUD.hide()

        }
        paymentView?.removeFromSuperview()
        paymentView = nil
    }
    func PaymentViewClose() {
        paymentView?.removeFromSuperview()
        paymentView = nil
        
    }
}
