//
//  HLLTopCell.swift
//  GeliBusinessPlatform
//
//  Created by junye lu on 2020/7/27.
//  Copyright © 2020 junye lu. All rights reserved.
//

import UIKit
import SDWebImage

protocol HLLTopCellDelegate {
    func HLLTopCellBtnClick(idx:Int)
    func HLLTopCellScrollIdx(idx:Int)
//    func HLLTopCellOtherClick(isSelect:Bool)
}
class HLLTopCell: UITableViewCell,UIScrollViewDelegate {
    var idx = 0
    var delegate:HLLTopCellDelegate?
    
    @IBAction func btnClick(_ sender: UIButton) {
        leftBtn.isHidden = false
        rightBtn.isHidden = false
        
        if sender == leftBtn {
            if idx >= 1 {
                idx -= 1
            }
            if idx == 0 {
                leftBtn.isHidden = true
            }
        }else{
            if idx < datas.count - 1 {
                idx += 1
            }
            if idx == datas.count - 1 {
                rightBtn.isHidden = true
            }
        }
        
        scrollView?.setContentOffset(CGPoint(x: scViewBg.bounds.size.width * CGFloat(idx), y: (scrollView?.frame.origin.y)!), animated: true)
        delegate?.HLLTopCellBtnClick(idx: idx)
    }
    func scrollViewDidEndDecelerating(_ scrollView: UIScrollView) {
        let isStop = !scrollView.isTracking && !scrollView.isDragging && !scrollView.isDecelerating
        if isStop {
            var idx:Int = Int(scrollView.contentOffset.x/scViewBg.bounds.size.width)
            if idx < 0 {
                idx = 0
            }
            if idx > datas.count - 1 {
                idx = datas.count - 1
            }
            delegate?.HLLTopCellScrollIdx(idx:idx)
        }
    }
    
    @IBOutlet weak var btnView: UIView!
    
    @objc func otherClick(_ sender: UIButton) {
        
        print("abc")
    }
    func scrollViewDidScroll(_ scrollView: UIScrollView) {
        leftBtn.isHidden = false
        rightBtn.isHidden = false
        if scrollView.contentOffset.x/scViewBg.bounds.size.width < 1 {
            leftBtn.isHidden = true
        }
        let num = datas.count - 1
        
        if scrollView.contentOffset.x/scViewBg.bounds.size.width >= CGFloat(num) {
            rightBtn.isHidden = true
        }
        
        var numIdx = Int(scrollView.contentOffset.x/scViewBg.bounds.size.width - 1)
        if numIdx < 0 {
            numIdx = 0
        }
        if numIdx > num {
            numIdx = num
        }
        let model = datas[numIdx]
        weightLbl.text = model.vehicle_price_text_item?.text_weight
        sizeLbl.text = model.vehicle_price_text_item?.text_size
        tjLbl.text = model.vehicle_price_text_item?.text_volume
    }
    
    @IBOutlet weak var rightBtn: UIButton!
    @IBOutlet weak var leftBtn: UIButton!
    @IBOutlet weak var scViewBg: UIView!
    @IBOutlet weak var tjLbl: UILabel!
    @IBOutlet weak var sizeLbl: UILabel!
    @IBOutlet weak var weightLbl: UILabel!
    
    var datas:Array<vehicle_arr_data> = []{
        didSet{
            if datas.count < 2 {
                rightBtn.isHidden = true
            }else{
                rightBtn.isHidden = false
            }
            if datas.count > 0 {
                let model = datas[idx]
                weightLbl.text = model.vehicle_price_text_item?.text_weight
                sizeLbl.text = model.vehicle_price_text_item?.text_size
                tjLbl.text = model.vehicle_price_text_item?.text_volume
            }
        }
    }
    
    var scrollView:UIScrollView?
    override func awakeFromNib() {
        super.awakeFromNib()
        
        leftBtn.isHidden = true
        
        self.selectionStyle = .none
    }
    
    override func layoutIfNeeded() {
        super.layoutIfNeeded()
    
        if scrollView == nil {
            scrollView = UIScrollView(frame: scViewBg.bounds)
            scViewBg.addSubview(scrollView!)
            scrollView?.isPagingEnabled = true
            scrollView?.showsHorizontalScrollIndicator = false
            scrollView?.delegate = self
        }
        if (scrollView?.subviews.count)! > 0 && scrollView != nil {
            for item in scrollView!.subviews {
                item.removeFromSuperview()
            }
        }
        
        let num = datas.count
        
        scrollView?.contentSize = CGSize(width: (scViewBg.bounds.size.width) * CGFloat(num), height: (scViewBg.bounds.size.height))
        
        for i in 0 ..< num{
            let view = UIView(frame: CGRect(x: CGFloat(i) * (scViewBg.bounds.size.width), y:0, width: scViewBg.bounds.size.width, height: scViewBg.bounds.size.height))
            let model = datas[i]
            let imgV = UIImageView()
            view.addSubview(imgV)
            SDWebImageDownloader.shared.downloadImage(with: URL(string:model.img_url_high_light!), options: .continueInBackground, progress: { (a, b, nil) in
            }) { (img, data, err, true) in
                imgV.image = img
                if img != nil {
                let p = self.scViewBg.bounds.size.width  / (img!.size.width)
                    imgV.snp.makeConstraints { (make) in
                        make.width.equalTo((imgV.image?.size.width)! * p * 0.6)
                        make.height.equalTo((imgV.image?.size.height)! * p * 0.5)
                        make.centerX.equalTo(view.snp.centerX)
                        make.centerY.equalTo(view.snp.centerY)
                    }
                }
            }
            scrollView?.addSubview(view)
        }
    }
    
    override func setSelected(_ selected: Bool, animated: Bool) {
        super.setSelected(selected, animated: animated)
        
        // Configure the view for the selected state
    }
    
}
