//
//  OnlyViewCell.swift
//  GeliBusinessPlatform
//
//  Created by junye lu on 2020/8/11.
//  Copyright © 2020 junye lu. All rights reserved.
//

import UIKit
protocol OnlyViewCellDelegate {
    func OnlyViewCellSelect(idx:String)
}
class OnlyViewCell: UITableViewCell {
    var delegate:OnlyViewCellDelegate?
    @IBOutlet weak var btnViewH: NSLayoutConstraint!
    var datas:Array<vehicle_std_arr_data>?
    @IBOutlet weak var btnView: UIView!
    override func awakeFromNib() {
        super.awakeFromNib()
        self.selectionStyle = .none
        
        // Initialization code
    }
    var isNotReady:Bool = true
    override func layoutSubviews() {
        super.layoutSubviews()
        if isNotReady {
            for index in 0 ..< datas!.count{
                let item = datas![index]
                let width = fullScreenWidth - 30
                let w = width / 3
                let cols = 3
                
                let col = index % cols
                let row = index / cols
                
                let shopX = CGFloat(col) * (w + 10)
                let shopY = CGFloat(row) * (20 + 5)
                let btn = UIButton(frame: CGRect(x: shopX , y: shopY , width: w, height: 20))
                btn.setImage(UIImage(named: "daixuan"), for: .normal)
                btn.setImage(UIImage(named: "yuxuan"), for: .selected)
                btn.addTarget(self, action: #selector(carSelect(sender:)), for: .touchUpInside)
                btn.tag = index
                btn.setTitle("   " + item.name!, for: .normal)
                btn.titleLabel?.font = UIFont.systemFont(ofSize: 11)
                btn.setTitleColor(UIColor(named: "灰色字体颜色"), for: .normal)
                btn.titleLabel?.font = UIFont.systemFont(ofSize: 13)
                btnView.addSubview(btn)
                if index == datas!.count - 1 {
                    btnViewH.constant = shopY+20
                    isNotReady = false
                }
            }
        }
        
    }
    @objc func carSelect(sender:UIButton){
        if sender.isSelected {
            sender.isSelected = false
        }else{
            sender.isSelected = true
        }
        
        delegate?.OnlyViewCellSelect(idx: datas![sender.tag].name!)
    }
    override func setSelected(_ selected: Bool, animated: Bool) {
        super.setSelected(selected, animated: animated)
        
        // Configure the view for the selected state
    }
    
}
