//
//  YDLBVc.swift
//  GeliBusinessPlatform
//
//  Created by junye lu on 2020/6/10.
//  Copyright © 2020 junye lu. All rights reserved.
//

import UIKit

class YDLBVc: BaseViewController,UITableViewDelegate,UITableViewDataSource,UISearchBarDelegate,SearchBarViewDelegate,UITextFieldDelegate,TimeSelectViewDelgate,YunDanLieBiaoCellDelegate,PaymentViewDelegate, GeliAlertViewDelegate{
    func sureGeliAlertViewAction(sender: UIButton) {
        print("取消订单")
        let rowModel = datas[sender.tag]
        HUD.flash(.progress)
        cancelLogisticsOrder(["wb_no":rowModel.wb_no as Any,"user_token":UserToken as Any], success: { (data) in
            //通知刷新
            HUD.hide()
            NotificationCenter.default.post(name: NSNotification.Name(rawValue: "logistDetail"), object: nil, userInfo: nil)
        }) { (err) in
            
        }
    }
    
    func PaymentViewClose() {
        paymentView?.removeFromSuperview()
        paymentView = nil
    }
    
    func PaymentViewPassInputFinish(fullpass: String) {
        HUD.flash(.progress)
        let rowModel = datas[selectIndex!]
        payDelivery(["wb_no":rowModel.wb_no  as Any,"user_token":UserToken  as Any,"pwd":fullpass  as Any], success: { (data) in
            //通知刷新
            HUD.hide()
            NotificationCenter.default.post(name: NSNotification.Name(rawValue: "logistDetail"), object: nil, userInfo: nil)
        }) { (err) in
            
        }
        paymentView?.removeFromSuperview()
        paymentView = nil
    }
    let UserToken = UserDefaults.standard.value(forKey: "user_token")
    @IBOutlet weak var timeBgH: NSLayoutConstraint!
    @IBOutlet weak var scvContentH: NSLayoutConstraint!
    @IBOutlet weak var contentView: UIView!
    @IBAction func listControlAction(_ sender: Any) {
        print("调用筛选列表")
        blackBtn.isHidden = !blackBtn.isHidden
        preView.isHidden = !preView.isHidden
        removeBlackBtnView()
    }
    
    let calendarV = TimeSelectView(frame: CGRect(x: 0, y: 0, width: fullScreenWidth, height: 235))
    
    @IBOutlet weak var preView: UIView!
    
    @IBOutlet weak var listView: UITableView!
    @IBOutlet weak var searchVBg: UIView!
    @IBOutlet weak var topView: UIView!
    
    @IBOutlet weak var timeTF: UITextField!
    @IBOutlet weak var standerTF: UITextField!
    @IBOutlet weak var orderNumTF: UITextField!
    
    
    @IBOutlet weak var blackBtn: UIButton!
    @IBAction func closeAction(_ sender: UIButton) {
        preView.isHidden = !preView.isHidden
        blackBtn.isHidden = !blackBtn.isHidden
    }
    var searchV : SearchBarView? = nil
    var datas:Array<LogisticsDataModel> = []
    
    var keyWord = ""
    
    @IBOutlet weak var timeBgView: UIView!
    var wlgsArr:Array<UIButton> = []
    var zfztArr:Array<UIButton> = []
    var dyztArr:Array<UIButton> = []
    var ydztArr:Array<UIButton> = []
    
    func setBtnArr(){
        for item in contentView.subviews {
            if item.isKind(of: UIButton.self){
                let btn = item as! UIButton
                switch btn.titleLabel!.text {
                case "顺丰":
                    wlgsArr.append(btn)
                    break
                case "货拉拉":
                    wlgsArr.append(btn)
                    break
                case "京东":
                    wlgsArr.append(btn)
                    break
                case "已付款":
                    zfztArr.append(btn)
                    break
                case "未付款":
                    zfztArr.append(btn)
                    break
                case "已退款":
                    zfztArr.append(btn)
                    break
                case "全部":
                    if btn.tag == 99 {
                        //运单状态
                        ydztArr.append(btn)
                    }else if btn.tag == 101{
                        wlgsArr.append(btn)
                        //物流公司
                    }else{
                        dyztArr.append(btn)
                        //打印状态
                    }
                    break
                case "已打印":
                    dyztArr.append(btn)
                    break
                case "未打印":
                    dyztArr.append(btn)
                    break
                case "下单完成":
                    ydztArr.append(btn)
                    break
                case "揽收成功":
                    ydztArr.append(btn)
                    break
                case "运输中":
                    ydztArr.append(btn)
                    break
                case "已签收":
                    ydztArr.append(btn)
                    break
                case "已取消":
                    ydztArr.append(btn)
                    break
                default:
                    break
                }
            }
        }
    }
    
    //    @objc func closeTimeSelect(){
    //        timeBgH.constant = 0
    //        scvContentH.constant = 680
    //        calendarV.removeFromSuperview()
    //
    //    }
    
    deinit {
        NotificationCenter.default.removeObserver(self)
    }
    @objc func refreshList(){
        listView.mj_header?.beginRefreshing()
    }
    override func viewDidLoad() {
        super.viewDidLoad()
        
        NotificationCenter.default.addObserver(self, selector: #selector(refreshList), name: NSNotification.Name(rawValue: "logistDetail"), object: nil)
        
        //        let tap = UITapGestureRecognizer(target: self, action: #selector(closeTimeSelect))
        //        contentView.addGestureRecognizer(tap)
        timeBgH.constant = 0
        scvContentH.constant = 680
        
        setBtnArr()
        
        orderNumTF.tag = 1
        orderNumTF.delegate = self
        standerTF.delegate = self
        
        navbar.title = "运单列表"
        self.view.addSubview(navbar)
        SetTopFrame(view: topView, height: 51)
        listView.separatorStyle = .none
        listView.register(UINib(nibName: "YunDanLieBiaoCell", bundle: nil), forCellReuseIdentifier: "YunDanLieBiaoCell")
        
        let searchBr = SearchBarView.init()
        searchVBg.addSubview(searchBr)
        searchBr.snp.makeConstraints { (make) in
            make.left.equalTo(10)
            make.right.equalTo(-10)
            make.centerY.equalToSuperview()
            make.height.equalTo(35)
        }
        searchV = searchBr
        searchBr.placeholderStr = "请输入运单号/收货人/发货人/地址"
        searchBr.cornerRadius = 35/2.0
        searchBr.delegate = self
        searchBr.delegateL = self
        
        
        headerMJ.setRefreshingTarget(self, refreshingAction: #selector(loadData))
        self.listView!.mj_header = headerMJ
        self.listView.mj_header?.beginRefreshing()
        footerMJ.setRefreshingTarget(self, refreshingAction: #selector(loadMoreData))
        self.listView!.mj_footer = footerMJ
        self.listView?.mj_header?.beginRefreshing()
        
    }
    func btnUISet(btn:UIButton){
        btn.isSelected = !btn.isSelected
        if btn.isSelected {
            btn.setTitleColor(UIColor.white, for: .normal)
            btn.backgroundColor = UIColor(named: "按钮渐变色上")
        }else{
            btn.setTitleColor(UIColor(named: "个人中心灰色字体"), for: .normal)
            btn.backgroundColor = UIColor(named: "多选按钮背景颜色")
        }
    }
    
    
    
    @IBAction func btnClick(_ sender: UIButton) {
        //        if sender.titleLabel!.text != "重置" && sender.titleLabel!.text != "确定"{
        //            btnUISet(btn: sender)
        //        }
        switch sender.titleLabel?.text {
        case "顺丰":
            for item in wlgsArr {
                if item.titleLabel!.text == sender.titleLabel?.text{
                    item.isSelected = true
                    item.setTitleColor(UIColor.white, for: .normal)
                    item.backgroundColor = UIColor(named: "按钮渐变色上")
                }else{
                    item.isSelected = false
                    item.setTitleColor(UIColor(named: "个人中心灰色字体"), for: .normal)
                    item.backgroundColor = UIColor(named: "多选按钮背景颜色")
                }
            }
            break
        case "货拉拉":
            for item in wlgsArr {
                if item.titleLabel!.text == sender.titleLabel?.text{
                    item.isSelected = true
                    item.setTitleColor(UIColor.white, for: .normal)
                    item.backgroundColor = UIColor(named: "按钮渐变色上")
                }else{
                    item.isSelected = false
                    item.setTitleColor(UIColor(named: "个人中心灰色字体"), for: .normal)
                    item.backgroundColor = UIColor(named: "多选按钮背景颜色")
                }
            }
            break
        case "京东":
            for item in wlgsArr {
                if item.titleLabel!.text == sender.titleLabel?.text{
                    item.isSelected = true
                    item.setTitleColor(UIColor.white, for: .normal)
                    item.backgroundColor = UIColor(named: "按钮渐变色上")
                }else{
                    item.isSelected = false
                    item.setTitleColor(UIColor(named: "个人中心灰色字体"), for: .normal)
                    item.backgroundColor = UIColor(named: "多选按钮背景颜色")
                }
            }
            break
        case "已付款":
            for item in zfztArr {
                if item.titleLabel!.text == sender.titleLabel?.text{
                    item.isSelected = true
                    item.setTitleColor(UIColor.white, for: .normal)
                    item.backgroundColor = UIColor(named: "按钮渐变色上")
                }else{
                    item.isSelected = false
                    item.setTitleColor(UIColor(named: "个人中心灰色字体"), for: .normal)
                    item.backgroundColor = UIColor(named: "多选按钮背景颜色")
                }
            }
            break
        case "未付款":
            for item in zfztArr {
                if item.titleLabel!.text == sender.titleLabel?.text{
                    item.isSelected = true
                    item.setTitleColor(UIColor.white, for: .normal)
                    item.backgroundColor = UIColor(named: "按钮渐变色上")
                }else{
                    item.isSelected = false
                    item.setTitleColor(UIColor(named: "个人中心灰色字体"), for: .normal)
                    item.backgroundColor = UIColor(named: "多选按钮背景颜色")
                }
            }
            break
        case "已退款":
            for item in zfztArr {
                if item.titleLabel!.text == sender.titleLabel?.text{
                    item.isSelected = true
                    item.setTitleColor(UIColor.white, for: .normal)
                    item.backgroundColor = UIColor(named: "按钮渐变色上")
                }else{
                    item.isSelected = false
                    item.setTitleColor(UIColor(named: "个人中心灰色字体"), for: .normal)
                    item.backgroundColor = UIColor(named: "多选按钮背景颜色")
                }
            }
            break
        case "全部":
            if sender.tag == 99 {
                //运单状态
                for item in ydztArr {
                    if item.titleLabel!.text == sender.titleLabel?.text{
                        item.isSelected = true
                        item.setTitleColor(UIColor.white, for: .normal)
                        item.backgroundColor = UIColor(named: "按钮渐变色上")
                    }else{
                        item.isSelected = false
                        item.setTitleColor(UIColor(named: "个人中心灰色字体"), for: .normal)
                        item.backgroundColor = UIColor(named: "多选按钮背景颜色")
                    }
                }
            }else if sender.tag == 101{
                //物流公司
                for item in wlgsArr {
                    if item.titleLabel!.text == sender.titleLabel?.text{
                        item.isSelected = true
                        item.setTitleColor(UIColor.white, for: .normal)
                        item.backgroundColor = UIColor(named: "按钮渐变色上")
                    }else{
                        item.isSelected = false
                        item.setTitleColor(UIColor(named: "个人中心灰色字体"), for: .normal)
                        item.backgroundColor = UIColor(named: "多选按钮背景颜色")
                    }
                }
            }else{
                //打印状态
                for item in dyztArr {
                    if item.titleLabel!.text == sender.titleLabel?.text{
                        item.isSelected = true
                        item.setTitleColor(UIColor.white, for: .normal)
                        item.backgroundColor = UIColor(named: "按钮渐变色上")
                    }else{
                        item.isSelected = false
                        item.setTitleColor(UIColor(named: "个人中心灰色字体"), for: .normal)
                        item.backgroundColor = UIColor(named: "多选按钮背景颜色")
                    }
                }
            }
            break
        case "已打印":
            for item in dyztArr {
                if item.titleLabel!.text == sender.titleLabel?.text{
                    item.isSelected = true
                    item.setTitleColor(UIColor.white, for: .normal)
                    item.backgroundColor = UIColor(named: "按钮渐变色上")
                }else{
                    item.isSelected = false
                    item.setTitleColor(UIColor(named: "个人中心灰色字体"), for: .normal)
                    item.backgroundColor = UIColor(named: "多选按钮背景颜色")
                }
            }
            break
        case "未打印":
            for item in dyztArr {
                if item.titleLabel!.text == sender.titleLabel?.text{
                    item.isSelected = true
                    item.setTitleColor(UIColor.white, for: .normal)
                    item.backgroundColor = UIColor(named: "按钮渐变色上")
                }else{
                    item.isSelected = false
                    item.setTitleColor(UIColor(named: "个人中心灰色字体"), for: .normal)
                    item.backgroundColor = UIColor(named: "多选按钮背景颜色")
                }
            }
            break
        case "下单完成":
            for item in ydztArr {
                if item.titleLabel!.text == sender.titleLabel?.text{
                    item.isSelected = true
                    item.setTitleColor(UIColor.white, for: .normal)
                    item.backgroundColor = UIColor(named: "按钮渐变色上")
                }else{
                    item.isSelected = false
                    item.setTitleColor(UIColor(named: "个人中心灰色字体"), for: .normal)
                    item.backgroundColor = UIColor(named: "多选按钮背景颜色")
                }
            }
            break
        case "揽收成功":
            for item in ydztArr {
                if item.titleLabel!.text == sender.titleLabel?.text{
                    item.isSelected = true
                    item.setTitleColor(UIColor.white, for: .normal)
                    item.backgroundColor = UIColor(named: "按钮渐变色上")
                }else{
                    item.isSelected = false
                    item.setTitleColor(UIColor(named: "个人中心灰色字体"), for: .normal)
                    item.backgroundColor = UIColor(named: "多选按钮背景颜色")
                }
            }
            break
        case "运输中":
            for item in ydztArr {
                if item.titleLabel!.text == sender.titleLabel?.text{
                    item.isSelected = true
                    item.setTitleColor(UIColor.white, for: .normal)
                    item.backgroundColor = UIColor(named: "按钮渐变色上")
                }else{
                    item.isSelected = false
                    item.setTitleColor(UIColor(named: "个人中心灰色字体"), for: .normal)
                    item.backgroundColor = UIColor(named: "多选按钮背景颜色")
                }
            }
            break
        case "已签收":
            for item in ydztArr {
                if item.titleLabel!.text == sender.titleLabel?.text{
                    item.isSelected = true
                    item.setTitleColor(UIColor.white, for: .normal)
                    item.backgroundColor = UIColor(named: "按钮渐变色上")
                }else{
                    item.isSelected = false
                    item.setTitleColor(UIColor(named: "个人中心灰色字体"), for: .normal)
                    item.backgroundColor = UIColor(named: "多选按钮背景颜色")
                }
            }
            break
        case "已取消":
            for item in ydztArr {
                if item.titleLabel!.text == sender.titleLabel?.text{
                    item.isSelected = true
                    item.setTitleColor(UIColor.white, for: .normal)
                    item.backgroundColor = UIColor(named: "按钮渐变色上")
                }else{
                    item.isSelected = false
                    item.setTitleColor(UIColor(named: "个人中心灰色字体"), for: .normal)
                    item.backgroundColor = UIColor(named: "多选按钮背景颜色")
                }
            }
            break
        case "重置":
            print("12")
            contentView.subviews.forEach { (item) in
                if item.isKind(of: UITextField.classForCoder()){
                    print("1")
                    let tf = item as! UITextField
                    tf.text = ""
                }
                if item.isKind(of: UIButton.classForCoder()){
                    print("2")
                    let btn = item as! UIButton
                    btn.isSelected = false
                    if btn.tag != 996 {
                        btn.setTitleColor(UIColor(named: "个人中心灰色字体"), for: .normal)
                        btn.backgroundColor = UIColor(named: "多选按钮背景颜色")
                    }
                }
            }
            
            calendarV.clearTheSelect()
            BeginDate = nil
            EndDate = nil
            lc_id = ""
            pay_status = ""
            delivery_status = ""
            order_sn = ""
            sale_plat = ""
            
            break
        case "确定":
            preView.isHidden = true
            blackBtn.isHidden = true
            listView.mj_header?.beginRefreshing()
            
            var wlgsStr = ""
            var zfztStr = ""
            var dyztStr = ""
            var ydztStr = ""
            for item in wlgsArr {
                if item.isSelected {
                    wlgsStr = item.titleLabel?.text as! String
                }
            }
            for item in zfztArr {
                if item.isSelected {
                    zfztStr = item.titleLabel?.text as! String
                }
            }
            for item in dyztArr {
                if item.isSelected {
                    dyztStr = item.titleLabel?.text as! String
                }
            }
            for item in ydztArr {
                if item.isSelected {
                    ydztStr = item.titleLabel?.text as! String
                }
            }
            switch wlgsStr {
            case "全部":
                lc_id = ""
            case "顺丰":
                lc_id = "2"
            case "京东":
                lc_id = "1"
            case "货拉拉":
                lc_id = "11"
            default:
                lc_id = ""
                break
            }
            switch zfztStr {
            case "已付款":
                pay_status = "2"
            case "未付款":
                pay_status = "1"
            case "已退款":
                pay_status = "3"
            default:
                pay_status = ""
                break
            }
            switch ydztStr {
            case "下单完成":
                delivery_status = "1"
            case "揽收成功":
                delivery_status = "2"
            case "运输中":
                delivery_status = "3"
            case "已签收":
                delivery_status = "4"
            case "已取消":
                delivery_status = "5"
            default:
                delivery_status = ""
                break
            }
            print(wlgsStr,zfztStr,dyztStr,ydztStr)
            break
        default:
            break
        }
    }
    
    
    func tableView(_ tableView: UITableView, didSelectRowAt indexPath: IndexPath) {
        let rowModel = datas[indexPath.row]

        if rowModel.lc_name == "货拉拉" {
            let vc = WaybillDetailViewController()
            vc.lwb_no = rowModel.lwb_no!
            self.navigationController?.pushViewController(vc, animated: true)
        }else{
            let vc = YunDanXiangQingViewController()
            vc.orderID = rowModel.id
            self.navigationController?.pushViewController(vc, animated: true)
        }

    }
    var BeginDate: Date! = nil
    var EndDate: Date! = nil
    @IBAction func timeSelectAction(_ sender: Any) {
        print("选择时间")
        if timeBgH.constant == 235 {
            timeBgH.constant = 0
            scvContentH.constant = 680
            calendarV.removeFromSuperview()
            
        }else{
            timeBgH.constant = 235
            scvContentH.constant = 915
            
            calendarV.moreSelection = true
            timeBgView.addSubview(calendarV)
            calendarV.delegate = self
            
            if BeginDate != nil {
                calendarV.setOldDate(beginD: BeginDate!, endD: EndDate!)
            }
        }
        
    }
    //MARK:--日历代理
    func selectMoreDate(beginDate: Date, endginDate: Date) {
        //bug
        let timeInterval:TimeInterval = beginDate.timeIntervalSince1970
        let timeIntervalEnd:TimeInterval = endginDate.timeIntervalSince1970
        
        timeTF.text = dayByDouble(sender: timeInterval) + "," + dayByDouble(sender: timeIntervalEnd)
        EndDate = endginDate
        BeginDate = beginDate
        
    }
    //MARK: - 加载数据
    var start_time = 0
    var end_time = 0
    var lc_id = "" //物流公司id    下单物流 1京东 2顺丰
    var order_sn = ""
    var sale_plat = "" //所属平台
    var pay_status = "" //运单运费支付状态：1待支付 2已支付 3已退款
    var delivery_status = "" //运单状态：1下单完成 2揽收成功 3运输中 4已签收 5已取消 6拒收 7再投
    
    var page = 1
    @objc func loadData(){
        print("加载数据")
        removeBlackBtnView()
        page = 1 
        if BeginDate == nil {
            start_time = 0
            end_time = 0
        }else{
            let timeInterval:TimeInterval = BeginDate!.timeIntervalSince1970
            let timeIntervalEnd:TimeInterval = EndDate!.timeIntervalSince1970
            start_time = Int(timeInterval)
            end_time = Int(timeIntervalEnd)
        }
        
        let UserToken = UserDefaults.standard.value(forKey: "user_token")
        
        jdOrderList(["user_token":UserToken as Any,"keyword":keyWord as Any,"start_time":start_time as Any,"end_time":end_time as Any,"lc_id":lc_id as Any,"order_sn":order_sn as Any,"sale_plat":sale_plat as Any,"pay_status":pay_status as Any,"delivery_status":delivery_status as Any,"page":page as Any], success: { (data) in
            
            self.datas.removeAll()
            let dataModel = data as! LogisticsModel
            if dataModel.code == 1 {
                self.datas = dataModel.data!
                
                self.page = 2
            }
            self.listView.mj_header?.endRefreshing()
            self.listView.reloadData()
            
        }) { (error) in
            self.listView.mj_header?.endRefreshing()
            
        }
    }
    @objc func loadMoreData(){
        print("加载数据")
        removeBlackBtnView()
        
        if BeginDate == nil {
            start_time = 0
            end_time = 0
        }else{
            let timeInterval:TimeInterval = BeginDate!.timeIntervalSince1970
            let timeIntervalEnd:TimeInterval = EndDate!.timeIntervalSince1970
            start_time = Int(timeInterval)
            end_time = Int(timeIntervalEnd)
        }
        
        let UserToken = UserDefaults.standard.value(forKey: "user_token")
        
        jdOrderList(["user_token":UserToken as Any,"keyword":keyWord as Any,"start_time":start_time as Any,"end_time":end_time as Any,"lc_id":lc_id as Any,"order_sn":order_sn as Any,"sale_plat":sale_plat as Any,"pay_status":pay_status as Any,"delivery_status":delivery_status as Any,"page":page as Any], success: { (data) in
            
            let dataModel = data as! LogisticsModel
            if dataModel.code == 1 {
                
                dataModel.data?.forEach({ (item) in
                    self.datas.append(item)
                })
                
                self.page = self.page + 1
            }
            self.listView.reloadData()
            self.listView?.mj_footer?.endRefreshing()
            
        }) { (error) in
            self.listView?.mj_footer?.endRefreshing()
            
        }
    }
    
    
    //MARK:--搜索模块
    //MAKR:--调起搜索后添加个蒙版本
    var blackBtnView:UIButton! = nil
    func searchBarShouldBeginEditing(_ searchBar: UISearchBar) -> Bool {
        print("调起搜索后添加个蒙版本")
        
        blackBtn.isHidden = true
        preView.isHidden = true
        blackBtnView = UIButton ()
        blackBtnView.backgroundColor = UIColor.init(named: "提示视图背景色")
        view.addSubview(blackBtnView)
        blackBtnView.snp.makeConstraints { (make) in
            make.left.right.bottom.equalToSuperview()
            make.top.equalTo(searchVBg.snp_bottom)
        }
        blackBtnView.addTarget(self, action: #selector(removeBlackBtnView), for: .touchUpInside)
        return true
    }
    @objc func removeBlackBtnView(){
        if blackBtnView != nil {
            blackBtnView.removeFromSuperview()
            searchV!.resignFirstResponder()
        }
    }
    
    //MARK:--搜索按钮代理
    func searchBarSearchButtonClicked(_ searchBar: UISearchBar) {
        print("点击搜索关键字进行--\(searchBar.text)")
        searchBar.resignFirstResponder()
        if blackBtnView != nil {
            blackBtnView.removeFromSuperview()
        }
        
        keyWord = searchBar.text!
        listView.mj_header?.beginRefreshing()
    }
    
    //MARK:--清空搜索代理
    func clearSearchAction() {
        
    }
    //MARK:--编辑即将结束
    func searchBarTextDidEndEditing(_ searchBar: UISearchBar) {
        print("编辑即将结束了--")
        removeBlackBtnView()
        if keyWord.count > 0 {
            keyWord = searchBar.text!
            if keyWord.count == 0 {
                listView.mj_header?.beginRefreshing()
            }
        }
    }
    func tableView(_ tableView: UITableView, heightForRowAt indexPath: IndexPath) -> CGFloat {
        
        let rowModel = datas[indexPath.row]
        
        if rowModel.lc_name == "货拉拉" {
            if rowModel.delivery_status == 1 {
                return 257
            }
            if rowModel.delivery_status == 4 && rowModel.pay_status == 1   {
                return 257

            }
            return 227
        }
        
        if rowModel.delivery_status == 1 {
            return 257
        }
        if ((rowModel.freight)! > 0) && rowModel.pay_status == 1 {
            return 257
            
        }
        
        return 227
    }
    func tableView(_ tableView: UITableView, numberOfRowsInSection section: Int) -> Int {
        return datas.count
    }
    
    func tableView(_ tableView: UITableView, cellForRowAt indexPath: IndexPath) -> UITableViewCell {
        let cell = tableView.dequeueReusableCell(withIdentifier: "YunDanLieBiaoCell") as! YunDanLieBiaoCell
        
        cell.delegate = self
        cell.tag = indexPath.row
        
        cell.acButton.isHidden = true
        
        let rowModel = datas[indexPath.row]
        if rowModel.lc_name == "货拉拉" {
            if rowModel.delivery_status == 1 {
                cell.acButton.isHidden = false
                cell.acButton.setTitle("取消运单", for: .normal)
                
            }
            if rowModel.delivery_status == 4 && rowModel.pay_status == 1   {
                cell.acButton.isHidden = false
                cell.acButton.setTitle("支付运费", for: .normal)
            }
        }else{
            if rowModel.delivery_status == 1 {
                cell.acButton.isHidden = false
                cell.acButton.setTitle("取消运单", for: .normal)
            }
            if ((rowModel.freight)! > 0) && rowModel.pay_status == 1 {
                cell.acButton.isHidden = false
                cell.acButton.setTitle("支付运费", for: .normal)
            }
        }

        cell.acButton.tag = indexPath.row
        
        cell.title1.text = "运单号：" + rowModel.lwb_no!
        cell.title2.text = rowModel.lc_name!
        cell.senderLbl.text = rowModel.s_city_name!
        cell.receiverLbl.text = rowModel.r_city_name!
        cell.statusLbl.text = rowModel.delivery_status_cn!
        
        cell.productNameLbl.text = "寄托物：" + rowModel.express_item_name!
        cell.signLbl.text = "签收状态：-"
        cell.standerLbl.text = "订单平台：" + rowModel.sale_plat!
        
        if rowModel.sale_plat?.count == 0 {
            cell.standerLbl.text = "订单平台：-"
        }
        cell.timeLbl.text = "签收时间：" + dayByDouble(sender: rowModel.sign_time!)
        if rowModel.sign_time! == 0 {
            cell.timeLbl.text = "签收时间：-"
        }
        cell.orderNumLbl.text = "订单号：" + rowModel.order_sn!
        if rowModel.order_sn?.count == 0 {
            cell.orderNumLbl.text = "订单号：-"
        }

        
        return cell
    }
    //MARK:--cell 按钮方法
    var paymentView:PaymentView?
    var selectIndex: Int?
    func YunDanLieBiaoCellAction(sender: UIButton) {
        

        
        let rowModel = datas[sender.tag]
        if rowModel.lc_name == "货拉拉" {
            let vc = WaybillDetailViewController()
            vc.lwb_no = rowModel.lwb_no!
            self.navigationController?.pushViewController(vc, animated: true)
            return
        }
        
        selectIndex = sender.tag
        switch sender.titleLabel?.text {
        case "支付运费":
            if paymentView == nil{
                paymentView = PaymentView(frame: view.bounds)
                paymentView?.delegate = self
                paymentView?.price = rowModel.freight
                view.addSubview(paymentView!)
            }
            break
        case "取消运单":
            let alertView = GeliAlertView(frame: self.view.window!.bounds)
            alertView.delegate = self;
            alertView.tishiLbl.text = ""
            alertView.titileLbl.text = "是否取消运单？"
            alertView.rightBtn.setAttributedTitle(NSAttributedString(string: "确定"), for: .normal)
            alertView.rightBtn.tag = sender.tag
            self.view.window?.addSubview(alertView)
            break
        default:
            break
        }
    }
    func textFieldDidBeginEditing(_ textField: UITextField) {
        if (orderNumTF == textField) {
            order_sn = orderNumTF.text!
        }
        if (standerTF == textField) {
            sale_plat = standerTF.text!
        }
    }
    func textFieldDidEndEditing(_ textField: UITextField) {
        if (orderNumTF == textField) {
            order_sn = orderNumTF.text!
        }
        if (standerTF == textField) {
            sale_plat = standerTF.text!
        }
    }
    
}
