//
//  CGDListVC.swift
//  GeliBusinessPlatform
//
//  Created by junye lu on 2020/6/12.
//  Copyright © 2020 junye lu. All rights reserved.
//

import UIKit
import ViewAnimator //cell动效

class CGDListVC: BaseViewController , UITableViewDelegate, UITableViewDataSource, GeliAlertViewDelegate,CGDListCell2Delegate,CGDXQVcDelegate,XinCaiGouViewControllerDelegate,NewRKVcDelegate,GeliAlertTextViewDelegate, CGDListCellDelegate{
    var po_id:Int?
    func sureGeliAlertTextViewAction(sender: String) {
        if isPass == false {
            if sender.count == 0 {
                HUD.flash(.label("请填写不通过原因"), delay: 1.2)
                return
            }
            HUD.flash(.progress)
            let dict = ["user_token":UserToken as Any,"po_id":po_id as Any,"order_status":3 as Any,"reason":sender as Any]
            purchaseOrderAudit(dict, success: { (data) in
                HUD.hide()
                
                self.listView.mj_header?.beginRefreshing()
                
            }) { (error) in
                
            }
        }else{
            HUD.flash(.progress)
            let dict = ["user_token":UserToken as Any,"po_id":po_id as Any,"order_status":2 as Any,"reason":sender as Any]
            purchaseOrderAudit(dict, success: { (data) in
                HUD.hide()
                self.isPass = false
                self.listView.mj_header?.beginRefreshing()
            }) { (error) in
                
            }
        }
        
    }
    
    func NewRKVcFinish() {
        listView.mj_header?.beginRefreshing()
    }
    
    func XinCaiGouViewControllerFinish() {
        listView.mj_header?.beginRefreshing()
    }
    
    
    func sureGeliAlertViewAction(sender: UIButton) {
        let dict = ["user_token":UserToken as Any,"po_id":sender.tag as Any]
        if isBackOut {
            backOut(dict, success: { (data) in
                HUD.hide()
                HUD.flash(.labeledSubSuccess(subtitle: "撤销成功"), delay: 1.2)
                self.isBackOut = false //关闭进入撤销状态
                self.listView.mj_header?.beginRefreshing()
            }) { (error) in
                
            }
        }else{
            cancelPurchaseOrder(dict, success: { (data) in
                self.listView.mj_header?.beginRefreshing()
            }) { (err) in
                
            }
        }
    }
    
    deinit {
           /// 移除通知
           NotificationCenter.default.removeObserver(self)
       }
    func CGDXQVcChangePayStatus(){
       NotificationCenter.default.post(name: NSNotification.Name("updateXQ"), object: self, userInfo: nil)
    }
    
    func CGDXQVcFinishAction() {
        listView.mj_header?.beginRefreshing()
    }
    
    var page : Int = 0
    var isUpData = false
    var keyword = ""
    var orderStatus = 1
    let UserToken = UserDefaults.standard.value(forKey: "user_token")
    
    var datas:Array<PurchaseOrderListDataModel> = []
    
    override func viewDidLoad() {
        super.viewDidLoad()
        switch self.title {
        case "待审核":
            orderStatus = 1
            break
        case "已通过":
            orderStatus = 2
            break
        case "未通过":
            orderStatus = 3
            break
        case "已完成":
            orderStatus = 5
            break
        default:
            break
        }
        setTabv()
        
        // Do any additional setup after loading the view.
    }
    
    
    //MARK:--VC 初始化
    convenience init(title: String) {
        self.init(title: title, content: "")
    }
    init(title: String, content: String) {
        super.init(nibName: nil, bundle: nil)
        self.title = title
    }
    
    required init?(coder: NSCoder) {
        fatalError("init(coder:) has not been implemented")
    }
    //MARK: - CELL DELEGATE
    func tableView(_ tableView: UITableView, numberOfRowsInSection section: Int) -> Int {
        return datas.count
    }
    var isGm = false
    
    func tableView(_ tableView: UITableView, cellForRowAt indexPath: IndexPath) -> UITableViewCell {
        let cell = tableView.dequeueReusableCell(withIdentifier: "CGDListCell2") as! CGDListCell2
        let model = datas[indexPath.row]
        cell.cgDataArr = model.goods_res
        cell.nameLbl.text = model.po_no!
//        cell.orderNumerLbl.text = model.po_no!
        cell.statusLbl.isHidden = true
        var status = ""
        if orderStatus == 2 {
            cell.statusLbl.isHidden = false
            switch model.pay_status {
            case 1:
                status = "未付款"
                break
            case 2:
                status = "已付款"
                break
            case 3:
                status = "月结"
                break
            default:
                status = "欠款"
                break
            }
            cell.statusLbl.text = status
        }

        cell.countLbl.text = "\(model.total_num!)"
        cell.priceLbl.text = model.total_amount!
        cell.timeLbl.text = dayAndTimeByDouble(sender:Double(model.purchase_time!))
        
        var btnStr:Array<String> = []
        switch model.order_status {
        //订单状态（1未审核，2审核通过，3审核不通过，4已撤销，5已完成）
        case 1:
            if isGm {
                btnStr = ["通过","不通过"]
            }else{
                btnStr = ["修改信息","取消"]
            }
            break
        case 2,5://入库状态（1未入库，2部分入库，3已入库）
            switch model.push_status {
            case 1:
                btnStr = ["查看详情","入库",]
                break
            case 2:
                btnStr = ["查看详情","撤销入库","补录入库"]
                break
            default:
                btnStr = ["查看详情","撤销入库"]
                break
            }
            break
        case 3:
            btnStr = ["查看详情"]
            break
        default:
            break
        }
        cell.delegate = self
        cell.setCGDBtnUI(arr: btnStr, index: indexPath.row)
        return cell
    }
    var isPowerful = false
    func tableView(_ tableView: UITableView, didSelectRowAt indexPath: IndexPath) {
        let model = datas[indexPath.row]
        let vc = CGDXQVc()
        vc.po_id = model.po_id
        vc.delegate = self
        self.navigationController?.pushViewController(vc, animated: true)
    }
    var isBackOut = false //撤销入库状态:默认关闭
    var isPass =  false
    //MARK: - 点击cell 按钮
    func allBtnSubmit(sender: UIButton) {
        let model = datas[sender.tag]
        switch sender.titleLabel?.text {
        case "通过":
            isPass = true
            let alterView = GeliAlertTextView(frame: self.view.window!.bounds)
            alterView.delegate = self
            po_id = model.po_id
            alterView.titleLbl.text = "请填写通过原因（选填）"
            alterView.placerLbl.text = "请填写通过原因..."
            self.view.window?.addSubview(alterView)
            break
        case "不通过":
            let alterView = GeliAlertTextView(frame: self.view.window!.bounds)
            alterView.delegate = self
            po_id = model.po_id
            alterView.titleLbl.text = "请填写不通过原因（必填）"
            alterView.placerLbl.text = "请填写不通过原因..."
            self.view.window?.addSubview(alterView)
            break
        case "撤销入库":
            isBackOut = true//撤销入库状态:打开
            let alertView = GeliAlertView(frame: self.view.window!.bounds)
            alertView.delegate = self;
            alertView.tishiLbl.text = ""
            alertView.titileLbl.text = "是否撤销入库？"
            alertView.rightBtn.setAttributedTitle(NSAttributedString(string: "确定"), for: .normal)
            alertView.rightBtn.tag = model.po_id!
            self.view.window?.addSubview(alertView)
            break
        case "入库","补录入库":
            var rkDatas:Array<InputInitInfoGoodsInfoModel> = []
            model.goods_res?.forEach({ (item) in
                if item.no_push_num != 0 {
                let dict = [
                    "sku_id":item.sku_id as Any,
                    "goods_id":item.goods_id as Any,
                    "goods_name":item.goods_name as Any,
                    "spec_str":item.sku_name as Any,
                    "goods_thumb":"" as Any,
                    "price":item.price as Any,
                    "inventory":0 as Any,
                    "warehouse_inventory":0 as Any,
                    "BZQ":"" as Any,
                    "ZJ":"" as Any,
                    "RKSL":"" as Any,
                    "RKJG":"" as Any,
                    "DayType":1 as Any,
                    "createDay":"" as Any,
                    "createDayStr":"" as Any,
                    "chuKuLiang":"" as Any,
                    "pog_id":item.pog_id as Any,
                    "no_push_num":item.no_push_num as Any
                ]
                let mo = InputInitInfoGoodsInfoModel(JSON: dict)
                rkDatas.append(mo!)
                }
            })
            let vc = NewRKVc()
            vc.isCaiGou = true
            vc.rkSelectArr = rkDatas
            vc.po_id = model.po_id!
            vc.delegate = self
            vc.orderNumStr = model.po_no! as! String
            self.navigationController?.pushViewController(vc, animated: true)
            break
        case "修改信息":
            let vc = XinCaiGouViewController()
            vc.delegate = self
            vc.cgName = model.purchaser!
            vc.orderNum = model.po_no!
            vc.po_id = model.po_id!
            vc.ven_id = model.ven_id!
            vc.ven_name = model.ven_name!
            vc.dayTime = model.purchase_time!
            vc.contentStr = model.remarks!
            vc.typeSelect = model.type! - 1
            
            model.goods_res?.forEach({ (item) in
                let dict = [
                    "goods_name":item.goods_name as Any,
                    "goods_id":item.goods_id as Any,
                    "sku_id":item.sku_id as Any,
                    "spec_str":item.sku_name as Any,
                    "unit":item.unit as Any,
                    "price":item.price as Any,
                    "target_Count":item.num as Any,
                    "target_Price":item.amount as Any,
                    "pog_id":item.pog_id as Any
                    ] as [String : Any]
                let mo = GetGoodsInfoDataModel(JSON: dict)
                
                vc.datas.append(mo!)
                vc.recordArr.append(mo!)
            })
            self.navigationController?.pushViewController(vc, animated: true)
            break
        case "取消":
            let alertView = GeliAlertView(frame: self.view.window!.bounds)
            alertView.delegate = self;
            alertView.tishiLbl.text = ""
            alertView.titileLbl.text = "是否取消？"
            alertView.rightBtn.setAttributedTitle(NSAttributedString(string: "确定"), for: .normal)
            alertView.rightBtn.tag = model.po_id!
            self.view.window?.addSubview(alertView)
            break
        default:
            break
        }
    }
    
    //MARK: - alertView delegate
    
    
    //MARK:-- tablev 处理
    var listView :UITableView!
    var tableSearchV :UITableView! = nil
    
    private let animations = [AnimationType.from(direction: .bottom, offset: 300*glscale)]
    
    func setTabv() {
        listView = UITableView()
        view.addSubview(listView);
        listView.snp.makeConstraints { (make) in
            make.top.left.right.bottom.equalToSuperview()
        }
        listView.backgroundColor = UIColor.init(named: "app底色")
        listView.delegate = self
        listView.dataSource = self
        listView.separatorStyle = .none
        listView?.register(UINib(nibName: "CGDListCell2", bundle: nil), forCellReuseIdentifier: "CGDListCell2")
        
        let footerTbV = UIView(frame: CGRect(x: 0, y: 0, width: view.frame.size.width, height: 15*glscale))
        footerTbV.backgroundColor = UIColor.init(named: "app底色")
        listView.tableFooterView = footerTbV
        
        //下拉刷新相关设置
        headerMJ.setRefreshingTarget(self, refreshingAction: #selector(loadData))
        self.listView!.mj_header = headerMJ
        //上拉加载相关设置
        footerMJ.setRefreshingTarget(self, refreshingAction: #selector(loadMoreData))
        self.listView!.mj_footer = footerMJ
        self.listView?.mj_header?.beginRefreshing()
        
    }
    
    //MARK:--加载数据
    @objc func loadData(){
        print("加载数据")
        isUpData = true
        page = 1
        
        let dic = ["user_token":UserToken as Any,"keyword":keyword as Any,"page":page as Any,"order_status":orderStatus as Any]
        purchaseOrderList(dic, success: { (data) in
            self.datas.removeAll()
            let model = data as! PurchaseOrderListModel
            print("model.data?.purchase_auth? == ",model.data?.purchase_auth)
            if model.data?.purchase_auth != nil {
                if (model.data?.purchase_auth?.contains("119"))!{
                    self.isGm = true
                }
            }
            
            model.data?.list?.forEach({ (item) in
                self.datas.append(item)
            })
            self.listView.reloadData()
            self.listView?.mj_header?.endRefreshing()
            self.page = 2
            self.listView.performBatchUpdates({
                UIView.animate(views: self.listView!.visibleCells,
                               animations: self.animations, completion: {
                                
                })
                if model.data?.list?.count == 0 {
                    self.listView?.mj_footer?.endRefreshingWithNoMoreData()
                }else{
                    self.listView?.mj_footer?.endRefreshing()
                }
            }, completion: nil)
        }) { (error) in
            self.listView?.mj_header?.endRefreshing()
        }
    }
    
    //MARK:--加载更多数据
    @objc func loadMoreData(){
        print("加载更多数据")
        
        let dic = ["user_token":UserToken as Any,"keyword":keyword as Any,"page":page as Any,"order_status":orderStatus as Any]
        purchaseOrderList(dic, success: { (data) in
            let model = data as! PurchaseOrderListModel
            if model.data?.list?.count == 0 {
                self.listView?.mj_footer?.endRefreshingWithNoMoreData()
            }else{
                self.page += 1
                model.data?.list?.forEach({ (model) in
                    self.datas.append(model)
                })
                self.listView.reloadData()
                self.listView?.mj_footer?.endRefreshing()
            }
        }) { (error) in
            self.listView?.mj_footer?.endRefreshing()
        }
    }
    func tableView(_ tableView: UITableView, heightForRowAt indexPath: IndexPath) -> CGFloat {
        let model = self.datas[indexPath.row]
        
        if model.goods_res!.count > 4 {
            return CGFloat(200 + (49 * 4))
        }
        return CGFloat(200 + (49 * model.goods_res!.count))
    }
}
