//
//  CGDListViewController.swift
//  GeliBusinessPlatform
//
//  Created by junye lu on 2020/6/12.
//  Copyright © 2020 junye lu. All rights reserved.
//

import UIKit
import Parchment

class CGDListViewController: BaseViewController  ,UISearchBarDelegate, SearchBarViewDelegate, PagingViewControllerDelegate ,XinCaiGouViewControllerDelegate{
    func XinCaiGouViewControllerFinish() {
        let vc = viewControllers[selectIndex]
        vc.listView.mj_header?.beginRefreshing()
    }
    
    @IBOutlet weak var contentView: UIView!
    @IBOutlet weak var searchBg: UIView!
    func clearSearchAction() {
        
    }  
    //头部滚动视图
    weak var pagingVC : PagingViewController?
    fileprivate let cities = [
        "待审核",
        "已通过",
        "未通过",
        "已完成"
    ]
    let viewControllers = [
        CGDListVC(title: "待审核"),
        CGDListVC(title: "已通过"),
        CGDListVC(title: "未通过"),
        CGDListVC(title: "已完成"),
    ]
    
    var searchV : SearchBarView? = nil
    func rightBtnClick() {
        
        removeBlackBtnView()
        
        let vc = XinCaiGouViewController()
        vc.delegate = self
        self.navigationController?.pushViewController(vc, animated: true)
    }
    var vc1Refresh = false
    var vc2Refresh = false
    @objc func updateXQ(nofi : Notification){
        vc1Refresh = true
        vc2Refresh = true
        
        if vc1Refresh {
            let vc1 = viewControllers[1]
            if vc1.listView != nil {
                vc1.listView.mj_header?.beginRefreshing {
                    self.vc1Refresh = false
                }
            }
        }
        if vc2Refresh {
            let vc3 = viewControllers[3]
            if vc3.listView != nil {
                vc3.listView.mj_header?.beginRefreshing {
                    self.vc2Refresh = false
                }
            }
        }
    }
    deinit {
        /// 移除通知
        NotificationCenter.default.removeObserver(self)
    }
    override func viewDidLoad() {
        super.viewDidLoad()
        navbar.title = "采购列表"
        navbar.rightTitle = "新增"
        self.view.addSubview(navbar)
        
        NotificationCenter.default.addObserver(self, selector: #selector(updateXQ), name: NSNotification.Name(rawValue:"updateXQ"), object: nil)
        
        SetTopFrame(view: searchBg, height: 52)
        //searchbar
        let searchBr = SearchBarView.init()
        self.searchBg.addSubview(searchBr)
        searchBr.snp.makeConstraints { (make) in
            make.left.right.equalTo(0)
            make.centerY.equalToSuperview()
            make.height.equalTo(35)
        }
        searchV = searchBr
        searchBr.placeholderStr = "输入订单编号/制单人名称/采购人名称"
        searchBr.cornerRadius = 35/2.0
        searchBr.delegate = self
        searchBr.delegateL = self
        
        let pagingViewController = PagingViewController(viewControllers: viewControllers)
        pagingViewController.indicatorColor = UIColor.init(named: "蓝色字体颜色")!
        pagingViewController.menuItemSize = .fixed(width: 0, height: 44*glscale)
        pagingViewController.menuHorizontalAlignment = .left
        pagingViewController.font = UIFont.systemFont(ofSize: 13)
        pagingViewController.selectedFont = UIFont.systemFont(ofSize: 13)
        pagingViewController.textColor = UIColor.init(named: "灰色字体颜色")!
        pagingViewController.selectedTextColor = UIColor.init(named: "蓝色字体颜色")!
        pagingViewController.delegate = self
        pagingViewController.dataSource = self
        pagingViewController.sizeDelegate = self
        addChild(pagingViewController)
        contentView.addSubview(pagingViewController.view)
        contentView.constrainToEdges(pagingViewController.view)
        pagingViewController.didMove(toParent: self)
        pagingVC = pagingViewController
        
        
        pagingVC?.select(index: selectIndex)
        
    }
    //MARK:--搜索按钮代理
    var keyword = ""
    func searchBarSearchButtonClicked(_ searchBar: UISearchBar) {
        print("点击搜索进行--")
        searchBar.resignFirstResponder()
        keyword = searchBar.text!
        viewControllers.forEach { (vc) in
            vc.keyword = keyword
            vc.isUpData = false
        }
        let vc = viewControllers[selectIndex]
        vc.listView.mj_header?.beginRefreshing()
    }
    //MARK:--取消搜索代理
    
    func searchBarTextDidEndEditing(_ searchBar: UISearchBar) {
        print("编辑即将结束了--")
        removeBlackBtnView()
        if searchBar.text?.count == 0 && keyword.count != 0{
            keyword = searchBar.text!
            viewControllers.forEach { (vc) in
                vc.keyword = keyword
                vc.isUpData = false
            }
            let vc = viewControllers[selectIndex]
            vc.listView.mj_header?.beginRefreshing()
        }
    }
    //MAKR:--调起搜索后添加个蒙版本
    var blackBtnView:UIButton! = nil
    func searchBarShouldBeginEditing(_ searchBar: UISearchBar) -> Bool {
        print("调起搜索后添加个蒙版本")
        blackBtnView = UIButton ()
        blackBtnView.backgroundColor = UIColor.init(named: "提示视图背景色")
        contentView.addSubview(blackBtnView)
        blackBtnView.snp.makeConstraints { (make) in
            make.left.right.top.bottom.equalToSuperview()
        }
        blackBtnView.addTarget(self, action: #selector(removeBlackBtnView), for: .touchUpInside)
        return true
    }
    @objc func removeBlackBtnView(){
        if blackBtnView != nil {
            blackBtnView.removeFromSuperview()
            searchV!.resignFirstResponder()
        }
    }
    
    //MARK:---滚动选择
    var selectIndex = 0
    func pagingViewController(_ pagingViewController: PagingViewController, didScrollToItem pagingItem: PagingItem, startingViewController: UIViewController?, destinationViewController: UIViewController, transitionSuccessful: Bool) {
        guard let item = pagingItem as? PagingIndexItem else { return}
        print("滚动至vc\(item.index)")
        if selectIndex != item.index {
            selectIndex = item.index
            let vc = viewControllers[selectIndex]
            if !vc.isUpData {
                vc.listView.mj_header?.beginRefreshing()
            }
        }
    }
    
}
extension CGDListViewController: PagingViewControllerDataSource {
    
    func pagingViewController(_: PagingViewController, pagingItemAt index: Int) -> PagingItem {
        return PagingIndexItem(index: index, title: cities[index])
    }
    
    func pagingViewController(_: PagingViewController, viewControllerAt index: Int) -> UIViewController {
        return viewControllers[index]
    }
    
    func numberOfViewControllers(in pagingViewController: PagingViewController) -> Int {
        return cities.count
    }
    
}

extension CGDListViewController: PagingViewControllerSizeDelegate {
    func pagingViewController(_ pagingViewController: PagingViewController, widthForPagingItem pagingItem: PagingItem, isSelected: Bool) -> CGFloat {
        let width = fullScreenWidth / 4 * 0.9
        if isSelected {
            return width * 1.5
        } else {
            return width
        }
    }
}
