//
//  CGDListCell.swift
//  GeliBusinessPlatform
//
//  Created by junye lu on 2020/6/10.
//  Copyright © 2020 junye lu. All rights reserved.
//

import UIKit
protocol CGDListCellDelegate {
    func allBtnSubmit(sender: UIButton)
}
class CGDListCell: UITableViewCell {
    //先货后款图标
    @IBOutlet weak var beforeOrderLbl: UILabel!
    //销售下单图标
    @IBOutlet weak var formLbl: UILabel!
    ///预售图标
    @IBOutlet weak var yuShouStatus: UILabel!
     ///列表底图
    @IBOutlet weak var listBgView: UIView!
    ///按钮底图
    @IBOutlet weak var btnBgView: UIView!
    ///数量
    @IBOutlet weak var countLbl: UILabel!
    ///价格
    @IBOutlet weak var priceLbl: UILabel!
    ///状态
    @IBOutlet weak var statusLbl: UILabel!
    ///时间
    @IBOutlet weak var timeLbl: UILabel!
    @IBOutlet weak var orderNumerLbl: UILabel!
    
    @IBOutlet weak var formNSlayout: NSLayoutConstraint!
    
    @IBOutlet weak var beforeNSLayout: NSLayoutConstraint!
    
    var delegate:CGDListCellDelegate?
    
    //订单列表数据
    var dataArr:Array<OrderListGoodsModel>?
    //采购列表数据
    var cgDataArr:Array<PurchaseOrderListDataItemsModel>?
    
    override func awakeFromNib() {
        super.awakeFromNib()
        self.selectionStyle = .none
        // Initialization code
    }
    override func layoutIfNeeded() {
        if dataArr != nil {
            setListView(arr: dataArr!)
        }
        if cgDataArr != nil {
            setCGDListView(arr: cgDataArr!)
        }
        super.layoutIfNeeded()
        
    }
    
    func setCGDBtnUI(arr:Array<String>,index:Int){
        //按钮
        btnBgView.subviews.forEach { (view) in
            view.removeFromSuperview()
        }
        var tempBtn:UIButton? = nil
        arr.forEach { (str) in
            let rightBtn = UIButton(type: .custom)
            rightBtn.layer.borderWidth =  1
            rightBtn.tag = index
            rightBtn.backgroundColor = UIColor.white
            rightBtn.layer.borderColor = UIColor.init(named: "按钮渐变色上")?.cgColor
            rightBtn.setTitleColor(UIColor.init(named: "按钮渐变色上"), for: .normal)
            rightBtn.titleLabel?.font = UIFont.systemFont(ofSize: 13)
            rightBtn.layer.cornerRadius = 2
            rightBtn.isUserInteractionEnabled = true
            if str == "查看详情"{
                rightBtn.setTitle(str, for: .normal)
                rightBtn.isUserInteractionEnabled = false
            }else if str == "修改信息" || str == "通过"{
                rightBtn.setTitle(str, for: .normal)
                rightBtn.setTitleColor(UIColor.white, for: .normal)
                rightBtn.backgroundColor = UIColor.init(named: "按钮渐变色上")
                rightBtn.layer.borderColor = UIColor.init(named: "按钮渐变色上")?.cgColor
            }else if str  == "取消"{
                rightBtn.setTitle(str, for: .normal)
            }else if str  == "撤销入库"{
                rightBtn.setTitle(str, for: .normal)
            }else if str  == "入库"{
                rightBtn.setTitle(str, for: .normal)
            }else if str  == "补录入库"{
                rightBtn.setTitle(str, for: .normal)
            }else if str == "不通过"{
                rightBtn.setTitle(str, for: .normal)
            }
            
            
            btnBgView.addSubview(rightBtn)
            if tempBtn == nil {
                rightBtn.snp.makeConstraints { (make) in
                    make.width.equalTo(82*glscale)
                    make.height.equalTo(30)
                    make.right.equalTo(0)
                    make.top.equalTo(0)
                }
            }else{
                rightBtn.snp.makeConstraints { (make) in
                    make.width.equalTo(82*glscale)
                    make.height.equalTo(30)
                    make.right.equalTo(tempBtn!.snp_left).offset(-15)
                    make.top.equalTo(0)
                }
            }
            rightBtn.addTarget(self, action: #selector(btnAction(sender:)), for: .touchUpInside)
            tempBtn = rightBtn
        }
        
    }
    
    //订单列表设置底部按钮
    func setBtnView(arr:Array<String>,index:Int){
        //按钮
        btnBgView.subviews.forEach { (view) in
            view.removeFromSuperview()
        }
        
        var tempBtn:UIButton? = nil
        arr.forEach { (str) in
            
            let rightBtn = UIButton(type: .custom)
            rightBtn.layer.borderWidth =  1
            rightBtn.tag = index
            rightBtn.backgroundColor = UIColor.white
            rightBtn.layer.borderColor = UIColor.init(named: "按钮渐变色上")?.cgColor
            rightBtn.setTitleColor(UIColor.init(named: "按钮渐变色上"), for: .normal)
            rightBtn.titleLabel?.font = UIFont.systemFont(ofSize: 13)
            rightBtn.layer.cornerRadius = 3
            rightBtn.setTitle(str, for: .normal)

            btnBgView.addSubview(rightBtn)
            if tempBtn == nil {
                rightBtn.snp.makeConstraints { (make) in
                    if str.count > 4 {
                        make.width.equalTo(110*glscale)
                    }else{
                        make.width.equalTo(80*glscale)
                    }
                    make.height.equalTo(30)
                    make.right.equalTo(0)
                    make.top.equalTo(0)
                }
                rightBtn.setTitleColor(UIColor.white, for: .normal)
                rightBtn.backgroundColor = UIColor.init(named: "按钮渐变色上")
                rightBtn.layer.borderColor = UIColor.init(named: "按钮渐变色上")?.cgColor
            }else{
                rightBtn.snp.makeConstraints { (make) in
                    if str.count > 4 {
                        make.width.equalTo(110*glscale)
                    }else{
                        make.width.equalTo(80*glscale)
                    }
                    make.height.equalTo(30)
                    make.right.equalTo(tempBtn!.snp_left).offset(-15)
                    make.top.equalTo(0)
                }
            }
            rightBtn.addTarget(self, action: #selector(btnAction(sender:)), for: .touchUpInside)
            tempBtn = rightBtn
        }
    }
    //订单列表底部按钮方法
    @objc func btnAction(sender:UIButton){
        self.delegate?.allBtnSubmit(sender: sender)
    }
    
    //订单列表设置数据
    func setCGDListView(arr:Array<PurchaseOrderListDataItemsModel>){
        //列表
        listBgView.subviews.forEach { (view) in
            view.removeFromSuperview()
        }
        if arr.count > 0 {
            var num = 0
            if arr.count > 4 {
                num = 4
            }else{
                num = arr.count
            }
            for i in 0 ..< num {
                let model = arr[i]
                let view = UIView()
                listBgView.addSubview(view)
                view.backgroundColor = UIColor.white
                view.snp.makeConstraints { (make) in
                    make.top.equalTo(i * 49)
                    make.left.right.equalTo(0)
                    make.height.equalTo(49)
                }
                if i != num - 1 {
                    let dotLine = UIImageView()
                    view.addSubview(dotLine)
                    dotLine.image = UIImage(named: "dotLine")
                    dotLine.snp.makeConstraints { (make) in
                        make.left.equalTo(15)
                        make.bottom.right.equalTo(0)
                        make.height.equalTo(1)
                    }
                }
                let lbl = UILabel()
                lbl.font = UIFont.systemFont(ofSize: 13)
                lbl.textColor = UIColor(named: "灰色字体颜色")
                lbl.text = model.goods_name
                view.addSubview(lbl)
                lbl.snp.makeConstraints { (make) in
                    make.left.equalTo(15)
                    make.bottom.top.equalTo(0)
                    make.right.equalTo(-80*glscale)
                    
                }
                
                let lbl2 = UILabel()
                lbl2.font = UIFont.systemFont(ofSize: 13)
                lbl2.textColor = UIColor(named: "灰色字体颜色")
                lbl2.text = "x" + "\(model.num!)"
                lbl2.textAlignment = .right
                view.addSubview(lbl2)
                lbl2.snp.makeConstraints { (make) in
                    make.right.equalTo(-15)
                    make.bottom.left.top.equalTo(0)
                }
            }
        }
    }
    
    //订单列表设置数据
    func setListView(arr:Array<OrderListGoodsModel>){
        //列表
        listBgView.subviews.forEach { (view) in
            view.removeFromSuperview()
        }
        if arr.count > 0 {
            var num = 0
            if arr.count > 4 {
                num = 4
            }else{
                num = arr.count
            }
            for i in 0 ..< num {
                let model = arr[i]
                let view = UIView()
                listBgView.addSubview(view)
                view.backgroundColor = UIColor.white
                view.snp.makeConstraints { (make) in
                    make.top.equalTo(i * 49)
                    make.left.right.equalTo(0)
                    make.height.equalTo(49)
                }
                if i != num - 1 {
                    let dotLine = UIImageView()
                    view.addSubview(dotLine)
                    dotLine.image = UIImage(named: "dotLine")
                    dotLine.snp.makeConstraints { (make) in
                        make.left.equalTo(15)
                        make.bottom.right.equalTo(0)
                        make.height.equalTo(1)
                    }
                }
                let lbl = UILabel()
                lbl.font = UIFont.systemFont(ofSize: 13)
                lbl.textColor = UIColor(named: "灰色字体颜色")
                lbl.text = model.goods_name
                view.addSubview(lbl)
                lbl.snp.makeConstraints { (make) in
                    make.left.equalTo(15)
                    make.bottom.top.equalTo(0)
                    make.right.equalTo(-80*glscale)
                    
                }
                
                let lbl2 = UILabel()
                lbl2.font = UIFont.systemFont(ofSize: 13)
                lbl2.textColor = UIColor(named: "灰色字体颜色")
                lbl2.text = "x" + "\(model.goods_number!)"
                lbl2.textAlignment = .right
                view.addSubview(lbl2)
                lbl2.snp.makeConstraints { (make) in
                    make.right.equalTo(-15)
                    make.bottom.left.top.equalTo(0)
                }
            }
        }
    }
    
    override func setSelected(_ selected: Bool, animated: Bool) {
        super.setSelected(selected, animated: animated)
        
        // Configure the view for the selected state
    }
    
}
