//
//  CGDXQVc.swift
//  GeliBusinessPlatform
//
//  Created by junye lu on 2020/6/10.
//  Copyright © 2020 junye lu. All rights reserved.
//

import UIKit
protocol CGDXQVcDelegate {
    func CGDXQVcFinishAction()
    func CGDXQVcChangePayStatus()
}
class CGDXQVc: BaseViewController,UITableViewDelegate,UITableViewDataSource,GLAlertSelectViewDelegate,GeliAlertTextViewDelegate,GeliAlertViewDelegate,NewRKVcDelegate, XinCaiGouViewControllerDelegate {
    func XinCaiGouViewControllerFinish() {
        loadData()
    }
    
    func NewRKVcFinish() {
        loadData()
    }
    
    @IBOutlet weak var btmHeight: NSLayoutConstraint!
    
    func sureGeliAlertViewAction(sender: UIButton) {
        
        let dict = ["user_token":UserToken as Any,"po_id":po_id as Any]
        if isBackOut {
            backOut(dict, success: { (data) in
                HUD.hide()
                HUD.flash(.labeledSubSuccess(subtitle: "撤销成功"), delay: 1.2)
                self.delegate?.CGDXQVcFinishAction()
                self.isBackOut = false
                self.navigationController?.popViewController(animated: true)
            }) { (error) in
            }
        }else{
            cancelPurchaseOrder(dict, success: { (data) in
                HUD.hide()
                
                self.delegate?.CGDXQVcFinishAction()
                self.isBackOut = false
                self.navigationController?.popViewController(animated: true)
            }) { (err) in
                
            }
        }
    }
    
    var delegate:CGDXQVcDelegate?
    func sureGeliAlertTextViewAction(sender: String) {
        if isPass == false {
            if sender.count == 0 {
                HUD.flash(.label("请填写不通过原因"), delay: 1.2)
                return
            }
            HUD.flash(.progress)
            let dict = ["user_token":UserToken as Any,"po_id":po_id as Any,"order_status":3 as Any,"reason":sender as Any]
            purchaseOrderAudit(dict, success: { (data) in
                HUD.hide()
                HUD.flash(.labeledSubSuccess(subtitle: "提交成功"), delay: 1.2)
                self.delegate?.CGDXQVcFinishAction()
                self.navigationController?.popViewController(animated: true)
            }) { (error) in
                
            }
        }else{
            HUD.flash(.progress)
            let dict = ["user_token":UserToken as Any,"po_id":po_id as Any,"order_status":2 as Any,"reason":sender as Any]
            purchaseOrderAudit(dict, success: { (data) in
                HUD.hide()
                HUD.flash(.labeledSubSuccess(subtitle: "提交成功"), delay: 1.2)
                self.delegate?.CGDXQVcFinishAction()
                self.navigationController?.popViewController(animated: true)
            }) { (error) in
                
            }
        }
        
    }
    
    var isPass = false
    @IBOutlet weak var btmColor: UIView!
    @IBOutlet weak var btmView: UIView!
    @IBOutlet weak var listView: UITableView!
    var btnTitle:Array<String> = []
    var po_id:Int?
    let tArr = ["制单信息","商品信息"]
    var glSelectView:GLAlertSelectView?
    
    let UserToken = UserDefaults.standard.value(forKey: "user_token")
    
    //MARK: - cell delegate
    
    var titleArr = ["采购单号","采购日期","供应商","采购人","采购类型","支付方式","支付状态","备注","制单人"]
    var holderArr = ["-","-","-","-","-","未支付","未付款","-","-"]
    
    let zfTypeArr = ["未付款","已付款","月结","欠款"]
    
    let zfWayArr =  ["未支付","现金","转账（私）","转账（公）","转账（微信）","转账（支付宝）"]
    
    var payZt = 0//支付状态
    var payFs = 0//支付方式
    
    var model:PurchaseOrderDetailDataModel?
    
    
    override func viewDidLoad() {
        super.viewDidLoad()
        navbar.title = "采购单详情"
        self.view.addSubview(navbar)
        SetTopFrameView(view: listView, btmView: btmView)
        listView.separatorStyle = .none
        listView.register(UINib(nibName: "TitleAndTFCell", bundle: nil), forCellReuseIdentifier: "TitleAndTFCell")
        listView.register(UINib(nibName: "TitleAndBtnCell", bundle: nil), forCellReuseIdentifier: "TitleAndBtnCell")
        listView.register(UINib(nibName: "CGDCell1", bundle: nil), forCellReuseIdentifier: "CGDCell1")
        loadData()
    }
    
    func setBtnUI(){
        btmView.subviews.forEach { (view) in
            view.removeFromSuperview()
        }
        if btnTitle.count == 0 {
            btmView.isHidden = true
            btmColor.isHidden = true
            btmHeight.constant = 0
            btmColor.backgroundColor = UIColor(named: "app底色")
        }else{
            btmHeight.constant = 49
            btmColor.backgroundColor = UIColor.white
            let w = fullScreenWidth / CGFloat(btnTitle.count)
            for i in 0 ..< btnTitle.count {
                let btn = UIButton(frame: CGRect(x: CGFloat(i)*w, y: 0, width: w, height: 49))
                btmView.addSubview(btn)
                btn.setTitle(btnTitle[i], for: .normal)
                btn.setTitleColor(UIColor(named: "蓝色字体颜色"), for: .normal)
                if btnTitle[i] == "修改信息" || btnTitle[i] == "通过" {
                    btn.backgroundColor = UIColor(named: "蓝色字体颜色")
                    btn.setTitleColor(UIColor.white, for: .normal)
                }
                btn.titleLabel?.font = UIFont.systemFont(ofSize: 13)
                btn.addTarget(self, action: #selector(btmBtnClick(sender:)), for: .touchUpInside)
            }
        }
        
    }
    var isBackOut = false
    @objc func btmBtnClick(sender:UIButton){
        switch sender.titleLabel?.text {
        case "取消":
            let alertView = GeliAlertView(frame: self.view.window!.bounds)
            alertView.delegate = self;
            alertView.tishiLbl.text = ""
            alertView.titileLbl.text = "是否取消？"
            alertView.rightBtn.setAttributedTitle(NSAttributedString(string: "确定"), for: .normal)
            alertView.rightBtn.tag = model!.po_id!
            self.view.window?.addSubview(alertView)
            break
        case "修改信息":
            let vc = XinCaiGouViewController()
            vc.delegate = self
            vc.cgName = model?.purchaser! as! String
            vc.orderNum = model?.po_no!
            vc.po_id = model?.po_id!
            vc.ven_id = model?.ven_id!
            vc.ven_name = model?.ven_name!
            vc.dayTime = (model?.purchase_time!)!
            vc.contentStr = model?.remarks! as! String
            vc.typeSelect = (model?.type!)! - 1
            
            model?.goods_res?.forEach({ (item) in
                let dict = [
                    "goods_name":item.goods_name as Any,
                    "goods_id":item.goods_id as Any,
                    "sku_id":item.sku_id as Any,
                    "spec_str":item.sku_name as Any,
                    "unit":item.unit as Any,
                    "price":item.price as Any,
                    "target_Count":item.num as Any,
                    "target_Price":item.amount as Any,
                    "pog_id":item.pog_id as Any
                    ] as [String : Any]
                let mo = GetGoodsInfoDataModel(JSON: dict)
                
                vc.datas.append(mo!)
                vc.recordArr.append(mo!)
            })
            self.navigationController?.pushViewController(vc, animated: true)
            break
        case "入库","补录入库":
            var rkDatas:Array<InputInitInfoGoodsInfoModel> = []
            model!.goods_res?.forEach({ (item) in
                if item.no_push_num != 0 {
                    let dict = [
                        "sku_id":item.sku_id as Any,
                        "goods_id":item.goods_id as Any,
                        "goods_name":item.goods_name as Any,
                        "spec_str":item.sku_name as Any,
                        "goods_thumb":"" as Any,
                        "price":item.price as Any,
                        "inventory":0 as Any,
                        "warehouse_inventory":0 as Any,
                        "BZQ":"" as Any,
                        "ZJ":"" as Any,
                        "RKSL":"" as Any,
                        "RKJG":"" as Any,
                        "DayType":1 as Any,
                        "createDay":"" as Any,
                        "createDayStr":"" as Any,
                        "chuKuLiang":"" as Any,
                        "pog_id":item.pog_id as Any,
                        "no_push_num":item.no_push_num as Any
                    ]
                    
                    let mo = InputInitInfoGoodsInfoModel(JSON: dict)
                    rkDatas.append(mo!)
                }
            })
            let vc = NewRKVc()
            vc.isCaiGou = true
            vc.rkSelectArr = rkDatas
            vc.po_id = model?.po_id! as! Int
            vc.delegate = self
            vc.orderNumStr = model?.po_no! as! String
            self.navigationController?.pushViewController(vc, animated: true)
            break
        case "撤销入库":
            isBackOut = true
            let alertView = GeliAlertView(frame: self.view.window!.bounds)
            alertView.delegate = self;
            alertView.tishiLbl.text = ""
            alertView.titileLbl.text = "是否撤销入库？"
            alertView.rightBtn.setAttributedTitle(NSAttributedString(string: "确定"), for: .normal)
            self.view.window?.addSubview(alertView)
            break
        case "通过":
            isPass = true
            let alterView = GeliAlertTextView(frame: self.view.window!.bounds)
            alterView.delegate = self
            alterView.titleLbl.text = "请填写通过原因（选填）"
            alterView.placerLbl.text = "请填写通过原因..."
            self.view.window?.addSubview(alterView)
            break
        case "不通过":
            let alterView = GeliAlertTextView(frame: self.view.window!.bounds)
            alterView.delegate = self
            alterView.titleLbl.text = "请填写不通过原因（必填）"
            alterView.placerLbl.text = "请填写不通过原因..."
            self.view.window?.addSubview(alterView)
            break
        default:
            break
        }
    }
    func loadData(){
        let dict = ["user_token":UserToken as Any,"po_id":po_id as Any]
        purchaseOrderDetail(dict, success: { (data) in
            let item = data as! PurchaseOrderDetailModel
            let mo = item.data
            
            self.holderArr.insert(mo!.purchase_order!.po_no!, at: 0)
            self.holderArr.remove(at: 1)
            
            self.holderArr.insert(dayByDouble(sender: mo!.purchase_order!.purchase_time!), at: 1)
            self.holderArr.remove(at: 2)
            if mo!.purchase_order!.ven_name!.count > 0 {
                self.holderArr.insert(mo!.purchase_order!.ven_name!, at: 2)
                self.holderArr.remove(at: 3)
            }
            if mo!.purchase_order!.purchaser!.count > 0 {
                self.holderArr.insert(mo!.purchase_order!.purchaser!, at: 3)
                self.holderArr.remove(at: 4)
            }
            if mo!.purchase_order!.type == 1 {
                self.holderArr.insert("临时采购", at: 4)
                self.holderArr.remove(at: 5)
            }else{
                self.holderArr.insert("固定采购", at: 4)
                self.holderArr.remove(at: 5)
            }
            
            
            self.payFs = mo!.purchase_order!.pay_type!
            self.payZt = mo!.purchase_order!.pay_status! - 1
            
            self.holderArr.removeLast()
            self.holderArr.append((mo!.purchase_order?.user_name!)!)
            
            self.holderArr.insert(self.zfWayArr[self.payFs], at: 5)
            self.holderArr.remove(at: 6)
            self.holderArr.insert(self.zfTypeArr[self.payZt], at: 6)
            self.holderArr.remove(at: 7)
            if mo!.purchase_order!.remarks!.count > 0 {
                self.holderArr.insert(mo!.purchase_order!.remarks!, at: 7)
                self.holderArr.remove(at: 8)
            }
            
            self.model = mo?.purchase_order
            
            switch self.model!.order_status {
            case 1 :
                if (mo?.purchase_auth?.contains("119"))! {
                    self.btnTitle = ["不通过","通过"]
                }else{
                    self.btnTitle = ["取消","修改信息"]
                }
                break
            //订单状态（1未审核，2审核通过，3审核不通过，4已撤销，5已完成）
            case 2,5://入库状态（1未入库，2部分入库，3已入库）
                switch self.model!.push_status {
                case 1:
                    self.btnTitle = ["入库"]
                    break
                case 2:
                    self.btnTitle = ["撤销入库","补录入库"]
                    break
                default:
                    self.btnTitle = ["撤销入库"]
                    break
                }
                break
            default:
                break
            }
            self.setBtnUI()
            
            self.listView.reloadData()
        }) { (error) in
            
        }
    }
    
    func tableView(_ tableView: UITableView, cellForRowAt indexPath: IndexPath) -> UITableViewCell {
        if indexPath.section == 0 {
            if indexPath.row == 5 || indexPath.row == 6 {
                let cell = tableView.dequeueReusableCell(withIdentifier: "TitleAndBtnCell") as! TitleAndBtnCell
                cell.nameLbl.text = titleArr[indexPath.row]
                cell.contentLbl.text = holderArr[indexPath.row]
                if indexPath.row == 6 {
                    if cell.contentLbl.text == "已付款"{
                        cell.arrowImg.isHidden = true
                        cell.contentRight.constant = 15
                    }else{
                        cell.arrowImg.isHidden = false
                        cell.contentRight.constant = 32
                    }
                }
                cell.btn.isUserInteractionEnabled = false
                if model?.order_status == 1 {
                    cell.arrowImg.isHidden = true
                }else{
                    cell.arrowImg.isHidden = false
                }
                return cell
            }else{
                let cell = tableView.dequeueReusableCell(withIdentifier: "TitleAndTFCell") as! TitleAndTFCell
                cell.nameLbl.text = titleArr[indexPath.row]
                cell.textTF.isUserInteractionEnabled = false
                cell.textTF.text = holderArr[indexPath.row]
                return cell
            }
        }
        let cell = tableView.dequeueReusableCell(withIdentifier: "CGDCell1") as! CGDCell1
        cell.btnWidth.constant = 0
        cell.lblRight.constant = 15
        let item = model?.goods_res![indexPath.row]
        cell.nameLbl.text = item?.goods_name
        let num = "\(item!.num!)" as NSString
        let amount = (item?.amount!)! as NSString
        cell.cgCount.text = num as String
        cell.cgPrice.text = amount as String
        cell.rkCount.text = "\(item!.num! - (item?.no_push_num)!)"
        cell.detailLbl.text =  "\(item!.sku_name!) ¥\(amount)x\(num) \(item!.unit!)"
        cell.cgTotalPrice.text =  String(format: "%.2f", num.floatValue * amount.floatValue)
        return cell
    }
    func tableView(_ tableView: UITableView, didSelectRowAt indexPath: IndexPath) {
        if model?.order_status != 2 && model?.order_status != 5{
            return
        }
        if indexPath.section == 0 {
            if indexPath.row == 6 {
                if payZt == 1 {
                    return
                }
                if glSelectView == nil {
                    let view = GLAlertSelectView(frame: self.view.bounds)
                    view.tag = 100
                    view.delegate = self
                    view.selectNum = payZt
                    view.isYsYf = true
                    view.tempNum = view.selectNum
                    view.cellTag = payZt
                    view.titleLbl.text = "请选择支付状态"
                    view.ysyfTitle = "请选择支付状态"
                    view.dataArr = zfTypeArr
                    if payFs != 0 {
                        view.deSelectArr = [0,2,3]
                    }
                    self.view.addSubview(view)
                    glSelectView = view
                }
            }
            if indexPath.row == 5 {
                if glSelectView == nil {
                    let view = GLAlertSelectView(frame: self.view.bounds)
                    view.tag = 999
                    view.delegate = self
                    view.selectNum = payFs
                    view.cellTag = payFs
                    view.isYsYf = true
                    view.ysyfTitle = "请选择支付方式"
                    view.tempNum = view.selectNum
                    view.titleLbl.text = "请选择支付方式"
                    view.dataArr = zfWayArr
                    self.view.addSubview(view)
                    glSelectView = view
                }
            }
        }
    }
    
    func GLAlertSelectDone() {
        glSelectView?.removeFromSuperview()
        glSelectView = nil
    }
    
    func tableView(_ tableView: UITableView, heightForRowAt indexPath: IndexPath) -> CGFloat {
        
        if indexPath.section == 0 {
            if model?.order_status == 1 {
                if indexPath.row == 5 || indexPath.row == 6 {
                    return 0
                }
            }
            return 49
        }
        return 173
    }
    
    func numberOfSections(in tableView: UITableView) -> Int {
        return 2
    }
    
    func tableView(_ tableView: UITableView, numberOfRowsInSection section: Int) -> Int {
        if section == 0 {
            return titleArr.count
        }
        if model != nil {
            return (model?.goods_res!.count)!
        }
        return 0
    }
    
    func tableView(_ tableView: UITableView, viewForFooterInSection section: Int) -> UIView? {
        let view = UIView(frame: CGRect(x: 0, y: 0, width: fullScreenWidth, height: 10))
        view.backgroundColor = UIColor(named: "app底色")
        return view
    }
    func tableView(_ tableView: UITableView, heightForFooterInSection section: Int) -> CGFloat {
        return 10
    }
    func GLAlertSelectViewFinish(sender: UIButton, title: String, cellTag: Int) {
        print("3",cellTag)
        if title == "请选择支付状态" {
            if payFs == 0 {
                payZt = sender.tag
                holderArr.insert(zfTypeArr[payZt], at: 6)
                holderArr.remove(at: 7)
                if payZt == 1{
                    payFs = 1
                    holderArr.insert(zfWayArr[payFs], at: 5)
                    holderArr.remove(at: 6)
                }
            }
        }
        if title == "请选择支付方式" {
            payFs = sender.tag
            holderArr.insert(zfWayArr[payFs], at: 5)
            holderArr.remove(at: 6)
            if payFs != 0 {
                payZt = 1
            }else{
                payZt = 0
            }
            holderArr.insert(zfTypeArr[payZt], at: 6)
            holderArr.remove(at: 7)
        }
        
        let dict = [
            "user_token":UserToken as Any,
            "po_id":po_id as Any,
            "pay_type":payFs as Any,
            "pay_status":payZt + 1 as Any
        ]
        payStatus(dict, success: { (data) in
            self.listView.reloadData()
            self.glSelectView?.removeFromSuperview()
            self.glSelectView = nil
            self.delegate!.CGDXQVcChangePayStatus()
        }) { (err) in
            
        }
    }
    func GLAlertSelectViewClick(selectNum: Int, view: GLAlertSelectView) {
        if view.tag == 999 {
            payFs = selectNum
            holderArr.insert(zfWayArr[payFs], at: 5)
            holderArr.remove(at: 6)
            if payFs != 0 {
                payZt = 1
            }else{
                payZt = 0
            }
            holderArr.insert(zfTypeArr[payZt], at: 6)
            holderArr.remove(at: 7)
        }else{
            if payFs == 0 {
                payZt = selectNum
                holderArr.insert(zfTypeArr[payZt], at: 6)
                holderArr.remove(at: 7)
            }
        }
        listView.reloadData()
        view.removeFromSuperview()
        glSelectView = nil
    }
    func GLASClose(view: GLAlertSelectView, selectnum: Int, selectArr: Array<Int>) {
        if selectnum != 10086 {
            if view.titleLbl.text == "请选择支付状态" {
                payZt = selectnum
            }
            if view.titleLbl.text == "请选择支付方式" {
                payFs = selectnum
            }
        }
        view.removeFromSuperview()
        glSelectView = nil
    }
    
    func tableView(_ tableView: UITableView, viewForHeaderInSection section: Int) -> UIView? {
        
        let view = UIView(frame: CGRect(x: 0, y: 0, width: fullScreenWidth, height: 39))
        view.backgroundColor = UIColor.white
        let lbl = UILabel(frame: CGRect(x: 15, y: 15, width: fullScreenWidth, height: 21))
        lbl.text = tArr[section]
        lbl.textColor = UIColor(named: "标题字颜色")
        lbl.font = UIFont.boldSystemFont(ofSize: 15)
        view.addSubview(lbl)
        return view
    }
    func tableView(_ tableView: UITableView, heightForHeaderInSection section: Int) -> CGFloat {
        return 39
    }
    
}
